# CSV

[![CI](https://github.com/JuliaData/CSV.jl/actions/workflows/ci.yml/badge.svg?branch=main)](https://github.com/JuliaData/CSV.jl/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/JuliaData/CSV.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaData/CSV.jl)
[![deps](https://juliahub.com/docs/CSV/deps.svg)](https://juliahub.com/ui/Packages/CSV/HHBkp?t=2)
[![version](https://juliahub.com/docs/CSV/version.svg)](https://juliahub.com/ui/Packages/CSV/HHBkp)
[![pkgeval](https://juliahub.com/docs/CSV/pkgeval.svg)](https://juliahub.com/ui/Packages/CSV/HHBkp)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.8004128.svg)](https://doi.org/10.5281/zenodo.8004128)

*A fast, flexible delimited file reader/writer for Julia.*

## Installation

The package is registered in the [`General`](https://github.com/JuliaRegistries/General) registry and so can be installed at the REPL with `] add CSV`.

## Documentation

- [**STABLE**][docs-stable-url] &mdash; **most recently tagged version of the documentation.**
- [**LATEST**][docs-latest-url] &mdash; *in-development version of the documentation.*

## Project Status

The package is tested against Julia `1.0`, current stable release, and nightly on Linux, OS X, and Windows.

## Contributing and Questions

Contributions are very welcome, as are feature requests and suggestions. Please open an
[issue][issues-url] if you encounter any problems or would just like to ask a question.

[docs-latest-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-latest-url]: https://JuliaData.github.io/CSV.jl/latest

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaData.github.io/CSV.jl/stable

[ci-img]: https://github.com/JuliaData/CSV.jl/workflows/CI/badge.svg
[ci-url]: https://github.com/JuliaData/CSV.jl/actions?query=workflow%3ACI+branch%3Amaster

[codecov-img]: https://codecov.io/gh/JuliaData/CSV.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaData/CSV.jl

[issues-url]: https://github.com/JuliaData/CSV.jl/issues

## Alternatives

There are several other packages for reading CSV files in Julia, which may suit your needs better:

* The standard library contains [DelimitedFiles.jl](https://docs.julialang.org/en/v1/stdlib/DelimitedFiles/), at least until Julia 1.8.
  This returns a `Matrix` rather than a [Tables.jl](https://github.com/JuliaData/Tables.jl)-style container, thus works best for files of homogeneous element type. 
  On large files, CSV.jl will be much faster.

* [CSVFiles.jl](https://github.com/queryverse/CSVFiles.jl) uses the [FileIO.jl](https://github.com/JuliaIO/FileIO.jl)'s `load` / `save` API,
  but otherwise has similar goals. Like CSV.jl, it works with [Tables.jl](https://github.com/JuliaData/Tables.jl) objects such as DataFrames.

* [DLMReader.jl](https://github.com/sl-solution/DLMReader.jl) also aims to be fast for large files,
  closely associated with [InMemoryDatasets.jl](https://github.com/sl-solution/InMemoryDatasets.jl).

* [Pandas.jl](https://github.com/JuliaPy/Pandas.jl) wraps Python's [pandas](https://pandas.pydata.org) library (using [PyCall.jl](https://github.com/JuliaPy/PyCall.jl)).
  This is a closer cousin of [DataFrames.jl](https://github.com/JuliaData/DataFrames.jl), but builds in the ability to read/write CSV files.

This README serves as developer documentation for CSV.jl internals. It doesn't pretend to be comprehensive, but was created with the aim to explain both the overall strategies CSV.jl uses in parsing delimited files as well as the trickiest mechanics and some of the reasoning that went into the architecture.

# CSV.File

Let's go over details specific to `CSV.File`.

## General parsing strategy/mechanics

In the context.jl file, we take care of processing/validating all the various options/keyword arguments from the first `CSV.File`/`CSV.read` call. The end result in a `CSV.Context` object, which represents a parsing "context" of a delimited file. It holds a reference to the input buffer as a `Vector{UInt8}`, detected or generated column names, byte position where parsing should start, whether parsing should use multiple threads, etc. One of the key fields of `CSV.Context` is `ctx.columns`, which is a `Vector{CSV.Column}`. A `CSV.Column` holds a bunch of information related to parsing a single column in a file, including it's currently detected/user-specified type, whether any `missing` values have been encountered, if the column will be dropped after parsing, whether it should be pooled, etc.

So the general strategy is to get the overall `CSV.Context` for a delimited file, then pass then choose one of two main paths for actual parsing based on whether parsing will use multiple threads or not. For non-threaded, we go directly into parsing the file, row by row, until finished. For multithreaded parsing, the `CSV.Context` will have determined the starting byte positions for each chunk and also sampled column types, so we spawn a threaded task per file "chunk", then need to synchronize the chunks after each has finished. This syncing is to ensure the parsed/detected types match and that pooled columns have matching refs. The final step for single or multithreaded parsing is to make the final columns: if no missing values were encountered, then we'll "unwrap" the SentinelArray to get a normal Vector for most standard types; for pooled columns, we'll create the actual PooledArray; for `stringtype=PosLenString`, we make a `PosLenStringVector`. For multithreaded parsing, we do the same steps, but also link the different threaded chunks into single long columns via `ChainedVector`.

## Non-standard types



## The `pool` keyword argument

CSV.jl provides a native integration with the [PooledArrays.jl](https://github.com/JuliaData/PooledArrays.jl/) package, which provides an array storage optimization by having a (hopefully) small pool of "expensive" (big or heap-allocated, or whatever) values, along with a memory-efficient integer array of "refs" where each ref maps to one of the values in the pool. This is sometimes referred to as a "dictionary encoding" in various data formats. As an example, if you have a column with 1,000,000 elements, but only 10 unique string values, you can have a `Vector{String}` pool to store the 10 unique strings and give each a unique `UInt32` value, and a `Vector{UInt32}` "ref array" for the million elements, where each element just indexes into the pool to get the actual string value.

By providing the `pool` keyword argument, users can control how this optimization will be applied to individual columns, or to all columns of the delimited text being read.

Valid inputs for `pool` include:
  * A `Bool`, `true` or `false`, which will apply to all string columns parsed; string columns either will _all_ be pooled, or _all_ not pooled
  * A `Real`, which will be converted to `Float64`, which should be a value between `0.0` and `1.0`, to indicate the % cardinality threshold _under which_ a column will be pooled. e.g. by passing `pool=0.1`, if a column has less than 10% unique values, it will end up as a `PooledArray`, otherwise a normal array. Like the `Bool` argument, this will apply the same % threshold to only/all string columns.
  * a `Tuple{Float64, Int}`, where the 1st argument is the same as the above percent threshold on cardinality, while the 2nd argument is an absolute upper limit on the # of unique values. This is useful for large datasets where 0.2 may grow to allow pooled columns with thousands of values; it's helpful performance-wise to put an upper limit like `pool=(0.2, 500)` to ensure no pooled column will have more than 500 unique values.
  * An `AbstractVector`, where the # of elements should/needs to match the # of columns in the dataset. Each element of the `pool` argument should be a `Bool`, `Real`, or `Tuple{Float64, Int}` indicating the pooling behavior for each specific column.
  * An `AbstractDict`, with keys as `String`s, `Symbol`s, or `Int`s referring to column names or indices, and values in the `AbstractDict` being `Bool`, `Real`, or `Tuple{Float64, Int}` to again signal how specific columns should be pooled
  * A function of the form `(i, nm) -> Union{Bool, Real, Tuple{Float64, Int}}` where it takes the column index and name as two arguments, and returns one of the first 3 possible pool values from the above list.

For the implementation of pooling:
  * We normalize however the keyword argument was provided to have a `pool` value per column while parsing
  * We also have a `pool` field on the `Context` structure in case columns are widened while parsing, they will take on this value
  * Once column parsing is done, the cardinality is checked against the individual column pool value and whether the column should be pooled or not is computed.

# Test fixtures via Artifacts

CSV.jl’s test fixtures live in an artifact (`artifact"testfiles"`) to avoid shipping ~30 MB of data to package users. The artifact is published as a GitHub release asset: `testdata-full-1/testfiles-artifact.tar.gz`. Running `Pkg.test` (or `test/runtests.jl`) will download it once and cache it in `~/.julia/artifacts`.

## Updating the testfiles artifact
1. Download and extract the current asset (preserves layout expected by tests):  
   `curl -L -o testfiles-artifact.tar.gz https://github.com/JuliaData/CSV.jl/releases/download/testdata-full-1/testfiles-artifact.tar.gz`  
   `mkdir testfiles && tar -xzf testfiles-artifact.tar.gz -C testfiles`
2. Edit files in `testfiles/` as needed (add/remove/update).
3. Repack and compute hashes with Julia (uses Tar/Artifacts only):  
   ```julia
   using Pkg.Artifacts, SHA, Tar
   artifact_hash = create_artifact() do artdir
       run(`cp -R testfiles/* $artdir`)
   end
   tarball = "testfiles-artifact.tar.gz"
   archive_artifact(artifact_hash, tarball)
   println((; artifact_hash, sha256=bytes2hex(open(sha256, tarball))))
   ```
4. Upload the new tarball to a release (same repo/tag is fine), update `test/Artifacts.toml` with the new `git-tree-sha1` and `sha256`, and keep the asset available so tests can download it.

Tests assume the artifact root contains the contents of the old `test/testfiles` directory (no extra nesting).

import Base: Ryu

"""
    CSV.write(file, table; kwargs...) => file
    table |> CSV.write(file; kwargs...) => file

Write a [Tables.jl interface input](https://github.com/JuliaData/Tables.jl) to a csv file, given as an `IO` argument or `String`/FilePaths.jl type representing the file name to write to.
Alternatively, `CSV.RowWriter` creates a row iterator, producing a csv-formatted string for each row in an input table.

Supported keyword arguments include:
* `bufsize::Int=2^22`: The length of the buffer to use when writing each csv-formatted row; default 4MB; if a row is larger than the `bufsize` an error is thrown
* `delim::Union{Char, String}=','`: a character or string to print out as the file's delimiter
* `quotechar::Char='"'`: ascii character to use for quoting text fields that may contain delimiters or newlines
* `openquotechar::Char`: instead of `quotechar`, use `openquotechar` and `closequotechar` to support different starting and ending quote characters
* `escapechar::Char='"'`: ascii character used to escape quote characters in a text field
* `missingstring::String=""`: string to print for `missing` values
* `dateformat=Dates.default_format(T)`: the date format string to use for printing out `Date` & `DateTime` columns
* `append=false`: whether to append writing to an existing file/IO, if `true`, it will not write column names by default
* `compress=false`: compress the written output using standard gzip compression (provided by the CodecZlib.jl package); note that a compression stream can always be provided as the first "file" argument to support other forms of compression; passing `compress=true` is just for convenience to avoid needing to manually setup a GzipCompressorStream
* `writeheader=!append`: whether to write an initial row of delimited column names, not written by default if appending
* `header`: pass a list of column names (Symbols or Strings) to use instead of the column names of the input table
* `newline='\\n'`: character or string to use to separate rows (lines in the csv file)
* `quotestrings=false`: whether to force all strings to be quoted or not
* `decimal='.'`: character to use as the decimal point when writing floating point numbers
* `transform=(col,val)->val`: a function that is applied to every cell e.g. we can transform all `nothing` values to `missing` using `(col, val) -> something(val, missing)`
* `bom=false`: whether to write a UTF-8 BOM header (0xEF 0xBB 0xBF) or not
* `partition::Bool=false`: by passing `true`, the `table` argument is expected to implement `Tables.partitions` and the `file` argument can either be an indexable collection of `IO`, file `String`s, or a single file `String` that will have an index appended to the name

## Examples

```julia
using CSV, Tables, DataFrames

# write out a DataFrame to csv file
df = DataFrame(rand(10, 10), :auto)
CSV.write("data.csv", df)

# write a matrix to an in-memory IOBuffer
io = IOBuffer()
mat = rand(10, 10)
CSV.write(io, Tables.table(mat))
```
"""
function write end

mutable struct Options{D, N, DF, M, TF}
    delim::D
    openquotechar::UInt8
    closequotechar::UInt8
    escapechar::UInt8
    newline::N # Union{UInt8, NTuple{N, UInt8}}
    decimal::UInt8
    dateformat::DF
    quotestrings::Bool
    missingstring::M
    transform::TF  # Function
    bom::Bool
end

tup(x::Char) = x % UInt8
tup(x::AbstractString) = Tuple(codeunits(x))
tlen(::UInt8) = 1
tlen(::NTuple{N, UInt8}) where {N} = N

function Options(;
    delim::Union{Char, String}=',',
    quotechar::Char='"',
    openquotechar::Union{Char, Nothing}=nothing,
    closequotechar::Union{Char, Nothing}=nothing,
    escapechar::Char='"',
    newline::Union{Char, String}='\n',
    decimal::Char='.',
    dateformat=nothing,
    quotestrings::Bool=false,
    missingstring::AbstractString="",
    transform::Function=_identity,
    bom::Bool=false,
    kw...
    )
    checkvaliddelim(delim)
    (isascii(something(openquotechar, quotechar)) && isascii(something(closequotechar, quotechar)) && isascii(escapechar)) || throw(ArgumentError("quote and escape characters must be ASCII characters "))
    oq, cq = openquotechar !== nothing ? (openquotechar % UInt8, closequotechar % UInt8) : (quotechar % UInt8, quotechar % UInt8)
    e = escapechar % UInt8
    return Options(tup(delim), oq, cq, e, tup(newline), decimal % UInt8, dateformat, quotestrings, tup(missingstring), transform, bom)
end

"""
    CSV.RowWriter(table; kwargs...)

Creates an iterator that produces csv-formatted strings for each row in the input table.

Supported keyword arguments include:
* `bufsize::Int=2^22`: The length of the buffer to use when writing each csv-formatted row; default 4MB; if a row is larger than the `bufsize` an error is thrown
* `delim::Union{Char, String}=','`: a character or string to print out as the file's delimiter
* `quotechar::Char='"'`: ascii character to use for quoting text fields that may contain delimiters or newlines
* `openquotechar::Char`: instead of `quotechar`, use `openquotechar` and `closequotechar` to support different starting and ending quote characters
* `escapechar::Char='"'`: ascii character used to escape quote characters in a text field
* `missingstring::String=""`: string to print for `missing` values
* `dateformat=Dates.default_format(T)`: the date format string to use for printing out `Date` & `DateTime` columns
* `header`: pass a list of column names (Symbols or Strings) to use instead of the column names of the input table
* `newline='\\n'`: character or string to use to separate rows (lines in the csv file)
* `quotestrings=false`: whether to force all strings to be quoted or not
* `decimal='.'`: character to use as the decimal point when writing floating point numbers
* `transform=(col,val)->val`: a function that is applied to every cell e.g. we can transform all `nothing` values to `missing` using `(col, val) -> something(val, missing)`
* `bom=false`: whether to write a UTF-8 BOM header (0xEF 0xBB 0xBF) or not
"""
struct RowWriter{T, S, O}
    source::T
    schema::S
    options::O
    buf::Vector{UInt8}
    header::Vector
    writeheader::Bool
end

Base.IteratorSize(::Type{RowWriter{T, S, O}}) where {T, S, O} = Base.IteratorSize(T)
Base.length(r::RowWriter) = length(r.source) + r.writeheader
Base.size(r::RowWriter) = (length(r.source) + r.writeheader,)
Base.eltype(r::RowWriter) = String

_identity(col, val) = val

function RowWriter(table;
    header::Vector=String[],
    writeheader::Bool=true,
    bufsize::Int=2^22,
    kw...)
    opts = Options(; kw...)
    source = Tables.rows(table)
    sch = Tables.schema(source)
    return RowWriter(source, sch, opts, Vector{UInt8}(undef, bufsize), header, writeheader)
end

struct DummyIO <: IO end
Base.write(io::DummyIO, a::SubArray{T,N,<:Array}) where {T,N} = error("`bufsize` for `CSV.RowWriter` was too small (default 4MB); try again passing a larger value for `bufsize`")

# first iteration produces column names
function Base.iterate(r::RowWriter)
    state = iterate(r.source)
    state === nothing && return nothing
    row, st = state
    colnames = isempty(r.header) ? Tables.columnnames(row) : r.header
    pos = 1
    if r.options.bom
        pos = writebom(r.buf, pos, length(r.buf), DummyIO())
    end
    cols = length(colnames)
    !r.writeheader && return iterate(r, (state, cols))
    pos = writenames(r.buf, pos, length(r.buf), DummyIO(), colnames, cols, r.options)
    return unsafe_string(pointer(r.buf), pos - 1), (state, cols)
end

function Base.iterate(r::RowWriter, (state, cols))
    state === nothing && return nothing
    row, st = state
    ref = Ref{Int}(1)
    writerow(r.buf, ref, length(r.buf), DummyIO(), r.schema, row, cols, r.options)
    return unsafe_string(pointer(r.buf), ref[] - 1), (iterate(r.source, st), cols)
end

write(file; kwargs...) = x->write(file, x; kwargs...)
function write(file, itr;
    append::Bool=false,
    compress::Bool=false,
    writeheader=nothing,
    partition::Bool=false,
    kw...)
    if writeheader !== nothing
        Base.depwarn("`writeheader=$writeheader` is deprecated in favor of `header=$writeheader`", :write)
        header = writeheader
    else
        header = !append
    end
    opts = Options(; kw...)
    if partition
        if file isa IO
            throw(ArgumentError("must pass single file name as a String, or iterable of filenames or IO arguments"))
        end
        outfiles = file isa String ? String[] : file
        @sync for (i, part) in enumerate(Tables.partitions(itr))
            @static if VERSION >= v"1.3-DEV"
                Threads.@spawn begin
                    if file isa String
                        push!(outfiles, string(file, "_$i"))
                    end
                    write(outfiles[i], part; append=append, compress=compress, writeheader=writeheader, partition=false, kw...)
                end
            else
                if file isa String
                    push!(outfiles, string(file, "_$i"))
                end
                write(outfiles[i], part; append=append, compress=compress, writeheader=writeheader, partition=false, kw...)
            end
        end
        return outfiles
    else
        rows = Tables.rows(itr)
        sch = Tables.schema(rows)
        return write(sch, rows, file, opts; append=append, compress=compress, header=header, kw...)
    end
end

function write(sch::Tables.Schema, rows, file, opts;
        append::Bool=false,
        compress::Bool=false,
        header::Union{Bool, Vector}=String[],
        bufsize::Int=2^22,
        kw...
    )
    colnames = !(header isa Vector) || isempty(header) ? sch.names : header
    cols = length(colnames)
    len = bufsize
    buf = Vector{UInt8}(undef, len)
    pos = 1
    with(file, append, compress) do io
        Base.@_inline_meta
        if !append && opts.bom
            pos = writebom(buf, pos, len, io)
        end
        if header === true || (header isa Vector && !append)
            pos = writenames(buf, pos, len, io, colnames, cols, opts)
        end
        ref = Ref{Int}(pos)
        for row in rows
            writerow(buf, ref, len, io, sch, row, cols, opts)
        end
        Base.write(io, resize!(buf, ref[] - 1))
    end
    return file
end

# handle unknown schema case
function write(::Nothing, rows, file, opts;
        append::Bool=false,
        compress::Bool=false,
        header::Union{Bool, Vector}=String[],
        bufsize::Int=2^22,
        kw...
    )
    len = bufsize
    buf = Vector{UInt8}(undef, len)
    pos = 1
    state = iterate(rows)
    if state === nothing
        if header isa Vector && !isempty(header)
            with(file, append, compress) do io
                !append && opts.bom && (pos = writebom(buf, pos, len, io) )
                pos = writenames(buf, pos, len, io, header, length(header), opts)
                Base.write(io, resize!(buf, pos - 1))
            end
        end
        return file
    end
    row, st = state
    names = header isa Bool || isempty(header) ? Tables.columnnames(row) : header
    sch = Tables.Schema(Tables.columnnames(row), nothing)
    cols = length(names)
    with(file, append, compress) do io
        if !append && opts.bom
            pos = writebom(buf, pos, len, io)
        end
        if header === true || (header isa Vector && !append)
            pos = writenames(buf, pos, len, io, names, cols, opts)
        end
        ref = Ref{Int}(pos)
        while true
            writerow(buf, ref, len, io, sch, row, cols, opts)
            state = iterate(rows, st)
            state === nothing && break
            row, st = state
        end
        Base.write(io, resize!(buf, ref[] - 1))
    end
    return file
end

_seekstart(io::T) where {T <: IO} = hasmethod(seek, Tuple{T, Integer}) ? seekstart(io) : nothing

function with(f::Function, @nospecialize(io), append, compress)
    needtoclose = false
    opened_stream = false
    if io isa Union{Base.TTY, Base.Pipe, Base.PipeEndpoint, Base.DevNull}
        # pass, can't seek these
    elseif io isa IO
        !append && _seekstart(io)
    else
        io = open(io, append ? "a" : "w")
        needtoclose = true
        opened_stream = true
    end
    if compress
        # Use stop_on_end=true if we didn't open the underlying stream ourselves.
        # This prevents the GzipCompressorStream from closing the user's IO when
        # the compressor is closed, allowing take!(io) to work on IOBuffer, etc.
        io = GzipCompressorStream(io; stop_on_end=!opened_stream)
        needtoclose = true
    end
    try
        return f(io)
    finally
        needtoclose && close(io)
    end
end

@noinline buffertoosmall(pos, len) = throw(ArgumentError("row size ($pos) too large for writing buffer ($len), pass a larger value to `bufsize` keyword argument"))

macro check(n)
    esc(quote
        @assert @isdefined(io) "internal error: `io` not defined in scope of `@check` macrocall"
        $n > length(buf) && buffertoosmall(pos + $n - 1, length(buf))
        if (pos + $n - 1) > len
            Base.write(io, view(buf, 1:(pos - 1)))
            pos = 1
        end
    end)
end

function writebom(buf, pos, len, io)
    @check 3
    @inbounds buf[pos] = 0xEF
    @inbounds buf[pos+1] = 0xBB
    @inbounds buf[pos+2] = 0xBF
    return pos + 3
end

function writedelimnewline(buf, pos, len, io, x::UInt8)
    @check 1
    @inbounds buf[pos] = x
    return pos + 1
end

function writedelimnewline(buf, pos, len, io, x)
    @check tlen(x)
    for i = 1:tlen(x)
        @inbounds buf[pos] = x[i]
        pos += 1
    end
    return pos
end

function writenames(buf, pos, len, io, header, cols, opts)
    cols = length(header)
    for (col, nm) in enumerate(header)
        pos = writecell(buf, pos, len, io, String(nm), opts)
        pos = writedelimnewline(buf, pos, len, io, ifelse(col == cols, opts.newline, opts.delim))
    end
    return pos
end

@noinline nothingerror(col) = error(
    """
    A `nothing` value was found in column $col and it is not a printable value.
    There are several ways to handle this situation:
    1) fix the data, perhaps replace `nothing` with `missing`,
    2) use `transform` option with a function to replace `nothing` with whatever value (including `missing`), like `CSV.write(...; transform=(col, val) -> something(val, missing))` or
    3) use `TableOperations.transform` option to transform specific columns
    """)

writerow(buf, pos, len, io, ::Nothing, row, cols, opts) =
    writerow(buf, pos, len, io, Tables.Schema(Tables.columnnames(row), nothing), row, cols, opts)

function writerow(buf, pos, len, io, sch, row, cols, opts)
    n, d = opts.newline, opts.delim
    Tables.eachcolumn(sch, row) do val, col, nm
        Base.@_inline_meta
        val = opts.transform(col, val)
        val === nothing && nothingerror(col)
        posx = writecell(buf, pos[], len, io, val, opts)
        pos[] = writedelimnewline(buf, posx, len, io, ifelse(col == cols, n, d))
    end
    return
end

function writerow(io::IO, row; opts::Union{Options, Nothing}=nothing, bufsize::Int=2^22, buf=Vector{UInt8}(undef, bufsize), len=bufsize, kw...)
    if opts === nothing
        opts = Options(; kw...)
    end
    nms = Tables.columnnames(row)
    pos = 1
    for i = 1:length(nms)
        val = opts.transform(i, Tables.getcolumn(row, i))
        val === nothing && nothingerror(col)
        pos = writecell(buf, pos, len, io, val, opts)
        pos = writedelimnewline(buf, pos, len, io, ifelse(i == length(nms), opts.newline, opts.delim))
    end
    Base.write(io, resize!(buf, pos - 1))
end

function writerow(row; opts::Union{Options, Nothing}=nothing, bufsize::Int=2^22, buf=Vector{UInt8}(undef, bufsize), len=bufsize, kw...)
    if opts === nothing
        opts = Options(; kw...)
    end
    io = DummyIO()
    nms = Tables.columnnames(row)
    pos = 1
    for i = 1:length(nms)
        val = opts.transform(i, Tables.getcolumn(row, i))
        val === nothing && nothingerror(col)
        pos = writecell(buf, pos, len, io, val, opts)
        pos = writedelimnewline(buf, pos, len, io, ifelse(i == length(nms), opts.newline, opts.delim))
    end
    return unsafe_string(pointer(buf), pos - 1)
end

function writecell(buf, pos, len, io, ::Missing, opts)
    str = opts.missingstring
    t = tlen(str)
    t == 0 && return pos
    @check t
    Base.@nexprs 12 i -> begin
        buf[pos] = str[i]
        pos += 1
        (i + 1) > t && return pos
    end
    for i = 13:t
        buf[pos] = str[i]
        pos += 1
    end
    return pos
end

function writecell(buf, pos, len, io, x::Bool, opts)
    @inbounds if x
        @check 4
        buf[pos] = UInt8('t')
        buf[pos + 1] = UInt8('r')
        buf[pos + 2] = UInt8('u')
        buf[pos + 3] = UInt8('e')
        pos += 4
    else
        @check 5
        buf[pos] = UInt8('f')
        buf[pos + 1] = UInt8('a')
        buf[pos + 2] = UInt8('l')
        buf[pos + 3] = UInt8('s')
        buf[pos + 4] = UInt8('e')
        pos += 5
    end
    return pos
end

function writecell(buf, pos, len, io, x::Integer, opts)
    if x < 0
        x = Base.uabs(x)
        @check 1
        @inbounds buf[pos] = UInt8('-')
        pos += 1
    end
    n = i = ndigits(x)
    @check i
    while i > 0
        @inbounds buf[pos + i - 1] = 48 + rem(x, 10)
        x = oftype(x, div(x, 10))
        i -= 1
    end
    return pos + n
end

function writecell(buf, pos, len, io, x::AbstractFloat, opts)
    bytes = codeunits(string(x))
    sz = sizeof(bytes)
    @check sz
    if opts.decimal != UInt8('.')
        for i = 1:sz
            @inbounds buf[pos] = bytes[i] == UInt8('.') ? opts.decimal : bytes[i]
            pos += 1
        end
    else
        for i = 1:sz
            @inbounds buf[pos] = bytes[i]
            pos += 1
        end
    end
    return pos
end

function writecell(buf, pos, len, io, x::T, opts) where {T <: Base.IEEEFloat}
    @check Ryu.neededdigits(T)
    return Ryu.writeshortest(buf, pos, x, false, false, true, -1, UInt8('e'), false, opts.decimal)
end

getvalue(x::T, df) where {T <: Dates.TimeType} = Dates.format(x, df === nothing ? Dates.default_format(T) : df)

function writecell(buf, pos, len, io, x::Dates.TimeType, opts)
    bytes = codeunits(getvalue(x, opts.dateformat))
    @check sizeof(bytes)
    for i = 1:sizeof(bytes)
        @inbounds buf[pos] = bytes[i]
        pos += 1
    end
    return pos
end

function writecell(buf, pos, len, io, x::Symbol, opts)
    ptr = Base.unsafe_convert(Ptr{UInt8}, x)
    sz = ccall(:strlen, Csize_t, (Cstring,), ptr)
    @check sz
    for i = 1:sz
        @inbounds buf[pos] = unsafe_load(ptr, i)
        pos += 1
    end
    return pos
end

# generic fallback; convert to string
writecell(buf, pos, len, io, x, opts) =
    writecell(buf, pos, len, io, Base.string(x), opts)

function writecell(buf, pos, len, io, x::AbstractString, opts)
    bytes = codeunits(x)
    sz = sizeof(bytes)
    # check if need to escape
    needtoescape, needtoquote = check(bytes, sz, opts.delim, opts.openquotechar, opts.closequotechar, opts.newline)
    needtoquote |= needtoescape
    needtoquote |= opts.quotestrings
    @check (sz + (needtoquote * 2) + (needtoescape * 2 * sz))
    if needtoquote
        @inbounds buf[pos] = opts.openquotechar
        pos += 1
    end
    if needtoescape
        oq, cq, e = opts.openquotechar, opts.closequotechar, opts.escapechar
        for i = 1:sz
            @inbounds b = bytes[i]
            if b == cq || b == oq
                @inbounds buf[pos] = e
                pos += 1
            end
            @inbounds buf[pos] = b
            pos += 1
        end
    else
        for i = 1:sz
            @inbounds buf[pos] = bytes[i]
            pos += 1
        end
    end
    if needtoquote
        @inbounds buf[pos] = opts.closequotechar
        pos += 1
    end
    return pos
end

function check(bytes, sz, delim::UInt8, oq, cq, newline::UInt8)
    isempty(bytes) && return false, false
    needtoescape = false
    @inbounds needtoquote = bytes[1] == oq
    @simd for i = 1:sz
        @inbounds b = bytes[i]
        needtoquote |= (b == delim) | (b == newline)
        needtoescape |= b == cq
    end
    return needtoescape, needtoquote
end

function check(bytes, sz, delim::UInt8, oq, cq, newline::Tuple)
    needtoescape = false
    @inbounds needtoquote = bytes[1] == oq
    j = 1
    for i = 1:sz
        @inbounds b = bytes[i]
        needtoquote |= b == delim
        needtoescape |= b == cq
        if !isempty(newline) && b == newline[j]
            j += 1
            if j > length(newline)
                needtoquote = true
                j = 1
            end
        else
            j = 1
        end
    end
    return needtoescape, needtoquote
end

function check(bytes, sz, delim::Tuple, oq, cq, newline::UInt8)
    needtoescape = false
    @inbounds needtoquote = bytes[1] == oq
    j = 1
    for i = 1:sz
        @inbounds b = bytes[i]
        needtoquote |= b == newline
        needtoescape |= b == cq
        if b == delim[j]
            j += 1
            if j > length(delim)
                needtoquote = true
                j = 1
            end
        else
            j = 1
        end
    end
    return needtoescape, needtoquote
end

function check(bytes, sz, delim::Tuple, oq, cq, newline::Tuple)
    needtoescape = false
    @inbounds needtoquote = bytes[1] === oq
    j = 1
    k = 1
    @simd for i = 1:sz
        @inbounds b = bytes[i]
        needtoescape |= b == cq
        if !isempty(newline) && b == newline[j]
            j += 1
            if j > length(newline)
                needtoquote = true
                j = 1
            end
        else
            j = 1
        end
        if b == delim[k]
            k += 1
            if k > length(delim)
                needtoquote = true
                k = 1
            end
        else
            k = 1
        end
    end
    return needtoescape, needtoquote
end

using CSV, Dates, WeakRefStrings, Tables, CodecZlib
using FilePathsBase
using FilePathsBase: /

const default_table = (col1=[1,2,3], col2=[4,5,6], col3=[7,8,9])

const weakrefs = StringVector{WeakRefString{UInt8}}(["hey", "hey", "hey"])

const table_types = (
    col1=[true, false, true],
    col2=[4.1,5.2,4e10],
    col3=[NaN, Inf, -Inf],
    col4=[Date(2017, 1, 1), Date(2018, 1, 1), Date(2019, 1, 1)],
    col5=[DateTime(2017, 1, 1, 4, 5, 6, 7), DateTime(2018, 1, 1, 4, 5, 6, 7), DateTime(2019, 1, 1, 4, 5, 6, 7)],
    col6=["hey", "there", "sailor"],
    col7=[weakrefs[1], weakrefs[2], weakrefs[3]],
    col8=weakrefs,
)

struct StructType
    adate::Date
    astring::Union{String, Nothing}
    aumber::Union{Real, Nothing}
end

struct AF <: AbstractFloat
    f::Float64
end
Base.string(x::AF) = string(x.f)

@testset "CSV.write" begin

    testcases = [
        (
            default_table,
            NamedTuple(),
            "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"
        ),
        (
            default_table,
            (delim='\t',),
            "col1\tcol2\tcol3\n1\t4\t7\n2\t5\t8\n3\t6\t9\n"
        ),
        (
            (col1=[1,2,3], col2=["hey", "the::re", "::sailor"], col3=[7,8,9]),
            (delim="::",),
            "col1::col2::col3\n1::hey::7\n2::\"the::re\"::8\n3::\"::sailor\"::9\n"
        ),
        (
            default_table,
            (header=[:Col1, :Col2, :Col3],),
            "Col1,Col2,Col3\n1,4,7\n2,5,8\n3,6,9\n"
        ),
        (
            default_table,
            (header=["Col1", "Col2", "Col3"],),
            "Col1,Col2,Col3\n1,4,7\n2,5,8\n3,6,9\n"
        ),
        (
            default_table,
            (bom=true,),
            "\xEF\xBB\xBFcol1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"
        ),
        (
            table_types,
            NamedTuple(),
            "col1,col2,col3,col4,col5,col6,col7,col8\ntrue,4.1,NaN,2017-01-01,2017-01-01T04:05:06.007,hey,hey,hey\nfalse,5.2,Inf,2018-01-01,2018-01-01T04:05:06.007,there,hey,hey\ntrue,4.0e10,-Inf,2019-01-01,2019-01-01T04:05:06.007,sailor,hey,hey\n"
        ),
        (
            default_table,
            (writeheader=false,),
            "1,4,7\n2,5,8\n3,6,9\n"
        ),
        (
            default_table,
            (writeheader=false,newline=""),
            "1,4,72,5,83,6,9"
        ),
        (
            default_table,
            (writeheader=false,newline="",delim="::"),
            "1::4::72::5::83::6::9"
        ),
        (
            (col4=[Date(2017, 1, 1), Date(2018, 1, 1), Date(2019, 1, 1)],
                col5=[DateTime(2017, 1, 1, 4, 5, 6, 7), DateTime(2018, 1, 1, 4, 5, 6, 7), DateTime(2019, 1, 1, 4, 5, 6, 7)],
            ),
            (dateformat="mm/dd/yyyy",),
            "col4,col5\n01/01/2017,01/01/2017\n01/01/2018,01/01/2018\n01/01/2019,01/01/2019\n"
        ),
        (
            (col1=[1,missing,3], col2=[missing, missing, missing], col3=[7,8,9]),
            NamedTuple(),
            "col1,col2,col3\n1,,7\n,,8\n3,,9\n"
        ),
        (
            (col1=[1,missing,3], col2=[missing, missing, missing], col3=[7,8,9]),
            (missingstring="NA",),
            "col1,col2,col3\n1,NA,7\nNA,NA,8\n3,NA,9\n"
        ),
        (
            (col1=[1,nothing,3], col2=[nothing, missing, missing], col3=[7,8,9]),
            (transform=(col, val) -> something(val, missing), missingstring="NA"),
            "col1,col2,col3\n1,NA,7\nNA,NA,8\n3,NA,9\n"
        ),
        (
            (col1=["hey, there, sailor", "this, also, has, commas", "this\n has\n newlines\n", "no quoting", "just a random \" quote character", ],),
            (escapechar='\\',),
            "col1\n\"hey, there, sailor\"\n\"this, also, has, commas\"\n\"this\n has\n newlines\n\"\nno quoting\n\"just a random \\\" quote character\"\n"
        ),
        (
            (col1=["\"hey there sailor\""],),
            (escapechar='\\',),
            "col1\n\"\\\"hey there sailor\\\"\"\n"
        ),
        (
            (col1=["{\"key\": \"value\"}", "{\"key\": null}"],),
            (openquotechar='{', closequotechar='}', escapechar='\\'),
            "col1\n{\\{\"key\": \"value\"\\}}\n{\\{\"key\": null\\}}\n"
        ),
        (
            default_table,
            (newline='\r',),
            "col1,col2,col3\r1,4,7\r2,5,8\r3,6,9\r"
        ),
        (
            default_table,
            (newline="\r\n",),
            "col1,col2,col3\r\n1,4,7\r\n2,5,8\r\n3,6,9\r\n"
        ),
        (
            default_table,
            (delim="::", newline="\r\n"),
            "col1::col2::col3\r\n1::4::7\r\n2::5::8\r\n3::6::9\r\n"
        ),
        (
            default_table,
            (delim="::", newline="\r"),
            "col1::col2::col3\r1::4::7\r2::5::8\r3::6::9\r"
        ),
        # quotedstrings: #362
        (
            (col1=[1,2,3], col2=["hey", "the::re", "::sailor"], col3=[7,8,9]),
            (delim="::", quotestrings=true),
            "\"col1\"::\"col2\"::\"col3\"\n1::\"hey\"::7\n2::\"the::re\"::8\n3::\"::sailor\"::9\n"
        ),
        (
            (col1=[1,2,3], col2=[4,5,6], col3=["hey \r\n there","sailor","ho"]),
            (delim="::", newline="\r\n"),
            "col1::col2::col3\r\n1::4::\"hey \r\n there\"\r\n2::5::sailor\r\n3::6::ho\r\n"
        ),
        (
            (col1=[1,2,3], col2=[4,5,6], col3=["hey \r\n there","sailor","ho"]),
            (delim="::", newline="\r\n", quotestrings=true),
            "\"col1\"::\"col2\"::\"col3\"\r\n1::4::\"hey \r\n there\"\r\n2::5::\"sailor\"\r\n3::6::\"ho\"\r\n"
        ),
        # custom float decimal: #385
        (
            (col1=[1.1,2.2,3.3], col2=[4,5,6], col3=[7,8,9]),
            (delim='\t', decimal=','),
            "col1\tcol2\tcol3\n1,1\t4\t7\n2,2\t5\t8\n3,3\t6\t9\n"
        ),
        # custom abstract float decimal: #1108
        (
            (col1=AF.([1.1,2.2,3.3]), col2=[4,5,6], col3=[7,8,9]),
            (delim='\t', decimal=','),
            "col1\tcol2\tcol3\n1,1\t4\t7\n2,2\t5\t8\n3,3\t6\t9\n"
        ),
        # issue 515
        (
            (col1=[""],),
            NamedTuple(),
            "col1\n\n"
        ),
        # issue 540
        (
            NamedTuple{(Symbol("col1,col2"),), Tuple{Vector{String}}}((["hey"],)),
            NamedTuple(),
            "\"col1,col2\"\nhey\n"
        ),
        # 568
        (
            [(a=big(1),)],
            NamedTuple(),
            "a\n1\n"
        ),
        # 756
        (
            Any[(a=1,)],
            NamedTuple(),
            "a\n1\n"
        ),
        # jcunwin
        (
            [StructType(Date("2021-12-01"), "string 1", 123.45), StructType(Date("2021-12-02"), "string 2", 456.78)],
            (header=["Date Column", "String Column", "Number Column"],),
            "Date Column,String Column,Number Column\n2021-12-01,string 1,123.45\n2021-12-02,string 2,456.78\n"
        ),
        # 1151
        (
            [(a=Int128(-170141183460469231731687303715884105728),
              b=big(-170141183460469231731687303715884105728),
              c=big(-170141183460469231731687303715884105729),)],
            NamedTuple(),
            "a,b,c\n-170141183460469231731687303715884105728,-170141183460469231731687303715884105728,-170141183460469231731687303715884105729\n"
        )
    ]

    io = IOBuffer()
    for case in testcases
        global x = case
        if :writeheader in keys(case[2])
            @test_deprecated case[1] |> CSV.write(io; case[2]...)
        else
            case[1] |> CSV.write(io; case[2]...)
        end
        @test String(take!(io)) == case[3]
        @test join(collect(CSV.RowWriter(case[1]; case[2]...))) == case[3]
    end

    @test_throws ErrorException (col1=[1,nothing,3], col2=[nothing, missing, missing], col3=[7,8,9]) |> CSV.write(io)

    default_table |> CSV.write(io)
    default_table |> CSV.write(io; append=false) # this is the default
    @test String(take!(io)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"

    default_table |> CSV.write(io)
    default_table |> CSV.write(io; append=true)
    @test String(take!(io)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n1,4,7\n2,5,8\n3,6,9\n"

    file = "test.csv"
    default_table |> CSV.write(file)
    @test String(read(file)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"
    rm(file)

    filepath = Path(file)
    default_table |> CSV.write(filepath)
    @test String(read(filepath)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"
    rm(filepath)

    open(file, "w") do io
        default_table |> CSV.write(io)
    end
    @test String(read(file)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"
    rm(file)

    # #247
    open(file, "w") do io
        write(io, "or5a2ztZo\n")
        @test_deprecated (A=1:3, B=[17, 17, 19], C=["Wg5", "SJ4", "w48"]) |> CSV.write(io; append=true, writeheader=true)
    end
    @test String(read(file)) == "or5a2ztZo\nA,B,C\n1,17,Wg5\n2,17,SJ4\n3,19,w48\n"
    rm(file)

    # unknown schema case
    opts = CSV.Options(UInt8(','), UInt8('"'), UInt8('"'), UInt8('"'), UInt8('\n'), UInt8('.'), nothing, false, (), (col,val)->val, true)
    rt = [(a=1, b=4.0, c=7), (a=2.0, b=missing, c="8"), (a=3, b=6.0, c="9")]
    CSV.write(nothing, rt, io, opts)
    @test String(take!(io)) == "\xEF\xBB\xBFa,b,c\n1,4.0,7\n2.0,,8\n3,6.0,9\n"

    opts = CSV.Options(UInt8(','), UInt8('"'), UInt8('"'), UInt8('"'), UInt8('\n'), UInt8('.'), nothing, false, (), (col,val)->val, false)
    io = IOBuffer()
    CSV.write(nothing, Tables.rows(default_table), io, opts)
    @test String(take!(io)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"

    rt = [(a=1, b=4.0, c=7), (a=2.0, b=missing, c="8"), (a=3, b=6.0, c="9")]
    CSV.write(nothing, rt, io, opts)
    @test String(take!(io)) == "a,b,c\n1,4.0,7\n2.0,,8\n3,6.0,9\n"

    CSV.write(nothing, Tables.rows((col1=Int[], col2=Float64[])), io, opts)
    @test String(take!(io)) == ""

    CSV.write(nothing, Tables.rows((col1=Int[], col2=Float64[])), io, opts; header=["col1", "col2"])
    @test String(take!(io)) == "col1,col2\n"

    # 280
    io = IOBuffer()
    CSV.write(io, (x=[',','\n', ','],))
    @test String(take!(io)) == "x\n\",\"\n\"\n\"\n\",\"\n"

    CSV.write(io, (x=['-'],y=['-']), delim='-')
    @test String(take!(io)) == "x-y\n\"-\"-\"-\"\n"

    CSV.write(io, (x= [[1 2; 3 4]],y=[[5 6; 7 8]]), delim=';')
    @test String(take!(io)) == "x;y\n\"[1 2; 3 4]\";\"[5 6; 7 8]\"\n"

    if !Sys.iswindows()
        try
            io = open("$file.gz", "w")
            open(`gzip`, "w", io) do f
                CSV.write(f, default_table)
            end
            run(`gunzip $file.gz`)
            @test String(read("$file")) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"
            rm(file)
        catch e
            @error "error running test" exception=(e, stacktrace(catch_backtrace()))
        end
    end

    # 357
    x1 = (ISBN=[9500286327, 671727680, 385333757], Book_Title=["Tres Mosqueteros, Los: Adaptacic\"n", "Romeo and Juliet", "Losing Julia"])
    CSV.write(  "x1.csv",  x1; delim=';' ,quotechar='"' ,escapechar='\\' )
    @test read("x1.csv", String) == "ISBN;Book_Title\n9500286327;\"Tres Mosqueteros, Los: Adaptacic\\\"n\"\n671727680;Romeo and Juliet\n385333757;Losing Julia\n"
    rm("x1.csv")

    # #137
    tbl = (a=[11,22], dt=[Date(2017,12,7), Date(2017,12,14)], dttm=[DateTime(2017,12,7), DateTime(2017,12,14)])
    io = IOBuffer()
    tbl |> CSV.write(io; delim='\t')
    seekstart(io)
    f = CSV.File(io; delim='\t')
    @test (f |> columntable) == tbl

    # validate char args: #369
    @test_throws ArgumentError default_table |> CSV.write(io; escapechar='☃')

    # write to stdout: #465
    old_stdout = stdout
    (rd, wr) = redirect_stdout()
    try
        default_table |> CSV.write(stdout)
    finally
        redirect_stdout(old_stdout)
        try
            close(wr)
        catch
        end
    end
    @test read(rd, String) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"

    df = (A=[1,2,3], B=["a", "b", "c"])
    # test control character delimiters
    for char ∈ Char.(UInt8[1,2,3,4])
        io = IOBuffer()
        CSV.write(io, df, delim=char)
        seekstart(io)
        @test columntable(CSV.File(io, delim=char)) == df
    end
    # don't allow writing with delimiters we refuse to read
    @test_throws ArgumentError CSV.write(io, df, delim='\r')

    # test with FilePath
    mktmpdir() do tmp
        CSV.write(tmp / "test.txt", df)
        @test columntable(CSV.File(tmp / "test.txt")) == df
    end

    io = Base.BufferStream()
    CSV.write(io, (a=[1,2,3], b=[4.1, 5.2, 6.3]))
    close(io)
    @test read(io, String) == "a,b\n1,4.1\n2,5.2\n3,6.3\n"

    # https://github.com/JuliaData/CSV.jl/issues/643
    s = join(1:1000000);
    @test_throws ArgumentError CSV.write("out.test.csv", [(a=s,)])

    # https://github.com/JuliaData/CSV.jl/issues/691
    io = IOBuffer()
    CSV.write(io, Tuple[(1,), (2,)], header=false)
    @test String(take!(io)) == "1\n2\n"

    # partition writing
    io = IOBuffer()
    io2 = IOBuffer()
    CSV.write([io, io2], Tables.partitioner((default_table, default_table)); partition=true)
    @test String(take!(io)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"
    @test String(take!(io2)) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"

    # compressed writing to IOBuffer
    # Verify that data is written (issue #1177 fix)
    io = IOBuffer()
    CSV.write(io, default_table; compress=true)
    @test isopen(io)  # IOBuffer should not be closed
    data = take!(io)
    @test length(data) > 0  # data should be written
    @test data[1] == 0x1f && data[2] == 0x8b  # gzip magic bytes
    # Verify data decompresses correctly
    decompressed = transcode(GzipDecompressor, data)
    @test String(decompressed) == "col1,col2,col3\n1,4,7\n2,5,8\n3,6,9\n"

    # compressed writing to file
    mktempdir() do dir
        path = joinpath(dir, "test.csv.gz")
        CSV.write(path, default_table; compress=true)
        ct = CSV.read(path, Tables.columntable)
        @test ct == default_table
    end

    # CSV.writerow
    row = (a=1, b=2.3, c="hey", d=Date(2022, 5, 4))
    str = CSV.writerow(row)
    @test str == "1,2.3,hey,2022-05-04\n"
    io = IOBuffer()
    CSV.writerow(io, row)
    @test String(take!(io)) == "1,2.3,hey,2022-05-04\n"
    str = CSV.writerow(row; delim='\t')
    @test str == "1\t2.3\they\t2022-05-04\n"

    # CSV.writebom
    # https://github.com/JuliaData/CSV.jl/pull/1179
    @test CSV.writebom(UInt8[1,2,3], 2, 1, IOBuffer()) isa Int

end # @testset "CSV.write"

"""
Internal structure used to track information for a single column in a delimited file.

Fields:
  * `type`: always a single, concrete type; no Union{T, Missing}; missingness is tracked in anymissing field; this field is mutable; it may start as one type and get "promoted" to another while parsing; two special types exist: `NeedsTypeDetection`, which specifies that we need to try and detect what type this column's values are and `HardMissing` which means the column type is definitely `Missing` and we don't need to detect anything; to get the "final type" of a column after parsing, call `CSV.coltype(col)`, which takes into account `anymissing`
  * `anymissing`: whether any missing values have been encountered while parsing; if a user provided a type like `Union{Int, Missing}`, we'll set this to `true`, or when `missing` values are encountered while parsing
  * `userprovidedtype`: whether the column type was provided by the user or not; this affects whether we'll promote a column's type while parsing, or emit a warning/error depending on `strict` keyword arg
  * `willdrop`: whether we'll drop this column from the final columnset; computed from select/drop keyword arguments; this will result in a column type of `HardMissing` while parsing, where an efficient parser is used to "skip" a field w/o allocating any parsed value
  * `pool`: computed from `pool` keyword argument; `true` is `1.0`, `false` is `0.0`, everything else is `Float64(pool)`; once computed, this field isn't mutated at all while parsing; it's used in type detection to determine whether a column will be pooled or not once a type is detected;
  * `columnspecificpool`: if `pool` was provided via Vector or Dict by user, then `true`, other `false`; if `false`, then only string column types will attempt pooling
  * `column`: the actual column vector to hold parsed values; field is typed as `AbstractVector` and while parsing, we do switches on `col.type` to assert the column type to make code concretely typed
  * `lock`: in multithreaded parsing, we have a top-level set of `Vector{Column}`, then each threaded parsing task makes its own copy to parse its own chunk; when synchronizing column types/pooled refs, the task-local `Column` will `lock(col.lock)` to make changes to the parent `Column`; each task-local `Column` shares the same `lock` of the top-level `Column`
  * `position`: for transposed reading, the current column position
  * `startposition`: for transposed reading, the starting position for this column
  * `endposition`: for transposed reading, the expected ending position for this column
"""
mutable struct Column
    # fields that are copied per task when parsing
    type::Type
    anymissing::Bool
    userprovidedtype::Bool
    willdrop::Bool
    pool::Union{Float64, Tuple{Float64, Int}}
    columnspecificpool::Bool
    # lazily/manually initialized fields
    column::AbstractVector
    # per top-level column fields (don't need to copy per task when parsing)
    lock::ReentrantLock
    position::Int
    startposition::Int
    endposition::Int
    options::Parsers.Options

    Column(type::Type, anymissing::Bool, userprovidedtype::Bool, willdrop::Bool, pool::Union{Float64, Tuple{Float64, Int}}, columnspecificpool::Bool) =
        new(type, anymissing, userprovidedtype, willdrop, pool, columnspecificpool)
end

function Column(type::Type, options::Union{Parsers.Options, Nothing}=nothing)
    T = nonmissingtypeunlessmissingtype(type)
    col = Column(type === Missing ? HardMissing : T,
        type >: Missing,
        type !== NeedsTypeDetection,
        false, NaN, false)
    if options !== nothing
        col.options = options
    end
    return col
end

# creating a per-task column from top-level column
function Column(x::Column)
    @assert isdefined(x, :lock)
    y = Column(x.type, x.anymissing, x.userprovidedtype, x.willdrop, x.pool, x.columnspecificpool)
    y.lock = x.lock # parent and child columns _share_ the same lock
    if isdefined(x, :options)
        y.options = x.options
    end
    # specifically _don't_ copy/re-use x.column; that needs to be allocated fresh per parsing task
    return y
end

"""
    isvaliddelim(delim)

Whether a character or string is valid for use as a delimiter.
"""
isvaliddelim(delim) = false
isvaliddelim(delim::Char) = delim != '\r' && delim != '\n' && delim != '\0'
isvaliddelim(delim::AbstractString) = all(isvaliddelim, delim)

"""
    checkvaliddelim(delim)

Checks whether a character or string is valid for use as a delimiter.  If
`delim` is `nothing`, it is assumed that the delimiter will be auto-selected.
Throws an error if `delim` is invalid.
"""
function checkvaliddelim(delim)
    delim !== nothing && !isvaliddelim(delim) &&
        throw(ArgumentError("invalid delim argument = '$(escape_string(string(delim)))', "*
                            "the following delimiters are invalid: '\\r', '\\n', '\\0'"))
end

function checkinvalidcolumns(dict::AbstractDict, argname, ncols, names)
    for (k, _) in dict
        if k isa Integer
            (0 < k <= ncols) || throw(ArgumentError("invalid column number provided in `$argname` keyword argument: $k. Column number must be 0 < i <= $ncols as detected in the data. To ignore invalid columns numbers in `$argname`, pass `validate=false`"))
        else
            isvalid = (k isa Regex && any(nm -> contains(string(nm), k), names)) || Symbol(k) in names
            isvalid || throw(ArgumentError("invalid column name provided in `$argname` keyword argument: $k. Valid column names detected in the data are: $names. To ignore invalid columns names in `$argname`, pass `validate=false`"))
        end
    end
    return nothing
end
function checkinvalidcolumns(vec::AbstractVector, argname, ncols, names)
    # we generally expect `length(types) == ncols` but still want to support the case where
    # an additional column is found later in the file and e.g. has its type given in `types`
    length(vec) >= ncols || throw(ArgumentError("provided `$argname::AbstractVector` keyword argument doesn't match detected # of columns: `$(length(vec)) < $ncols`"))
    return nothing
end
# if the argument isn't given as an AbstractDict or an AbstractVector then
# we have no way to check it again the number of cols or the names
checkinvalidcolumns(arg::Any, argname, ncols, names) = nothing

@noinline nonconcretetypes(types) = throw(ArgumentError("Non-concrete types passed in `types` keyword argument, please provide concrete types for columns: $types"))

# Create all the `Column`s and keep track of any non-standard eltypes for which we will
# later need generate specialized parsing methods.
# - `ncols` is the number of columns to create
# - `types` is the user-given input
function initialize_columns(ncols::Int, types, names, args...; validate)
    columns = Vector{Column}(undef, ncols)
    customtypes = Tuple{}
    validate && checkinvalidcolumns(types, "types", ncols, names)
    for i = 1:ncols
        col = initialize_column(i, types, names, args...)
        columns[i] = col
        if nonstandardtype(col.type) !== Union{}
            customtypes = tupcat(customtypes, nonstandardtype(col.type))
        end
    end
    return columns, customtypes
end

# Create a `Column` with their eltype set using any user-provided types,
# but without yet allocating a vector to hold the parsed results (see `allocate`)
# - `i` is the column number e.g. i=1 for the 1st column.
# - `types` is the user-given input
function initialize_column(i, types, names, stringtype, streaming::Bool, options)
    T = initial_column_type(i, types, names, stringtype, streaming::Bool)
    return Column(T, options)
end

function initial_column_type(i, types::AbstractVector, _, _, ::Bool)
    # we generally expected `length(types) == ncols` but we still want to support the case
    # where an additional column is found later in the file and wasn't in `types`
    i <= length(types) ? types[i] : NeedsTypeDetection
end

function initial_column_type(i, types::AbstractDict, names, stringtype, streaming::Bool)
    defaultT = streaming ? Union{stringtype, Missing} : NeedsTypeDetection
    # if an additional column is found while parsing, it will not have a name yet
    nm = i <= length(names) ? names[i] : ""
    getordefault(types, nm, i, defaultT)
end

function initial_column_type(i, types::Function, names, stringtype, streaming::Bool)
    defaultT = streaming ? Union{stringtype, Missing} : NeedsTypeDetection
    # if an additional column is found while parsing, it will not have a name yet
    nm = i <= length(names) ? names[i] : ""
    something(types(i, nm), defaultT)
end

function initial_column_type(_, ::Nothing, _, stringtype, streaming::Bool)
    streaming ? Union{stringtype, Missing} : NeedsTypeDetection
end

function initial_column_type(_, types::Type, _, _, ::Bool)
    types
end

function reinitialize_column_type!(columns, types, names, stringtype, streaming)
    for (i, col) in pairs(columns)
        col.type = initial_column_type(i, types, names, stringtype, streaming)
    end
end

mutable struct Context
    transpose::Bool
    name::String
    names::Vector{Symbol}
    rowsguess::Int
    cols::Int
    buf::Vector{UInt8}
    datapos::Int
    len::Int
    datarow::Int
    options::Parsers.Options
    columns::Vector{Column}
    pool::Union{Float64, Tuple{Float64, Int}}
    downcast::Bool
    customtypes::Type
    typemap::IdDict{Type, Type}
    stringtype::StringTypes
    limit::Int
    threaded::Bool
    ntasks::Int
    chunkpositions::Vector{Int}
    strict::Bool
    silencewarnings::Bool
    maxwarnings::Int
    debug::Bool
    tempfile::Union{String, Nothing}
    streaming::Bool
    types::Union{Nothing, Type, AbstractVector, AbstractDict, Function}
end

function initialize_column(i, ctx::Context)
    return initialize_column(i, ctx.types, ctx.names, ctx.stringtype, ctx.streaming, ctx.options)
end

# user-facing function if just the context is desired
function Context(source::ValidSources;
    # file options
    # header can be a row number, range of rows, or actual string vector
    header::Union{Integer, Vector{Symbol}, Vector{String}, AbstractVector{<:Integer}}=1,
    normalizenames::Bool=false,
    # by default, data starts immediately after header or start of file
    datarow::Integer=-1,
    skipto::Integer=-1,
    footerskip::Integer=0,
    transpose::Bool=false,
    comment::Union{String, Nothing}=nothing,
    ignoreemptyrows::Bool=true,
    ignoreemptylines=nothing,
    select=nothing,
    drop=nothing,
    limit::Union{Integer, Nothing}=nothing,
    buffer_in_memory::Bool=false,
    threaded::Union{Bool, Nothing}=nothing,
    ntasks::Union{Nothing, Integer}=nothing,
    tasks::Union{Nothing, Integer}=nothing,
    rows_to_check::Integer=DEFAULT_ROWS_TO_CHECK,
    lines_to_check=nothing,
    # parsing options
    missingstrings=String[],
    missingstring="",
    delim::Union{Nothing, Char, String}=nothing,
    ignorerepeated::Bool=false,
    quoted::Bool=true,
    quotechar::Union{UInt8, Char}='"',
    openquotechar::Union{UInt8, Char, Nothing}=nothing,
    closequotechar::Union{UInt8, Char, Nothing}=nothing,
    escapechar::Union{UInt8, Char}='"',
    dateformat::Union{String, Dates.DateFormat, Nothing, AbstractDict}=nothing,
    dateformats=nothing,
    decimal::Union{UInt8, Char}=UInt8('.'),
    groupmark::Union{Char, Nothing}=nothing,
    truestrings::Union{Vector{String}, Nothing}=TRUE_STRINGS,
    falsestrings::Union{Vector{String}, Nothing}=FALSE_STRINGS,
    stripwhitespace::Bool=false,
    # type options
    type=nothing,
    types=nothing,
    typemap::AbstractDict=IdDict{Type, Type}(),
    pool=DEFAULT_POOL,
    downcast::Bool=false,
    lazystrings::Bool=false,
    stringtype::StringTypes=DEFAULT_STRINGTYPE,
    strict::Bool=false,
    silencewarnings::Bool=false,
    maxwarnings::Int=DEFAULT_MAX_WARNINGS,
    debug::Bool=false,
    parsingdebug::Bool=false,
    validate::Bool=true,
    )
    return @refargs Context(source, header, normalizenames, datarow, skipto, footerskip, transpose, comment, ignoreemptyrows, ignoreemptylines, select, drop, limit, buffer_in_memory, threaded, ntasks, tasks, rows_to_check, lines_to_check, missingstrings, missingstring, delim, ignorerepeated, quoted, quotechar, openquotechar, closequotechar, escapechar, dateformat, dateformats, decimal, groupmark, truestrings, falsestrings, stripwhitespace, type, types, typemap, pool, downcast, lazystrings, stringtype, strict, silencewarnings, maxwarnings, debug, parsingdebug, validate, false)
end

@refargs function Context(source::ValidSources,
    # file options
    # header can be a row number, range of rows, or actual string vector
    header::Union{Integer, Vector{Symbol}, Vector{String}, AbstractVector{<:Integer}},
    normalizenames::Bool,
    datarow::Integer,
    skipto::Integer,
    footerskip::Integer,
    transpose::Bool,
    comment::Union{String, Nothing},
    ignoreemptyrows::Bool,
    ignoreemptylines::Union{Nothing, Bool},
    select,
    drop,
    limit::Union{Integer, Nothing},
    buffer_in_memory::Bool,
    threaded::Union{Nothing, Bool},
    ntasks::Union{Nothing, Integer},
    tasks::Union{Nothing, Integer},
    rows_to_check::Integer,
    lines_to_check::Union{Nothing, Integer},
    # parsing options
    missingstrings::Union{Nothing, String, Vector{String}},
    missingstring::Union{Nothing, String, Vector{String}},
    delim::Union{Nothing, UInt8, Char, String},
    ignorerepeated::Bool,
    quoted::Bool,
    quotechar::Union{UInt8, Char},
    openquotechar::Union{Nothing, UInt8, Char},
    closequotechar::Union{Nothing, UInt8, Char},
    escapechar::Union{UInt8, Char},
    dateformat::Union{Nothing, String, Dates.DateFormat, Parsers.Format, AbstractVector, AbstractDict},
    dateformats::Union{Nothing, String, Dates.DateFormat, Parsers.Format, AbstractVector, AbstractDict},
    decimal::Union{UInt8, Char},
    groupmark::Union{Char, Nothing},
    truestrings::Union{Nothing, Vector{String}},
    falsestrings::Union{Nothing, Vector{String}},
    stripwhitespace::Bool,
    # type options
    type::Union{Nothing, Type},
    types::Union{Nothing, Type, AbstractVector, AbstractDict, Function},
    typemap::AbstractDict,
    pool::Union{Bool, Real, AbstractVector, AbstractDict, Base.Callable, Tuple},
    downcast::Bool,
    lazystrings::Bool,
    stringtype::StringTypes,
    strict::Bool,
    silencewarnings::Bool,
    maxwarnings::Integer,
    debug::Bool,
    parsingdebug::Bool,
    validate::Bool,
    streaming::Bool)

    # initial argument validation and adjustment
    @inbounds begin
    ((source isa AbstractString || source isa AbstractPath) && !isfile(source)::Bool) && throw(ArgumentError("\"$source\" is not a valid file or doesn't exist"))
    if types !== nothing
        if types isa AbstractVector
            any(x->!concrete_or_concreteunion(x), types) && nonconcretetypes(types)
        elseif types isa AbstractDict
            typs = values(types)
            any(x->!concrete_or_concreteunion(x), typs) && nonconcretetypes(typs)
        elseif types isa Type
            concrete_or_concreteunion(types) || nonconcretetypes(types)
        end
    end
    checkvaliddelim(delim)
    ignorerepeated && delim === nothing && throw(ArgumentError("auto-delimiter detection not supported when `ignorerepeated=true`; please provide delimiter like `delim=','`"))
    if lazystrings && !streaming
        @warn "`lazystrings` keyword argument is deprecated; use `stringtype=PosLenString` instead"
        stringtype = PosLenString
    end
    if tasks !== nothing
        @warn "`tasks` keyword argument is deprecated; use `ntasks` instead"
        ntasks = tasks
    end
    if ignoreemptylines !== nothing
        @warn "`ignoreemptylines` keyword argument is deprecated; use `ignoreemptyrows` instead"
        ignoreemptyrows = ignoreemptylines
    end
    if lines_to_check !== nothing
        @warn "`lines_to_check` keyword argument is deprecated; use `rows_to_check` instead"
        rows_to_check = lines_to_check
    end
    if !isempty(missingstrings)
        @warn "`missingstrings` keyword argument is deprecated; pass a `Vector{String}` to `missingstring` instead"
        missingstring = missingstrings
    end
    if dateformats !== nothing
        @warn "`dateformats` keyword argument is deprecated; pass column date formats to `dateformat` keyword argument instead"
        dateformat = dateformats
    end
    if datarow != -1
        @warn "`datarow` keyword argument is deprecated; use `skipto` instead"
        skipto = datarow
    end
    if type !== nothing
        @warn "`type` keyword argument is deprecated; a single type can be passed to `types` instead"
        types = type
    end
    if threaded !== nothing
        @warn "`threaded` keyword argument is deprecated; to avoid multithreaded parsing, pass `ntasks=1`"
        ntasks = threaded ? Threads.nthreads() : 1
    end
    if header isa Integer
        if header == 1 && skipto == 1
            header = -1
        elseif skipto != -1 && skipto < header
            throw(ArgumentError("skipto row ($skipto) must come after header row ($header)"))
        end
    end
    if skipto == -1
        if isa(header, Vector{Symbol}) || isa(header, Vector{String})
            skipto = 0
        elseif header isa Integer
            # by default, data starts on line after header
            skipto = header + 1
        elseif header isa AbstractVector{<:Integer}
            skipto = last(header) + 1
        end
    end
    debug && println("header is: $header, skipto computed as: $skipto")
    # getsource will turn any input into a `AbstractVector{UInt8}`
    buf, pos, len, tempfile = getsource(source, buffer_in_memory)
    if len > MAX_INPUT_SIZE
        throw(ArgumentError("delimited source to parse too large; must be < $MAX_INPUT_SIZE bytes"))
    end
    # skip over initial BOM character, if present
    pos = consumeBOM(buf, pos, len)

    oq = something(openquotechar, quotechar) % UInt8
    eq = escapechar % UInt8
    cq = something(closequotechar, quotechar) % UInt8
    trues = truestrings === nothing ? nothing : truestrings
    falses = falsestrings === nothing ? nothing : falsestrings
    sentinel = missingstring === nothing ? missingstring : (isempty(missingstring) || (missingstring isa Vector && length(missingstring) == 1 && missingstring[1] == "")) ? missing : missingstring isa String ? [missingstring] : missingstring

    if delim === nothing
        if source isa AbstractString || source isa AbstractPath
            filename = string(source)
            del = endswith(filename, ".tsv") ? UInt8('\t') : endswith(filename, ".wsv") ? UInt8(' ') : UInt8('\n')
        else
            del = UInt8('\n')
        end
    else
        del = (delim isa Char && isascii(delim)) ? delim % UInt8 :
            (sizeof(delim) == 1 && isascii(delim)) ? delim[1] % UInt8 : delim
    end
    cmt = comment === nothing ? nothing : (pointer(comment), sizeof(comment))

    if footerskip > 0 && pos <= len
        lastbyte = buf[len]
        endpos = (lastbyte == UInt8('\r') || lastbyte == UInt8('\n')) +
            (lastbyte == UInt8('\n') && len > pos && buf[len - 1] == UInt8('\r'))
        revbuf = ReversedBuf(buf, pos, len)
        revbuflen = length(revbuf)
        rows_to_skip = footerskip
        revlen = 0
        while true
            revlen = skiptorow(revbuf, 1 + endpos, revbuflen, oq, eq, cq, nothing, ignoreemptyrows, 0, rows_to_skip) - 2
            comments = countcomments(buf, len - revlen + 1, len, oq, eq, cq, cmt)
            adjusted_rows_to_skip = footerskip + comments
            rows_to_skip == adjusted_rows_to_skip && break
            rows_to_skip = adjusted_rows_to_skip > rows_to_skip ?
                max(adjusted_rows_to_skip, 2 * rows_to_skip) :
                adjusted_rows_to_skip
        end
        len -= revlen
        debug && println("adjusted for footerskip, len = $(len + revlen - 1) => $len")
    end

    df = dateformat isa AbstractVector || dateformat isa AbstractDict ? nothing : dateformat
    wh1 = UInt8(' ')
    wh2 = UInt8('\t')
    if sentinel isa Vector
        for sent in sentinel
            if contains(sent, " ")
                wh1 = 0x00
            end
            if contains(sent, "\t")
                wh2 = 0x00
            end
        end
    end
    headerpos = datapos = pos
    if !transpose
        # step 1: detect the byte position where the column names start (headerpos)
        # and where the first data row starts (datapos)
        headerpos, datapos = detectheaderdatapos(buf, pos, len, oq, eq, cq, cmt, ignoreemptyrows, header, skipto)
        debug && println("headerpos = $headerpos, datapos = $datapos")
    end
    # step 2: detect delimiter (or use given) and detect number of (estimated) rows and columns
    # step 3: build Parsers.Options w/ parsing arguments
    if del isa UInt8
        d, rowsguess = detectdelimandguessrows(buf, headerpos, datapos, len, oq, eq, cq, cmt, ignoreemptyrows, del)
        wh1 = d == UInt(' ') ? 0x00 : wh1
        wh2 = d == UInt8('\t') ? 0x00 : wh2
        options = Parsers.Options(sentinel, wh1, wh2, oq, cq, eq, d, decimal, trues, falses, df, ignorerepeated, ignoreemptyrows, comment, quoted, parsingdebug, stripwhitespace, false, groupmark)
    elseif del isa Char
        _, rowsguess = detectdelimandguessrows(buf, headerpos, datapos, len, oq, eq, cq, cmt, ignoreemptyrows)
        options = Parsers.Options(sentinel, wh1, wh2, oq, cq, eq, del, decimal, trues, falses, df, ignorerepeated, ignoreemptyrows, comment, quoted, parsingdebug, stripwhitespace, false, groupmark)
        d = del
    elseif del isa String
        _, rowsguess = detectdelimandguessrows(buf, headerpos, datapos, len, oq, eq, cq, cmt, ignoreemptyrows)
        options = Parsers.Options(sentinel, wh1, wh2, oq, cq, eq, del, decimal, trues, falses, df, ignorerepeated, ignoreemptyrows, comment, quoted, parsingdebug, stripwhitespace, false, groupmark)
        d = del
    else
        error("invalid delim type")
    end
    debug && println("estimated rows: $rowsguess")
    debug && println("detected delimiter: \"$(escape_string(d isa UInt8 ? string(Char(d)) : d))\"")

    if !transpose
        # step 4a: if we're ignoring repeated delimiters, then we ignore any
        # that start a row, so we need to check if we need to adjust our headerpos/datapos
        if ignorerepeated
            if headerpos > 0
                headerpos = Parsers.checkdelim!(buf, headerpos, len, options)
            end
            datapos = Parsers.checkdelim!(buf, datapos, len, options)
        end

        # step 4b: generate or parse column names
        names = detectcolumnnames(buf, headerpos, datapos, len, options, header, normalizenames, oq, eq, cq, cmt, ignoreemptyrows)
        ncols = length(names)
    else
        # transpose
        rowsguess, names, positions, endpositions = detecttranspose(buf, pos, len, options, header, skipto, normalizenames)
        ncols = length(names)
        datapos = isempty(positions) ? 0 : positions[1]
    end
    debug && println("column names detected: $names")
    debug && println("byte position of data computed at: $datapos")

    # generate initial columns
    columns, customtypes = initialize_columns(ncols, types, names, stringtype, streaming, options; validate=validate)
    if transpose
        # set column positions
        for i = 1:ncols
            col = columns[i]
            col.position = positions[i]
            col.startposition = positions[i]
            col.endposition = endpositions[i]
        end
    end
    # check for nonstandard types in typemap
    typemap = convert(IdDict{Type, Type}, typemap)::IdDict{Type, Type}
    for T in values(typemap)
        if nonstandardtype(T) !== Union{}
            customtypes = tupcat(customtypes, nonstandardtype(T))
        end
    end

    # generate column options if applicable
    if dateformat isa AbstractDict
        for i = 1:ncols
            df = getordefault(dateformat, names[i], i, nothing)
            # devdoc: if we want to add any other column-specific parsing options, this is where we'd at the logic
            # e.g. per-column sentinel, decimal, trues, falses, openquotechar, closequotechar, escapechar, etc.
            if df !== nothing
                columns[i].options = Parsers.Options(sentinel, wh1, wh2, oq, cq, eq, d, decimal, trues, falses, df, ignorerepeated, ignoreemptyrows, comment, true, parsingdebug, stripwhitespace, false, groupmark)
            end
        end
        validate && checkinvalidcolumns(dateformat, "dateformat", ncols, names)
    end

    # pool keyword
    finalpool = 0.0
    if !streaming
        if pool isa AbstractVector
            length(pool) == ncols || throw(ArgumentError("provided `pool::AbstractVector` keyword argument doesn't match detected # of columns: `$(length(pool)) != $ncols`"))
            for i = 1:ncols
                col = columns[i]
                col.pool = getpool(pool[i])
                col.columnspecificpool = true
            end
        elseif pool isa AbstractDict
            for i = 1:ncols
                col = columns[i]
                p = getordefault(pool, names[i], i, NaN)
                if !isnan(p)
                    col.pool = getpool(p)
                    col.columnspecificpool = true
                end
            end
            validate && checkinvalidcolumns(pool, "pool", ncols, names)
        elseif pool isa Base.Callable
            for i = 1:ncols
                col = columns[i]
                p = pool(i, names[i])
                if p !== nothing
                    col.pool = getpool(p)
                    col.columnspecificpool = true
                end
            end
        else
            finalpool = getpool(pool)
            for col in columns
                col.pool = finalpool
            end
        end
    end

    # figure out if we'll drop any columns while parsing
    if select !== nothing && drop !== nothing
        throw(ArgumentError("`select` and `drop` keywords were both provided; only one or the other is allowed"))
    elseif select !== nothing
        if select isa AbstractVector{Bool}
            for i = 1:ncols
                select[i] || willdrop!(columns, i)
            end
        elseif select isa AbstractVector{<:Integer}
            for i = 1:ncols
                i in select || willdrop!(columns, i)
            end
        elseif select isa AbstractVector{Symbol} || select isa AbstractVector{<:AbstractString}
            select = map(Symbol, select)
            for i = 1:ncols
                names[i] in select || willdrop!(columns, i)
            end
        elseif select isa Base.Callable
            for i = 1:ncols
                select(i, names[i])::Bool || willdrop!(columns, i)
            end
        else
            throw(ArgumentError("`select` keyword argument must be an `AbstractVector` of `Int`, `Symbol`, `String`, or `Bool`, or a selector function of the form `(i, name) -> keep::Bool`"))
        end
    elseif drop !== nothing
        if drop isa AbstractVector{Bool}
            for i = 1:ncols
                drop[i] && willdrop!(columns, i)
            end
        elseif drop isa AbstractVector{<:Integer}
            for i = 1:ncols
                i in drop && willdrop!(columns, i)
            end
        elseif drop isa AbstractVector{Symbol} || drop isa AbstractVector{<:AbstractString}
            drop = map(Symbol, drop)
            for i = 1:ncols
                names[i] in drop && willdrop!(columns, i)
            end
        elseif drop isa Base.Callable
            for i = 1:ncols
                drop(i, names[i])::Bool && willdrop!(columns, i)
            end
        else
            throw(ArgumentError("`drop` keyword argument must be an `AbstractVector` of `Int`, `Symbol`, `String`, or `Bool`, or a selector function of the form `(i, name) -> keep::Bool`"))
        end
    end
    debug && println("computed types are: $types")

    # determine if we can use threads while parsing
    limit = something(limit, typemax(Int))
    minrows = min(limit, rowsguess)
    nthreads = Int(something(ntasks, Threads.nthreads()))
    if ntasks === nothing && !streaming && nthreads > 1 && !transpose && minrows > (nthreads * 5) && (minrows * ncols) >= 5_000
        threaded = true
        ntasks = nthreads
    elseif ntasks !== nothing && ntasks > 1
        threaded = true
        if transpose
            @warn "`ntasks > 1` not supported on transposed files"
            threaded = false
            ntasks = 1
        elseif minrows < (nthreads * 5)
            @warn "`ntasks > 1` but there were not enough estimated rows ($minrows) to justify multithreaded parsing"
            threaded = false
            ntasks = 1
        end
    else
        threaded = false
        ntasks = 1
    end
    # attempt to chunk up a file for multithreaded parsing; there's chance we can't figure out how to accurately chunk
    # due to quoted fields, so threaded might get set to false
    if threaded
        # when limiting w/ multithreaded parsing, we try to guess about where in the file the limit row # will be
        # then adjust our final file len to the end of that row
        # we add some cushion so we hopefully get the limit row correctly w/o shooting past too far and needing to resize! down
        # but we also don't guarantee limit will be exact w/ multithreaded parsing
        origrowsguess = rowsguess
        if limit !== typemax(Int)
            limit = Int(limit)
            limitposguess = ceil(Int, (limit / (origrowsguess * 0.8)) * len)
            if limitposguess < len
                newlen = [0, limitposguess, min(limitposguess * 2, len)]
                findchunkrowstart(newlen, 2, buf, options, typemap, downcast, ncols, 5, columns, Type[col.type for col in columns], ReentrantLock(), stringtype, Threads.Atomic{Int}(0), Threads.Atomic{Int}(0), Threads.Atomic{Bool}(true))
                len = newlen[2] - 1
                reinitialize_column_type!(columns, types, names, stringtype, streaming)
                origrowsguess = limit
            end
            debug && println("limiting, adjusting len to $len")
        end
        chunksize = div(len - datapos, ntasks)
        chunkpositions = [datapos + chunksize * i for i in 0:ntasks]
        chunkpositions[end] = len
        debug && println("initial byte positions before adjusting for start of rows: $chunkpositions")
        avgbytesperrow, successfullychunked = findrowstarts!(buf, options, chunkpositions, ncols, columns, stringtype, typemap, downcast, rows_to_check)
        ntasks = length(chunkpositions) - 1
        if successfullychunked
            origbytesperrow = ((len - datapos) / origrowsguess)
            weightedavgbytesperrow = ceil(Int, avgbytesperrow * ((ntasks - 1) / ntasks) + origbytesperrow * (1 / ntasks))
            rowsguess = ceil(Int, ((len - datapos) / weightedavgbytesperrow) * 1.01)
            debug && println("single-threaded estimated rows = $origrowsguess, multi-threaded estimated rows = $rowsguess")
            debug && println("multi-threaded column types sampled as: $columns")
        else
            # The following debug statement is doubled by a loud @warning or @error in parsefilechunk!
            debug && println("multi-threaded parsing failed! Falling back to single thread, reinitializing column types.")
            reinitialize_column_type!(columns, types, names, stringtype, streaming)
            threaded = false # the failing is signaled by having !ctx.threaded && ctx.ntasks > 1
        end
    end
    if !threaded
        chunkpositions = EMPTY_INT_ARRAY
        if limit < rowsguess
            rowsguess = limit
        end
    end

    end # @inbounds begin
    return Context(
        transpose,
        getname(source),
        names,
        rowsguess,
        ncols,
        buf,
        datapos,
        len,
        skipto,
        options,
        columns,
        finalpool,
        downcast,
        customtypes,
        typemap,
        stringtype,
        limit,
        threaded,
        ntasks,
        chunkpositions,
        strict,
        silencewarnings,
        maxwarnings,
        debug,
        tempfile,
        streaming,
        types,
    )
end

using PrecompileTools

@setup_workload begin
    # Putting some things in `setup` can reduce the size of the
    # precompile file and potentially make loading faster.
    PRECOMPILE_DATA = "int,float,date,datetime,bool,null,str,catg,int_float\n1,3.14,2019-01-01,2019-01-01T01:02:03,true,,hey,abc,2\n2,NaN,2019-01-02,2019-01-03T01:02:03,false,,there,abc,3.14\n"
    @compile_workload begin
        # all calls in this block will be precompiled, regardless of whether
        # they belong to your package or not (on Julia 1.8 and higher)
        CSV.File(IOBuffer(PRECOMPILE_DATA))
        CSV.File(Vector{UInt8}(PRECOMPILE_DATA))
    end
end

precompile(CSV.File, (String,))

using PrecompileTools

const PRECOMPILE_DATA = """"int,float,date,datetime,bool,null,str,catg,int_float
1,3.14,2019-01-01,2019-01-01T01:02:03,true,,hey,abc,2
2,NaN,2019-01-02,2019-01-03T01:02:03,false,,there,abc,3.14
"""

@compile_workload begin
    CSV.Context(IOBuffer(PRECOMPILE_DATA))
    collect(CSV.Rows(IOBuffer(PRECOMPILE_DATA)))

    # Use promotions.csv from src/ directory for precompilation
    collect(CSV.File(joinpath(dirname(pathof(CSV)), "promotions.csv")))

    CSV.read(IOBuffer(PRECOMPILE_DATA), Tables.dictcolumntable)

    table = Tables.dictcolumntable(Dict(
        :a => ["foo", "bar"],
        :b => [1, 2],
        :c => [1.0, NaN],
        :d => [true, false],
        :e => [Dates.today(), Dates.today()],
        :f => [Dates.now(), Dates.now()],
    ))
    CSV.write(IOBuffer(), table)
end

# generates precompile.jl files
using CSV, Parsers, SentinelArrays, SnoopCompile

const dir = joinpath(dirname(pathof(CSV)), "..", "test", "testfiles")

timings = @snoopi tmin=0.001 begin

f = CSV.File(joinpath(dir, "precompile.csv"))
f = CSV.File(joinpath(dir, "precompile_small.csv"))

end # @snoopi

pc = SnoopCompile.parcel(timings)
precom = joinpath(dirname(pathof(CSV)), "..", "precompile")
SnoopCompile.write(precom, pc)
mv(joinpath(precom, "precompile_CSV.jl"), joinpath(dirname(pathof(CSV)), "precompile.jl"); force=true)
mv(joinpath(precom, "precompile_Parsers.jl"), joinpath(dirname(pathof(Parsers)), "precompile.jl"); force=true)
mv(joinpath(precom, "precompile_SentinelArrays.jl"), joinpath(dirname(pathof(SentinelArrays)), "precompile.jl"); force=true)

# figure out at what byte position the header row(s) start and at what byte position the data starts
function detectheaderdatapos(buf, pos, len, oq, eq, cq, @nospecialize(cmt), ignoreemptyrows, @nospecialize(header), skipto)
    headerpos = 0
    datapos = 1
    if header isa Integer
        if header <= 0
            # no header row in dataset; skip to data
            datapos = skiptorow(buf, pos, len, oq, eq, cq, cmt, ignoreemptyrows, 1, skipto)
        else
            headerpos = skiptorow(buf, pos, len, oq, eq, cq, cmt, ignoreemptyrows, 1, header)
            datapos = skiptorow(buf, headerpos, len, oq, eq, cq, cmt, ignoreemptyrows, header, skipto)
        end
    elseif header isa AbstractVector{<:Integer}
        headerpos = skiptorow(buf, pos, len, oq, eq, cq, cmt, ignoreemptyrows, 1, header[1])
        datapos = skiptorow(buf, headerpos, len, oq, eq, cq, cmt, ignoreemptyrows, header[1], skipto)
    elseif header isa Union{AbstractVector{Symbol}, AbstractVector{String}}
        datapos = skiptorow(buf, pos, len, oq, eq, cq, cmt, ignoreemptyrows, 1, skipto)
    else
        throw(ArgumentError("unsupported header argument: $header"))
    end
    return headerpos, datapos
end

# this function scans a few rows and tracks the # of bytes and characters encountered
# it tries to guess a file's delimiter by which character showed up w/ the same frequency
# over all rows scanned; we use the average # of bytes per row w/ total length of the file
# to guess the total # of rows in the file
function detectdelimandguessrows(buf, headerpos, datapos, len, oq, eq, cq, @nospecialize(cmt), ignoreemptyrows, delim=0x00)
    nbytes = 0
    lastbytenewline = false
    parsedanylines = false
    nlines = 0
    headerbvc = ByteValueCounter()
    bvc = ByteValueCounter()
    b = 0x00
    # don't parse header row if there isn't one: #508
    if headerpos > 0
        pos = headerpos
        # parsing our header row is useful for delimiter
        # detection, but we don't track nbytes here
        # because the header row size doesn't necessarily
        # correlate w/ data row size
        while pos <= len
            parsedanylines = true
            @inbounds b = buf[pos]
            pos += 1
            if b == oq
                while pos <= len
                    @inbounds b = buf[pos]
                    pos += 1
                    if b == eq
                        if pos > len
                            break
                        elseif eq == cq && buf[pos] != cq
                            break
                        end
                        @inbounds b = buf[pos]
                        pos += 1
                    elseif b == cq
                        break
                    end
                end
            elseif b == UInt8('\n')
                nlines += 1
                lastbytenewline = true
                break
            elseif b == UInt8('\r')
                pos <= len && buf[pos] == UInt8('\n') && (pos += 1)
                nlines += 1
                lastbytenewline = true
                break
            else
                lastbytenewline = false
                incr!(headerbvc, b)
                incr!(bvc, b)
            end
        end
    end
    pos = max(1, checkcommentandemptyline(buf, datapos, len, cmt, ignoreemptyrows))
    while pos <= len && nlines < 10
        parsedanylines = true
        @inbounds b = buf[pos]
        pos += 1
        nbytes += 1
        if b == oq
            while pos <= len
                @inbounds b = buf[pos]
                pos += 1
                nbytes += 1
                if b == eq
                    if pos > len
                        break
                    elseif eq == cq && buf[pos] != cq
                        break
                    end
                    @inbounds b = buf[pos]
                    pos += 1
                    nbytes += 1
                elseif b == cq
                    break
                end
            end
        elseif b == UInt8('\n')
            pos = checkcommentandemptyline(buf, pos, len, cmt, ignoreemptyrows)
            nlines += 1
            lastbytenewline = true
        elseif b == UInt8('\r')
            pos <= len && buf[pos] == UInt8('\n') && (pos += 1)
            pos = checkcommentandemptyline(buf, pos, len, cmt, ignoreemptyrows)
            nlines += 1
            lastbytenewline = true
        else
            lastbytenewline = false
            incr!(bvc, b)
        end
    end
    nlines += parsedanylines && !lastbytenewline
    d = delim
    if delim == UInt8('\n')
        if nlines > 0
            d = UInt8('\n')
            if headerpos > 0
                # Prefer delimiters represented in the header over incidental data characters.
                for attempted_delim in (UInt8(','), UInt8('\t'), UInt8(' '), UInt8('|'), UInt8(';'), UInt8(':'))
                    hcnt = headerbvc.counts[Int(attempted_delim) + 1]
                    cnt = bvc.counts[Int(attempted_delim) + 1]
                    if hcnt > 0 && cnt > 0 && cnt % nlines == 0
                        d = attempted_delim
                        break
                    end
                end
            end
            if d == UInt8('\n')
                for attempted_delim in (UInt8(','), UInt8('\t'), UInt8(' '), UInt8('|'), UInt8(';'), UInt8(':'))
                    cnt = bvc.counts[Int(attempted_delim) + 1]
                    # @show Char(attempted_delim), cnt, nlines
                    if cnt > 0 && cnt % nlines == 0
                        d = attempted_delim
                        break
                    end
                end
            end
            if d == UInt8('\n')
                maxcnt = 0
                for attempted_delim in (UInt8(','), UInt8('\t'), UInt8('|'), UInt8(';'), UInt8(':'))
                    cnt = headerbvc.counts[Int(attempted_delim) + 1]
                    # @show Char(attempted_delim), cnt, maxcnt
                    if cnt > maxcnt
                        d = attempted_delim
                        maxcnt = cnt
                    end
                end
            end
            if d == UInt8('\n')
                d = UInt8(',')
            end
        else
            d = UInt8(',')
        end
    end
    guess = ((len - datapos) / (nbytes / nlines))
    rowsguess = isfinite(guess) ? ceil(Int, guess) : 0
    return d, max(1, rowsguess)
end

struct ByteValueCounter
    counts::Vector{Int}
    ByteValueCounter() = new(zeros(Int, 256))
end

function incr!(c::ByteValueCounter, b::UInt8)
    @inbounds c.counts[b + 1] += 1
    return
end

# given the various header and normalization options, figure out column names for a file
function detectcolumnnames(buf, headerpos, datapos, len, options, @nospecialize(header), normalizenames, oq, eq, cq, cmt, ignoreemptyrows)::Vector{Symbol}
    if header isa Union{AbstractVector{Symbol}, AbstractVector{String}}
        fields, pos = readsplitline(buf, datapos, len, options)
        isempty(header) && return [Symbol(:Column, i) for i = 1:length(fields)]
        names = header
    elseif headerpos == 0
        fields, pos = readsplitline(buf, datapos, len, options)
        # generate column names
        return [Symbol(:Column, i) for i = 1:length(fields)]
    elseif header isa Integer
        names, pos = readsplitline(buf, headerpos, len, options)
    elseif header isa AbstractVector{<:Integer}
        names, pos = readsplitline(buf, headerpos, len, options)
        for row = 2:length(header)
            pos = skiptorow(buf, pos, len, oq, eq, cq, cmt, ignoreemptyrows, 1, header[row] - header[row - 1])
            fields, pos = readsplitline(buf, pos, len, options)
            for (i, x) in enumerate(fields)
                names[i] *= "_" * x
            end
        end
    end
    return makeunique([normalizenames ? normalizename(x) : Symbol(x) for x in names])
end

# efficiently skip from `cur` to `dest` row
function skiptorow(buf, pos, len, oq, eq, cq, @nospecialize(cmt), ignoreemptyrows, cur, dest)
    nlines = Ref{Int}(0)
    pos = checkcommentandemptyline(buf, pos, len, cmt, ignoreemptyrows, nlines)
    cur += nlines[]
    nlines[] = 0
    while cur < dest && pos < len
        while pos <= len
            @inbounds b = buf[pos]
            pos += 1
            if b == oq
                while pos <= len
                    @inbounds b = buf[pos]
                    pos += 1
                    if b == eq
                        if pos > len
                            break
                        elseif eq == cq && buf[pos] != cq
                            break
                        end
                        @inbounds b = buf[pos]
                        pos += 1
                    elseif b == cq
                        break
                    end
                end
            elseif b == UInt8('\n')
                typeof(buf) == ReversedBuf && pos <= len && buf[pos] == UInt8('\r') && (pos += 1)
                cur += 1
                break
            elseif b == UInt8('\r')
                pos <= len && buf[pos] == UInt8('\n') && (pos += 1)
                cur += 1
                break
            end
        end
        pos = checkcommentandemptyline(buf, pos, len, cmt, ignoreemptyrows, nlines)
        cur += nlines[]
        nlines[] = 0
    end
    return pos
end

# read a single row, splitting cells on delimiters; used for parsing column names from header row(s)
function readsplitline(buf, pos, len, options)
    vals = String[]
    (pos > len || pos == 0) && return vals, pos
    col = 1
    while true
        res = Parsers.xparse(String, buf, pos, len, options)
        code = res.code
        push!(vals, columnname(buf, res.val, code, options, col))
        pos += res.tlen
        col += 1
        options.ignorerepeated && Parsers.newline(code) && break
        Parsers.delimited(code) && continue
        (Parsers.newline(code) || pos > len) && break
    end
    return vals, pos
end

function columnname(buf, poslen, code, options, i)
    if Parsers.sentinel(code) || poslen.len == 0
        return "Column$i"
    elseif Parsers.escapedstring(code)
        return Parsers.getstring(buf, poslen, options.e)
    else
        return unsafe_string(pointer(buf, poslen.pos), poslen.len)
    end
end

@inline function skipemptyrow(buf, pos, len)
    @inbounds b = buf[pos]
    if b == UInt8('\n')
        return pos + 1 + (typeof(buf) == ReversedBuf && (pos + 1) <= len && buf[pos + 1] == UInt8('\r'))
    elseif b == UInt8('\r')
        if pos + 1 < len && buf[pos + 1] == UInt8('\n')
            return pos + 2
        else
            return pos + 1
        end
    end
    return pos
end

const NLINES = Ref{Int}(0)

function checkcommentandemptyline(buf, pos, len, @nospecialize(cmt), ignoreemptyrows, nlines=NLINES)
    cmtptr, cmtlen = cmt === nothing ? (C_NULL, 0) : cmt
    ptr = pointer(buf, pos)
    while pos <= len
        skipped = matched = false
        if ignoreemptyrows
            newpos = skipemptyrow(buf, pos, len)
            if newpos > pos
                pos = newpos
                skipped = true
                nlines[] += 1
            end
        end
        if cmtlen > 0 && (pos + cmtlen - 1) <= len
            matched = Parsers.memcmp(ptr, cmtptr, cmtlen)
            if matched
                pos += cmtlen
                pos > len && break
                @inbounds b = buf[pos]
                while b != UInt8('\n') && b != UInt8('\r')
                    pos += 1
                    pos > len && break
                    @inbounds b = buf[pos]
                end
                b == UInt8('\r') && pos <= len && buf[pos + 1] == UInt8('\n') && (pos += 1)
                pos += 1
                nlines[] += 1
            end
        end
        (skipped | matched) || break
        ptr = pointer(buf, pos)
    end
    return pos
end

function countcomments(buf, pos, len, oq, eq, cq, @nospecialize(cmt))
    cmt === nothing && return 0
    cmtptr, cmtlen = cmt
    comments = 0
    while pos <= len
        if cmtlen > 0 && (pos + cmtlen - 1) <= len && Parsers.memcmp(pointer(buf, pos), cmtptr, cmtlen)
            comments += 1
            pos += cmtlen
            while pos <= len
                @inbounds b = buf[pos]
                pos += 1
                if b == UInt8('\n')
                    break
                elseif b == UInt8('\r')
                    pos <= len && buf[pos] == UInt8('\n') && (pos += 1)
                    break
                end
            end
        else
            newpos = skiptorow(buf, pos, len, oq, eq, cq, nothing, false, 0, 1)
            pos = newpos > pos ? newpos : len + 1
        end
    end
    return comments
end

struct ColumnProperties
    typecode::UInt8
    maxstringsize::UInt8
end
ColumnProperties(T) = ColumnProperties(T, 0x00)

@inline function (cp::ColumnProperties)(_, _, _, S::UInt8)
    T = cp.typecode
    if T === S
        return cp
    elseif T === NEEDSTYPEDETECTION
        return ColumnProperties(S, cp.maxstringsize)
    elseif S === NEEDSTYPEDETECTION
        return cp
    elseif T === MISSING
        return ColumnProperties(S, cp.maxstringsize)
    elseif S === MISSING
        return cp
    elseif isinttypecode(T) && isinttypecode(S)
        return ColumnProperties(promote_typecode(T, S), cp.maxstringsize)
    elseif isinttypecode(T) && S === FLOAT64
        return ColumnProperties(S, cp.maxstringsize)
    elseif T === FLOAT64 && isinttypecode(S)
        return cp
    else
        return ColumnProperties(STRING, cp.maxstringsize)
    end
end

function findnextnewline(pos, stop, buf, opts)
    while pos < stop
        res = Parsers.xparse(String, buf, pos, stop, opts)
        pos += res.tlen
        Parsers.newline(res.code) && return pos
    end
    return stop
end

function findchunkrowstart(ranges, i, buf, opts, typemap, downcast, ncols, rows_to_check, columns, origcoltypes, columnlock, @nospecialize(stringtype), totalbytes, totalrows, succeeded)
    pos = ranges[i]
    len = ranges[i + 1] - 1
    addtrailingcolumn = false # set if the file ends with an empty column with no trailing newline
    if i == length(ranges)-1
        len += 1 # correctly handle the absence of a trailing newline
        addtrailingcolumn = Parsers.delimited(Parsers.xparse(String, buf, len, len, opts).code)
    end
    nextrowpos = 0
    startpos = pos
    code = Parsers.ReturnCode(0)
    attempted_quoted = false
    while true
        # now we read the next `rows_to_check` rows and see if we get the roughly the right # of columns
        rowstartpos = pos
        parsedncols = rowsparsed = 0
        matchedncols = true
        columnprops = Vector{ColumnProperties}(undef, ncols)
        for i = 1:ncols
            if origcoltypes[i] === NeedsTypeDetection
                columnprops[i] = ColumnProperties(NEEDSTYPEDETECTION)
            else
                # if column type is already set, that means user provided manually
                # so we don't care about sampling that column's values for type
                columnprops[i] = ColumnProperties(0x00)
            end
        end
        for _ = 1:rows_to_check
            n = 1
            numcolsthisrow = 0
            while pos <= len
                res = Parsers.xparse(String, buf, pos, len, opts)
                poslen, code, tlen = res.val, res.code, res.tlen
                vpos, vlen = poslen.pos, poslen.len
                if n <= ncols && !Parsers.sentinel(code)
                    cp = columnprops[n]
                    if cp.typecode > 0x00
                        plen = unsafe_trunc(UInt8, poslen.len)
                        if plen > cp.maxstringsize
                            columnprops[n] = cp = ColumnProperties(cp.typecode, plen)
                        end
                        cp2 = detect(cp, buf, vpos, vpos + vlen - 1, opts, true, downcast)
                        if cp != cp2
                            columnprops[n] = cp2
                        end
                    end
                end
                pos += tlen
                numcolsthisrow += 1
                Parsers.newline(code) && break
                n += 1
            end
            rowsparsed += ((pos < len) | (numcolsthisrow != 0)) # trailing newline does not count
            parsedncols += numcolsthisrow
            matchedncols &= numcolsthisrow == ncols
        end
        parsedncols += addtrailingcolumn
        lock(columnlock) do
            for i = 1:ncols
                cp = columnprops[i]
                col = columns[i]
                if cp.typecode > 0x00
                    type = something(promote_types(col.type, something(TYPES[cp.typecode], stringtype)), stringtype)
                    if type === stringtype
                        type = pickstringtype(stringtype, cp.maxstringsize)
                    end
                    col.type = get(typemap, type, type)
                end
            end
        end
        f40 = ncols * 0.025
        if matchedncols && (ncols - f40) <= (parsedncols / rowsparsed) <= (ncols + f40)
            # ok, seems like we figured out the right start for parsing on this chunk
            Threads.atomic_add!(totalbytes, Int(pos - rowstartpos))
            Threads.atomic_add!(totalrows, rowsparsed)
            break
        end
        if attempted_quoted
            # wah, wah, waaaah. we tried starting outside a quoted field
            # we started assuming we were _inside_, but can't seem to parse
            # anything that matches roughly what we're expecting, bail on
            # multithreaded parsing
            succeeded[] = false
            break
        end
        # else, assume we were inside a quoted field:
        pos = startpos
        # if first byte is quotechar, need to check previous char for escapechar and if so, skip forward
        if buf[pos] == opts.cq && buf[pos - 1] == opts.e
            pos += 1
        end
        # start parsing until we find quotechar (ignoring escaped quote chars)
        cq, eq = opts.cq, opts.e
        while pos <= len
            b = buf[pos]
            pos += 1
            if b == eq
                if pos > len
                    break
                elseif eq == cq && buf[pos] != cq
                    break
                end
                b = buf[pos]
                pos += 1
            elseif b == cq
                break
            end
        end
        # ok, we made it out of a quoted field
        attempted_quoted = true
        pos = nextrowpos = findnextnewline(pos, len, buf, opts)
    end
    return ifelse(nextrowpos==0, startpos, nextrowpos)
end

# here we try to "chunk" up a file; given the equally spaced out byte positions in `ranges`, we start at each
# byte position and start parsing until we find the start of the next row; if the next rows all verify w/ the
# right # of expected columns then we move on to the next file chunk byte position. If we fail, we start over
# at the byte position, assuming we were in a quoted field (and encountered a newline inside the quoted
# field the first time through)
function findrowstarts!(buf, opts, ranges, ncols, columns, @nospecialize(stringtype), typemap, downcast, rows_to_check=5)
    totalbytes = Threads.Atomic{Int}(0)
    totalrows = Threads.Atomic{Int}(0)
    succeeded = Threads.Atomic{Bool}(true)
    lock = ReentrantLock()
    origcoltypes = Type[col.type for col in columns]
    stop = last(ranges)
    @sync for i in 2:(length(ranges) - 1)
        # preprocessing of ranges: ensure that each range starts and ends at a newline
        Threads.@spawn begin
            ranges[i] = findnextnewline(ranges[i], stop, buf, opts)
        end
    end
    # remove ranges starting after the end, if any
    new_last_idx = length(ranges)-1
    while ranges[new_last_idx] > stop
        new_last_idx -= 1
    end
    resize!(ranges, new_last_idx+1)
    ranges[end] = stop
    unique!(ranges) # in case multiple tasks start on the same row
    newranges = similar(ranges)
    N = length(ranges) - 1
    @sync for i in 2:N
        Threads.@spawn begin
            newranges[i] = findchunkrowstart(ranges, i, buf, opts, typemap, downcast, ncols, rows_to_check, columns, origcoltypes, lock, stringtype, totalbytes, totalrows, succeeded)
        end
    end
    @inbounds for i in 2:N # this update occurs after the parallel loop to avoid a race condition
        ranges[i] = newranges[i]
    end
    return totalbytes[] / totalrows[], succeeded[]
end

function detecttranspose(buf, pos, len, options, @nospecialize(header), skipto, normalizenames)
    if isa(header, Integer) && header > 0
        # skip to header column to read column names
        row, pos = skiptofield!(buf, pos, len, options, 1, header)
        # io now at start of 1st header cell
        res = Parsers.xparse(String, buf, pos, len, options)
        columnnames = [columnname(buf, res.val, res.code, options, 1)]
        pos += res.tlen
        row, pos = skiptofield!(buf, pos, len, options, header+1, skipto)
        columnpositions = Int[pos]
        datapos = pos
        rows, pos = countfields(buf, pos, len, options)
        endpositions = Int[pos]
        # we're now done w/ column 1, if EOF we're done, otherwise, parse column 2's column name
        cols = 1
        while pos <= len
            # skip to header column to read column names
            row, pos = skiptofield!(buf, pos, len, options, 1, header)
            cols += 1
            res = Parsers.xparse(String, buf, pos, len, options)
            push!(columnnames, columnname(buf, res.val, res.code, options, cols))
            pos += res.tlen
            row, pos = skiptofield!(buf, pos, len, options, header+1, skipto)
            push!(columnpositions, pos)
            _, pos = countfields(buf, pos, len, options)
            push!(endpositions, pos)
        end
    elseif isa(header, AbstractRange)
        # column names span several columns
        throw(ArgumentError("not implemented for transposed csv files"))
    elseif pos > len
        # empty file, use column names if provided
        datapos = pos
        columnpositions = Int[]
        endpositions = Int[]
        columnnames = header isa Vector && !isempty(header) ? String[string(x) for x in header] : []
        rows = 0
    else
        # column names provided explicitly or should be generated, they don't exist in data
        # skip to skipto
        row, pos = skiptofield!(buf, pos, len, options, 1, skipto)
        # io now at start of 1st data cell
        columnnames = [isa(header, Integer) || isempty(header) ? "Column1" : string(header[1])]
        columnpositions = Int[pos]
        datapos = pos
        rows, pos = countfields(buf, pos, len, options)
        endpositions = Int[pos]
        # we're now done w/ column 1, if EOF we're done, otherwise, parse column 2's column name
        cols = 1
        while pos <= len
            # skip to skipto column
            row, pos = skiptofield!(buf, pos, len, options, 1, skipto)
            cols += 1
            push!(columnnames, isa(header, Integer) || isempty(header) ? "Column$cols" : string(header[cols]))
            push!(columnpositions, pos)
            _, pos = countfields(buf, pos, len, options)
            push!(endpositions, pos)
        end
    end
    return rows, makeunique(map(x -> normalizenames ? normalizename(x) : Symbol(x), columnnames))::Vector{Symbol}, columnpositions, endpositions
end

function skiptofield!(buf, pos, len, options, row, header)
    while row < header
        while pos <= len
            res = Parsers.xparse(String, buf, pos, len, options)
            pos += res.tlen
            Parsers.delimited(res.code) && break
        end
        row += 1
    end
    return row, pos
end

function countfields(buf, pos, len, options)
    rows = 0
    while pos <= len
        res = Parsers.xparse(String, buf, pos, len, options)
        pos += res.tlen
        rows += 1
        Parsers.delimited(res.code) && continue
        (Parsers.newline(res.code) || pos > len) && break
    end
    return rows, pos
end

const KEYWORD_DOCS = """
# Arguments

## File layout options:

  * `header=1`: how column names should be determined; if given as an `Integer`, indicates the row to parse for column names; as an `AbstractVector{<:Integer}`, indicates a set of rows to be concatenated together as column names; `Vector{Symbol}` or `Vector{String}` give column names explicitly (should match # of columns in dataset); if a dataset doesn't have column names, either provide them as a `Vector`, or set `header=0` or `header=false` and column names will be auto-generated (`Column1`, `Column2`, etc.). Note that if a row number header and `comment` or `ignoreemptyrows` are provided, the header row will be the first non-commented/non-empty row _after_ the row number, meaning if the provided row number is a commented row, the header row will actually be the next non-commented row.
  * `normalizenames::Bool=false`: whether column names should be "normalized" into valid Julia identifier symbols; useful when using the `tbl.col1` `getproperty` syntax or iterating rows and accessing column values of a row via `getproperty` (e.g. `row.col1`)
  * `skipto::Integer`: specifies the row where the data starts in the csv file; by default, the next row after the `header` row(s) is used. If `header=0`, then the 1st row is assumed to be the start of data; providing a `skipto` argument does _not_ affect the `header` argument. Note that if a row number `skipto` and `comment` or `ignoreemptyrows` are provided, the data row will be the first non-commented/non-empty row _after_ the row number, meaning if the provided row number is a commented row, the data row will actually be the next non-commented row.
  * `footerskip::Integer`: number of rows at the end of a file to skip parsing.  Do note that commented rows (see the `comment` keyword argument) *do not* count towards the row number provided for `footerskip`, they are completely ignored by the parser
  * `transpose::Bool`: read a csv file "transposed", i.e. each column is parsed as a row
  * `comment::String`: string that will cause rows that begin with it to be skipped while parsing. Note that if a row number header or `skipto` and `comment` are provided, the header/data row will be the first non-commented/non-empty row _after_ the row number, meaning if the provided row number is a commented row, the header/data row will actually be the next non-commented row.
  * `ignoreemptyrows::Bool=true`: whether empty rows in a file should be ignored (if `false`, each column will be assigned `missing` for that empty row)
  * `select`: an `AbstractVector` of `Integer`, `Symbol`, `String`, or `Bool`, or a "selector" function of the form `(i, name) -> keep::Bool`; only columns in the collection or for which the selector function returns `true` will be parsed and accessible in the resulting `CSV.File`. Invalid values in `select` are ignored.
  * `drop`: inverse of `select`; an `AbstractVector` of `Integer`, `Symbol`, `String`, or `Bool`, or a "drop" function of the form `(i, name) -> drop::Bool`; columns in the collection or for which the drop function returns `true` will ignored in the resulting `CSV.File`. Invalid values in `drop` are ignored.
  * `limit`: an `Integer` to indicate a limited number of rows to parse in a csv file; use in combination with `skipto` to read a specific, contiguous chunk within a file; note for large files when multiple threads are used for parsing, the `limit` argument may not result in an exact # of rows parsed; use `ntasks=1` to ensure an exact limit if necessary
  * `buffer_in_memory`: a `Bool`, default `false`, which controls whether a `Cmd`, `IO`, or gzipped source will be read/decompressed in memory vs. using a temporary file.
  * `ntasks::Integer=Threads.nthreads()`: [not applicable to `CSV.Rows`] for multithreaded parsed files, this controls the number of tasks spawned to read a file in concurrent chunks; defaults to the # of threads Julia was started with (i.e. `JULIA_NUM_THREADS` environment variable or `julia -t N`); setting `ntasks=1` will avoid any calls to `Threads.@spawn` and just read the file serially on the main thread; a single thread will also be used for smaller files by default (< 5_000 cells)
  * `rows_to_check::Integer=$DEFAULT_ROWS_TO_CHECK`: [not applicable to `CSV.Rows`] a multithreaded parsed file will be split up into `ntasks` # of equal chunks; `rows_to_check` controls the # of rows are checked to ensure parsing correctly found valid rows; for certain files with very large quoted text fields, `lines_to_check` may need to be higher (10, 30, etc.) to ensure parsing correctly finds these rows
  * `source`: [only applicable for vector of inputs to `CSV.File`] a `Symbol`, `String`, or `Pair` of `Symbol` or `String` to `Vector`. As a single `Symbol` or `String`, provides the column name that will be added to the parsed columns, the values of the column will be the input "name" (usually file name) of the input from whence the value was parsed. As a `Pair`, the 2nd part of the pair should be a `Vector` of values matching the length of the # of inputs, where each value will be used instead of the input name for that inputs values in the auto-added column.

## Parsing options:

  * `missingstring`: either a `nothing`, `String`, or `Vector{String}` to use as sentinel values that will be parsed as `missing`; if `nothing` is passed, no sentinel/missing values will be parsed; by default, `missingstring=""`, which means only an empty field (two consecutive delimiters) is considered `missing`
  * `delim=','`: a `Char` or `String` that indicates how columns are delimited in a file; if no argument is provided, parsing will try to detect the most consistent delimiter on the first 10 rows of the file
  * `ignorerepeated::Bool=false`: whether repeated (consecutive/sequential) delimiters should be ignored while parsing; useful for fixed-width files with delimiter padding between cells
  * `quoted::Bool=true`: whether parsing should check for `quotechar` at the start/end of cells
  * `quotechar='"'`, `openquotechar`, `closequotechar`: a `Char` (or different start and end characters) that indicate a quoted field which may contain textual delimiters or newline characters
  * `escapechar='"'`: the `Char` used to escape quote characters in a quoted field
  * `dateformat::Union{String, Dates.DateFormat, Nothing, AbstractDict}`: a date format string to indicate how Date/DateTime columns are formatted for the entire file; if given as an `AbstractDict`, date format strings to indicate how the Date/DateTime columns corresponding to the keys are formatted. The Dict can map column index `Int`, or name `Symbol` or `String` to the format string for that column.
  * `decimal='.'`: a `Char` indicating how decimals are separated in floats, i.e. `3.14` uses `'.'`, or `3,14` uses a comma `','`
  * `groupmark=nothing`: optionally specify a single-byte character denoting the number grouping mark, this allows parsing of numbers that have, e.g., thousand separators (`1,000.00`).
  * `truestrings`, `falsestrings`: `Vector{String}`s that indicate how `true` or `false` values are represented; by default `"true", "True", "TRUE", "T", "1"` are used to detect `true` and `"false", "False", "FALSE", "F", "0"` are used to detect `false`; note that columns with only `1` and `0` values will default to `Int64` column type unless explicitly requested to be `Bool` via `types` keyword argument
  * `stripwhitespace=false`: if true, leading and trailing whitespace are stripped from string values, including column names

## Column Type Options:

  * `types`: a single `Type`, `AbstractVector` or `AbstractDict` of types, or a function of the form `(i, name) -> Union{T, Nothing}` to be used for column types; if a single `Type` is provided, _all_ columns will be parsed with that single type; an `AbstractDict` can map column index `Integer`, or name `Symbol` or `String` to type for a column, i.e. `Dict(1=>Float64)` will set the first column as a `Float64`, `Dict(:column1=>Float64)` will set the column named `column1` to `Float64` and, `Dict("column1"=>Float64)` will set the `column1` to `Float64`; if a `Vector` is provided, it must match the # of columns provided or detected in `header`. If a function is provided, it takes a column index and name as arguments, and should return the desired column type for the column, or `nothing` to signal the column's type should be detected while parsing.
  * `typemap::IdDict{Type, Type}`: a mapping of a type that should be replaced in every instance with another type, i.e. `Dict(Float64=>String)` would change every detected `Float64` column to be parsed as `String`; only "standard" types are allowed to be mapped to another type, i.e. `Int64`, `Float64`, `Date`, `DateTime`, `Time`, and `Bool`. If a column of one of those types is "detected", it will be mapped to the specified type.
  * `pool::Union{Bool, Real, AbstractVector, AbstractDict, Function, Tuple{Float64, Int}}=$DEFAULT_POOL`: [not supported by `CSV.Rows`] controls whether columns will be built as `PooledArray`; if `true`, all columns detected as `String` will be pooled; alternatively, the proportion of unique values below which `String` columns should be pooled (meaning that if the # of unique strings in a column is under 25%, `pool=0.25`, it will be pooled). If provided as a `Tuple{Float64, Int}` like `(0.2, 500)`, it represents the percent cardinality threshold as the 1st tuple element (`0.2`), and an upper limit for the # of unique values (`500`), under which the column will be pooled; this is the default (`pool=$DEFAULT_POOL`). If an `AbstractVector`, each element should be `Bool`, `Real`, or `Tuple{Float64, Int}` and the # of elements should match the # of columns in the dataset; if an `AbstractDict`, a `Bool`, `Real`, or `Tuple{Float64, Int}` value can be provided for individual columns where the dict key is given as column index `Integer`, or column name as `Symbol` or `String`. If a function is provided, it should take a column index and name as 2 arguments, and return a `Bool`, `Real`, `Tuple{Float64, Int}`, or `nothing` for each column.
  * `downcast::Bool=false`: controls whether columns detected as `Int64` will be "downcast" to the smallest possible integer type like `Int8`, `Int16`, `Int32`, etc.
  * `stringtype=$DEFAULT_STRINGTYPE`: controls how detected string columns will ultimately be returned; default is `InlineString`, which stores string data in a fixed-size primitive type that helps avoid excessive heap memory usage; if a column has values longer than 32 bytes, it will default to `String`. If `String` is passed, all string columns will just be normal `String` values. If `PosLenString` is passed, string columns will be returned as `PosLenStringVector`, which is a special "lazy" `AbstractVector` that acts as a "view" into the original file data. This can lead to the most efficient parsing times, but note that the "view" nature of `PosLenStringVector` makes it read-only, so operations like `push!`, `append!`, or `setindex!` are not supported. It also keeps a reference to the entire input dataset source, so trying to modify or delete the underlying file, for example, may fail
  * `strict::Bool=false`: whether invalid values should throw a parsing error or be replaced with `missing`
  * `silencewarnings::Bool=false`: if `strict=false`, whether invalid value warnings should be silenced
  * `maxwarnings::Int=$DEFAULT_MAX_WARNINGS`: if more than `maxwarnings` number of warnings are printed while parsing, further warnings will be silenced by default; for multithreaded parsing, each parsing task will print up to `maxwarnings`
  * `debug::Bool=false`: passing `true` will result in many informational prints while a dataset is parsed; can be useful when reporting issues or figuring out what is going on internally while a dataset is parsed
  * `validate::Bool=true`: whether or not to validate that columns specified in the `types`, `dateformat` and `pool` keywords are actually found in the data. If `false` no validation is done, meaning no error will be thrown if `types`/`dateformat`/`pool` specify settings for columns not actually found in the data.

## Iteration options:

  * `reusebuffer=false`: [only supported by `CSV.Rows`] while iterating, whether a single row buffer should be allocated and reused on each iteration; only use if each row will be iterated once and not re-used (e.g. it's not safe to use this option if doing `collect(CSV.Rows(file))` because only current iterated row is "valid")
"""

struct CSV_Foo
end

struct CSVString
    s::String
end

Base.parse(::Type{CSVString}, s::String) = CSVString(s)
Base.tryparse(::Type{CSVString}, s::String) = CSVString(s)
Base.zero(::Type{CSVString}) = CSVString("")

struct Dec64
    x::Float64
end

Base.parse(::Type{Dec64}, s::String) = Dec64(parse(Float64, s))
Base.tryparse(::Type{Dec64}, s::String) = Dec64(parse(Float64, s))
Base.zero(::Type{Dec64}) = Dec64(0.0)

@testset "CSV.File basics" begin

#test on non-existent file
@test_throws ArgumentError CSV.File("");

#test where skipto > headerrow
@test_throws ArgumentError CSV.File(joinpath(dir, "test_no_header.csv"); skipto=1, header=2);

#test bad types
@test_throws CSV.Error CSV.File(joinpath(dir, "test_float_in_int_column.csv"); types=[Int, Int, Int], strict=true)

# Integer overflow; #100
@test_throws CSV.Error CSV.File(joinpath(dir, "int64_overflow.csv"); types=[Int8], strict=true)

# #172
@test_throws ArgumentError CSV.File(joinpath(dir, "test_newline_line_endings.csv"), types=Dict(1=>Integer))

# #289
tmp = CSV.File(IOBuffer(" \"a, b\", \"c\" "), skipto=1) |> columntable
@test length(tmp) == 2
@test length(tmp[1]) == 1
@test tmp.Column1[1] == "a, b"
@test tmp.Column2[1] == "c"

tmp = CSV.File(IOBuffer(" \"2018-01-01\", \"1\" ,1,2,3"), skipto=1) |> columntable
@test length(tmp) == 5
@test length(tmp[1]) == 1
@test tmp.Column1[1] == Date(2018, 1, 1)
@test tmp.Column2[1] == 1
@test tmp.Column3[1] == 1
@test tmp.Column4[1] == 2
@test tmp.Column5[1] == 3

# #329
f = CSV.File(joinpath(dir, "test_types.csv"), types=Dict(:string=>Union{Missing,DateTime}), silencewarnings=true)
@test f.string[1] === missing

# #352
@test_throws KeyError first(CSV.File(joinpath(dir, "test_types.csv"))).a

@test_throws ArgumentError CSV.File(IOBuffer("a\0b\n1\02\n"); delim='\0')
@test_throws ArgumentError CSV.File(IOBuffer("a\0b\n1\02\n"); delim="\0")

f = CSV.File(IOBuffer("a,b\n1,2\n"); header=3)
@test isempty(f.types)
@test f.rows == 0

f = CSV.File(IOBuffer("a,b\n1,2\n"); skipto=3)
@test f.names == [:a, :b]
@test f.rows == 0

f = CSV.File(IOBuffer("a,b\n1,2\n"); skipto=3)
@test f.names == [:a, :b]
@test f.rows == 0

f = CSV.File(IOBuffer("a,b\n1,2\n"); limit=0)
@test f.names == [:a, :b]
@test f.rows == 0

# 387
f = CSV.File(IOBuffer("a,b\n1,1\n1,2\n1,3\n"))

for rows in Iterators.partition(f, 2)
    for row in rows
        # get last property
        getproperty(row, :b)
        @test row.a == 1
    end
end

# 391
rows = collect(f)
@test rows[1].a == 1
@test rows[1].a == 1

# 459
rows = collect(CSV.File(joinpath(dir, "time.csv"); dateformat="H:M:S"))
@test rows[1].time == Time(0)
@test rows[2].time == Time(0, 10)

# 388
f = CSV.File(joinpath(dir, "GSM2230757_human1_umifm_counts.csv"); ntasks=1);
@test length(f.names) == 20128
@test length(f) == 3

# 386
f = CSV.File(IOBuffer("fullVisitorId,PredictedLogRevenue\n18966949534117,0\n39738481224681,0\n"), limit=3)
@test f.rows == 2
rows = collect(f)
@test rows[1].fullVisitorId == 18966949534117
@test rows[2].fullVisitorId == 39738481224681

f = CSV.File(IOBuffer("col1,col2\n1.0,hi"), limit=3)
@test (length(f), length(f.names)) == (1, 2)

# 288
f = CSV.File(IOBuffer("x\n\",\"\n\",\""))
@test (length(f), length(f.names)) == (2, 1)

# delimiter auto-detection
f = CSV.File(IOBuffer("x\n1\n2\n"))
@test (length(f), length(f.names)) == (2, 1)

f = CSV.File(IOBuffer("x,y\n1,\n2,\n"))
@test (length(f), length(f.names)) == (2, 2)

f = CSV.File(IOBuffer("x y\n1 \n2 \n"))
@test (length(f), length(f.names)) == (2, 2)

f = CSV.File(IOBuffer("x\ty\n1\t\n2\t\n"))
@test (length(f), length(f.names)) == (2, 2)

f = CSV.File(IOBuffer("x|y\n1|\n2|\n"))
@test (length(f), length(f.names)) == (2, 2)

f = CSV.File(IOBuffer("a;b;c\n1,1;2,2;3,3\n4,4;5,5;6,6\n"); decimal=',')
@test (length(f), length(f.names)) == (2, 3)
@test f.a == [1.1, 4.4]
@test f.b == [2.2, 5.5]
@test f.c == [3.3, 6.6]

# type promotion
# int => float
f = CSV.File(IOBuffer("x\n1\n3.14"))
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] === 1.0
@test f.x[2] === 3.14

# int => missing
f = CSV.File(IOBuffer("x\n1\n\n"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] == 1
@test f.x[2] === missing

# missing => int
f = CSV.File(IOBuffer("x\n\n1\n"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] === missing
@test f.x[2] == 1

# missing => int => float
f = CSV.File(IOBuffer("x\n\n1\n3.14\n"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (3, 1)
@test f.x[1] === missing
@test f.x[2] === 1.0
@test f.x[3] === 3.14

# int => missing => float
f = CSV.File(IOBuffer("x\n1\n\n3.14\n"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (3, 1)
@test f.x[1] === 1.0
@test f.x[2] === missing
@test f.x[3] === 3.14

# int => float => missing
f = CSV.File(IOBuffer("x\n1\n3.14\n\n"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (3, 1)
@test f.x[1] === 1.0
@test f.x[2] === 3.14
@test f.x[3] === missing

# int => string
f = CSV.File(IOBuffer("x\n1\nabc"))
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] == "1"
@test f.x[2] == "abc"

# float => string
f = CSV.File(IOBuffer("x\n3.14\nabc"))
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] == "3.14"
@test f.x[2] == "abc"

# int => float => string
f = CSV.File(IOBuffer("x\n1\n3.14\nabc"))
@test (length(f), length(f.names)) == (3, 1)
@test f.x[1] == "1"
@test f.x[2] == "3.14"
@test f.x[3] == "abc"

# missing => int => float => string
f = CSV.File(IOBuffer("x\n\n1\n3.14\nabc"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (4, 1)
@test f.x[1] === missing
@test f.x[2] == "1"
@test f.x[3] == "3.14"
@test f.x[4] == "abc"

# downcast
f = CSV.File(IOBuffer("x\n1"), downcast=true, ignoreemptyrows=true)
@test eltype(f.x) === Int8

f = CSV.File(IOBuffer("x\n1\n$(typemax(Int16))"), downcast=true, ignoreemptyrows=true)
@test eltype(f.x) === Int16

f = CSV.File(IOBuffer("x\n1\n$(typemax(Int16))\n$(typemax(Int32))"), downcast=true, ignoreemptyrows=true)
@test eltype(f.x) === Int32

f = CSV.File(IOBuffer("x\n1\n$(typemax(Int16))\n$(typemax(Int32))\n$(typemax(Int64))"), downcast=true, ignoreemptyrows=true)
@test eltype(f.x) === Int64

f = CSV.File(IOBuffer("x\n1\n$(typemax(Int16))\n$(typemax(Int32))\n$(typemax(Int64))\n$(typemax(Int128))"), downcast=true, ignoreemptyrows=true)
@test eltype(f.x) === Int128

f = CSV.File(IOBuffer("x\n1\n$(typemax(Int16))\n$(typemax(Int32))\n$(typemax(Int64))\n$(typemax(Int128))\n3.14"), downcast=true, ignoreemptyrows=true)
@test eltype(f.x) === Float64

f = CSV.File(IOBuffer("x\n1\n$(typemax(Int16))\n$(typemax(Int32))\n$(typemax(Int64))\n$(typemax(Int128))\n3.14\nabc"), downcast=true, ignoreemptyrows=true)
@test eltype(f.x) === String

f = CSV.File(IOBuffer("x\n\n1"), downcast=true, ignoreemptyrows=false)
@test eltype(f.x) === Union{Missing, Int8}

f = CSV.File(IOBuffer("x\n\n1\n$(typemax(Int16))"), downcast=true, ignoreemptyrows=false)
@test eltype(f.x) === Union{Missing, Int16}

f = CSV.File(IOBuffer("x\n\n1\n$(typemax(Int16))\n$(typemax(Int32))"), downcast=true, ignoreemptyrows=false)
@test eltype(f.x) === Union{Missing, Int32}

f = CSV.File(IOBuffer("x\n\n1\n$(typemax(Int16))\n$(typemax(Int32))\n$(typemax(Int64))"), downcast=true, ignoreemptyrows=false)
@test eltype(f.x) === Union{Missing, Int64}

f = CSV.File(IOBuffer("x\n\n1\n$(typemax(Int16))\n$(typemax(Int32))\n$(typemax(Int64))\n$(typemax(Int128))"), downcast=true, ignoreemptyrows=false)
@test eltype(f.x) === Union{Missing, Int128}

f = CSV.File(IOBuffer("x\n\n1\n$(typemax(Int16))\n$(typemax(Int32))\n$(typemax(Int64))\n$(typemax(Int128))\n3.14"), downcast=true, ignoreemptyrows=false)
@test eltype(f.x) === Union{Missing, Float64}

# missing => catg
f = CSV.File(IOBuffer("x\n\na\n"), pool=true, ignoreemptyrows=false)
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] === missing
@test f.x[2] == "a"

# catg => missing
f = CSV.File(IOBuffer("x\na\n\n"), pool=true, ignoreemptyrows=false)
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] == "a"
@test f.x[2] === missing

# catg => string
f = CSV.File(IOBuffer("x\na\nb\na\nb\na\nb\na\nc\nd\ne\nf\ng\nh\ni\nj\nk\nl\nn\nm\no\np\nq\nr\n"), pool=0.5)
@test typeof(f.x) == Vector{InlineString1}

# a few corner cases for escape strings
f = CSV.File(IOBuffer("\"column name with \"\" escape character inside\"\n1\n"))
@test keys(f[1])[1] == Symbol("column name with \" escape character inside")

f = CSV.File(IOBuffer("\"column name with \"\" escape character inside\",1\n,2"), transpose=true)
@test keys(f[1])[1] == Symbol("column name with \" escape character inside")
@test keys(f[1])[2] == :Column2

f = CSV.File(IOBuffer("x\na\nb\n\"quoted field with \"\" escape character inside\"\n"), pool=true)
@test f.x[1] == "a"
@test f.x[3] == "quoted field with \" escape character inside"

f = CSV.File(IOBuffer("x\na\nb\n\"quoted field with \"\" escape character inside\"\n"), pool=true)
@test f.x[1] == "a"
@test f.x[3] == "quoted field with \" escape character inside"

# invalid quoted field is fatal error
@test_throws CSV.Error CSV.File(IOBuffer("x\n\"quoted field that never ends"))
@test_throws CSV.Error CSV.File(IOBuffer("x\nhey\n\"quoted field that never ends"))
@test_throws CSV.Error CSV.File(IOBuffer("x\n\n\"quoted field that never ends"))
@test_throws CSV.Error CSV.File(IOBuffer("x\n1\n\"quoted field that never ends"))
@test_throws CSV.Error CSV.File(IOBuffer("x\n1.0\n\"quoted field that never ends"))
@test_throws CSV.Error CSV.File(IOBuffer("x\na\n\"quoted field that never ends"), pool=true)

# invalid integer
f = CSV.File(IOBuffer("x\nabc\n"), types=Int)
@test (length(f), length(f.names)) == (1, 1)
@test f.x[1] === missing

@test_throws CSV.Error CSV.File(IOBuffer("x\nabc\n"), types=Int, strict=true)

# transpose corner cases
f = CSV.File(IOBuffer("x,y,1\nx2,y2,2\n"), transpose=true, header=2)
@test f.names == [:y, :y2]
@test (length(f), length(f.names)) == (1, 2)
@test f.y[1] == 1
@test f.y2[1] == 2

f = CSV.File(IOBuffer("x,y,1\nx2,y2,2\n"), transpose=true, header=1, skipto=3)
@test f.names == [:x, :x2]
@test (length(f), length(f.names)) == (1, 2)
@test f.x[1] == 1
@test f.x2[1] == 2

f = CSV.File(IOBuffer("x,y,1\nx2,y2,2\n"), transpose=true, header=false, skipto=3)
@test f.names == [:Column1, :Column2]
@test (length(f), length(f.names)) == (1, 2)
@test f.Column1[1] == 1
@test f.Column2[1] == 2

f = CSV.File(IOBuffer(""), transpose=true, header=false)
@test (length(f), length(f.names)) == (0, 0)

f = CSV.File(IOBuffer(""), transpose=true, header=Symbol[])
@test (length(f), length(f.names)) == (0, 0)

@testset "transpose string promotion (#1172)" begin
    normalize(x) = map(y -> ismissing(y) ? missing : string(y), x)
    expected_a = [missing, "1", "x", "3"]
    expected_b = [missing, 4, 5, 6]

    for value in ("x", "\"x\"")
        source = "a,,1,$value,3\nb,,4,5,6"
        f = CSV.File(IOBuffer(source); transpose=true)
        @test isequal(normalize(f.a), expected_a)
        @test isequal(f.b, expected_b)
    end

    source = "a,,1,\"x\",3\nb,,4,5,6"
    table = CSV.read(IOBuffer(source), Tables.columntable; transpose=true)
    @test isequal(normalize(table.a), expected_a)
    @test isequal(table.b, expected_b)

    rows = Tables.rowtable(CSV.Rows(IOBuffer(source); transpose=true))
    @test isequal([ismissing(row.a) ? missing : string(row.a) for row in rows], expected_a)
    @test isequal([ismissing(row.b) ? missing : string(row.b) for row in rows],
        [missing, "4", "5", "6"])

    f = CSV.File(IOBuffer("skip,a,,1,x,3\nskip,b,,4,5,6"); transpose=true, header=2)
    @test isequal(normalize(f.a), expected_a)
    @test isequal(f.b, expected_b)

    f = CSV.File(IOBuffer(",1,x,3\n,4,5,6"); transpose=true, header=[:a, :b])
    @test isequal(normalize(f.a), expected_a)
    @test isequal(f.b, expected_b)

    f = CSV.File(IOBuffer(source); transpose=true, limit=3)
    @test isequal(normalize(f.a), expected_a[1:3])
    @test isequal(f.b, expected_b[1:3])

    f = CSV.File(IOBuffer("a,,1,x,3\nb,4"); transpose=true)
    @test isequal(normalize(f.a), expected_a)
    @test isequal(f.b, [4, missing, missing, missing])
end

# providing empty header vector
f = CSV.File(IOBuffer("x\nabc\n"), header=Symbol[])
@test f.names == [:Column1]

# Union{Bool, Missing}
f = CSV.File(IOBuffer("x\ntrue\n\n"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] === true
@test f.x[2] === missing

# Union{Date, Missing}
f = CSV.File(IOBuffer("x\n2019-01-01\n\n"), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] === Date(2019, 1, 1)
@test f.x[2] === missing

# types is Dict{String, Type}
f = CSV.File(IOBuffer("x\n2019-01-01\n\n"), types=Dict("x"=>Date), ignoreemptyrows=false)
@test (length(f), length(f.names)) == (2, 1)
@test f.x[1] === Date(2019, 1, 1)
@test f.x[2] === missing

# various CSV.File/CSV.Row properties
f = CSV.File(IOBuffer("int,float,date,datetime,bool,null,str,catg,int_float\n1,3.14,2019-01-01,2019-01-01T01:02:03,true,,hey,abc,2\n2,NaN,2019-01-02,2019-01-03T01:02:03,false,,there,abc,3.14\n"), pool=0.3)
@test Tables.istable(f)
@test Tables.rowaccess(typeof(f))
@test Tables.columnaccess(typeof(f))
@test Tables.schema(f) == Tables.Schema([:int, :float, :date, :datetime, :bool, :null, :str, :catg, :int_float], [Int, Float64, Date, DateTime, Bool, Missing, InlineString7, InlineString3, Float64])
@test Tables.rows(f) === f
@test eltype(f) <: CSV.Row
row = first(f)
@test propertynames(row) == [:int, :float, :date, :datetime, :bool, :null, :str, :catg, :int_float]
@test row.int == 1
@test row.float == 3.14
@test row.date == Date(2019, 1, 1)
@test row.datetime == DateTime(2019, 1, 1, 1, 2, 3)
@test row.bool === true
@test row.null === missing
@test row.str == "hey"
@test row.catg == "abc"
@test typeof(row.catg) == InlineString3
@test row.int_float === 2.0
row = iterate(f, 2)[1]
@test row.int_float === 3.14

# 448
@test_throws ArgumentError CSV.File(IOBuffer("x\n1\n2\n3\n#4"); ignorerepeated=true)

# reported by oxinabox on slack; issue w/ manually specified pool column type and 0 rows
f = CSV.File(IOBuffer("x\n"), pool=true)
@test (length(f), length(f.names)) == (0, 1)

f = CSV.File(IOBuffer("x\n1\n2\n3\n#4"), comment="#")
@test length(f.x) == 3
@test f.x[end] == 3

# 453
@test_throws ArgumentError CSV.File(IOBuffer("x\n1\n2\n3\n#4"), types=[CSV_Foo])
@test_throws ArgumentError CSV.File(IOBuffer("x\n1\n2\n3\n#4"), types=Dict(:x=>CSV_Foo))

# 447
f = CSV.File(IOBuffer("a,b,c\n1,2,3\n\n"))
@test (length(f), length(f.names)) == (1, 3)

f = CSV.File(IOBuffer("zip\n11111-1111\n"), dateformat = "y-m-dTH:M:S.s")
@test (length(f), length(f.names)) == (1, 1)

# `cat` isn't always available on Windows
catcmd = `$(Base.julia_cmd()) --eval "write(stdout, open(ARGS[1]))"`
f = CSV.File(`$(catcmd) $(joinpath(dir, "test_basic.csv"))`)
@test columntable(f) == columntable(CSV.File(joinpath(dir, "test_basic.csv")))

#476
f = CSV.File(joinpath(dir, "randoms.csv.gz"); buffer_in_memory=true)
@test (length(f), length(f.names)) == (70000, 7)

f = CSV.File(IOBuffer("thistime\n10:00:00.0\n12:00:00.0"))
@test typeof(f.thistime[1]) <: Dates.Time
@test f.thistime[1] === Time(10)

# 530
f = CSV.File(IOBuffer(",column2\nNA,2\n2,3"), missingstring=["NA"])
@test f.names == [:Column1, :column2]

# reported on slack from Kevin Bonham
f = CSV.File(IOBuffer("x\n01:02:03\n\n04:05:06\n"), delim=',', ignoreemptyrows=false)
@test isequal(f.x, [Dates.Time(1,2,3), missing, Dates.Time(4,5,6)])

# 566
f = CSV.File(IOBuffer("x\r\n1\r\n2\r\n3\r\n4\r\n5\r\n"), footerskip=3)
@test length(f) == 2
@test f[1][1] == 1

# Comment rows do not count towards footerskip.
for newline in ("\n", "\r\n", "\r")
    csv = join(("a,b", "1,2", "3,4", "# trailing comment 1", "# trailing comment 2"), newline) * newline
    f = CSV.File(IOBuffer(csv); comment="#", footerskip=1)
    @test Tables.rowtable(f) == [(a=1, b=2)]
    rows = CSV.Rows(IOBuffer(csv); comment="#", footerskip=1, types=Int)
    @test Tables.rowtable(rows) == [(a=1, b=2)]
end

# 578
f = CSV.File(IOBuffer("h1234567890123456\t"^2262 * "lasthdr\r\n" * "dummy dummy dummy\r\n" * ("1.23\t"^2262 * "2.46\r\n")^10), skipto=3, ntasks=1);
@test (length(f), length(f.names)) == (10, 2263)
@test all(x -> eltype(x) == Float64, Tables.Columns(f))

# Date constructor throws which breaks CSV parsing error handling flow
f = CSV.File(IOBuffer("date\n2020-05-05\n2020-05-32"))

# multiple dateformats
f = CSV.File(IOBuffer("time,date,datetime\n10:00:00.0,04/16/2020,2020-04-16 23:14:00\n"), dateformat=Dict(2=>"mm/dd/yyyy", 3=>"yyyy-mm-dd HH:MM:SS"))
@test length(f) == 1
@test f[1].time == Dates.Time(10)
@test f[1].date == Dates.Date(2020, 4, 16)
@test f[1].datetime == Dates.DateTime(2020, 4, 16, 23, 14)

# custom types
f = CSV.File(
    IOBuffer("int8,uint32,bigint,bigfloat,dec64,csvstring\n1,2,170141183460469231731687303715884105727,3.14,1.02,hey there sailor\n2,,,,,\n");
    types=[Int8, UInt32, BigInt, BigFloat, Dec64, CSVString]
)
@test f.int8 isa Vector{Int8}
@test f.int8 == Int8[1, 2]
@test f.uint32 isa Vector{Union{UInt32, Missing}}
@test isequal(f.uint32, [0x00000002, missing])
@test f.bigint isa CSV.SVec2{BigInt}
@test isequal(f.bigint, [BigInt(170141183460469231731687303715884105727), missing])
@test f.bigfloat isa CSV.SVec2{BigFloat}
@test isequal(f.bigfloat, [parse(BigFloat, "3.14"), missing])
@test f.dec64 isa CSV.SVec{Dec64}
@test isequal(f.dec64, [Dec64(1.02), missing])
@test f.csvstring isa CSV.SVec2{CSVString}
@test isequal(f.csvstring, [CSVString("hey there sailor"), missing])

f = CSV.File(joinpath(dir, "randoms.csv.gz"); types=[Int, CSVString, String, Float64, Dec64, Date, DateTime])
@test f.id isa AbstractVector{Int}
@test f.first isa AbstractVector{CSVString}
@test f.wage isa AbstractVector{Union{Missing, Dec64}}

f = CSV.File(joinpath(dir, "promotions.csv"); stringtype=PosLenString)
@test Tables.schema(f).types == (Float64, Union{Missing, Int}, Union{Missing, Float64}, PosLenString, Union{Missing, PosLenString}, PosLenString, PosLenString, Union{Missing, Int})

f = CSV.File(joinpath(dir, "promotions.csv"); limit=7500, ntasks=2)
@test length(f) == 7500

f = CSV.File(IOBuffer("1,2\r\n3,4\r\n\r\n5,6\r\n"); header=["col1", "col2"], ignoreemptyrows=true)
@test f.col1 == [1, 3, 5]

f = CSV.File(joinpath(dir, "escape_row_starts.csv"); ntasks=2)
@test length(f) == 10000
@test eltype(f.col1) == String
@test eltype(f.col2) == Int

mktempdir() do tmp
    # 1139: multiline quoted fields should still parse correctly when a chunk
    # boundary initially lands inside the quoted field body.
    n = 4000
    path = joinpath(tmp, "issue1139.csv")
    text = "123\nabc"
    CSV.write(path, (id=1:n, text=fill(text, n)))
    ctx = CSV.Context(path; ntasks=2)
    @test ctx.threaded
    f = CSV.File(path; ntasks=2)
    @test length(f) == n
    @test all(==(text), f.text)
    @test map(x -> parse(Int, string(x)), f.id[2038:2040]) == [2038, 2039, 2040]
    @test f.text[2038:2040] == fill(text, 3)
end

f = CSV.File(IOBuffer("col1\nhey\nthere\nsailor"); stringtype=PosLenString)
@test f.col1 isa PosLenStringVector
@test Tables.columnnames(f) == [:col1]
@test propertynames(f) == [:col1]
@test occursin("IOBuffer", CSV.getname(f))
@test CSV.getcols(f) == 1
@test Base.IndexStyle(f) == Base.IndexLinear()
@test f.col1 === Tables.getcolumn(f, 1)
@test columntable(f) == columntable(collect(f))
show(f)

let str = "hash me", seed = UInt(0x1234)
    GC.@preserve str begin
        ptrstr = CSV.PointerString(pointer(str), ncodeunits(str))
        @test hash(ptrstr, seed) == hash(str, seed)
        @test hash(ptrstr) isa UInt
    end
end

f = CSV.File(joinpath(dir, "big_types.csv"); stringtype=PosLenString, pool=false)
@test eltype(f.time) == Dates.Time
@test eltype(f.bool) == Bool
@test eltype(f.lazy) == PosLenString
@test eltype(f.lazy_missing) == Union{PosLenString, Missing}

r = CSV.Rows(joinpath(dir, "big_types.csv"); types=[Dates.Time, Bool, String, Union{String, Missing}])
row = first(r)
@test row.time == Dates.Time(12)
@test row.bool
@test row.lazy == "hey"
@test row.lazy_missing === missing

@test CSV.File(IOBuffer("col1\n1")).col1 == [1]

chunks = CSV.Chunks(joinpath(dir, "promotions.csv"); stringtype=PosLenString, ntasks=2)
@test sum(length, chunks) == 10000
@test Tables.partitions(chunks) === chunks

@test_throws ArgumentError CSV.Chunks(joinpath(dir, "promotions.csv"); stringtype=PosLenString, ntasks=1)

# Test `ntasks` has expected defaults.
chunks = CSV.Chunks(joinpath(dir, "promotions.csv"); stringtype=PosLenString)
if Threads.nthreads() == 1
    @test length(chunks) == 8
else
    @test length(chunks) == Threads.nthreads()
end

# 668
buf = IOBuffer("""
       garbage
       a,b
       1,2
       """)
readline(buf)
f = CSV.File(buf, header=["A", "B"])
@test length(f) == 2
@test f.names == [:A, :B]
@test (f[1].A, f[1].B) == ("a", "b")
@test (f[2].A, f[2].B) == ("1", "2")

# 680: ensure typemap works with custom types
for tm in (Dict(Int => (Int === Int64 ? Int32 : Int64)),
           IdDict(Int => (Int === Int64 ? Int32 : Int64)))
    f = CSV.File(IOBuffer("a\n1\n2\n3"); typemap=tm)
end
@test f.a isa Vector{Int === Int64 ? Int32 : Int64}
f = CSV.File(IOBuffer("a\n1\n2\n3"); typemap=IdDict(Int=>String))
@test f.a isa Vector{String}

# 678
f = CSV.File(IOBuffer("""x,y
                                       a,b
                                       a,b
                                       a,b
                                       a,b
                                       a,b
                                       a,b
                                       a,b
                                       a,b
                                       a,b

                                       """), ignoreemptyrows=false)
@test f.x[end] === missing
@test f.y[end] === missing

# 679
f = CSV.File(IOBuffer("a,b,c\n1,2,3\n4,5,6\n"); select=["a"], types=Dict(2=>Int8))
@test f.a == [1, 4]

f = CSV.File(transcode(GzipDecompressor, Mmap.mmap(joinpath(dir, "randoms.csv.gz"))); types=Dict(:id=>Int32), select=["first"])
@test length(f) == 70000
@test eltype(f.first) == InlineString15

# 723
f = CSV.File(IOBuffer("col1,col2,col3\n1.0,2.0,3.0\n1.0,2.0,3.0\n1.0,2.0,3.0\n1.0,2.0,3.0\n"); ntasks=2)
@test length(f) == 4
@test f isa CSV.File

# 726
f = CSV.File(IOBuffer("col1,col2,col3,col4,col5\na,b,c,d,e\n" * "a,b,c,d\n"^101))
@test length(f) == 102

# 743
f = CSV.File(IOBuffer("col1\n\n \n  \n1\n2\n3"), missingstring=["", " ", "  "], ignoreemptyrows=false)
@test length(f) == 6
@test isequal(f.col1, [missing, missing, missing, 1, 2, 3])

f = CSV.File(IOBuffer("a\n1"))
@test length(f) == 1
@test f.a == [1]

# 788
f = CSV.File(IOBuffer("""
# 1'2
name
junk
1
"""), comment="#", header=2, skipto=4)
@test length(f) == 1
@test f[1].name == 1

f = CSV.File(IOBuffer("""
# 1'2"
name
junk
1
"""), comment="#", header=2, skipto=4)
@test length(f) == 1
@test f[1].name == 1

# 799
f = CSV.File(IOBuffer("Created Date\nToday\n"))
@test length(f) == length(f.names)
@test f[1][Symbol("Created Date")] == "Today"

# 796
csv = "1, a\n2, b\n3, c\n4, d\n\n"
f = CSV.File(IOBuffer(csv); skipto=1, footerskip=1)
@test length(f) == 4
f = CSV.File(IOBuffer(csv); skipto=1, footerskip=2)
@test length(f) == 3

csv = "1, a\r\n2, b\r\n3, c\r\n4, d\r\n\r\n"
f = CSV.File(IOBuffer(csv); skipto=1, footerskip=1)
@test length(f) == 4
f = CSV.File(IOBuffer(csv); skipto=1, footerskip=2)
@test length(f) == 3

csv = "1, a\r2, b\r3, c\r4, d\r\r"
f = CSV.File(IOBuffer(csv); skipto=1, footerskip=1)
@test length(f) == 4
f = CSV.File(IOBuffer(csv); skipto=1, footerskip=2)
@test length(f) == 3

f = CSV.File(IOBuffer(join(rand(["a", "b", "c"], 500), "\n")); header=false, ntasks=2)
rt = Tables.rowtable(f)
@test length(rt) == 500
@test eltype(rt) == NamedTuple{(:Column1,), Tuple{InlineString1}}

f = CSV.File(IOBuffer("a, 0.1, 0.2, 0.3\nb, 0.4"); transpose=true)
@test length(f) == 3
@test f.a == [0.1, 0.2, 0.3]
@test isequal(f.b, [0.4, missing, missing])

# 845
f = CSV.File(IOBuffer("x\n\0\n"))
@test length(f) == 1
@test f.x[1] == "\0"

# 836
f = CSV.File(IOBuffer("x\n\"abc\"\n"); quoted=false)
@test f.x[1] == "\"abc\""

# 768
f = CSV.File(IOBuffer("a,b,c\n1,2,3\n,null,4\n"), missingstring=nothing)
@test eltype(f.a) <: AbstractString
@test f.a[2] == ""

# 858
row = first(CSV.Rows(IOBuffer("a,b,c\n1,2,3\n\n"); select=[:a, :c]))
@test length(row) == 2
@test row.a == "1" && row.c == "3"

# 802; throw error when invalid columns passed in types/dateformat/pool keyword arguments
@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); types=Dict(4 => Float64))
@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); types=Dict(:d => Float64))
@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); types=Dict("d" => Float64))

@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); dateformat=Dict(4 => "dd/mm/yyyy"))
@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); dateformat=Dict(:d => "dd/mm/yyyy"))
@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); dateformat=Dict("d" => "dd/mm/yyyy"))

@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); pool=Dict(4 => true))
@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); pool=Dict(:d => true))
@test_throws ArgumentError CSV.File(IOBuffer("a,b,c\n1,2,3"); pool=Dict("d" => true))

# 910; disable checking of invalid columns passed in types/dateformat/pool keyword arguments
@test (@test_logs CSV.File(
    IOBuffer("a,b,c\n1,2,3");
    types=Dict(4 => Float64),
    dateformat=Dict(:e => "dd/mm/yyyy"),
    pool=Dict("f" => true),
    validate=false
)) isa CSV.File

# 871

f = CSV.File(IOBuffer("a,b,c\n1,2,3\n3.14,5,6\n"); typemap=IdDict(Float64 => String))
@test f.a isa AbstractVector{<:AbstractString}

# support SubArray{UInt8} as source
f = CSV.File(IOBuffer(strip(""""column_name","data_type","is_nullable"\nfoobar,string,YES\nbazbat,timestamptz,YES""")))
@test length(f) == 2
@test f.column_name == ["foobar", "bazbat"]
data = Vector{UInt8}(""""column_name","data_type","is_nullable"\nfoobar,string,YES\nbazbat,timestamptz,YES""")
f = CSV.File(@view(data[:]))
@test length(f) == 2
@test f.column_name == ["foobar", "bazbat"]

# Preprocessing must honor SubArray and IOBuffer source bounds.
data = Vector{UInt8}("a,b\n1,2\n3,4\n")
compressed = transcode(GzipCompressor, data)
prefix = Vector{UInt8}("ignored prefix")
suffix = Vector{UInt8}("ignored suffix")

parent = vcat(prefix, compressed, suffix)
firstbyte = length(prefix) + 1
lastbyte = firstbyte + length(compressed) - 1
for buffer_in_memory in (false, true)
    f = CSV.File(@view(parent[firstbyte:lastbyte]); buffer_in_memory)
    @test Tables.rowtable(f) == [(a=1, b=2), (a=3, b=4)]
end

io = IOBuffer(vcat(prefix, compressed))
seek(io, length(prefix))
f = CSV.File(io)
@test Tables.rowtable(f) == [(a=1, b=2), (a=3, b=4)]

parent = vcat(compressed, data)
firstbyte = length(compressed) + 1
f = CSV.File(@view(parent[firstbyte:end]))
@test Tables.rowtable(f) == [(a=1, b=2), (a=3, b=4)]

parent = vcat(prefix, data, suffix)
firstbyte = length(prefix) + 1
lastbyte = firstbyte + length(data) - 1
f = CSV.File(@view(parent[firstbyte:lastbyte]); footerskip=1)
@test Tables.rowtable(f) == [(a=1, b=2)]
@test isempty(CSV.File(UInt8[0xef, 0xbb, 0xbf]; footerskip=1))

# 901; nonstandard types passed via types=T
f = CSV.File(IOBuffer("a,b,c\n1.2,3.4,5.6\n"); types=Float32)
@test length(f) == 1
@test NamedTuple(f[1]) === (a=Float32(1.2), b=Float32(3.4), c=Float32(5.6))

f = CSV.File(IOBuffer("a,b,c\n1.2,3.4,5.6\n"); types=BigFloat)
@test length(f) == 1
@test f[1].a == BigFloat("1.2") && f[1].b == BigFloat("3.4") && f[1].c == BigFloat("5.6")

# 894
f = CSV.File(codeunits("a,b,c\n1.2,3.4,5.6\n"))
@test length(f) == 1
@test NamedTuple(f[1]) === (a=1.2, b=3.4, c=5.6)

# 896
f = CSV.File(codeunits("a,b,c,d\n1,2,3.14,hey\n4,2,6.5,hey\n");
                types=(i, nm) -> i == 1 ? Int8 : i == 2 ? BigInt : i == 3 ? Float64 : String,
                pool=(i, nm) -> i == 2 ? true : nothing)
@test f.a == [1, 4]
@test eltype(f.a) == Int8
@test f.b == [2, 2]
@test f.b isa PooledVector{BigInt}
@test f.c == [3.14, 6.5]
@test f.d == ["hey", "hey"]

# 929
str = """id,pos_1,pos_2,pos_3,has_prisoner,capture_time,shape
5,11,86,1,false,0,diamond
4,5,43,1,false,0,diamond
6,16,90,1,false,0,diamond
7,75,35,1,false,0,diamond
2,35,89,1,false,0,diamond
10,81,25,1,false,0,diamond
9,48,98,1,false,0,diamond
8,98,62,1,false,0,diamond
3,50,2,1,false,0,diamond
1,95,24,1,false,0,diamond"""
r = collect(CSV.Rows(IOBuffer(str); types=Dict(:shape => Symbol)))
@test length(r) == 10

# 932
f = CSV.File(joinpath(dir, "multithreadedpromote.csv"))
@test eltype(f.col1) == String7
@test length(f) == 5001

# 942
data = """
name, age
Jack, 12
Tom, 10
"""
f = CSV.File(IOBuffer(data); select=[2], type=Int32)
@test length(f) == 2
@test length(f.names) == 1

# 939
row = join((i == 1 ? string(i + 10000000000) : i == 60_000 ? "0\n" : rand(("-1", "0", "1")) for i = 1:60_000), " ")
data = repeat(row, 271);
f = CSV.File(IOBuffer(data); header=false, types=Dict(1 => String), typemap=IdDict(Int => Int8));
@test f.types == [i == 1 ? String : Int8 for i = 1:60_000]
f = CSV.File(IOBuffer(data); header=false, types=Dict(1 => String), downcast=true);
@test f.types == [i == 1 ? String : Int8 for i = 1:60_000]

f = CSV.File(IOBuffer(data); header=false, types=Dict(1 => String), typemap=Dict(Int => Int8), ntasks=16);
@test f.types == [i == 1 ? String : Int8 for i = 1:60_000]

# 948
f = @test_logs CSV.File(IOBuffer("a,b\n1,2\n3,"))
@test f.a == [1, 3]
@test isequal(f.b, [2, missing])

# 1190
for source in ("a,b,c\n1,2,3\n4,5", "a,b,c\n1,2,3\n4,5\n")
    f = @test_logs (:warn, r"only found 2 / 3 columns around data row: 2") CSV.File(IOBuffer(source))
    @test isequal(f.c, [3, missing])
end

# duplicate column names
f = CSV.File(IOBuffer("a,a,a\n"))
@test f.names == [:a, :a_1, :a_2]

f = CSV.File(IOBuffer("a,a_1,a\n"))
@test f.names == [:a, :a_1, :a_2]

f = CSV.File(IOBuffer("a,a,a_1\n")) # this case is not covered in test_duplicate_columnnames.csv
@test f.names == [:a, :a_2, :a_1]

# 951
data = """
| Name       |  Zip |
| Joe        |  123 |
| Mary Anne  | 1234 |
"""
f = CSV.File(IOBuffer(data); delim='|', normalizenames=true, stripwhitespace=false)
@test f.Name[1] == " Joe        "
f = CSV.File(IOBuffer(data); delim='|', stripwhitespace=true)
@test f.Name[2] == "Mary Anne"

# 963
f = CSV.File(IOBuffer(join((rand(("a,$(rand())", "b,$(rand())")) for _ = 1:10^6), "\n")), header=false, limit=10000)
@test length(f) == 10000

# fix bool detection
f = CSV.File(IOBuffer("a\nfalse\n"))
@test eltype(f.a) == Bool

# 1014
# types is Dict{Regex}
data = IOBuffer("a_col,b_col,c,d\n1,2,3.14,hey\n4,2,6.5,hey\n")
f = CSV.File(data; types=Dict(r"_col$" => Int16))
@test eltype(f.a_col) == Int16
@test eltype(f.b_col) == Int16
@test_throws ArgumentError CSV.File(data; types=Dict(r"_column$" => Int16))
# types is Dict{Any} including `Regex` key
f = CSV.File(data; types=Dict(r"_col$" => Int16, "c" => Float16))
@test eltype(f.a_col) == Int16
@test eltype(f.b_col) == Int16
@test eltype(f.c) == Float16
# Regex has lower precedence than exact column name/number match
f = CSV.File(data; types=Dict(r"_col$" => Int16, :a_col => Int8))
@test eltype(f.a_col) == Int8
@test eltype(f.b_col) == Int16
# dateformat supports Regex
f = CSV.File(IOBuffer("time,date1,date2\n10:00:00.0,04/16/2020,04/17/2022\n"); dateformat=Dict(r"^date"=>"mm/dd/yyyy"))
@test f[1].date1 == Dates.Date(2020, 4, 16)
@test f[1].date2 == Dates.Date(2022, 4, 17)

# 1021 - https://github.com/JuliaData/CSV.jl/issues/1021
# user-given types for columns only found later in file
str = """
    1 2 3
    1 2
    1 2 3 4
    1
    1 2 3 4 5
    """
f = CSV.File(IOBuffer(str); delim=" ", header=false, types=String)
@test String <: eltype(f.Column5)
# case where `types isa AbstractVector`
f = CSV.File(IOBuffer(str); delim=" ", header=false, types=[Int8, Int16, Int32, Int64, Int128])
@test Int128 <: eltype(f.Column5)
# case where `types isa Function`
f = CSV.File(IOBuffer(str); delim=" ", header=false, types=(i,nm) -> (i == 5 ? Int8 : String))
@test Int8 <: eltype(f.Column5)
# case where `types isa AbstractDict`
f = CSV.File(IOBuffer(str); delim=" ", header=false, types=Dict(r".*" => Float16))
@test Float16 <: eltype(f.Column5)

# 1080
# bug in reading multiple files when a column shares name with a field in File
f = CSV.File(map(IOBuffer, ["name\n2\n", "name\n11\n"]))
@test f.name == [2, 11]

end

using Documenter, CSV

makedocs(;
    modules=[CSV],
    format=Documenter.HTML(prettyurls=false),
    pages=[
        "Home" => "index.md",
        "Reading" => "reading.md",
        "Writing" => "writing.md",
        "Examples" => "examples.md",
    ],
    repo="https://github.com/JuliaData/CSV.jl/blob/{commit}{path}#{line}",
    sitename="CSV.jl",
    authors="Jacob Quinn",
    warnonly = Documenter.except(),
)

deploydocs(;
    repo="github.com/JuliaData/CSV.jl",
    devbranch = "main"
)

using Test, CSV, Mmap, Dates, Tables, PooledArrays, CodecZlib, FilePathsBase, SentinelArrays, Parsers, WeakRefStrings, InlineStrings
using LazyArtifacts

const dir = artifact"testfiles"

@eval macro $(:try)(ex)
    quote
        try $(esc(ex))
        catch
        end
    end
end

@testset "CSV" begin

@testset "CSV.File" begin

include("basics.jl")
include("testfiles.jl")
include("iteration.jl")

end # @testset "CSV.File"

include("write.jl")

@testset "PooledArrays" begin

    f = CSV.File(IOBuffer("X\nb\nc\na\nc"), pool=true)
    @test typeof(f.X) == PooledArrays.PooledArray{InlineString1,UInt32,1,Array{UInt32,1}}
    @test (length(f), length(f.names)) == (4, 1)
    @test f.X == ["b", "c", "a", "c"]
    @test f.X.refs[2] == f.X.refs[4]

    f = CSV.File(IOBuffer("X\nb\nc\na\nc"), pool=0.75)
    @test typeof(f.X) == PooledArrays.PooledArray{InlineString1,UInt32,1,Array{UInt32,1}}
    @test (length(f), length(f.names)) == (4, 1)
    @test f.X == ["b", "c", "a", "c"]
    @test f.X.refs[2] == f.X.refs[4]

    f = CSV.File(IOBuffer("X\nb\nc\n\nc"), pool=true, ignoreemptyrows=false)
    @test typeof(f.X) == PooledArray{Union{Missing, InlineString1},UInt32,1,Array{UInt32,1}}
    @test (length(f), length(f.names)) == (4, 1)
    @test f.X[3] === missing

    f = CSV.File(IOBuffer("X\nc\nc\n\nc\nc\nc\nc\nc\nc"), pool=0.25, ignoreemptyrows=false)
    @test typeof(f.X) == PooledArray{Union{Missing, InlineString1},UInt32,1,Array{UInt32,1}}
    @test (length(f), length(f.names)) == (9, 1)
    @test isequal(f.X, ["c", "c", missing, "c", "c", "c", "c", "c", "c"])

end

@testset "CSV.Rows" begin

    rows = CSV.Rows(IOBuffer("X\nb\nc\na\nc"))
    show(rows)
    row = first(rows)
    @test row.X == "b"
    @test row[1] == "b"

    # limit
    rows = collect(CSV.Rows(IOBuffer("X\nb\nc\na\nc"), limit=1))
    @test length(rows) == 1
    @test rows[1][1] == "b"
    rows = collect(CSV.Rows(IOBuffer("X\nb\nc\na\nc"), limit=0))
    @test length(rows) == 0

    # transpose
    rows = collect(CSV.Rows(IOBuffer("x,1\nx2,2\n"), transpose=true))
    @test length(rows) == 1
    @test rows[1].x == "1"
    @test rows[1].x2 == "2"

    # ignorerepeated
    rows = collect(CSV.Rows(IOBuffer("x   y   z\n   1   2   3"), ignorerepeated=true, delim=' '))
    @test length(rows) == 1
    @test length(rows[1]) == 3
    @test all(rows[1] .== ["1", "2", "3"])
    row = rows[1]
    @test CSV.Parsers.parse(Int, row, 1) == 1
    @test CSV.Parsers.parse(Int, row, :x) == 1
    @test CSV.detect(row, 2) == 2
    @test CSV.detect(row, :y) == 2

    # 448
    @test_throws ArgumentError CSV.Rows(IOBuffer("x\n1\n2\n3\n#4"), ignorerepeated=true)

    # 447
    rows = collect(CSV.Rows(IOBuffer("a,b,c\n1,2,3\n\n")))
    @test length(rows) == 1
    @test all(rows[1] .== ["1", "2", "3"])

    # not enough columns
    rows = collect(CSV.Rows(IOBuffer("x,y,z\n1\n2,3\n4,5,6")))
    @test length(rows) == 3
    @test all(isequal.(rows[1], ["1", missing, missing]))
    @test all(isequal.(rows[2], ["2", "3", missing]))
    @test all(rows[3] .== ["4", "5", "6"])

    # too many columns
    rows = collect(CSV.Rows(IOBuffer("x,y,z\n1,2,3\n4,5,6,7,8,")))
    @test length(rows) == 2
    @test isequal(values(rows[1]), ["1", "2", "3", missing, missing])
    @test isequal(values(rows[2]), ["4", "5", "6", "7", "8"])

    # fatal
    @test_throws CSV.Error collect(CSV.Rows(IOBuffer("x\n\"invalid quoted field")))

    # reusebuffer
    rows = collect(CSV.Rows(IOBuffer("x\n1\n2\n3")))
    @test length(rows) == 3
    @test rows[1][1] == "1"
    @test rows[2][1] == "2"
    @test rows[3][1] == "3"
    rows = collect(CSV.Rows(IOBuffer("x\n1\n2\n3"), reusebuffer=true))
    @test length(rows) == 3
    @test rows[1][1] == "3"
    @test rows[2][1] == "3"
    @test rows[3][1] == "3"

    for (i, row) in enumerate(CSV.Rows(IOBuffer("x\n1\n2\n3"), reusebuffer=true))
        @test all(row .== [string(i)])
    end

    # 903
    rows = collect(CSV.Rows(IOBuffer("int,float,date,datetime,bool,null,str,catg,int_float\n1,3.14,2019-01-01,2019-01-01T01:02:03,true,,hey,abc,2\n,,,,,,,,\n2,NaN,2019-01-02,2019-01-03T01:02:03,false,,there,abc,3.14\n"); types=[Int, Float64, Date, DateTime, Bool, Missing, String, String, Float64]))
    @test isequal(collect(rows[1]), [1, 3.14, Date(2019, 1, 1), DateTime(2019, 1, 1, 1, 2, 3), true, missing, "hey", "abc", 2.0])
    foreach(x -> @test(x === missing), rows[2])
    @test isequal(collect(rows[3]), [2, NaN, Date(2019, 1, 2), DateTime(2019, 1, 3, 1, 2, 3), false, missing, "there", "abc", 3.14])
end

@testset "CSV.detect" begin

@test CSV.detect("") == ""
@test CSV.detect("1") == 1
@test CSV.detect("1.1") == 1.1
@test CSV.detect("2015-01-01") == Date(2015)
@test CSV.detect("2015-01-01T03:04:05") == DateTime(2015, 1, 1, 3, 4, 5)
@test CSV.detect("03:04:05") == Time(3, 4, 5)
@test CSV.detect("true") === true
@test CSV.detect("false") === false
@test CSV.detect("abc") === "abc"

end

@testset "CSV.promote_types" begin

@test CSV.promote_types(Int64, Float64) == Float64
@test CSV.promote_types(Int64, Int64) == Int64
@test CSV.promote_types(CSV.NeedsTypeDetection, Float64) == Float64
@test CSV.promote_types(Float64, CSV.NeedsTypeDetection) == Float64
@test CSV.promote_types(Float64, Missing) == Float64
@test CSV.promote_types(Float64, String) === String

end

@testset "CSV.File with select/drop" begin

csv = """
a,b,c,d,e
1,2,3,4,5
6,7,8,9,10
"""

f = CSV.File(IOBuffer(csv), select=[1, 3, 5])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), select=[:a, :c, :e])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), select=["a", "c", "e"])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), select=[true, false, true, false, true])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), select=(i, nm) -> i in (1, 3, 5))
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), select=Int[])
@test length(f) == 2
@test length(f[1]) == 0

f = CSV.File(IOBuffer(csv), select=[1, 2, 3, 4, 5])
@test length(f) == 2
@test length(f[1]) == 5

f = CSV.File(IOBuffer(csv), drop=[2, 4])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), drop=[:b, :d])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), drop=["b", "d"])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), drop=[false, true, false, true, false])
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), drop=(i, nm) -> i in (2, 4))
@test f.a == [1, 6]
@test all(f[1] .== [1, 3, 5])
@test length(f[1]) == 3

f = CSV.File(IOBuffer(csv), drop=Int[])
@test length(f) == 2
@test length(f[1]) == 5

f = CSV.File(IOBuffer(csv), drop=[1, 2, 3, 4, 5])
@test length(f) == 2
@test length(f[1]) == 0

end

@testset "CSV.Chunks" begin

chunks = CSV.Chunks(transcode(GzipDecompressor, Mmap.mmap(joinpath(dir, "randoms.csv.gz"))); ntasks=2)
@test length(chunks) == 2
state = iterate(chunks)
f, st = state
@test length(f) == 35086
state = iterate(chunks, st)
f, st = state
@test length(f) == 34914

end

function strs(x::Vector, e=nothing)
    len = sum(x -> sizeof(coalesce(x, "")), x)
    data = Vector{UInt8}(undef, len)
    poslens = Vector{PosLen}(undef, length(x))
    pos = 1
    anymissing = false
    for (i, s) in enumerate(x)
        if s !== missing
            slen = sizeof(s)
            bytes = codeunits(s)
            copyto!(data, pos, bytes, 1, slen)
            poslens[i] = PosLen(pos, slen, false, e !== nothing && e in bytes)
            pos += slen
        else
            anymissing = true
            poslens[i] = PosLen(pos, 0, true, false)
        end
    end
    return PosLenStringVector{anymissing ? Union{Missing, PosLenString} : PosLenString}(data, poslens, something(e, 0x00))
end

arrtype(x::ChainedVector{T, AT}) where {T, AT} = AT

@testset "CSV.chaincolumns!" begin

mv = MissingVector(1)
vec = [big(1)]
svec = convert(SentinelArray{BigInt}, [big(1), missing])
# MissingVector -> Vector{CustomType}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), vec)) == typeof(svec)
# Vector{CustomType} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), mv)) == typeof(svec)
# MissingVector -> SentinelVector{CustomType}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), svec)) == typeof(svec)
# SentinelVector{CustomType} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), mv)) == typeof(svec)
# Vector{CustomType} -> SentinelVector{CustomType}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), svec)) == typeof(svec)
# SentinelVector{CustomType} -> Vector{CustomType}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), vec)) == typeof(svec)
# Vector{CustomType} -> Vector{CustomType}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), vec)) == Vector{BigInt}
# SentinelVector{CustomType} -> SentinelVector{CustomType}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), svec)) == typeof(svec)

vec = strs(["hey", "there", "sailor"])
svec = strs(["hey", "ho", missing])
# MissingVector -> PosLenStringVector{PosLenString}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), vec)) <: PosLenStringVector{Union{PosLenString, Missing}}
# PosLenStringVector{PosLenString} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), mv)) <: PosLenStringVector{Union{PosLenString, Missing}}
# MissingVector -> PosLenStringVector{Union{PosLenString, Missing}}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), svec)) <: PosLenStringVector{Union{PosLenString, Missing}}
# PosLenStringVector{Union{PosLenString, Missing}} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), mv)) <: PosLenStringVector{Union{PosLenString, Missing}}
# PosLenStringVector{PosLenString} -> PosLenStringVector{Union{PosLenString, Missing}}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), svec)) <: PosLenStringVector{Union{PosLenString, Missing}}
# PosLenStringVector{Union{PosLenString, Missing}} -> PosLenStringVector{PosLenString}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), vec)) <: PosLenStringVector{Union{PosLenString, Missing}}

vec = [true, false, true]
svec = [true, false, missing]
# MissingVector -> Vector{Bool}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), vec)) == Vector{Union{Bool, Missing}}
# Vector{Bool} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), mv)) == Vector{Union{Bool, Missing}}
# MissingVector -> Vector{Union{Bool, Missing}}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), svec)) == Vector{Union{Bool, Missing}}
# Vector{Union{Bool, Missing}} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), mv)) == Vector{Union{Bool, Missing}}
# Vector{Bool} -> Vector{Union{Bool, Missing}}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), svec)) == Vector{Union{Bool, Missing}}
# Vector{Union{Bool, Missing}} -> Vector{Bool}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), vec)) == Vector{Union{Bool, Missing}}

vec = Int32[1, 2, 3]
svec = Union{Int32, Missing}[1, 2, missing]
# MissingVector -> Vector{Int32}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), vec)) == Vector{Union{Int32, Missing}}
# Vector{Int32} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), mv)) == Vector{Union{Int32, Missing}}
# MissingVector -> Vector{Union{Int32, Missing}}
@test arrtype(CSV.chaincolumns!(ChainedVector([mv]), svec)) == Vector{Union{Int32, Missing}}
# Vector{Union{Int32, Missing}} -> MissingVector
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), mv)) == Vector{Union{Int32, Missing}}
# Vector{Int32} -> Vector{Union{Int32, Missing}}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec]), svec)) == Vector{Union{Int32, Missing}}
# Vector{Union{Int32, Missing}} -> Vector{Int32}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec]), vec)) == Vector{Union{Int32, Missing}}

vec1 = Int32[1, 2, 3]
vec2 = Int64[1, 2, 3]
svec1 = convert(SentinelArray{Int32}, [Int32(1), Int32(2), missing])
svec2 = convert(SentinelArray{Int64}, [Int64(1), Int64(2), missing])
# Vector{Int32} -> Vector{Int64}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), vec2)) == Vector{Int64}
# Vector{Int64} -> Vector{Int32}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec2]), vec1)) == Vector{Int64}
# Vector{Int32} -> SentinelVector{Int64}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), svec2)) == typeof(svec2)
# SentinelVector{Int32} -> Vector{Int64}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), vec2)) == typeof(svec2)
# SentinelVector{Int32} -> SentinelVector{Int64}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), svec2)) == typeof(svec2)
# SentinelVector{Int64} -> SentinelVector{Int32}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec2]), svec1)) == typeof(svec2)

vec1 = String3["hey", "ho"]
vec2 = String7["hey", "ho"]
svec1 = convert(SentinelArray{String3}, [String3("hey"), missing])
svec2 = convert(SentinelArray{String7}, [String7("hey"), missing])
# Vector{InlineString3} -> Vector{InlineString7}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), vec2)) == Vector{String7}
# Vector{InlineString7} -> Vector{InlineString3}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec2]), vec1)) == Vector{String7}
# Vector{InlineString3} -> SentinelVector{InlineString7}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), svec2)) == typeof(svec2)
# SentinelVector{InlineString3} -> Vector{InlineString7}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), vec2)) == typeof(svec2)
# SentinelVector{InlineString3} -> SentinelVector{InlineString7}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), svec2)) == typeof(svec2)
# SentinelVector{InlineString7} -> SentinelVector{InlineString3}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec2]), svec1)) == typeof(svec2)

vec1 = Int64[1, 2]
vec2 = [3.14, 2.28]
svec1 = convert(SentinelArray{Int64}, [Int64(1), missing])
svec2 = convert(SentinelArray{Float64}, [3.14, missing])
# Vector{Int64} -> Vector{Float64}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), vec2)) == Vector{Float64}
# Vector{Float64} -> Vector{Int64}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec2]), vec1)) == Vector{Float64}
# Vector{Int64} -> SentinelVector{Float64}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), svec2)) == typeof(svec2)
# SentinelVector{Int64} -> Vector{Float64}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), vec2)) == typeof(svec2)
# SentinelVector{Int64} -> SentinelVector{Float64}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), svec2)) == typeof(svec2)
# SentinelVector{Float64} -> SentinelVector{Int64}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec2]), svec1)) == typeof(svec2)

vec1 = String3["hey", "ho"]
vec2 = ["hey", "ho"]
svec1 = convert(SentinelArray{String3}, [String3("hey"), missing])
svec2 = convert(SentinelArray{String}, ["ho", missing])
# Vector{InlineString3} -> Vector{String}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), vec2)) == Vector{String}
# Vector{String} -> Vector{InlineString3}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec2]), vec1)) == Vector{String}
# Vector{InlineString3} -> SentinelVector{String}
@test arrtype(CSV.chaincolumns!(ChainedVector([vec1]), svec2)) == typeof(svec2)
# SentinelVector{InlineString3} -> Vector{String}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), vec2)) == typeof(svec2)
# SentinelVector{InlineString3} -> SentinelVector{String}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec1]), svec2)) == typeof(svec2)
# SentinelVector{String} -> SentinelVector{InlineString3}
@test arrtype(CSV.chaincolumns!(ChainedVector([svec2]), svec1)) == typeof(svec2)

vec1 = String3["hey", "ho"]
vec2 = ["hey", "ho"]
svec1 = convert(SentinelArray{String3}, [String3("hey"), missing])
svec2 = convert(SentinelArray{String}, ["ho", missing])
function pvecs(vec1, vec2, svec1, svec2)
    return PooledArray(vec1), PooledArray(vec2), PooledArray(svec1), PooledArray(svec2)
end
# MissingVector -> PooledVector{String7}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(mv, pvec1)) == typeof(psvec1)
# PooledVector{String} -> MissingVector
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(pvec2, mv)) == typeof(psvec2)
# MissingVector -> PooledVector{Union{String, Missing}}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(mv, psvec2)) == typeof(psvec2)
# PooledVector{Union{String7, Missing}} -> MissingVector
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(psvec1, mv)) == typeof(psvec1)
# PooledVector{String} -> Vector{String}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(pvec2, vec2)) == typeof(pvec2)
# PooledVector{String} -> SentinelVector{String7}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(pvec2, svec1)) == typeof(psvec2)
# PooledVector{Union{String, Missing}} -> Vector{String}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(psvec2, vec2)) == typeof(psvec2)
# PooledVector{Union{String7, Missing}} -> SentinelVector{String}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(psvec1, svec2)) == typeof(psvec2)
# PooledVector{String} -> PooledVector{Union{String, Missing}}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(pvec2, psvec2)) == typeof(psvec2)
# PooledVector{String} -> PooledVector{Union{String7, Missing}}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(pvec2, psvec1)) == typeof(psvec2)
# Vector{String} -> PooledVector{String7}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(vec2, pvec1)) == typeof(pvec2)
# SentinelVector{String} -> PooledVector{String7}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(svec2, pvec1)) == typeof(psvec2)
# Vector{String7} -> PooledVector{Union{String, Missing}}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(vec1, psvec2)) == typeof(psvec2)
# SentinelVector{String7} -> PooledVector{Union{String, Missing}}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(svec1, psvec2)) == typeof(psvec2)
# PooledVector{Union{String7, Missing}} -> PooledVector{String7}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(psvec1, pvec1)) == typeof(psvec1)
# PooledVector{Union{String, Missing}} -> PooledVector{String7}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(psvec2, pvec1)) == typeof(psvec2)

# issue 925; ambiguity in `CSV._promote(::Type{PooledVector{T,R,RA}}, x::PooledVector{T,R,RA})`
# PooledVector{String3} -> PooledVector{String}
pvec1, pvec2, psvec1, psvec2 = pvecs(vec1, vec2, svec1, svec2)
@test typeof(CSV.chaincolumns!(pvec1, pvec2)) == typeof(pvec2)

end

@testset "CSV.File vector inputs" begin

data = [
    "a,b,c\n1,2,3\n4,5,6\n",
    "a,b,c\n7,8,9\n10,11,12\n",
    "a,b,c\n13,14,15\n16,17,18",
]

f = CSV.File(map(IOBuffer, data))
@test length(f) == 6
@test f.names == [:a, :b, :c]
@test f.a == [1, 4, 7, 10, 13, 16]

data = [
    "a,b\nbill,x\njane,y\n",
    "a,b\ntomm,z\ntimm,\n",
    "a,b\njoee,z\njerr,g\n",
]

f = CSV.File(map(IOBuffer, data))
@test length(f) == 6
@test isequal(f.b, ["x", "y", "z", missing, "z", "g"])

data = [
    "a,b,c\n1,2,3\n4,5,6\n",
    "a,b,c\n7.14,8,9\n10,11,12\n",
    "a,b,c\n13,14,15\n16,17,18",
]

f = CSV.File(map(IOBuffer, data))
@test eltype(f.a) == Float64

data = [
    "a,b,c\n1,2,3\n4,5,6\n",
    "a2,b,c\n7,8,9\n10,11,12\n",
    "a,b,c\n13,14,15\n16,17,18",
]

f = CSV.File(map(IOBuffer, data))
@test isequal(f.a, [1, 4, missing, missing, 13, 16])

f = CSV.File(map(IOBuffer, data); source=:source)
@test eltype(f.source) == String
@test f.source isa PooledArray

f = CSV.File(map(IOBuffer, data); source="source")
@test eltype(f.source) == String
@test f.source isa PooledArray

f = CSV.File(map(IOBuffer, data); source="source"=>[1,2,3])
@test eltype(f.source) <: Integer
@test f.source isa PooledArray

f = CSV.File(map(IOBuffer, data); source=:source=>["1", "2", "3"])
@test eltype(f.source) == String
@test f.source isa PooledArray

end

end

# custom types to represent some special parsing states a column might be in

# not just that a column type is Missing, but that we'll end up dropping the column
# eventually (i.e. implies col.willdrop) or the user specifically set the column
# type to Missing (i.e. col.userprovided && col.type === Missing)
# a column type may be Missing and we still want to try and detect a proper column type
# but in HardMissing case, we don't; we know the column will *always* be Missing
struct HardMissing end

function willdrop!(columns, i)
    @inbounds col = columns[i]
    col.willdrop = true
    col.type = HardMissing
    return
end

struct NeedsTypeDetection end

nonmissingtypeunlessmissingtype(::Type{T}) where {T} = ifelse(T === Missing, Missing, nonmissingtype(T))
finaltype(T) = T
finaltype(::Type{HardMissing}) = Missing
finaltype(::Type{NeedsTypeDetection}) = Missing
coltype(col) = ifelse(col.anymissing, Union{finaltype(col.type), Missing}, finaltype(col.type))

maybepooled(col) = col.pool isa Tuple ? (col.pool[1] > 0.0) : (col.pool > 0.0)

function getpool(x)::Union{Float64, Tuple{Float64, Int}}
    if x isa Bool
        return x ? 1.0 : 0.0
    elseif x isa Tuple
        y = Float64(x[1])
        (isnan(y) || 0.0 <= y <= 1.0) || throw(ArgumentError("pool tuple 1st argument must be in the range: 0.0 <= x <= 1.0"))
        try
            z = Int(x[2])
            @assert z > 0
            return (y, z)
        catch
            throw(ArgumentError("pool tuple 2nd argument must be a positive integer > 0"))
        end
    else
        y = Float64(x)
        (isnan(y) || 0.0 <= y <= 1.0) || throw(ArgumentError("pool argument must be in the range: 0.0 <= x <= 1.0"))
        return y
    end
end

tupcat(::Type{Tuple{}}, S) = Tuple{S}
tupcat(::Type{Tuple{T}}, S) where {T} = Tuple{T, S}
tupcat(::Type{Tuple{T, T2}}, S) where {T, T2} = Tuple{T, T2, S}
tupcat(::Type{Tuple{T, T2, T3}}, S) where {T, T2, T3} = Tuple{T, T2, T3, S}
tupcat(::Type{Tuple{T, T2, T3, T4}}, S) where {T, T2, T3, T4} = Tuple{T, T2, T3, T4, S}
tupcat(::Type{T}, S) where {T <: Tuple} = Tuple{Any[(fieldtype(T, i) for i = 1:fieldcount(T))..., S]...}

const StringTypes = Union{Type{String}, Type{PosLenString}, Type{<:InlineString}}
pickstringtype(T, maxstringsize) = T === InlineString ? (maxstringsize < DEFAULT_MAX_INLINE_STRING_LENGTH ? InlineStringType(maxstringsize) : String) : T

# we define our own bit flag on a Parsers.ReturnCode to signal if a column needs to promote to string
const PROMOTE_TO_STRING = 0b0100000000000000 % Int16
promote_to_string(code) = code & PROMOTE_TO_STRING > 0

isinttype(T) = T === Int8 || T === Int16 || T === Int32 || T === Int64 || T === Int128

@inline function promote_types(@nospecialize(T), @nospecialize(S))
    T === S && return T
    T === NeedsTypeDetection && return S
    S === NeedsTypeDetection && return T
    T === Missing && return S
    S === Missing && return T
    isinttype(T) && isinttype(S) && return promote_type(T, S)
    isinttype(T) && S === Float64 && return S
    T === Float64 && isinttype(S) && return T
    T <: InlineString && S <: InlineString && return promote_type(T, S)
    (T === String || S === String) && return String
    T <: InlineString && return T
    S <: InlineString && return S
    return nothing
end

# when users pass non-standard types, we need to keep track of them in a Tuple{...} to generate efficient custom parsing kernel codes
@inline function nonstandardtype(T)
    T = nonmissingtype(T)
    if T === Union{} ||
       T === NeedsTypeDetection ||
       T isa StringTypes ||
       isinttype(T) ||
       T === Float16 ||
       T === Float32 ||
       T === Float64 ||
       T === Bool ||
       T === Date ||
       T === DateTime ||
       T === Time
        return Union{}
    end
    return T
end

## column array allocating
# we don't want to use SentinelVector for small integer types due to the higher risk of
# sentinel value collision, so we just use Vector{Union{T, Missing}} and convert to Vector{T} if no missings were found
const SmallIntegers = Union{Int8, UInt8, Int16, UInt16, Int32, UInt32}

const SVec{T} = SentinelVector{T, T, Missing, Vector{T}}
const SVec2{T} = SentinelVector{T, typeof(undef), Missing, Vector{T}}

promotevectype(::Type{T}) where {T <: Union{Bool, SmallIntegers}} = vectype(T)
promotevectype(::Type{T}) where {T} = SentinelVector{T}

# allocate columns for a full file
function allocate!(columns, rowsguess)
    for i = 1:length(columns)
        @inbounds col = columns[i]
        # if the type hasn't been detected yet, then column will get allocated
        # in the detect method while parsing
        if col.type !== NeedsTypeDetection
            col.column = allocate(col.type, rowsguess)
        end
    end
    return
end

setmissing!(col, i) = col[i] = missing
const POSLEN_MISSING = PosLen(0, 0, true)
setmissing!(col::Vector{PosLen}, i) = col[i] = POSLEN_MISSING

@inline function allocate(T, len)
    if T === NeedsTypeDetection || T === HardMissing || T === Missing
        # MissingVector is an efficient representation in SentinelArrays.jl package
        return MissingVector(len)
    elseif T === PosLenString
        A = Vector{PosLen}(undef, len)
        memset!(pointer(A), typemax(UInt8), sizeof(A))
        return A
    elseif T === String
        return SentinelVector{String}(undef, len)
    elseif T === Bool
        return Vector{Union{Missing, Bool}}(undef, len)
    elseif T <: SmallIntegers
        return Vector{Union{Missing, T}}(undef, len)
    else
        return SentinelVector{T}(undef, len)
    end
end

function reallocate!(@nospecialize(A), len)
    if A isa Vector{PosLen}
        oldlen = length(A)
        resize!(A, len)
        # when reallocating, we just need to make sure the missing bit is set for lazy string PosLen
        memset!(pointer(A, oldlen + 1), typemax(UInt8), (len - oldlen) * 8)
    else
        resize!(A, len)
    end
    return
end

firstarray(x::ChainedVector) = x.arrays[1]

columntype(::Type{T}) where {T <: Union{Bool, SmallIntegers}} = Vector{Union{T, Missing}}
columntype(::Type{T}) where {T} = isbitstype(T) ? SVec{T} : SVec2{T}
columntype(::Type{PosLenString}) = Vector{PosLen}

vectype(::Type{T}) where {T <: Union{Bool, SmallIntegers}} = Vector{Union{T, Missing}}
vectype(::Type{T}) where {T} = isbitstype(T) ? SVec{T} : SVec2{T}
vectype(::Type{PosLenString}) = PosLenStringVector{Union{PosLenString, Missing}}
pooledvectype(::Type{T}) where {T} = PooledVector{Union{T, Missing}, UInt32, Vector{UInt32}}
pooledtype(::Type{T}) where {T} = PooledVector{T, UInt32, Vector{UInt32}}
# missingvectype(::PooledVector{T, R, AT}) where {T, R, AT} = PooledVector{Union{T, Missing}, R, AT}

_promote(::Type{A}, x::A) where {A} = x
_promote(::Type{A}, x::MissingVector) where {A <: AbstractVector{T}} where {T} = allocate(Base.nonmissingtype(T), length(x))
_promote(::Type{A}, x::Vector) where {A <: SentinelArray{T}} where {T} = convert(SentinelVector{T}, x)
_promote(::Type{Vector{T}}, x::Vector) where {T} = convert(Vector{T}, x)
_promote(::Type{A}, x::SentinelVector) where {A <: SentinelVector{T}} where {T} = convert(SentinelVector{T}, x)
_promote(::Type{PosLenStringVector{Union{PosLenString, Missing}}}, x::PosLenStringVector{PosLenString}) = PosLenStringVector{Union{PosLenString, Missing}}(x.data, x.poslens, x.e)
_promote(::Type{PosLenStringVector{Union{PosLenString, Missing}}}, x::MissingVector) = PosLenStringVector{Union{PosLenString, Missing}}(UInt8[], fill(POSLEN_MISSING, x.len), 0x00)
_promote(::Type{PooledVector{Union{T, Missing}, R, RA}}, x::PooledVector) where {T, R, RA} =
    PooledArray(PooledArrays.RefArray(x.refs), convert(Dict{Union{T, Missing}, UInt32}, x.invpool), convert(Vector{Union{T, Missing}}, x.pool))
_promote(::Type{PooledVector{Union{T, Missing}, R, RA}}, x::MissingVector) where {T, R, RA} =
    PooledArray(PooledArrays.RefArray(fill(UInt32(1), length(x))), Dict{Union{T, Missing}, UInt32}(missing => UInt32(1)), Union{T, Missing}[missing])
_promote(::Type{PooledVector{T, R, RA}}, x) where {T, R, RA} = PooledArray{T}(x)
_promote(::Type{PooledVector{T, R, RA}}, x::PooledVector{T, R, RA}) where {T, R, RA} = x  # avoid ambiguity
_promote(::Type{PooledVector{T, R, RA}}, x::PooledVector{T, R, RA}) where {T>:Missing, R, RA} = x  # avoid ambiguity

function chaincolumns!(@nospecialize(a), @nospecialize(b))
    if a isa PooledArray || b isa PooledArray
        # special-case PooledArrays apart from other container types
        # because we want the outermost array to be PooledArray instead of ChainedVector
        if eltype(a) == eltype(b)
            if a isa PooledArray
                return append!(a, b)
            else
                px = _promote(pooledtype(eltype(a)), a)
                return append!(px, b)
            end
        elseif a isa MissingVector
            P = pooledvectype(eltype(b))
        elseif b isa MissingVector
            P = pooledvectype(eltype(a))
        elseif eltype(a) >: Missing || eltype(b) >: Missing
            P = pooledvectype(promote_types(Base.nonmissingtype(eltype(a)), Base.nonmissingtype(eltype(b))))
        else
            # both arrays are non-missing, but not same eltype, just need to promote
            P = pooledtype(promote_types(eltype(a), eltype(b)))
        end
        px = _promote(P, a)
        py = _promote(P, b)
        return append!(px, py)
    end
    c = firstarray(a)
    if typeof(c) == typeof(b)
        # easiest case; vector types match, so just append
        return append!(a, b)
    elseif c isa MissingVector
        A = vectype(Base.nonmissingtype(eltype(b)))
    elseif b isa MissingVector
        A = vectype(Base.nonmissingtype(eltype(c)))
    elseif c isa Vector && b isa SentinelVector
        A = vectype(promote_types(eltype(c), Base.nonmissingtype(eltype(b))))
    elseif c isa SentinelVector && b isa Vector
        A = vectype(promote_types(Base.nonmissingtype(eltype(c)), eltype(b)))
    elseif c isa PosLenStringVector{PosLenString} && b isa PosLenStringVector{Union{PosLenString, Missing}}
        A = typeof(b)
    elseif c isa PosLenStringVector{Union{PosLenString, Missing}} && b isa PosLenStringVector{PosLenString}
        A = typeof(c)
    elseif c isa Vector{Bool} && b isa Vector{Union{Bool, Missing}}
        A = typeof(b)
    elseif c isa Vector{Union{Bool, Missing}} && b isa Vector{Bool}
        A = typeof(c)
    elseif c isa Vector{<:SmallIntegers} && b isa Vector{<:Union{SmallIntegers, Missing}}
        A = typeof(b)
    elseif c isa Vector{<:Union{SmallIntegers, Missing}} && b isa Vector{<:SmallIntegers}
        A = typeof(c)
    elseif c isa Vector && b isa Vector
        # two vectors, but we know eltype doesn't match, so try to promote
        A = Vector{promote_types(eltype(c), eltype(b))}
    elseif c isa SentinelVector && b isa SentinelVector
        A = vectype(promote_types(Base.nonmissingtype(eltype(c)), Base.nonmissingtype(eltype(b))))
    end
    x = ChainedVector([_promote(A, x) for x in a.arrays])
    y = _promote(A, b)
    return append!(x, y)
end

# one-liner suggested from ScottPJones
consumeBOM(buf, pos) = (length(buf) >= 3 && buf[pos] == 0xef && buf[pos + 1] == 0xbb && buf[pos + 2] == 0xbf) ? pos + 3 : pos

if isdefined(Base, :Memory)
    if isdefined(Base,:wrap)
        __wrap(x) = Base.wrap(Array,x,length(x))
        __wrap(x::Array) = x
    else
        __wrap(x) = view(x,Base.OneTo(length(x)))
        __wrap(x::Array) = x
    end
else
    __wrap(x) = x
end

# whatever input is given, turn it into an AbstractVector{UInt8} we can parse with
@inline function getbytebuffer(x, buffer_in_memory)
    tfile = nothing
    if x isa Vector{UInt8}
        return x, 1, length(x), tfile
    elseif x isa SubArray{UInt8, 1, Vector{UInt8}}
        return parent(x), first(x.indices[1]), last(x.indices[1]), tfile
    elseif x isa StringCodeUnits
        return unsafe_wrap(Vector{UInt8}, x.s), 1, length(x), tfile
    elseif x isa IOBuffer
        if x.data isa Vector{UInt8}
            return x.data, x.ptr, x.size, tfile
        elseif x.data isa SubArray{UInt8}
            x = x.data
            return parent(x), first(x.indices), last(x.indices), tfile
        else #support from IOBuffer containing Memory
            y = __wrap(x.data) #generates a Vector{UInt8} from Memory{UInt8}, if available.
            return y, x.ptr, x.size, tfile
        end
    elseif x isa Cmd || x isa IO
        if buffer_in_memory
            buf = Base.read(x isa Cmd ? open(x) : x)
        else
            buf, tfile = buffer_to_tempfile(CodecZlib.TranscodingStreams.Noop(), x isa Cmd ? open(x) : x)
        end
        return buf, 1, length(buf), tfile
    else
        try
            buf = Mmap.mmap(string(x))
            return buf, 1, length(buf), tfile
        catch e
            # if we can't mmap, try just buffering the whole thing into a tempfile byte vector
            if buffer_in_memory
                buf = Base.read(x)
            else
                buf, tfile = buffer_to_tempfile(CodecZlib.TranscodingStreams.Noop(), open(x))
            end
            return buf, 1, length(buf), tfile
        end
    end
end

function getsource(@nospecialize(x), buffer_in_memory)
    buf, pos, len, tfile = getbytebuffer(x, buffer_in_memory)::Tuple{Vector{UInt8},Int,Int,Union{Nothing,String}}
    if length(buf) >= 2 && buf[1] == 0x1f && buf[2] == 0x8b
        # gzipped source, gunzip it
        if buffer_in_memory
            buf = transcode(GzipDecompressor, buf)
        else
            # 917; if we already buffered input to tempfile, make sure the compressed tempfile is
            # cleaned up since we're only passing the *uncompressed* tempfile up for removal post-parsing
            tfile1 = tfile === nothing ? nothing : tfile
            buf, tfile = buffer_to_tempfile(GzipDecompressor(), IOBuffer(buf))
            if tfile1 !== nothing
                rm(tfile1; force=true)
            end
        end
        pos = 1
        len = length(buf)
    end
    return buf, pos, len, tfile
end

@inline function buffer_to_tempfile(codec, x)
    file, output = mktemp()
    stream = CodecZlib.TranscodingStream(codec, output)
    Base.write(stream, x)
    close(stream)
    return Mmap.mmap(file), file
end

@inline function getname(x)
    if x isa AbstractVector{UInt8}
        return "<raw byte buffer: $(hash(x))>"
    elseif x isa IO
        return string("<", typeof(x), ": $(hash(x))>")
    else
        return string(x)
    end
end

# normalizing column name utilities
const RESERVED = Set(["local", "global", "export", "let",
    "for", "struct", "while", "const", "continue", "import",
    "function", "if", "else", "try", "begin", "break", "catch",
    "return", "using", "baremodule", "macro", "finally",
    "module", "elseif", "end", "quote", "do"])

normalizename(name::Symbol) = name
function normalizename(name::String)::Symbol
    uname = strip(Unicode.normalize(name))
    id = Base.isidentifier(uname) ? uname : map(c->Base.is_id_char(c) ? c : '_', uname)
    cleansed = string((isempty(id) || !Base.is_id_start_char(id[1]) || id in RESERVED) ? "_" : "", id)
    return Symbol(replace(cleansed, r"(_)\1+"=>"_"))
end

function makeunique(names)
    set = Set(names)
    length(set) == length(names) && return Symbol[Symbol(x) for x in names]
    nms = Symbol[]
    nextsuffix = Dict{eltype(names), UInt}()
    for nm in names
        if haskey(nextsuffix, nm)
            k = nextsuffix[nm]
            newnm = Symbol("$(nm)_$k")
            while newnm in set || haskey(nextsuffix, newnm)
                k += 1
                newnm = Symbol("$(nm)_$k")
            end
            nextsuffix[nm] = k + 1
            nm = newnm
        end
        push!(nms, nm)
        nextsuffix[nm] = 1
    end
    @assert length(names) == length(nms)
    return nms
end

getordefault(x::AbstractDict{String}, nm, i, def) = haskey(x, string(nm)) ? x[string(nm)] : def
getordefault(x::AbstractDict{Symbol}, nm, i, def) = haskey(x, nm) ? x[nm] : def
getordefault(x::AbstractDict{Int}, nm, i, def) = haskey(x, i) ? x[i] : def
function getordefault(x::AbstractDict{Regex}, nm, i, def)
    for (re, T) in x
        contains(string(nm), re) && return T
    end
    return def
end
function getordefault(x::AbstractDict, nm, i, def)
    return if haskey(x, i)
        x[i]
    elseif haskey(x, nm)
        x[nm]
    elseif haskey(x, string(nm))
        x[string(nm)]
    else
        val = _firstmatch(x, string(nm))
        val !== nothing ? val : def
    end
end

# return the first value in `x` with a `key::Regex` that matches on `nm`
function _firstmatch(x::AbstractDict, nm::AbstractString)
    for (k, T) in x
        k isa Regex && contains(nm, k) && return T
    end
    return nothing
end

# given a DateFormat, is it meant for parsing Date, DateTime, or Time?
function timetype(df::Parsers.Format)::Union{Type{Date}, Type{Time}, Type{DateTime}}
    date = false
    time = false
    for token in df.tokens
        T = typeof(token)
        if T in (Dates.DatePart{'H'}, Dates.DatePart{'I'}, Dates.DatePart{'M'}, Dates.DatePart{'S'}, Dates.DatePart{'s'})
            time = true
        elseif T in (Dates.DatePart{'y'}, Dates.DatePart{'Y'}, Dates.DatePart{'m'}, Dates.DatePart{'d'}, Dates.DatePart{'u'}, Dates.DatePart{'U'})
            date = true
        end
    end
    return ifelse(date & time, DateTime, ifelse(time, Time, Date))
end

# if a cell value of a csv file has escape characters, we need to unescape it
function unescape(s, e)
    n = ncodeunits(s)
    buf = Base.StringVector(n)
    len = 1
    i = 1
    @inbounds begin
        while i <= n
            b = codeunit(s, i)
            if b == e
                i += 1
                b = codeunit(s, i)
            end
            @inbounds buf[len] = b
            len += 1
            i += 1
        end
    end
    resize!(buf, len - 1)
    return String(buf)
end

"""
    CSV.detect(str::String)

Use the same logic used by `CSV.File` to detect column types, to parse a value from a plain string.
This can be useful in conjunction with the `CSV.Rows` type, which returns each cell of a file as a String.
The order of types attempted is: `Int`, `Float64`, `Date`, `DateTime`, `Bool`, and if all fail, the input String is returned.
No errors are thrown.
For advanced usage, you can pass your own `Parsers.Options` type as a keyword argument `option=ops` for sentinel value detection.
"""
function detect end

@inline pass(code, tlen, x, typecode) = (code, tlen, x, typecode)

function detect(str::String; opts=Parsers.OPTIONS)
    code, tlen, x, xT = detect(pass, codeunits(str), 1, sizeof(str), opts, true)
    return something(x, str)
end

const DetectTypes = Union{Missing, Int8, Int16, Int32, Int64, Float64, Date, DateTime, Time, Bool, Nothing, PosLen}

const NEEDSTYPEDETECTION = 0x01
const HARDMISSING = 0x02
const MISSING = 0x03
const INT8 = 0x04
const INT16 = 0x05
const INT32 = 0x06
const INT64 = 0x07
const FLOAT64 = 0x08
const DATE = 0x09
const DATETIME = 0x0a
const TIME = 0x0b
const BOOL = 0x0c
const STRING = 0x0d
const TYPES = Union{Nothing, Type}[NeedsTypeDetection, HardMissing, Missing, Int8, Int16, Int32, Int64, Float64, Date, DateTime, Time, Bool, nothing]
isinttypecode(T) = T === INT8 || T === INT16 || T === INT32 || T === INT64
promote_typecode(a, b) = max(a, b)
typecode(@nospecialize(T)) = T === Missing ? MISSING : T === Int8 ? INT8 : T === Int16 ? INT16 : T === Int32 ? INT32 : T === Int64 ? INT64 :
                           T === Float64 ? FLOAT64 : T === Date ? DATE : T === DateTime ? DATETIME : T === Time ? TIME : T === Bool ? BOOL :
                           T === NeedsTypeDetection ? NEEDSTYPEDETECTION : T === HardMissing ? HARDMISSING : STRING

concrete_or_concreteunion(T) = isconcretetype(T) ||
    (T isa Union && concrete_or_concreteunion(T.a) && concrete_or_concreteunion(T.b))

@inline smallestint(cb, code, tlen, x) = x < typemax(Int8) ? cb(code, tlen, unsafe_trunc(Int8, x), INT8) : x < typemax(Int16) ? cb(code, tlen, unsafe_trunc(Int16, x), INT16) : x < typemax(Int32) ? cb(code, tlen, unsafe_trunc(Int32, x), INT32) : cb(code, tlen, x, INT64)
_widen(T) = widen(T)
_widen(::Type{Int128}) = Float64
_widen(::Type{Float64}) = nothing

@noinline function _parseany(T, buf, pos, len, opts)::Parsers.Result{Any}
    return Parsers.xparse(T, buf, pos, len, opts, Any)
end

@inline function detect(cb, buf, pos, len, opts, ensure_full_buf_consumed=true, downcast=false, row=0, col=0)
    int = Parsers.xparse(Int, buf, pos, len, opts)
    code, tlen = int.code, int.tlen
    if Parsers.invalidquotedfield(code)
        fatalerror(buf, pos, tlen, code, row, col)
    end
    if Parsers.sentinel(code) && code > 0
        return cb(code, tlen, missing, NEEDSTYPEDETECTION)
    end
    if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
        return downcast ? smallestint(cb, code, tlen, int.val) : cb(code, tlen, int.val, Int === Int64 ? INT64 : INT32)
    end
    float = Parsers.xparse(Float64, buf, pos, len, opts)
    code, tlen = float.code, float.tlen
    if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
        return cb(code, tlen, float.val, FLOAT64)
    end
    if opts.dateformat === nothing
        date = Parsers.xparse(Date, buf, pos, len, opts, Date)
        code, tlen = date.code, date.tlen
        if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
            return cb(code, tlen, date.val, DATE)
        end
        datetime = Parsers.xparse(DateTime, buf, pos, len, opts)
        code, tlen = datetime.code, datetime.tlen
        if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
            return cb(code, tlen, datetime.val, DATETIME)
        end
        time = Parsers.xparse(Time, buf, pos, len, opts)
        code, tlen = time.code, time.tlen
        if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
            return cb(code, tlen, time.val, TIME)
        end
    else
        # use user-provided dateformat
        DT = timetype(opts.dateformat)
        if DT === Date
            dt = Parsers.xparse(DT, buf, pos, len, opts)
            code, tlen = dt.code, dt.tlen
            if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
                return cb(code, tlen, dt.val, DATE)
            end
        elseif DT === Time
            dt2 = Parsers.xparse(DT, buf, pos, len, opts)
            code, tlen = dt2.code, dt2.tlen
            if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
                return cb(code, tlen, dt2.val, TIME)
            end
        elseif DT === DateTime
            dt3 = Parsers.xparse(DT, buf, pos, len, opts)
            code, tlen = dt3.code, dt3.tlen
            if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
                return cb(code, tlen, dt3.val, DATETIME)
            end
        end
    end
    bool = Parsers.xparse(Bool, buf, pos, len, opts)
    code, tlen = bool.code, bool.tlen
    if Parsers.ok(code) && (!ensure_full_buf_consumed || (ensure_full_buf_consumed == ((pos + tlen - 1) == len)))
        return cb(code, tlen, bool.val, BOOL)
    end
    return cb(code, tlen, nothing, STRING)
end

# a ReversedBuf takes a byte vector and indexes backwards;
# used for the footerskip keyword argument, which starts at the bottom of the file
# and skips lines backwards
struct ReversedBuf <: AbstractVector{UInt8}
    buf::Vector{UInt8}
end

Base.size(a::ReversedBuf) = size(a.buf)
Base.IndexStyle(::Type{ReversedBuf}) = Base.IndexLinear()
Base.getindex(a::ReversedBuf, i::Int) = a.buf[end + 1 - i]
Base.pointer(a::ReversedBuf, pos::Integer=1) = pointer(a.buf, length(a.buf) + 1 - pos)

memset!(ptr, value, num) = ccall(:memset, Ptr{Cvoid}, (Ptr{Cvoid}, Cint, Csize_t), ptr, value, num)

struct PointerString
    ptr::Ptr{UInt8}
    len::Int
end

function Base.hash(s::PointerString, h::UInt)
    h += Base.memhash_seed
    ccall(Base.memhash, UInt, (Ptr{UInt8}, Csize_t, UInt32), s.ptr, s.len, h % UInt32) + h
end

import Base: ==
function ==(x::AbstractString, y::PointerString)
    sizeof(x) == y.len && ccall(:memcmp, Cint, (Ptr{UInt8}, Ptr{UInt8}, Csize_t), pointer(x), y.ptr, y.len) == 0
end
function ==(x::PointerString, y::PointerString)
    x.len == y.len && ccall(:memcmp, Cint, (Ptr{UInt8}, Ptr{UInt8}, Csize_t), x.ptr, y.ptr, y.len) == 0
end
==(y::PointerString, x::AbstractString) = x == y

Base.ncodeunits(s::PointerString) = s.len
@inline function Base.codeunit(s::PointerString, i::Integer)
    @boundscheck checkbounds(s, i)
    GC.@preserve s unsafe_load(s.ptr + i - 1)
end

_unsafe_string(p, len) = ccall(:jl_pchar_to_string, Ref{String}, (Ptr{UInt8}, Int), p, len)
Base.String(x::PointerString) = _unsafe_string(x.ptr, x.len)
WeakRefStrings.PosLenString(x::PointerString) = PosLenString(unsafe_wrap(Array, x.ptr, x.len), PosLen(1, x.len), 0x00)

struct Arg
    x::Any
end
Base.getindex(x::Arg) = x.x

macro refargs(ex)
    ex isa Expr || throw(ArgumentError("must pass an expression to @refargs"))
    (ex.head == :call || ex.head == :function) || throw(ArgumentError("@refargs ex must be function call or definition"))
    if ex.head == :call
        for i = 2:length(ex.args)
            ex.args[i] = Expr(:call, :(CSV.Arg), ex.args[i])
        end
        return esc(ex)
    else # ex.head == :function
        refs = Expr(:block)
        fargs = ex.args[1].args
        for i = 2:length(fargs)
            arg = fargs[i]
            (arg isa Symbol || arg.head == :(::)) || throw(ArgumentError("unsupported argument expression: `$arg`"))
            nm = arg isa Symbol ? arg : arg.args[1]
            T = arg isa Symbol ? :Any : arg.args[2]
            push!(refs.args, Expr(:(=), Expr(:(::), nm, T), Expr(:ref, nm)))
            fargs[i] = Expr(:(::), nm, :(CSV.Arg))
        end
        pushfirst!(ex.args[2].args, refs)
        return esc(ex)
    end
end

using DataFrames, CSV, BenchmarkTools

randnothing(pct_nothing) = let v = rand() 
    v < pct_nothing ? nothing : v
end

randnothing(n, pct) = [randnothing(pct) for _ in 1:n]

df1(n) = DataFrame(x = rand(n), y = rand(n), z = rand(n))

df2(n, pct = 0.1) = 
    DataFrame(x = randnothing(n, pct), y = randnothing(n, pct), z = randnothing(n, pct))

test1(df) = @benchmark CSV.write("/tmp/tom.csv", $df)

test2(df) = @benchmark CSV.write("/tmp/tom.csv", $df, transform = (col,val) -> something(val, missing))

function test(msg, f, df)
    println(msg)
    for i in 4:7
        rows = 10^i
        println(rows, " rows: ", f(df(rows)))
    end
end

length(ARGS) > 0 || (println("Usage: julia perf_write.jl [master|new]"); exit(1))
command = ARGS[1]

if command == "master"
    test("Testing without nothing values", test1, df1)
elseif command == "new"
    test("Testing without nothing values (default transform)", test1, df1)
    test("Testing without nothing values (to-missing transform)", test2, df1)
    test("Testing with nothing values (to-missing transform)", test2, df2)
else 
    error("Unknown command: $command")
end

struct Chunks
    ctx::Context
    Chunks(ctx::Context) = new(ctx)
end

"""
    CSV.Chunks(source; ntasks::Integer=Threads.nthreads(), kwargs...) => CSV.Chunks

Returns a file "chunk" iterator. Accepts all the same inputs and keyword arguments as [`CSV.File`](@ref),
see those docs for explanations of each keyword argument.

The `ntasks` keyword argument specifies how many chunks a file should be split up into, defaulting to
the # of threads available to Julia (i.e. `JULIA_NUM_THREADS` environment variable) or 8 if Julia is
run single-threaded.

Each iteration of `CSV.Chunks` produces the next chunk of a file as a `CSV.File`. While initial file
metadata detection is done only once (to determine # of columns, column names, etc), each iteration
does independent type inference on columns. This is significant as different chunks may end up with
different column types than previous chunks as new values are encountered in the file. Note that, as
with `CSV.File`, types may be passed manually via the `type` or `types` keyword arguments.

This functionality is new and thus considered experimental; please
[open an issue](https://github.com/JuliaData/CSV.jl/issues/new) if you run into any problems/bugs.

$KEYWORD_DOCS
"""
function Chunks(source::ValidSources;
    # file options
    # header can be a row number, range of rows, or actual string vector
    header::Union{Integer, Vector{Symbol}, Vector{String}, AbstractVector{<:Integer}}=1,
    normalizenames::Bool=false,
    # by default, data starts immediately after header or start of file
    datarow::Integer=-1,
    skipto::Integer=-1,
    footerskip::Integer=0,
    transpose::Bool=false,
    comment::Union{String, Nothing}=nothing,
    ignoreemptyrows::Bool=true,
    ignoreemptylines=nothing,
    select=nothing,
    drop=nothing,
    limit::Union{Integer, Nothing}=nothing,
    buffer_in_memory::Bool=false,
    ntasks::Union{Integer, Nothing}=Threads.nthreads() == 1 ? 8 : Threads.nthreads(),
    tasks::Union{Nothing, Integer}=nothing,
    rows_to_check::Integer=DEFAULT_ROWS_TO_CHECK,
    lines_to_check=nothing,
    # parsing options
    missingstrings=String[],
    missingstring="",
    delim::Union{Nothing, Char, String}=nothing,
    ignorerepeated::Bool=false,
    quoted::Bool=true,
    quotechar::Union{UInt8, Char}='"',
    openquotechar::Union{UInt8, Char, Nothing}=nothing,
    closequotechar::Union{UInt8, Char, Nothing}=nothing,
    escapechar::Union{UInt8, Char}='"',
    dateformat::Union{String, Dates.DateFormat, Nothing, AbstractDict}=nothing,
    dateformats=nothing,
    decimal::Union{UInt8, Char}=UInt8('.'),
    groupmark::Union{Char, Nothing}=nothing,
    truestrings::Union{Vector{String}, Nothing}=TRUE_STRINGS,
    falsestrings::Union{Vector{String}, Nothing}=FALSE_STRINGS,
    stripwhitespace::Bool=false,
    # type options
    type=nothing,
    types=nothing,
    typemap::AbstractDict=IdDict{Type, Type}(),
    pool::Union{Bool, Real, AbstractVector, AbstractDict, Base.Callable, Tuple}=DEFAULT_POOL,
    downcast::Bool=false,
    lazystrings::Bool=false,
    stringtype::StringTypes=DEFAULT_STRINGTYPE,
    strict::Bool=false,
    silencewarnings::Bool=false,
    maxwarnings::Int=DEFAULT_MAX_WARNINGS,
    debug::Bool=false,
    parsingdebug::Bool=false,
    validate=true,
    )

    ctx = @refargs Context(source, header, normalizenames, datarow, skipto, footerskip, transpose, comment, ignoreemptyrows, ignoreemptylines, select, drop, limit, buffer_in_memory, nothing, ntasks, tasks, rows_to_check, lines_to_check, missingstrings, missingstring, delim, ignorerepeated, quoted, quotechar, openquotechar, closequotechar, escapechar, dateformat, dateformats, decimal, groupmark, truestrings, falsestrings, stripwhitespace, type, types, typemap, pool, downcast, lazystrings, stringtype, strict, silencewarnings, maxwarnings, debug, parsingdebug, validate, false)
    !ctx.threaded && throw(ArgumentError("unable to iterate chunks from input file source"))
    foreach(col -> col.lock = ReentrantLock(), ctx.columns)
    return Chunks(ctx)
end

Base.IteratorSize(::Type{Chunks}) = Base.HasLength()
Base.length(x::Chunks) = x.ctx.ntasks
Base.eltype(x::Chunks) = File

function Base.iterate(x::Chunks, i=1)
    i > x.ctx.ntasks && return nothing
    names = copy(x.ctx.names)
    columns = [Column(col) for col in x.ctx.columns]
    datapos = x.ctx.chunkpositions[i]
    len = x.ctx.chunkpositions[i + 1] - (i != x.ctx.ntasks)
    rowsguess = cld(x.ctx.rowsguess, x.ctx.ntasks)
    threaded = false
    ntasks = 1
    limit = typemax(Int)
    ctx = Context(x.ctx.transpose, x.ctx.name, names, rowsguess, x.ctx.cols, x.ctx.buf, datapos, len, 1, x.ctx.options, columns, x.ctx.pool, x.ctx.downcast, x.ctx.customtypes, x.ctx.typemap, x.ctx.stringtype, limit, threaded, ntasks, x.ctx.chunkpositions, x.ctx.strict, x.ctx.silencewarnings, x.ctx.maxwarnings, x.ctx.debug, x.ctx.tempfile, x.ctx.streaming, x.ctx.types)
    f = File(ctx, true)
    return f, i + 1
end

Tables.partitions(x::Chunks) = x

# a Row "view" type for iterating `CSV.File`
struct Row <: Tables.AbstractRow
    names::Vector{Symbol}
    columns::Vector{Column}
    lookup::Dict{Symbol, Column}
    row::Int
end

getnames(r::Row) = getfield(r, :names)
getcolumn(r::Row, col::Int) = getfield(r, :columns)[col].column
getcolumn(r::Row, col::Symbol) = getfield(r, :lookup)[col].column
getrow(r::Row) = getfield(r, :row)

Tables.columnnames(r::Row) = getnames(r)

@inline function Tables.getcolumn(row::Row, ::Type{T}, i::Int, nm::Symbol) where {T}
    column = getcolumn(row, i)
    @inbounds x = column[getrow(row)]
    return x
end

@inline function Tables.getcolumn(row::Row, col::Symbol)
    column = getcolumn(row, col)
    @inbounds x = column[getrow(row)]
    return x
end

@inline function Tables.getcolumn(row::Row, col::Int)
    column = getcolumn(row, col)
    @inbounds x = column[getrow(row)]
    return x
end

"""
    CSV.File(input; kwargs...) => CSV.File

Read a UTF-8 CSV input and return a `CSV.File` object, which is like a lightweight table/dataframe, allowing dot-access to columns
and iterating rows. Satisfies the Tables.jl interface, so can be passed to any valid sink, yet to avoid unnecessary copies of data,
use `CSV.read(input, sink; kwargs...)` instead if the `CSV.File` intermediate object isn't needed.

The [`input`](@ref input) argument can be one of:
  * filename given as a string or FilePaths.jl type
  * a `Vector{UInt8}` or `SubArray{UInt8, 1, Vector{UInt8}}` byte buffer
  * a `CodeUnits` object, which wraps a `String`, like `codeunits(str)`
  * a csv-formatted string can also be passed like `IOBuffer(str)`
  * a `Cmd` or other `IO`
  * a gzipped file (or gzipped data in any of the above), which will automatically be decompressed for parsing
  * a `Vector` of any of the above, which will parse and vertically concatenate each source, returning a single, "long" `CSV.File`

To read a csv file from a url, use the Downloads.jl stdlib or HTTP.jl package, where the resulting downloaded tempfile or `HTTP.Response` body can be passed like:
```julia
using Downloads, CSV
f = CSV.File(Downloads.download(url))

# or

using HTTP, CSV
f = CSV.File(HTTP.get(url).body)
```

Opens the file or files and uses passed arguments to detect the number of columns and column types, unless column types are provided
manually via the `types` keyword argument. Note that passing column types manually can slightly increase performance
for each column type provided (column types can be given as a `Vector` for all columns, or specified per column via
name or index in a `Dict`).

When a `Vector` of inputs is provided, the column names and types of each separate file/input must match to be vertically concatenated. Separate threads will
be used to parse each input, which will each parse their input using just the single thread. The results of all threads are then vertically concatenated using
`ChainedVector`s to lazily concatenate each thread's columns.

For text encodings other than UTF-8, load the [StringEncodings.jl](https://github.com/JuliaStrings/StringEncodings.jl)
package and call e.g. `CSV.File(open(read, input, enc"ISO-8859-1"))`.

The returned `CSV.File` object supports the [Tables.jl](https://github.com/JuliaData/Tables.jl) interface
and can iterate `CSV.Row`s. `CSV.Row` supports `propertynames` and `getproperty` to access individual row values. `CSV.File`
also supports entire column access like a `DataFrame` via direct property access on the file object, like `f = CSV.File(file); f.col1`.
Or by getindex access with column names, like `f[:col1]` or `f["col1"]`. The returned columns are `AbstractArray` subtypes, including:
`SentinelVector` (for integers), regular `Vector`, `PooledVector` for pooled columns, `MissingVector` for columns of all `missing` values,
`PosLenStringVector` when `stringtype=PosLenString` is passed, and `ChainedVector` will chain one of the previous array types together for
data inputs that use multiple threads to parse (each thread parses a single "chain" of the input).
Note that duplicate column names will be detected and adjusted to ensure uniqueness (duplicate column name `a` will become `a_1`).
For example, one could iterate over a csv file with column names `a`, `b`, and `c` by doing:

```julia
for row in CSV.File(file)
    println("a=\$(row.a), b=\$(row.b), c=\$(row.c)")
end
```

By supporting the Tables.jl interface, a `CSV.File` can also be a table input to any other table sink function. Like:

```julia
# materialize a csv file as a DataFrame, copying columns from CSV.File
df = CSV.File(file) |> DataFrame

# to avoid making a copy of parsed columns, use CSV.read
df = CSV.read(file, DataFrame)

# load a csv file directly into an sqlite database table
db = SQLite.DB()
tbl = CSV.File(file) |> SQLite.load!(db, "sqlite_table")
```

$KEYWORD_DOCS
"""
struct File <: AbstractVector{Row}
    name::String
    names::Vector{Symbol}
    types::Vector{Type}
    rows::Int
    cols::Int
    columns::Vector{Column}
    lookup::Dict{Symbol, Column}
end

getname(f::File) = getfield(f, :name)
getnames(f::File) = getfield(f, :names)
gettypes(f::File) = getfield(f, :types)
getrows(f::File) = getfield(f, :rows)
getcols(f::File) = getfield(f, :cols)
getcolumns(f::File) = getfield(f, :columns)
getlookup(f::File) = getfield(f, :lookup)
getcolumn(f::File, col::Int) = getfield(f, :columns)[col]
getcolumn(f::File, col::Symbol) = getfield(f, :lookup)[col]

function Base.show(io::IO, f::File)
    println(io, "CSV.File(\"$(getname(f))\"):")
    println(io, "Size: $(getrows(f)) x $(getcols(f))")
    show(io, Tables.schema(f))
end

Base.IndexStyle(::Type{File}) = Base.IndexLinear()
Base.eltype(::File) = Row
Base.size(f::File) = (getrows(f),)

Tables.isrowtable(::Type{File}) = true
Tables.columnaccess(::Type{File}) = true
Tables.schema(f::File)  = Tables.Schema(getnames(f), gettypes(f))
Tables.columns(f::File) = f
Tables.columnnames(f::File) = getnames(f)
Base.propertynames(f::File) = getnames(f)

function Base.getproperty(f::File, col::Symbol)
    lookup = getfield(f, :lookup)
    return haskey(lookup, col) ? lookup[col].column : getfield(f, col)
end

function Base.getindex(f::File, col::Symbol)
    lookup = getfield(f, :lookup)
    return haskey(lookup, col) ? lookup[col].column : getfield(f, col)
end

Base.getindex(f::File, col::String) = getindex(f, Symbol(col))

Tables.getcolumn(f::File, nm::Symbol) = getcolumn(f, nm).column
Tables.getcolumn(f::File, i::Int) = getcolumn(f, i).column

Base.@propagate_inbounds function Base.getindex(f::File, row::Int)
    @boundscheck checkbounds(f, row)
    return Row(getnames(f), getcolumns(f), getlookup(f), row)
end

function File(source::ValidSources;
    # file options
    # header can be a row number, range of rows, or actual string vector
    header::Union{Integer, Vector{Symbol}, Vector{String}, AbstractVector{<:Integer}}=1,
    normalizenames::Bool=false,
    # by default, data starts immediately after header or start of file
    datarow::Integer=-1,
    skipto::Integer=-1,
    footerskip::Integer=0,
    transpose::Bool=false,
    comment::Union{String, Nothing}=nothing,
    ignoreemptyrows::Bool=true,
    ignoreemptylines=nothing,
    select=nothing,
    drop=nothing,
    limit::Union{Integer, Nothing}=nothing,
    buffer_in_memory::Bool=false,
    threaded::Union{Bool, Nothing}=nothing,
    ntasks::Union{Nothing, Integer}=nothing,
    tasks::Union{Nothing, Integer}=nothing,
    rows_to_check::Integer=DEFAULT_ROWS_TO_CHECK,
    lines_to_check=nothing,
    # parsing options
    missingstrings=String[],
    missingstring="",
    delim::Union{Nothing, Char, String}=nothing,
    ignorerepeated::Bool=false,
    quoted::Bool=true,
    quotechar::Union{UInt8, Char}='"',
    openquotechar::Union{UInt8, Char, Nothing}=nothing,
    closequotechar::Union{UInt8, Char, Nothing}=nothing,
    escapechar::Union{UInt8, Char}='"',
    dateformat::Union{String, Dates.DateFormat, Nothing, AbstractDict}=nothing,
    dateformats=nothing,
    decimal::Union{UInt8, Char}=UInt8('.'),
    groupmark::Union{Char, Nothing}=nothing,
    truestrings::Union{Vector{String}, Nothing}=TRUE_STRINGS,
    falsestrings::Union{Vector{String}, Nothing}=FALSE_STRINGS,
    stripwhitespace::Bool=false,
    # type options
    type=nothing,
    types=nothing,
    typemap::AbstractDict=IdDict{Type, Type}(),
    pool=DEFAULT_POOL,
    downcast::Bool=false,
    lazystrings::Bool=false,
    stringtype::StringTypes=DEFAULT_STRINGTYPE,
    strict::Bool=false,
    silencewarnings::Bool=false,
    maxwarnings::Int=DEFAULT_MAX_WARNINGS,
    debug::Bool=false,
    parsingdebug::Bool=false,
    validate::Bool=true,
    )
    # header=1;normalizenames=false;datarow=-1;skipto=-1;footerskip=0;transpose=false;comment=nothing;ignoreemptyrows=true;ignoreemptylines=nothing;
    # select=nothing;drop=nothing;limit=nothing;threaded=nothing;ntasks=Threads.nthreads();tasks=nothing;rows_to_check=30;lines_to_check=nothing;missingstrings=String[];missingstring="";
    # delim=nothing;ignorerepeated=false;quoted=true;quotechar='"';openquotechar=nothing;closequotechar=nothing;escapechar='"';dateformat=nothing;
    # dateformats=nothing;decimal=UInt8('.');groupmark=nothing;truestrings=nothing;falsestrings=nothing;type=nothing;types=nothing;typemap=IdDict{Type,Type}();
    # pool=CSV.DEFAULT_POOL;downcast=false;lazystrings=false;stringtype=String;strict=false;silencewarnings=false;maxwarnings=100;debug=false;parsingdebug=false;buffer_in_memory=false
    # @descend CSV.Context(CSV.Arg(source), CSV.Arg(header), CSV.Arg(normalizenames), CSV.Arg(datarow), CSV.Arg(skipto), CSV.Arg(footerskip), CSV.Arg(transpose), CSV.Arg(comment), CSV.Arg(ignoreemptyrows), CSV.Arg(ignoreemptylines), CSV.Arg(select), CSV.Arg(drop), CSV.Arg(limit), CSV.Arg(buffer_in_memory), CSV.Arg(threaded), CSV.Arg(ntasks), CSV.Arg(tasks), CSV.Arg(rows_to_check), CSV.Arg(lines_to_check), CSV.Arg(missingstrings), CSV.Arg(missingstring), CSV.Arg(delim), CSV.Arg(ignorerepeated), CSV.Arg(quoted), CSV.Arg(quotechar), CSV.Arg(openquotechar), CSV.Arg(closequotechar), CSV.Arg(escapechar), CSV.Arg(dateformat), CSV.Arg(dateformats), CSV.Arg(decimal), CSV.Arg(truestrings), CSV.Arg(falsestrings), CSV.Arg(type), CSV.Arg(types), CSV.Arg(typemap), CSV.Arg(pool), CSV.Arg(downcast), CSV.Arg(lazystrings), CSV.Arg(stringtype), CSV.Arg(strict), CSV.Arg(silencewarnings), CSV.Arg(maxwarnings), CSV.Arg(debug), CSV.Arg(parsingdebug), CSV.Arg(false))
    ctx = @refargs Context(source, header, normalizenames, datarow, skipto, footerskip, transpose, comment, ignoreemptyrows, ignoreemptylines, select, drop, limit, buffer_in_memory, threaded, ntasks, tasks, rows_to_check, lines_to_check, missingstrings, missingstring, delim, ignorerepeated, quoted, quotechar, openquotechar, closequotechar, escapechar, dateformat, dateformats, decimal, groupmark, truestrings, falsestrings, stripwhitespace, type, types, typemap, pool, downcast, lazystrings, stringtype, strict, silencewarnings, maxwarnings, debug, parsingdebug, validate, false)
    return File(ctx)
end

function File(ctx::Context, @nospecialize(chunking::Bool=false))
    @inbounds begin
    # we now do our parsing pass over the file, starting at datapos
    if ctx.threaded
        # multithreaded parsing
        rowsguess, ntasks, columns = ctx.rowsguess, ctx.ntasks, ctx.columns
        # calculate our guess for how many rows will be parsed by each concurrent parsing task
        rowchunkguess = cld(rowsguess, ntasks)
        wholecolumnslock = ReentrantLock() # in case columns are widened during parsing
        pertaskcolumns = Vector{Vector{Column}}(undef, ntasks)
        # initialize each top-level column's lock; used after a task is done parsing its chunk of rows
        # and it "checks in" the types it parsed for each column
        foreach(col -> col.lock = ReentrantLock(), columns)
        rows = zeros(Int, ntasks) # how many rows each parsing task ended up actually parsing
        @sync for i = 1:ntasks
            @wkspawn multithreadparse($ctx, $pertaskcolumns, $rowchunkguess, $i, $rows, $wholecolumnslock)
            # CSV.multithreadparse(ctx, pertaskcolumns, rowchunkguess, i, rows, wholecolumnslock)
        end
        finalrows = sum(rows)
        if ctx.limit < finalrows
            finalrows = ctx.limit
            # adjust columns according to limit
            acc = 0
            for i = 1:ntasks
                if acc + rows[i] > finalrows
                    # need to resize this tasks columns down
                    if finalrows - acc > 0
                        for col in pertaskcolumns[i]
                            if isdefined(col, :column)
                                resize!(col.column, finalrows - acc)
                            end
                        end
                    else
                        for col in pertaskcolumns[i]
                            if isdefined(col, :column)
                                empty!(col.column)
                            end
                        end
                    end
                end
                acc += rows[i]
            end
        end
        # ok, all the parsing tasks have finished and we've promoted their types w/ the top-level columns
        # so now we just need to finish processing each column by making ChainedVectors of the individual columns
        # from each task
        # quick check that each set of task columns has the right # of columns
        for i = 1:ntasks
            task_columns = pertaskcolumns[i]
            if length(task_columns) < length(columns)
                # some other task widened columns that this task didn't likewise detect
                for _ = (length(task_columns) + 1):length(columns)
                    push!(task_columns, Column(Missing, ctx.options))
                end
            end
        end
        @sync for (j, col) in enumerate(columns)
            @wkspawn multithreadpostparse($ctx, $ntasks, $pertaskcolumns, $rows, $finalrows, $j, $col)
        end
    else
        # single-threaded parsing
        columns = ctx.columns
        allocate!(columns, ctx.rowsguess)
        t = Base.time()
        finalrows, pos = parsefilechunk!(ctx, ctx.datapos, ctx.len, ctx.rowsguess, 0, columns, ctx.customtypes)::Tuple{Int, Int}
        ctx.debug && println("time for initial parsing: $(Base.time() - t)")
        # cleanup our columns if needed
        for col in columns
@label processcolumn
            if col.type === NeedsTypeDetection
                # fill in uninitialized column fields
                col.type = Missing
                col.column = MissingVector(finalrows)
                col.pool = 0.0
            end
            T = col.anymissing ? Union{col.type, Missing} : col.type
            if maybepooled(col) &&
                (col.type isa StringTypes || col.columnspecificpool) &&
                checkpooled!(T, nothing, col, 0, 1, finalrows, ctx)
                # col.column is a PooledArray
            elseif col.type === PosLenString
                # string col parsed lazily; return a PosLenStringVector
                makeposlen!(col, coltype(col), ctx)
            elseif !col.anymissing
                # if no missing values were parsed for a col, we want to "unwrap" it to a plain Vector{T}
                if col.type === Bool
                    col.column = convert(Vector{Bool}, col.column)
                elseif col.type !== Union{} && col.type <: SmallIntegers
                    col.column = convert(Vector{col.type}, col.column)
                else
                    col.column = parent(col.column)
                end
            end
        end
    end
    # delete any dropped columns from names, columns
    names = ctx.names
    if length(columns) > length(names)
        # columns were widened during parsing, auto-generate trailing column names
        names = makeunique(append!(names, [Symbol(:Column, i) for i = (length(names) + 1):length(columns)]))
    end
    for i = length(columns):-1:1
        col = columns[i]
        if col.willdrop
            deleteat!(names, i)
            deleteat!(columns, i)
        end
    end
    types = Type[coltype(col) for col in columns]
    lookup = Dict(k => v for (k, v) in zip(names, columns))
    ctx.debug && println("types after parsing: $types, pool = $(ctx.pool)")
    # for windows, it's particularly finicky about throwing errors when you try to modify an mmapped file
    # so we just want to make sure we finalize the input buffer so users don't run into surprises
    # on Julia 1.11 the underlying memory needs to be finalized to unmmap the file.
    # Ref: https://github.com/JuliaLang/julia/pull/54210
    if !chunking && Sys.iswindows() && ctx.stringtype !== PosLenString
        if VERSION ≥ v"1.11"
            finalize(ctx.buf.ref.mem)
        else
            finalize(ctx.buf)
        end
    end
    # check if a temp file was generated for parsing
    if !chunking && ctx.tempfile !== nothing && ctx.stringtype !== PosLenString
        rm(ctx.tempfile; force=true)
    end
    end # @inbounds begin
    return File(ctx.name, names, types, finalrows, length(columns), columns, lookup)
end

function multithreadparse(ctx, pertaskcolumns, rowchunkguess, i, rows, wholecolumnslock)
    columns = ctx.columns
    tt = Base.time()
    task_columns = [Column(col) for col in columns] # task-local columns derived from top-level columns
    allocate!(task_columns, rowchunkguess)
    pertaskcolumns[i] = task_columns
    task_pos = ctx.chunkpositions[i]
    task_len = ctx.chunkpositions[i + 1] - (i != ctx.ntasks)
    # for error-reporting purposes, we want to try and give the best guess of where a row emits a warning/error, so compute that
    rowchunkoffset = (ctx.datarow - 1) + (rowchunkguess * (i - 1))
    task_rows, task_pos = parsefilechunk!(ctx, task_pos, task_len, rowchunkguess, rowchunkoffset, task_columns, ctx.customtypes)::Tuple{Int, Int}
    rows[i] = task_rows
    # promote column types/flags this task detected while parsing
    lock(wholecolumnslock) do
        # check if this task widened columns while parsing
        if length(task_columns) > length(columns)
            for j = (length(columns) + 1):length(task_columns)
                col = task_columns[j] # I'm pretty sure it's ok to just use the per-task column directly here as new top-level column?
                # initialize lock since it hasn't been initialized yet
                col.lock = ReentrantLock()
                push!(columns, col)
            end
        end
    end
    # now we know that columns is at least as long as task_columns
    for j = 1:length(task_columns)
        col = columns[j]
        # note col.lock is shared amongst all tasks (i.e. belongs to parent columns[i].lock)
        lock(col.lock) do
            task_col = task_columns[j]
            T = col.type
            col.type = something(promote_types(T, task_col.type), ctx.stringtype)
            if T !== col.type
                ctx.debug && println("promoting col = $j from $T to $(col.type), task chunk ($i) was type = $(task_col.type)")
            end
            col.anymissing |= task_col.anymissing
        end
    end
    ctx.debug && println("finished parsing $task_rows rows on task = $i: time for parsing: $(Base.time() - tt)")
    return
end

function multithreadpostparse(ctx, ntasks, pertaskcolumns, rows, finalrows, j, col)
    # first check if need to re-parse any chunks
    for i = 1:ntasks
        task_columns = pertaskcolumns[i]
        task_col = task_columns[j]
        task_rows = rows[i]
        # check if we need to promote a task-local column based on what other threads parsed
        T = col.type # final promoted type from amongst all separate parsing tasks
        T2 = task_col.type
        if T isa StringTypes && !(T2 isa StringTypes)
            # promoting non-string to string column
            ctx.debug && println("multithreaded promoting column $j to string from $T2")
            task_len = ctx.chunkpositions[i + 1] - (i != ntasks)
            task_pos = ctx.chunkpositions[i]
            promotetostring!(ctx, ctx.buf, task_pos, task_len, task_rows, sum(rows[1:i-1]), task_columns, ctx.customtypes, j, Ref(0), task_rows, T)
            col.type = something(promote_types(T, task_columns[j].type), ctx.stringtype)
            T = col.type
        end
    end
    for i = 1:ntasks
        task_columns = pertaskcolumns[i]
        task_col = task_columns[j]
        task_rows = rows[i]
        # check if we need to promote a task-local column based on what other threads parsed
        T = col.type # final promoted type from amongst all separate parsing tasks
        T2 = task_col.type
        if T === Float64 && T2 <: Integer
            # one chunk parsed as Int, another as Float64, promote to Float64
            ctx.debug && println("multithreaded promoting column $j to float")
            task_col.column = convert(SentinelVector{Float64}, task_col.column)
        elseif T !== T2 && (T <: InlineString || (T === String && T2 <: InlineString))
            # promote to widest InlineString type
            task_col.column = convert(SentinelVector{T}, task_col.column)
        elseif T !== T2
            # one chunk parsed all missing values, but another chunk had a typed value, promote to that
            # while keeping all values `missing` (allocate by default ensures columns have all missing values)
            ctx.debug && println("multithreaded promoting column $j from missing on task $i")
            task_col.column = allocate(T, task_rows)
        end
    end
    T = col.anymissing ? Union{col.type, Missing} : col.type
    if maybepooled(col) &&
        (col.type isa StringTypes || col.columnspecificpool) &&
        checkpooled!(T, pertaskcolumns, col, j, ntasks, finalrows, ctx)
        # col.column is a PooledArray
    elseif col.type === Int64
        # we need to special-case Int here because while parsing, a default Int64 sentinel value is chosen to
        # represent missing; if any chunk bumped into that sentinel value while parsing, then it cycled to a
        # new sentinel value; this step ensures that each chunk has the same encoded sentinel value
        # passing force=false means it will first check if all chunks already have the same sentinel and return
        # immediately if so, which will be the case most often
        SentinelArrays.newsentinel!((pertaskcolumns[i][j].column::SVec{Int64} for i = 1:ntasks)...; force=false)
        makechain!(col.type, pertaskcolumns, col, j, ntasks)
    elseif col.type === PosLenString
        col.column = ChainedVector(PosLenStringVector{coltype(col)}[makeposlen!(pertaskcolumns[i][j], coltype(col), ctx) for i = 1:ntasks])
    elseif col.type === NeedsTypeDetection || col.type === HardMissing
        col.type = Missing
        col.column = MissingVector(finalrows)
    else
        makechain!(col.type, pertaskcolumns, col, j, ntasks)
    end
    if finalrows < length(col.column)
        # we only ever resize! down here, so no need to use reallocate!
        resize!(col.column, finalrows)
    end
    return
end

function makechain!(::Type{T}, pertaskcolumns, col, j, ntasks) where {T}
    if col.anymissing
        col.column = ChainedVector([pertaskcolumns[i][j].column for i = 1:ntasks])
    else
        if col.type === Bool
            col.column = ChainedVector([convert(Vector{Bool}, pertaskcolumns[i][j].column::vectype(T)) for i = 1:ntasks])
        elseif col.type !== Union{} && col.type <: SmallIntegers
            col.column = ChainedVector([convert(Vector{col.type}, pertaskcolumns[i][j].column::vectype(T)) for i = 1:ntasks])
        else
            col.column = ChainedVector([parent(pertaskcolumns[i][j].column) for i = 1:ntasks])
        end
    end
    return
end

# T is Union{T, Missing} or T depending on col.anymissing
function checkpooled!(::Type{T}, pertaskcolumns, col, j, ntasks, nrows, ctx) where {T}
    S = Base.nonmissingtype(T)
    pool = Dict{T, UInt32}()
    lastref = Ref{UInt32}(0)
    refs = Vector{UInt32}(undef, nrows)
    k = 1
    limit = col.pool isa Tuple ? col.pool[2] : typemax(Int)
    for i = 1:ntasks
        column = (pertaskcolumns === nothing ? col.column : pertaskcolumns[i][j].column)::columntype(S)
        for x in column
            if x isa PosLen
                if x.missingvalue
                    refs[k] = get!(pool, missing) do
                        lastref[] += UInt32(1)
                    end
                elseif x.escapedvalue
                    val = S === PosLenString ? S(ctx.buf, x, ctx.options.e) : Parsers.getstring(ctx.buf, x, ctx.options.e)
                    refs[k] = get!(pool, val) do
                        lastref[] += UInt32(1)
                    end
                else
                    val = PointerString(pointer(ctx.buf, x.pos), x.len)
                    index = Base.ht_keyindex2!(pool, val)
                    if index > 0
                        found_key = pool.vals[index]
                        ref = found_key::UInt32
                    else
                        new = lastref[] += UInt32(1)
                        if S === PosLenString
                            Base._setindex!(pool, new, S(ctx.buf, x, ctx.options.e), -index)
                        else
                            Base._setindex!(pool, new, S(val), -index)
                        end
                        ref = new
                    end
                    refs[k] = ref
                end
            else
                refs[k] = get!(pool, x) do
                    lastref[] += UInt32(1)
                end
            end
            k += 1
            if length(pool) > limit
                return false
            end
        end
    end
    cpool = col.pool
    percent = cpool isa Tuple ? cpool[1] : cpool
    if ((length(pool) - 1) / nrows) <= percent
        col.column = PooledArray(PooledArrays.RefArray(refs), pool)
        return true
    else
        return false
    end
end

function makeposlen!(col, T, ctx)
    col.column = PosLenStringVector{T}(ctx.buf, col.column::Vector{PosLen}, ctx.options.e)
    return col.column
end

function parsefilechunk!(ctx::Context, pos, len, rowsguess, rowoffset, columns, ::Type{customtypes})::Tuple{Int, Int} where {customtypes}
    buf = ctx.buf
    transpose = ctx.transpose
    limit = ctx.limit
    row = 0
    startpos = pos
    if pos <= len && len > 0 && row < limit
        numwarnings = Ref(0)
        while true
            row += 1
            # @show columns
            @inbounds pos = parserow(startpos, row, numwarnings, ctx, buf, pos, len, rowsguess, rowoffset, columns, customtypes)::Int
            # @show columns
            row == limit && break
            (transpose ? all(c -> c.position >= c.endposition, columns) : pos > len) && break
            # if our initial row estimate was too few, we need to reallocate our columns to read the rest of the file/chunk
            if !transpose && row + 1 > rowsguess
                # (bytes left in file/chunk) / (avg bytes per row) == estimated rows left in file (+ 5% to try and avoid reallocating)
                estimated_rows_left = ceil(Int, ((len - pos) / ((pos - startpos) / row)) * 1.05)
                newrowsguess = rowsguess + estimated_rows_left
                newrowsguess = max(rowsguess + 1, newrowsguess)
                ctx.debug && reallocatecolumns(rowoffset + row, rowsguess, newrowsguess)
                for col in columns
                    isdefined(col, :column) && reallocate!(col.column, newrowsguess)
                end
                rowsguess = newrowsguess
            end
        end
        if !ctx.threaded && ctx.ntasks > 1 && !ctx.silencewarnings
            # !ctx.threaded && ctx.ntasks > 1 indicate that multithreaded parsing failed.
            # These messages echo the corresponding debug statement in the definition of ctx
            if numwarnings[] > 0
                @warn "Multithreaded parsing failed and fell back to single-threaded parsing, check previous warnings for possible reasons."
            else
                @error "Multithreaded parsing failed and fell back to single-threaded parsing. This can happen if the input contains multi-line fields; otherwise, please report this issue."
            end
        end
    end
    # done parsing (at least this chunk), so resize columns to final row count
    for col in columns
        # we only ever resize! down here, so no need to use reallocate!
        isdefined(col, :column) && resize!(col.column, row)
    end
    return row, pos
end

@noinline reallocatecolumns(row, old, new) = @warn("thread = $(Threads.threadid()) warning: didn't pre-allocate enough column while parsing around row $row, re-allocating from $old to $new...")
@noinline notenoughcolumns(cols, ncols, row) = @warn("thread = $(Threads.threadid()) warning: only found $cols / $ncols columns around data row: $row. Filling remaining columns with `missing`")
@noinline toomanycolumns(cols, row) = @warn("thread = $(Threads.threadid()) warning: parsed expected $cols columns, but didn't reach end of line around data row: $row. Parsing extra columns and widening final columnset")
@noinline stricterror(T, buf, pos, len, code, row, col) = throw(Error("thread = $(Threads.threadid()) error parsing $T around row = $row, col = $col: \"$(String(buf[pos:pos+len-1]))\", error=$(Parsers.codes(code))"))
@noinline warning(T, buf, pos, len, code, row, col) = @warn("thread = $(Threads.threadid()) warning: error parsing $T around row = $row, col = $col: \"$(String(buf[pos:pos+len-1]))\", error=$(Parsers.codes(code))")
@noinline fatalerror(buf, pos, len, code, row, col) = throw(Error("thread = $(Threads.threadid()) fatal error, encountered an invalidly quoted field while parsing around row = $row, col = $col: \"$(String(buf[pos:pos+len-1]))\", error=$(Parsers.codes(code)), check your `quotechar` arguments or manually fix the field in the file itself"))
@noinline toomanywwarnings() = @warn("thread = $(Threads.threadid()): too many warnings, silencing any further warnings")

Base.@propagate_inbounds function parserow(startpos, row, numwarnings, ctx::Context, buf, pos, len, rowsguess, rowoffset, columns, ::Type{customtypes})::Int where {customtypes}
    # @show columns
    ncols = length(columns)
    for i = 1:ncols
        col = columns[i]
        if ctx.transpose
            pos = col.position
        end
        type = col.type
        cellstartpos = pos
        if type === HardMissing
            pos, code = parsevalue!(Missing, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === NeedsTypeDetection
            pos, code = detectcell(buf, pos, len, row, rowoffset, i, col, ctx, rowsguess)
        elseif type === Int8
            pos, code = parsevalue!(Int8, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Int16
            pos, code = parsevalue!(Int16, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Int32
            pos, code = parsevalue!(Int32, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Int64
            pos, code = parsevalue!(Int64, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Int128
            pos, code = parsevalue!(Int128, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Float16
            pos, code = parsevalue!(Float16, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Float32
            pos, code = parsevalue!(Float32, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Float64
            pos, code = parsevalue!(Float64, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString1
            pos, code = parsevalue!(InlineString1, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString3
            pos, code = parsevalue!(InlineString3, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString7
            pos, code = parsevalue!(InlineString7, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString15
            pos, code = parsevalue!(InlineString15, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString31
            pos, code = parsevalue!(InlineString31, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString63
            pos, code = parsevalue!(InlineString63, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString127
            pos, code = parsevalue!(InlineString127, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === InlineString255
            pos, code = parsevalue!(InlineString255, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === String
            pos, code = parsevalue!(String, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === PosLenString
            pos, code = parsevalue!(PosLenString, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Date
            pos, code = parsevalue!(Date, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === DateTime
            pos, code = parsevalue!(DateTime, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Time
            pos, code = parsevalue!(Time, buf, pos, len, row, rowoffset, i, col, ctx)
        elseif type === Bool
            pos, code = parsevalue!(Bool, buf, pos, len, row, rowoffset, i, col, ctx)
        else
            if customtypes !== Tuple{}
                pos, code = parsecustom!(customtypes, buf, pos, len, row, rowoffset, i, col, ctx)
            else
                error("Column $i bad column type: `$(type)`")
            end
        end
        if promote_to_string(code)
            ctx.debug && println("promoting column i = $i to string from $(type) on chunk = $(Threads.threadid())")
            if type <: InlineString
                newT = String
            elseif ctx.stringtype === InlineString
                str = Parsers.xparse(String, buf, cellstartpos, len, col.options)
                newT = pickstringtype(InlineString, str.val.len)
            else
                newT = ctx.stringtype
            end
            promotetostring!(ctx, buf, startpos, len, rowsguess, rowoffset, columns, customtypes, i, numwarnings, row, newT)
        end
        if ctx.transpose
            col.position = pos
        else
            if i < ncols
                if Parsers.newline(code) || pos > len
                    # in https://github.com/JuliaData/CSV.jl/issues/948,
                    # it was noticed that if we reached the EOF right before parsing
                    # the last expected column, then the warning is a bit spurious.
                    # The final value is `missing` and the csv writer chose to just
                    # "close" the file w/o including a final newline
                    # we can treat this special-case as "valid" and not emit a warning
                    if !(pos > len && i == (ncols - 1))
                        ctx.silencewarnings || numwarnings[] > ctx.maxwarnings || notenoughcolumns(i, ncols, rowoffset + row)
                        !ctx.silencewarnings && numwarnings[] == ctx.maxwarnings && toomanywwarnings()
                        numwarnings[] += 1
                    end
                    for j = (i + 1):ncols
                        columns[j].anymissing = true
                    end
                    break # from for i = 1:ncols
                end
            elseif pos <= len && !Parsers.newline(code)
                # extra columns on this row, let's widen
                ctx.silencewarnings || toomanycolumns(ncols, rowoffset + row)
                j = i + 1
                while pos <= len && !Parsers.newline(code)
                    col = initialize_column(j, ctx)
                    col.anymissing = ctx.streaming || rowoffset == 0 && row > 1 # assume all previous rows were missing
                    col.pool = ctx.pool
                    T = col.type
                    # TODO: Support edge case where a custom type was provided for the new column?
                    # Right now if `T` is a `nonstandardtype` not already in `customtypes`, then
                    # we won't have a specialised parse method for it, so parsing is expected to fail.
                    # Only log the error, rather than throw, in case parsing somehow works.
                    nonstandardtype(T) === Union{} || T in ctx.customtypes.parameters || @error "Parsing extra column with unknown type `$T`. Parsing may fail!"
                    if T === NeedsTypeDetection
                        pos, code = detectcell(buf, pos, len, row, rowoffset, j, col, ctx, rowsguess)
                    else
                        # need to allocate
                        col.column = allocate(T, ctx.rowsguess)
                        pos, code = parsevalue!(T, buf, pos, len, row, rowoffset, j, col, ctx)
                    end
                    j += 1
                    push!(columns, col)
                end
            end
        end
    end
    return pos
end

function detectcell(buf, pos, len, row, rowoffset, i, col, ctx, rowsguess)::Tuple{Int, Int16}
    # debug && println("detecting on task $(Threads.threadid())")
    opts = col.options
    code, tlen, x, xT = detect(pass, buf, pos, len, opts, false, ctx.downcast, rowoffset + row, i)
    if x === missing
        col.anymissing = true
        @goto finaldone
    end
    newT = ctx.stringtype
    if x !== nothing
        # we found a non-missing value
        newT = get(ctx.typemap, typeof(x), typeof(x))
        if !(newT isa StringTypes)
            if newT !== typeof(x)
                # type-mapping typeof(x) => newT
                # this ultimate call to Parsers.xparse has no hope in inference (because of the typeof(x) => newT mapping)
                # so we "outline" the call and assert the types of everything but `y` to make sure `code` and `tlen` stay type stable
                res = _parseany(newT, buf, pos, len, opts)
                code, tlen = res.code, res.tlen
                if Parsers.ok(code)
                    val = res.val
                    @goto done
                end
            else
                val = x
                @goto done
            end
        end
    end
    # if we "fall through" to here, that means we either detected a string value
    # or we're type-mapping from another detected type to string
    str = Parsers.xparse(String, buf, pos, len, opts)
    poslen = str.val
    if newT === InlineString && poslen.len < DEFAULT_MAX_INLINE_STRING_LENGTH
        newT = InlineStringType(poslen.len)
        val = newT(PosLenString(buf, poslen, opts.e))
    elseif newT === PosLenString
        newT = PosLenString
        val = poslen
    else
        newT = String
        val = Parsers.getstring(buf, poslen, opts.e)
    end
@label done
    # if we're here, that means we found a non-missing value, so we need to update column
    column = allocate(newT, rowsguess)
    column[row] = val
    col.column = column
    col.type = newT
@label finaldone
    return pos + tlen, code
end

function parsevalue!(::Type{type}, buf, pos, len, row, rowoffset, i, col, ctx)::Tuple{Int, Int16} where {type}
    opts = col.options
    res = Parsers.xparse(type === Missing ? String : type, buf, pos, len, opts)
    code = res.code
    if !Parsers.invalid(code)
        if type !== Missing
            if Parsers.sentinel(code)
                col.anymissing = true
            else
                column = col.column
                val = res.val
                if column isa Vector{PosLen} && val isa PosLen
                    @inbounds (column::Vector{PosLen})[row] = val
                elseif type === String
                    @inbounds (column::SVec2{String})[row] = Parsers.getstring(buf, val, opts.e)
                else
                    @inbounds (column::vectype(type))[row] = val
                end
            end
        end
    else
        # something went wrong parsing
        if Parsers.invalidquotedfield(code)
            # this usually means parsing is borked because of an invalidly quoted field, hard error
            fatalerror(buf, pos, res.tlen, code, rowoffset + row, i)
        end
        if type !== Missing && type !== PosLenString && type !== String
            if col.userprovidedtype
                if !ctx.strict
                    ctx.silencewarnings || warning(type, buf, pos, res.tlen, code, rowoffset + row, i)
                    col.anymissing = true
                else
                    stricterror(type, buf, pos, res.tlen, code, rowoffset + row, i)
                end
            else
                if type === Int8 || type === Int16 || type === Int32 || type === Int64 || type === Int128
                    newT = _widen(type)
                    while newT !== nothing && !Parsers.ok(code)
                        newT = get(ctx.typemap, newT, newT)
                        if newT isa StringTypes
                            code |= PROMOTE_TO_STRING
                            break
                        end
                        code = trytopromote!(type, newT, buf, pos, len, col, row)
                        newT = _widen(newT)
                    end
                elseif type === InlineString1 || type === InlineString3 || type === InlineString7 || type === InlineString15
                    newT = widen(type)
                    while newT !== InlineString63
                        ret = _parseany(newT, buf, pos, len, opts)
                        if !Parsers.invalid(ret.code)
                            col.type = newT
                            column = col.column
                            col.column = convert(SentinelVector{newT}, col.column::vectype(type))
                            @inbounds col.column[row] = ret.val
                            return pos + ret.tlen, ret.code
                        end
                        newT = widen(newT)
                    end
                    #TODO: should we just convert(SentinelVector{String}) here?
                    code |= PROMOTE_TO_STRING
                else
                    code |= PROMOTE_TO_STRING
                end
            end
        end
    end
    return pos + res.tlen, code
end

@noinline function trytopromote!(::Type{from}, ::Type{to}, buf, pos, len, col, row)::Int16 where {from, to}
    res = Parsers.xparse(to, buf, pos, len, col.options)
    code = res.code
    if !Parsers.invalid(code)
        col.type = to
        column = col.column
        if column isa vectype(from)
            col.column = convert(promotevectype(to), column)
            @inbounds col.column[row] = res.val
        end
    else
        code |= PROMOTE_TO_STRING
    end
    return code
end

@inline function parsecustom!(::Type{customtypes}, buf, pos, len, row, rowoffset, i, col, ctx) where {customtypes}
    if @generated
        block = Expr(:block)
        push!(block.args, quote
            error("CSV.jl code-generation error, unexpected column type: $(type)")
        end)
        for i = 1:fieldcount(customtypes)
            T = fieldtype(customtypes, i)
            pushfirst!(block.args, quote
                if type === $T
                    return parsevalue!($T, buf, pos, len, row, rowoffset, i, col, ctx)
                end
            end)
        end
        pushfirst!(block.args, :(type = col.type))
        pushfirst!(block.args, Expr(:meta, :inline))
        # @show block
        return block
    else
        # println("generated function failed")
        return parsevalue!(col.type, buf, pos, len, row, rowoffset, i, col, ctx)
    end
end

@noinline function promotetostring!(ctx::Context, buf, pos, len, rowsguess, rowoffset, columns, ::Type{customtypes}, column_to_promote, numwarnings, limit, stringtype) where {customtypes}
    cols = [i == column_to_promote ? columns[i] : Column(Missing, columns[i].options) for i = 1:length(columns)]
    col = cols[column_to_promote]
    col.column = allocate(stringtype, rowsguess)
    col.type = stringtype
    row = 0
    startpos = pos
    if pos <= len && len > 0
        while row < limit
            row += 1
            @inbounds pos = parserow(startpos, row, numwarnings, ctx, buf, pos, len, rowsguess, rowoffset, cols, customtypes)
            pos > len && break
        end
    end
    return
end

function File(sources::Vector;
    source::Union{Nothing, Symbol, AbstractString,
        Pair{<:Union{Symbol, AbstractString}, <:AbstractVector}}=nothing,
    kw...)
    isempty(sources) && throw(ArgumentError("unable to read delimited data from empty sources array"))
    if source isa Pair
        length(source.second) == length(sources) || throw(ArgumentError("source pair keyword argument list ($(length(source.second))) must match length of input vector ($(length(sources)))"))
    end
    length(sources) == 1 && return File(sources[1]; kw...)
    all(x -> x isa ValidSources, sources) || throw(ArgumentError("all provided sources must be one of: `$ValidSources`"))
    kws = merge(values(kw), (ntasks=1,))
    f = File(sources[1]; kws...)
    rows = getrows(f)
    for col in getcolumns(f)
        col.column = ChainedVector([col.column])
    end
    files = Vector{File}(undef, length(sources) - 1)
    @sync for i = 2:length(sources)
        Threads.@spawn begin
            files[i - 1] = File(sources[i]; kws...)
        end
    end
    lookup = getlookup(f)
    for i = 2:length(sources)
        f2 = files[i - 1]
        rows += getrows(f2)
        fl2 = getlookup(f2)
        for (nm, col) in lookup
            if haskey(fl2, nm)
                col.column = chaincolumns!(col.column, fl2[nm].column)
            else
                col.column = chaincolumns!(col.column, MissingVector(getrows(f2)))
            end
        end
    end
    if source !== nothing
        # add file name of each "partition" as 1st column
        pushfirst!(files, f)
        vals = source isa Pair ? source.second : [getname(f) for f in files]
        pool = Dict(x => UInt32(i) for (i, x) in enumerate(vals))
        arr = PooledArray(PooledArrays.RefArray(ChainedVector([fill(UInt32(i), getrows(f)) for (i, f) in enumerate(files)])), pool)
        col = Column(eltype(arr))
        col.column = arr
        push!(getcolumns(f), col)
        colnm = Symbol(source isa Pair ? source.first : source)
        push!(getnames(f), colnm)
        push!(gettypes(f), eltype(arr))
        getlookup(f)[colnm] = col
    end
    return File(getname(f), getnames(f), gettypes(f), rows, getcols(f), getcolumns(f), getlookup(f))
end

@testset "CSV.File iteration" begin
    for file in ("test_not_enough_columns.csv", "test_correct_trailing_missings.csv")
        f = CSV.File(joinpath(dir, file))
    
        rows = collect(f)
        @test isequal(map(row->row.A, rows), [1, 4])
        @test isequal(map(row->row.B, rows), [2, 5])
        @test isequal(map(row->row.C, rows), [3, 6])
        @test isequal(map(row->row.D, rows), [missing, missing])
        @test isequal(map(row->row.E, rows), [missing, missing])

        @test isequal(map(row->row.A, f), [1, 4])
        @test isequal(map(row->row.B, f), [2, 5])
        @test isequal(map(row->row.C, f), [3, 6])
        @test isequal(map(row->row.D, f), [missing, missing])
        @test isequal(map(row->row.E, f), [missing, missing])

        @test isequal(map(row->(row.A, row.A, row.A), f), [(1, 1, 1), (4, 4, 4)])
        @test isequal(map(row->(row.B, row.B, row.B), f), [(2, 2, 2), (5, 5, 5)])
        @test isequal(map(row->(row.C, row.C, row.C), f), [(3, 3, 3), (6, 6, 6)])
        @test isequal(map(row->(row.D, row.D, row.D), f), [(missing, missing, missing), (missing, missing, missing)])
        @test isequal(map(row->(row.E, row.E, row.E), f), [(missing, missing, missing), (missing, missing, missing)])
        
        @test isequal(map(row->(row.A, row.D), f), [(1, missing), (4, missing)])
        @test isequal(map(row->(row.A, row.E), f), [(1, missing), (4, missing)])
        @test isequal(map(row->(row.B, row.D), f), [(2, missing), (5, missing)])
        @test isequal(map(row->(row.B, row.E), f), [(2, missing), (5, missing)])
        @test isequal(map(row->(row.C, row.D), f), [(3, missing), (6, missing)])
        @test isequal(map(row->(row.C, row.E), f), [(3, missing), (6, missing)])

        @test isequal(map(row->(row.D, row.A), f), [(missing, 1), (missing, 4)])
        @test isequal(map(row->(row.E, row.A), f), [(missing, 1), (missing, 4)])
        @test isequal(map(row->(row.D, row.B), f), [(missing, 2), (missing, 5)])
        @test isequal(map(row->(row.E, row.B), f), [(missing, 2), (missing, 5)])
        @test isequal(map(row->(row.D, row.C), f), [(missing, 3), (missing, 6)])
        @test isequal(map(row->(row.E, row.C), f), [(missing, 3), (missing, 6)])

        @test isequal(map(row->(row.A, row.C), f), [(1, 3), (4, 6)])
        @test isequal(map(row->(row.C, row.A), f), [(3, 1), (6, 4)])
        @test isequal(map(row->(row.B, row.C), f), [(2, 3), (5, 6)])
        @test isequal(map(row->(row.C, row.B), f), [(3, 2), (6, 5)])
        
        @test isequal(map(row->(row.A, row.B), f), [(1, 2), (4, 5)])
        @test isequal(map(row->(row.B, row.A), f), [(2, 1), (5, 4)])
        
        @test isequal(map(row->(row.A, row.B, row.C), f), [(1, 2, 3), (4, 5, 6)])
        @test isequal(map(row->(row.B, row.A, row.C), f), [(2, 1, 3), (5, 4, 6)])
        @test isequal(map(row->(row.A, row.C, row.B), f), [(1, 3, 2), (4, 6, 5)])
        @test isequal(map(row->(row.B, row.C, row.A), f), [(2, 3, 1), (5, 6, 4)])
        @test isequal(map(row->(row.C, row.A, row.B), f), [(3, 1, 2), (6, 4, 5)])
        @test isequal(map(row->(row.C, row.B, row.A), f), [(3, 2, 1), (6, 5, 4)])

        @test isequal(map(row->(row.A, row.B, row.C, row.D), f), [(1, 2, 3, missing), (4, 5, 6, missing)])
        @test isequal(map(row->(row.B, row.A, row.C, row.D), f), [(2, 1, 3, missing), (5, 4, 6, missing)])
        @test isequal(map(row->(row.A, row.C, row.B, row.D), f), [(1, 3, 2, missing), (4, 6, 5, missing)])
        @test isequal(map(row->(row.B, row.C, row.A, row.D), f), [(2, 3, 1, missing), (5, 6, 4, missing)])
        @test isequal(map(row->(row.C, row.A, row.B, row.D), f), [(3, 1, 2, missing), (6, 4, 5, missing)])
        @test isequal(map(row->(row.C, row.B, row.A, row.D), f), [(3, 2, 1, missing), (6, 5, 4, missing)])
        @test isequal(map(row->(row.A, row.B, row.D, row.C), f), [(1, 2, missing, 3), (4, 5, missing, 6)])
        @test isequal(map(row->(row.B, row.A, row.D, row.C), f), [(2, 1, missing, 3), (5, 4, missing, 6)])
        @test isequal(map(row->(row.A, row.C, row.D, row.B), f), [(1, 3, missing, 2), (4, 6, missing, 5)])
        @test isequal(map(row->(row.B, row.C, row.D, row.A), f), [(2, 3, missing, 1), (5, 6, missing, 4)])
        @test isequal(map(row->(row.C, row.A, row.D, row.B), f), [(3, 1, missing, 2), (6, 4, missing, 5)])
        @test isequal(map(row->(row.C, row.B, row.D, row.A), f), [(3, 2, missing, 1), (6, 5, missing, 4)])
        @test isequal(map(row->(row.A, row.D, row.B, row.C), f), [(1, missing, 2, 3), (4, missing, 5, 6)])
        @test isequal(map(row->(row.B, row.D, row.A, row.C), f), [(2, missing, 1, 3), (5, missing, 4, 6)])
        @test isequal(map(row->(row.A, row.D, row.C, row.B), f), [(1, missing, 3, 2), (4, missing, 6, 5)])
        @test isequal(map(row->(row.B, row.D, row.C, row.A), f), [(2, missing, 3, 1), (5, missing, 6, 4)])
        @test isequal(map(row->(row.C, row.D, row.A, row.B), f), [(3, missing, 1, 2), (6, missing, 4, 5)])
        @test isequal(map(row->(row.C, row.D, row.B, row.A), f), [(3, missing, 2, 1), (6, missing, 5, 4)])
        @test isequal(map(row->(row.D, row.A, row.B, row.C), f), [(missing, 1, 2, 3), (missing, 4, 5, 6)])
        @test isequal(map(row->(row.D, row.B, row.A, row.C), f), [(missing, 2, 1, 3), (missing, 5, 4, 6)])
        @test isequal(map(row->(row.D, row.A, row.C, row.B), f), [(missing, 1, 3, 2), (missing, 4, 6, 5)])
        @test isequal(map(row->(row.D, row.B, row.C, row.A), f), [(missing, 2, 3, 1), (missing, 5, 6, 4)])
        @test isequal(map(row->(row.D, row.C, row.A, row.B), f), [(missing, 3, 1, 2), (missing, 6, 4, 5)])
        @test isequal(map(row->(row.D, row.C, row.B, row.A), f), [(missing, 3, 2, 1), (missing, 6, 5, 4)])

        @test isequal(map(row->(row.A, row.B, row.C, row.D, row.E), f), [(1, 2, 3, missing, missing), (4, 5, 6, missing, missing)])
        @test isequal(map(row->(row.B, row.A, row.C, row.D, row.E), f), [(2, 1, 3, missing, missing), (5, 4, 6, missing, missing)])
        @test isequal(map(row->(row.A, row.C, row.B, row.D, row.E), f), [(1, 3, 2, missing, missing), (4, 6, 5, missing, missing)])
        @test isequal(map(row->(row.B, row.C, row.A, row.D, row.E), f), [(2, 3, 1, missing, missing), (5, 6, 4, missing, missing)])
        @test isequal(map(row->(row.C, row.A, row.B, row.D, row.E), f), [(3, 1, 2, missing, missing), (6, 4, 5, missing, missing)])
        @test isequal(map(row->(row.C, row.B, row.A, row.D, row.E), f), [(3, 2, 1, missing, missing), (6, 5, 4, missing, missing)])
        @test isequal(map(row->(row.A, row.B, row.D, row.C, row.E), f), [(1, 2, missing, 3, missing), (4, 5, missing, 6, missing)])
        @test isequal(map(row->(row.B, row.A, row.D, row.C, row.E), f), [(2, 1, missing, 3, missing), (5, 4, missing, 6, missing)])
        @test isequal(map(row->(row.A, row.C, row.D, row.B, row.E), f), [(1, 3, missing, 2, missing), (4, 6, missing, 5, missing)])
        @test isequal(map(row->(row.B, row.C, row.D, row.A, row.E), f), [(2, 3, missing, 1, missing), (5, 6, missing, 4, missing)])
        @test isequal(map(row->(row.C, row.A, row.D, row.B, row.E), f), [(3, 1, missing, 2, missing), (6, 4, missing, 5, missing)])
        @test isequal(map(row->(row.C, row.B, row.D, row.A, row.E), f), [(3, 2, missing, 1, missing), (6, 5, missing, 4, missing)])
        @test isequal(map(row->(row.A, row.D, row.B, row.C, row.E), f), [(1, missing, 2, 3, missing), (4, missing, 5, 6, missing)])
        @test isequal(map(row->(row.B, row.D, row.A, row.C, row.E), f), [(2, missing, 1, 3, missing), (5, missing, 4, 6, missing)])
        @test isequal(map(row->(row.A, row.D, row.C, row.B, row.E), f), [(1, missing, 3, 2, missing), (4, missing, 6, 5, missing)])
        @test isequal(map(row->(row.B, row.D, row.C, row.A, row.E), f), [(2, missing, 3, 1, missing), (5, missing, 6, 4, missing)])
        @test isequal(map(row->(row.C, row.D, row.A, row.B, row.E), f), [(3, missing, 1, 2, missing), (6, missing, 4, 5, missing)])
        @test isequal(map(row->(row.C, row.D, row.B, row.A, row.E), f), [(3, missing, 2, 1, missing), (6, missing, 5, 4, missing)])
        @test isequal(map(row->(row.D, row.A, row.B, row.C, row.E), f), [(missing, 1, 2, 3, missing), (missing, 4, 5, 6, missing)])
        @test isequal(map(row->(row.D, row.B, row.A, row.C, row.E), f), [(missing, 2, 1, 3, missing), (missing, 5, 4, 6, missing)])
        @test isequal(map(row->(row.D, row.A, row.C, row.B, row.E), f), [(missing, 1, 3, 2, missing), (missing, 4, 6, 5, missing)])
        @test isequal(map(row->(row.D, row.B, row.C, row.A, row.E), f), [(missing, 2, 3, 1, missing), (missing, 5, 6, 4, missing)])
        @test isequal(map(row->(row.D, row.C, row.A, row.B, row.E), f), [(missing, 3, 1, 2, missing), (missing, 6, 4, 5, missing)])
        @test isequal(map(row->(row.D, row.C, row.B, row.A, row.E), f), [(missing, 3, 2, 1, missing), (missing, 6, 5, 4, missing)])

        @test isequal(map(row->(row.A, row.B, row.C, row.E, row.D), f), [(1, 2, 3, missing, missing), (4, 5, 6, missing, missing)])
        @test isequal(map(row->(row.B, row.A, row.C, row.E, row.D), f), [(2, 1, 3, missing, missing), (5, 4, 6, missing, missing)])
        @test isequal(map(row->(row.A, row.C, row.B, row.E, row.D), f), [(1, 3, 2, missing, missing), (4, 6, 5, missing, missing)])
        @test isequal(map(row->(row.B, row.C, row.A, row.E, row.D), f), [(2, 3, 1, missing, missing), (5, 6, 4, missing, missing)])
        @test isequal(map(row->(row.C, row.A, row.B, row.E, row.D), f), [(3, 1, 2, missing, missing), (6, 4, 5, missing, missing)])
        @test isequal(map(row->(row.C, row.B, row.A, row.E, row.D), f), [(3, 2, 1, missing, missing), (6, 5, 4, missing, missing)])
        @test isequal(map(row->(row.A, row.B, row.D, row.E, row.C), f), [(1, 2, missing, missing, 3), (4, 5, missing, missing, 6)])
        @test isequal(map(row->(row.B, row.A, row.D, row.E, row.C), f), [(2, 1, missing, missing, 3), (5, 4, missing, missing, 6)])
        @test isequal(map(row->(row.A, row.C, row.D, row.E, row.B), f), [(1, 3, missing, missing, 2), (4, 6, missing, missing, 5)])
        @test isequal(map(row->(row.B, row.C, row.D, row.E, row.A), f), [(2, 3, missing, missing, 1), (5, 6, missing, missing, 4)])
        @test isequal(map(row->(row.C, row.A, row.D, row.E, row.B), f), [(3, 1, missing, missing, 2), (6, 4, missing, missing, 5)])
        @test isequal(map(row->(row.C, row.B, row.D, row.E, row.A), f), [(3, 2, missing, missing, 1), (6, 5, missing, missing, 4)])
        @test isequal(map(row->(row.A, row.D, row.B, row.E, row.C), f), [(1, missing, 2, missing, 3), (4, missing, 5, missing, 6)])
        @test isequal(map(row->(row.B, row.D, row.A, row.E, row.C), f), [(2, missing, 1, missing, 3), (5, missing, 4, missing, 6)])
        @test isequal(map(row->(row.A, row.D, row.C, row.E, row.B), f), [(1, missing, 3, missing, 2), (4, missing, 6, missing, 5)])
        @test isequal(map(row->(row.B, row.D, row.C, row.E, row.A), f), [(2, missing, 3, missing, 1), (5, missing, 6, missing, 4)])
        @test isequal(map(row->(row.C, row.D, row.A, row.E, row.B), f), [(3, missing, 1, missing, 2), (6, missing, 4, missing, 5)])
        @test isequal(map(row->(row.C, row.D, row.B, row.E, row.A), f), [(3, missing, 2, missing, 1), (6, missing, 5, missing, 4)])
        @test isequal(map(row->(row.D, row.A, row.B, row.E, row.C), f), [(missing, 1, 2, missing, 3), (missing, 4, 5, missing, 6)])
        @test isequal(map(row->(row.D, row.B, row.A, row.E, row.C), f), [(missing, 2, 1, missing, 3), (missing, 5, 4, missing, 6)])
        @test isequal(map(row->(row.D, row.A, row.C, row.E, row.B), f), [(missing, 1, 3, missing, 2), (missing, 4, 6, missing, 5)])
        @test isequal(map(row->(row.D, row.B, row.C, row.E, row.A), f), [(missing, 2, 3, missing, 1), (missing, 5, 6, missing, 4)])
        @test isequal(map(row->(row.D, row.C, row.A, row.E, row.B), f), [(missing, 3, 1, missing, 2), (missing, 6, 4, missing, 5)])
        @test isequal(map(row->(row.D, row.C, row.B, row.E, row.A), f), [(missing, 3, 2, missing, 1), (missing, 6, 5, missing, 4)])

        @test isequal(map(row->(row.A, row.B, row.E, row.C, row.D), f), [(1, 2, missing, 3, missing), (4, 5, missing, 6, missing)])
        @test isequal(map(row->(row.B, row.A, row.E, row.C, row.D), f), [(2, 1, missing, 3, missing), (5, 4, missing, 6, missing)])
        @test isequal(map(row->(row.A, row.C, row.E, row.B, row.D), f), [(1, 3, missing, 2, missing), (4, 6, missing, 5, missing)])
        @test isequal(map(row->(row.B, row.C, row.E, row.A, row.D), f), [(2, 3, missing, 1, missing), (5, 6, missing, 4, missing)])
        @test isequal(map(row->(row.C, row.A, row.E, row.B, row.D), f), [(3, 1, missing, 2, missing), (6, 4, missing, 5, missing)])
        @test isequal(map(row->(row.C, row.B, row.E, row.A, row.D), f), [(3, 2, missing, 1, missing), (6, 5, missing, 4, missing)])
        @test isequal(map(row->(row.A, row.B, row.E, row.D, row.C), f), [(1, 2, missing, missing, 3), (4, 5, missing, missing, 6)])
        @test isequal(map(row->(row.B, row.A, row.E, row.D, row.C), f), [(2, 1, missing, missing, 3), (5, 4, missing, missing, 6)])
        @test isequal(map(row->(row.A, row.C, row.E, row.D, row.B), f), [(1, 3, missing, missing, 2), (4, 6, missing, missing, 5)])
        @test isequal(map(row->(row.B, row.C, row.E, row.D, row.A), f), [(2, 3, missing, missing, 1), (5, 6, missing, missing, 4)])
        @test isequal(map(row->(row.C, row.A, row.E, row.D, row.B), f), [(3, 1, missing, missing, 2), (6, 4, missing, missing, 5)])
        @test isequal(map(row->(row.C, row.B, row.E, row.D, row.A), f), [(3, 2, missing, missing, 1), (6, 5, missing, missing, 4)])
        @test isequal(map(row->(row.A, row.D, row.E, row.B, row.C), f), [(1, missing, missing, 2, 3), (4, missing, missing, 5, 6)])
        @test isequal(map(row->(row.B, row.D, row.E, row.A, row.C), f), [(2, missing, missing, 1, 3), (5, missing, missing, 4, 6)])
        @test isequal(map(row->(row.A, row.D, row.E, row.C, row.B), f), [(1, missing, missing, 3, 2), (4, missing, missing, 6, 5)])
        @test isequal(map(row->(row.B, row.D, row.E, row.C, row.A), f), [(2, missing, missing, 3, 1), (5, missing, missing, 6, 4)])
        @test isequal(map(row->(row.C, row.D, row.E, row.A, row.B), f), [(3, missing, missing, 1, 2), (6, missing, missing, 4, 5)])
        @test isequal(map(row->(row.C, row.D, row.E, row.B, row.A), f), [(3, missing, missing, 2, 1), (6, missing, missing, 5, 4)])
        @test isequal(map(row->(row.D, row.A, row.E, row.B, row.C), f), [(missing, 1, missing, 2, 3), (missing, 4, missing, 5, 6)])
        @test isequal(map(row->(row.D, row.B, row.E, row.A, row.C), f), [(missing, 2, missing, 1, 3), (missing, 5, missing, 4, 6)])
        @test isequal(map(row->(row.D, row.A, row.E, row.C, row.B), f), [(missing, 1, missing, 3, 2), (missing, 4, missing, 6, 5)])
        @test isequal(map(row->(row.D, row.B, row.E, row.C, row.A), f), [(missing, 2, missing, 3, 1), (missing, 5, missing, 6, 4)])
        @test isequal(map(row->(row.D, row.C, row.E, row.A, row.B), f), [(missing, 3, missing, 1, 2), (missing, 6, missing, 4, 5)])
        @test isequal(map(row->(row.D, row.C, row.E, row.B, row.A), f), [(missing, 3, missing, 2, 1), (missing, 6, missing, 5, 4)])

        @test isequal(map(row->(row.A, row.E, row.B, row.C, row.D), f), [(1, missing, 2, 3, missing), (4, missing, 5, 6, missing)])
        @test isequal(map(row->(row.B, row.E, row.A, row.C, row.D), f), [(2, missing, 1, 3, missing), (5, missing, 4, 6, missing)])
        @test isequal(map(row->(row.A, row.E, row.C, row.B, row.D), f), [(1, missing, 3, 2, missing), (4, missing, 6, 5, missing)])
        @test isequal(map(row->(row.B, row.E, row.C, row.A, row.D), f), [(2, missing, 3, 1, missing), (5, missing, 6, 4, missing)])
        @test isequal(map(row->(row.C, row.E, row.A, row.B, row.D), f), [(3, missing, 1, 2, missing), (6, missing, 4, 5, missing)])
        @test isequal(map(row->(row.C, row.E, row.B, row.A, row.D), f), [(3, missing, 2, 1, missing), (6, missing, 5, 4, missing)])
        @test isequal(map(row->(row.A, row.E, row.B, row.D, row.C), f), [(1, missing, 2, missing, 3), (4, missing, 5, missing, 6)])
        @test isequal(map(row->(row.B, row.E, row.A, row.D, row.C), f), [(2, missing, 1, missing, 3), (5, missing, 4, missing, 6)])
        @test isequal(map(row->(row.A, row.E, row.C, row.D, row.B), f), [(1, missing, 3, missing, 2), (4, missing, 6, missing, 5)])
        @test isequal(map(row->(row.B, row.E, row.C, row.D, row.A), f), [(2, missing, 3, missing, 1), (5, missing, 6, missing, 4)])
        @test isequal(map(row->(row.C, row.E, row.A, row.D, row.B), f), [(3, missing, 1, missing, 2), (6, missing, 4, missing, 5)])
        @test isequal(map(row->(row.C, row.E, row.B, row.D, row.A), f), [(3, missing, 2, missing, 1), (6, missing, 5, missing, 4)])
        @test isequal(map(row->(row.A, row.E, row.D, row.B, row.C), f), [(1, missing, missing, 2, 3), (4, missing, missing, 5, 6)])
        @test isequal(map(row->(row.B, row.E, row.D, row.A, row.C), f), [(2, missing, missing, 1, 3), (5, missing, missing, 4, 6)])
        @test isequal(map(row->(row.A, row.E, row.D, row.C, row.B), f), [(1, missing, missing, 3, 2), (4, missing, missing, 6, 5)])
        @test isequal(map(row->(row.B, row.E, row.D, row.C, row.A), f), [(2, missing, missing, 3, 1), (5, missing, missing, 6, 4)])
        @test isequal(map(row->(row.C, row.E, row.D, row.A, row.B), f), [(3, missing, missing, 1, 2), (6, missing, missing, 4, 5)])
        @test isequal(map(row->(row.C, row.E, row.D, row.B, row.A), f), [(3, missing, missing, 2, 1), (6, missing, missing, 5, 4)])
        @test isequal(map(row->(row.D, row.E, row.A, row.B, row.C), f), [(missing, missing, 1, 2, 3), (missing, missing, 4, 5, 6)])
        @test isequal(map(row->(row.D, row.E, row.B, row.A, row.C), f), [(missing, missing, 2, 1, 3), (missing, missing, 5, 4, 6)])
        @test isequal(map(row->(row.D, row.E, row.A, row.C, row.B), f), [(missing, missing, 1, 3, 2), (missing, missing, 4, 6, 5)])
        @test isequal(map(row->(row.D, row.E, row.B, row.C, row.A), f), [(missing, missing, 2, 3, 1), (missing, missing, 5, 6, 4)])
        @test isequal(map(row->(row.D, row.E, row.C, row.A, row.B), f), [(missing, missing, 3, 1, 2), (missing, missing, 6, 4, 5)])
        @test isequal(map(row->(row.D, row.E, row.C, row.B, row.A), f), [(missing, missing, 3, 2, 1), (missing, missing, 6, 5, 4)])

        @test isequal(map(row->(row.E, row.A, row.B, row.C, row.D), f), [(missing, 1, 2, 3, missing), (missing, 4, 5, 6, missing)])
        @test isequal(map(row->(row.E, row.B, row.A, row.C, row.D), f), [(missing, 2, 1, 3, missing), (missing, 5, 4, 6, missing)])
        @test isequal(map(row->(row.E, row.A, row.C, row.B, row.D), f), [(missing, 1, 3, 2, missing), (missing, 4, 6, 5, missing)])
        @test isequal(map(row->(row.E, row.B, row.C, row.A, row.D), f), [(missing, 2, 3, 1, missing), (missing, 5, 6, 4, missing)])
        @test isequal(map(row->(row.E, row.C, row.A, row.B, row.D), f), [(missing, 3, 1, 2, missing), (missing, 6, 4, 5, missing)])
        @test isequal(map(row->(row.E, row.C, row.B, row.A, row.D), f), [(missing, 3, 2, 1, missing), (missing, 6, 5, 4, missing)])
        @test isequal(map(row->(row.E, row.A, row.B, row.D, row.C), f), [(missing, 1, 2, missing, 3), (missing, 4, 5, missing, 6)])
        @test isequal(map(row->(row.E, row.B, row.A, row.D, row.C), f), [(missing, 2, 1, missing, 3), (missing, 5, 4, missing, 6)])
        @test isequal(map(row->(row.E, row.A, row.C, row.D, row.B), f), [(missing, 1, 3, missing, 2), (missing, 4, 6, missing, 5)])
        @test isequal(map(row->(row.E, row.B, row.C, row.D, row.A), f), [(missing, 2, 3, missing, 1), (missing, 5, 6, missing, 4)])
        @test isequal(map(row->(row.E, row.C, row.A, row.D, row.B), f), [(missing, 3, 1, missing, 2), (missing, 6, 4, missing, 5)])
        @test isequal(map(row->(row.E, row.C, row.B, row.D, row.A), f), [(missing, 3, 2, missing, 1), (missing, 6, 5, missing, 4)])
        @test isequal(map(row->(row.E, row.A, row.D, row.B, row.C), f), [(missing, 1, missing, 2, 3), (missing, 4, missing, 5, 6)])
        @test isequal(map(row->(row.E, row.B, row.D, row.A, row.C), f), [(missing, 2, missing, 1, 3), (missing, 5, missing, 4, 6)])
        @test isequal(map(row->(row.E, row.A, row.D, row.C, row.B), f), [(missing, 1, missing, 3, 2), (missing, 4, missing, 6, 5)])
        @test isequal(map(row->(row.E, row.B, row.D, row.C, row.A), f), [(missing, 2, missing, 3, 1), (missing, 5, missing, 6, 4)])
        @test isequal(map(row->(row.E, row.C, row.D, row.A, row.B), f), [(missing, 3, missing, 1, 2), (missing, 6, missing, 4, 5)])
        @test isequal(map(row->(row.E, row.C, row.D, row.B, row.A), f), [(missing, 3, missing, 2, 1), (missing, 6, missing, 5, 4)])
        @test isequal(map(row->(row.E, row.D, row.A, row.B, row.C), f), [(missing, missing, 1, 2, 3), (missing, missing, 4, 5, 6)])
        @test isequal(map(row->(row.E, row.D, row.B, row.A, row.C), f), [(missing, missing, 2, 1, 3), (missing, missing, 5, 4, 6)])
        @test isequal(map(row->(row.E, row.D, row.A, row.C, row.B), f), [(missing, missing, 1, 3, 2), (missing, missing, 4, 6, 5)])
        @test isequal(map(row->(row.E, row.D, row.B, row.C, row.A), f), [(missing, missing, 2, 3, 1), (missing, missing, 5, 6, 4)])
        @test isequal(map(row->(row.E, row.D, row.C, row.A, row.B), f), [(missing, missing, 3, 1, 2), (missing, missing, 6, 4, 5)])
        @test isequal(map(row->(row.E, row.D, row.C, row.B, row.A), f), [(missing, missing, 3, 2, 1), (missing, missing, 6, 5, 4)])
    end
end

mutable struct TempFileWrapper
    file::Union{String, Nothing}
end

# structure for iterating over a csv file
# no automatic type inference is done, but types are allowed to be passed
# for as many columns as desired; `CSV.detect(row, i)` can also be used to
# use the same inference logic used in `CSV.File` for determining a cell's typed value
struct Rows{IO, customtypes, V, stringtype}
    name::String
    names::Vector{Symbol} # only includes "select"ed columns
    columns::Vector{Column}
    columnmap::Vector{Int} # maps "select"ed column index to actual file column index
    buf::IO
    datapos::Int
    datarow::Int
    len::Int
    limit::Int
    options::Parsers.Options
    reusebuffer::Bool
    values::Vector{V} # once values are parsed, put in values; allocated on each iteration if reusebuffer=false
    lookup::Dict{Symbol, Int}
    numwarnings::Base.RefValue{Int}
    maxwarnings::Int
    ctx::Context
    tempfile::TempFileWrapper
end

function Base.show(io::IO, r::Rows)
    println(io, "CSV.Rows(\"$(r.name)\"):")
    println(io, "Size: $(length(r.columns))")
    show(io, Tables.schema(r))
end

"""
    CSV.Rows(source; kwargs...) => CSV.Rows

Read a csv input returning a `CSV.Rows` object.

The [`input`](@ref input) argument can be one of:
  * filename given as a string or FilePaths.jl type
  * a `Vector{UInt8}` or `SubArray{UInt8, 1, Vector{UInt8}}` byte buffer
  * a `CodeUnits` object, which wraps a `String`, like `codeunits(str)`
  * a csv-formatted string can also be passed like `IOBuffer(str)`
  * a `Cmd` or other `IO`
  * a gzipped file (or gzipped data in any of the above), which will automatically be decompressed for parsing


To read a csv file from a url, use the HTTP.jl package, where the `HTTP.Response` body can be passed like:
```julia
f = CSV.Rows(HTTP.get(url).body)
```

For other `IO` or `Cmd` inputs, you can pass them like: `f = CSV.Rows(read(obj))`.

While similar to [`CSV.File`](@ref), `CSV.Rows` provides a slightly different interface, the tradeoffs including:
  * Very minimal memory footprint; while iterating, only the current row values are buffered
  * Only provides row access via iteration; to access columns, one can stream the rows into a table type
  * Performs no type inference; each column/cell is essentially treated as `Union{String, Missing}`, users can utilize the performant `Parsers.parse(T, str)` to convert values to a more specific type if needed, or pass types upon construction using the `type` or `types` keyword arguments

Opens the file and uses passed arguments to detect the number of columns, ***but not*** column types (column types default to `String` unless otherwise manually provided).
The returned `CSV.Rows` object supports the [Tables.jl](https://github.com/JuliaData/Tables.jl) interface
and can iterate rows. Each row object supports `propertynames`, `getproperty`, and `getindex` to access individual row values.
Note that duplicate column names will be detected and adjusted to ensure uniqueness (duplicate column name `a` will become `a_1`).
For example, one could iterate over a csv file with column names `a`, `b`, and `c` by doing:

```julia
for row in CSV.Rows(file)
    println("a=\$(row.a), b=\$(row.b), c=\$(row.c)")
end
```

$KEYWORD_DOCS
"""
function Rows(source::ValidSources;
    # file options
    # header can be a row number, range of rows, or actual string vector
    header::Union{Integer, Vector{Symbol}, Vector{String}, AbstractVector{<:Integer}}=1,
    normalizenames::Bool=false,
    # by default, data starts immediately after header or start of file
    datarow::Integer=-1,
    skipto::Integer=-1,
    footerskip::Integer=0,
    transpose::Bool=false,
    comment::Union{String, Nothing}=nothing,
    ignoreemptyrows::Bool=true,
    ignoreemptylines=nothing,
    select=nothing,
    drop=nothing,
    limit::Union{Integer, Nothing}=nothing,
    buffer_in_memory::Bool=false,
    # parsing options
    missingstrings=String[],
    missingstring="",
    delim::Union{Nothing, Char, String}=nothing,
    ignorerepeated::Bool=false,
    quoted::Bool=true,
    quotechar::Union{UInt8, Char}='"',
    openquotechar::Union{UInt8, Char, Nothing}=nothing,
    closequotechar::Union{UInt8, Char, Nothing}=nothing,
    escapechar::Union{UInt8, Char}='"',
    dateformat::Union{String, Dates.DateFormat, Nothing, AbstractDict}=nothing,
    dateformats=nothing,
    decimal::Union{UInt8, Char}=UInt8('.'),
    groupmark::Union{Char, Nothing}=nothing,
    truestrings::Union{Vector{String}, Nothing}=TRUE_STRINGS,
    falsestrings::Union{Vector{String}, Nothing}=FALSE_STRINGS,
    stripwhitespace::Bool=false,
    # type options
    type=nothing,
    types=nothing,
    typemap::AbstractDict=IdDict{Type, Type}(),
    pool=false,
    downcast::Bool=false,
    stringtype::StringTypes=PosLenString,
    lazystrings::Bool=stringtype === PosLenString,
    strict::Bool=false,
    silencewarnings::Bool=false,
    maxwarnings::Int=100,
    debug::Bool=false,
    parsingdebug::Bool=false,
    validate::Bool=true,
    reusebuffer::Bool=false,
    )
    ctx = @refargs Context(source, header, normalizenames, datarow, skipto, footerskip, transpose, comment, ignoreemptyrows, ignoreemptylines, select, drop, limit, buffer_in_memory, nothing, nothing, nothing, 0, nothing, missingstrings, missingstring, delim, ignorerepeated, quoted, quotechar, openquotechar, closequotechar, escapechar, dateformat, dateformats, decimal, groupmark, truestrings, falsestrings, stripwhitespace, type, types, typemap, pool, downcast, lazystrings, stringtype, strict, silencewarnings, maxwarnings, debug, parsingdebug, validate, true)
    foreach(col -> col.pool = 0.0, ctx.columns)
    allocate!(ctx.columns, 1)
    values = all(x->x.type === ctx.stringtype && x.anymissing, ctx.columns) && ctx.stringtype === PosLenString ? Vector{PosLen}(undef, ctx.cols) : Vector{Any}(undef, ctx.cols)
    columnmap = collect(1:ctx.cols)
    for i = ctx.cols:-1:1
        col = ctx.columns[i]
        if col.willdrop
            deleteat!(ctx.names, i)
            deleteat!(columnmap, i)
        end
    end
    lookup = Dict(nm=>i for (i, nm) in enumerate(ctx.names))
    tempfile = TempFileWrapper(ctx.tempfile)
    if tempfile.file !== nothing
        finalizer(tempfile) do x
            rm(x.file; force=true)
        end
    end
    return Rows{typeof(ctx.buf), ctx.customtypes, eltype(values), ctx.stringtype}(
        ctx.name,
        ctx.names,
        ctx.columns,
        columnmap,
        ctx.buf,
        ctx.datapos,
        ctx.datarow,
        ctx.len,
        ctx.limit,
        ctx.options,
        reusebuffer,
        values,
        lookup,
        Ref(0),
        ctx.maxwarnings,
        ctx,
        tempfile
    )
end

Tables.isrowtable(::Type{<:Rows}) = true
Tables.schema(r::Rows) = Tables.Schema(r.names, [coltype(x) for x in view(r.columns, r.columnmap)])
Base.eltype(::Rows) = Row2
Base.IteratorSize(::Type{<:Rows}) = Base.SizeUnknown()

@inline function setcustom!(::Type{customtypes}, values, columns, i, setmissing) where {customtypes}
    if @generated
        block = Expr(:block)
        push!(block.args, quote
            error("CSV.jl code-generation error, unexpected column type: $(typeof(column))")
        end)
        for i = 1:fieldcount(customtypes)
            T = fieldtype(customtypes, i)
            vT = vectype(T)
            pushfirst!(block.args, quote
                column = columns[i].column
                if column isa $vT
                    if setmissing
                        setmissing!(column, 1)
                    else
                        @inbounds values[i] = column[1]
                    end
                    return
                end
            end)
        end
        pushfirst!(block.args, Expr(:meta, :inline))
        # @show block
        return block
    else
        # println("generated function failed")
        @inbounds values[i] = columns[i].column[1]
        return
    end
end

function checkwidencolumns!(r::Rows{ct, V}, cols) where {ct, V}
    if cols > length(r.values)
        # we widened while parsing this row, need to widen other supporting objects
        for i = (length(r.values) + 1):cols
            push!(r.values, V === Any ? missing : Base.bitcast(PosLen, Parsers.MISSING_BIT))
            nm = Symbol(:Column, i)
            push!(r.names, nm)
            r.lookup[nm] = length(r.values)
            push!(r.columnmap, i)
        end
    end
    return
end

macro unrollcolumns(setmissing, values, ex)
    return esc(quote
        if column isa MissingVector
            if !($setmissing)
                @inbounds $(values)[i] = missing
            end
        elseif column isa Vector{PosLen}
            $ex
        elseif column isa Vector{Union{Missing, Int8}}
            $ex
        elseif column isa Vector{Union{Missing, Int16}}
            $ex
        elseif column isa Vector{Union{Missing, Int32}}
            $ex
        elseif column isa SVec{Int32}
            $ex
        elseif column isa SVec{Int64}
            $ex
        elseif column isa SVec{Int128}
            $ex
        elseif column isa SVec{Float16}
            $ex
        elseif column isa SVec{Float32}
            $ex
        elseif column isa SVec{Float64}
            $ex
        elseif column isa SVec{InlineString1}
            $ex
        elseif column isa SVec{InlineString3}
            $ex
        elseif column isa SVec{InlineString7}
            $ex
        elseif column isa SVec{InlineString15}
            $ex
        elseif column isa SVec{InlineString31}
            $ex
        elseif column isa SVec{InlineString63}
            $ex
        elseif column isa SVec{InlineString127}
            $ex
        elseif column isa SVec{InlineString255}
            $ex
        elseif column isa SVec2{String}
            $ex
        elseif column isa SVec{Date}
            $ex
        elseif column isa SVec{DateTime}
            $ex
        elseif column isa SVec{Time}
            $ex
        elseif column isa Vector{Union{Missing, Bool}}
            $ex
        elseif customtypes !== Tuple{}
            setcustom!(customtypes, $values, columns, i, $setmissing)
        else
            error("bad array type: $(typeof(column))")
        end
    end)
end

@inline function Base.iterate(r::Rows{IO, customtypes, V, stringtype}, (pos, len, row)=(r.datapos, r.len, 1)) where {IO, customtypes, V, stringtype}
    (pos > len || row > r.limit) && return nothing
    columns = r.columns
    cols = length(columns)
    for i = 1:cols
        @inbounds column = columns[i].column
        @unrollcolumns true nothing begin
            setmissing!(column, 1)
        end
    end
    pos = parserow(1, 1, r.numwarnings, r.ctx, r.buf, pos, len, 1, r.datarow + row - 2, columns, customtypes)
    cols = length(columns)
    values = r.reusebuffer ? r.values : Vector{V}(undef, cols)
    checkwidencolumns!(r, cols)
    for i = 1:cols
        @inbounds column = columns[i].column
        @unrollcolumns false values begin
            @inbounds values[i] = column[1]
        end
    end
    return Row2{V, stringtype}(r.names, r.columns, r.columnmap, r.lookup, values, r.buf), (pos, len, row + 1)
end

struct Row2{V, stringtype} <: Tables.AbstractRow
    names::Vector{Symbol}
    columns::Vector{Column}
    columnmap::Vector{Int}
    lookup::Dict{Symbol, Int}
    values::Vector{V}
    buf::Vector{UInt8}
end

getnames(r::Row2) = getfield(r, :names)
getcolumns(r::Row2) = getfield(r, :columns)
getcolumnmap(r::Row2) = getfield(r, :columnmap)
getlookup(r::Row2) = getfield(r, :lookup)
getvalues(r::Row2) = getfield(r, :values)
getbuf(r::Row2) = getfield(r, :buf)
getV(::Row2{V}) where {V} = V
getstringtype(::Row2{V, stringtype}) where {V, stringtype} = stringtype

Tables.columnnames(r::Row2) = getnames(r)

Base.checkbounds(r::Row2, i) = 0 < i < length(r)

Tables.getcolumn(r::Row2, nm::Symbol) = Tables.getcolumn(r, getlookup(r)[nm])
Tables.getcolumn(r::Row2, i::Int) = Tables.getcolumn(r, coltype(getcolumns(r)[i]), i, getnames(r)[i])

Base.@propagate_inbounds function Tables.getcolumn(r::Row2, ::Type{T}, i::Int, nm::Symbol) where {T}
    @boundscheck checkbounds(r, i)
    j = getcolumnmap(r)[i]
    values = getvalues(r)
    V = getV(r)
    @inbounds val = j > length(values) ? (V === PosLen ? Parsers.MISSING_BIT : missing) : values[j]
    stringtype = getstringtype(r)
    if V === PosLen
        # column type must be stringtype
        # @show T, stringtype
        @assert T === Union{stringtype, Missing}
        e = getcolumns(r)[j].options.e
        if (val isa PosLen && val.missingvalue) || val == Parsers.MISSING_BIT
            return missing
        elseif stringtype === PosLenString
            return PosLenString(getbuf(r), val, e)
        elseif stringtype === String
            return Parsers.getstring(getbuf(r), val, e)
        end
    else
        # at least some column types were manually provided
        if val isa PosLen
            if val.missingvalue
                return missing
            else
                e = getcolumns(r)[j].options.e
                return PosLenString(getbuf(r), val, e)
            end
        else
            return val
        end
    end
end

@noinline stringsonly() = error("Parsers.parse only allowed on String column types")

Base.@propagate_inbounds function Parsers.parse(::Type{T}, r::Row2, i::Int) where {T}
    @boundscheck checkbounds(r, i)
    @inbounds begin
        j = getcolumnmap(r)[i]
        col = getcolumns(r)[j]
        col.type isa StringTypes || stringsonly()
        poslen = getvalues(r)[j]
        poslen.missingvalue && return missing
        pos = poslen.pos
        res = Parsers.xparse(T, getbuf(r), pos, pos + poslen.len, col.options)
    end
    return Parsers.ok(res.code) ? (res.val::T) : missing
end

Base.@propagate_inbounds function detect(r::Row2, i::Int)
    @boundscheck checkbounds(r, i)
    @inbounds begin
        j = getcolumnmap(r)[i]
        col = getcolumns(r)[j]
        col.type isa StringTypes || stringsonly()
        poslen = getvalues(r)[j]
        poslen.missingvalue && return missing
        pos = poslen.pos
        code, tlen, x, xT = detect(pass, getbuf(r), pos, pos + poslen.len - 1, col.options)
        return x === nothing ? r[i] : x
    end
end

function Parsers.parse(::Type{T}, r::Row2, nm::Symbol) where {T}
    @inbounds x = Parsers.parse(T, r, getlookup(r)[nm])
    return x
end

function detect(r::Row2, nm::Symbol)
    @inbounds x = detect(r, getlookup(r)[nm])
    return x
end

"""
CSV provides fast, flexible reader & writer for delimited text files in various formats.

Reading:
- `CSV.File` reads delimited data and returns a `CSV.File` object, which allows dot-access to columns and iterating rows.
- `CSV.read` is similar to `CSV.File` but used when the input will be passed directly to a sink function such as a `DataFrame`.
- `CSV.Rows` reads delimited data and returns a `CSV.Rows` object, which allows "streaming" the data by iterating and thereby has a lower memory footprint than `CSV.File`.
- `CSV.Chunks` allows processing extremely large files in "batches" or "chunks".
Writing:
- `CSV.write` writes a [Tables.jl interface input](https://github.com/JuliaData/Tables.jl) such as a `DataFrame` to a csv file or an in-memory IOBuffer.
- `CSV.RowWriter` creates an iterator that produces csv-formatted strings for each row in the input table.
Here is an example of reading a csv file and passing the input to a `DataFrame`:
```julia
using CSV, DataFrames
ExampleInputDF = CSV.read("ExampleInputFile.csv", DataFrame)
```
Here is an example of writing out a `DataFrame` to a csv file:
```julia
using CSV, DataFrames
ExampleOutputDF = DataFrame(rand(10,10), :auto)
CSV.write("ExampleOutputFile.csv", ExampleOutputDF)
```
"""
module CSV

if !isdefined(Base, :contains)
    contains(haystack, needle) = occursin(needle, haystack)
end

# stdlib
using Mmap, Dates, Unicode
# Parsers.jl is used for core type parsing from byte buffers
# and all other parsing options (quoted fields, delimiters, dateformats etc.)
using Parsers
# Tables.jl allows integration with all other table/data file formats
using Tables
# PooledArrays.jl is used for materializing pooled columns
using PooledArrays
# SentinelArrays.jl allow efficient conversion from Vector{Union{T, Missing}} to Vector{T}
# it also provides the MissingVector and ChainedVector array types
using SentinelArrays
# InlineStrings and WeakRefStrings provide the InlineString and PosLenString types for more gc-friendly string types
using InlineStrings, WeakRefStrings
export PosLenString, InlineString
export String1, String3, String7, String15, String31, String63, String127, String255
# CodecZlib is used for unzipping gzip files
using CodecZlib
# FilePathsBase allows more structured file path types
using FilePathsBase
# WorkerUtilities for lock/spawn utilities
using WorkerUtilities

struct Error <: Exception
    msg::String
end

Base.showerror(io::IO, e::Error) = println(io, e.msg)

# constants
const DEFAULT_STRINGTYPE = InlineString
const DEFAULT_POOL = (0.2, 500)
const DEFAULT_ROWS_TO_CHECK = 30
const DEFAULT_MAX_WARNINGS = 100
const DEFAULT_MAX_INLINE_STRING_LENGTH = 32
const TRUE_STRINGS = ["true", "True", "TRUE", "T", "1"]
const FALSE_STRINGS = ["false", "False", "FALSE", "F", "0"]
const StringCodeUnits = Base.CodeUnits{UInt8, String}
const ValidSources = Union{Vector{UInt8}, SubArray{UInt8, 1, Vector{UInt8}}, StringCodeUnits, IO, Cmd, AbstractString, AbstractPath}
const MAX_INPUT_SIZE = Int === Int64 ? 2^42 : typemax(Int32)
const EMPTY_INT_ARRAY = Int[]

include("keyworddocs.jl")
include("utils.jl")
include("detection.jl")
include("context.jl")
include("file.jl")
include("chunks.jl")
include("rows.jl")
include("write.jl")

"""
    CSV.read(source, sink::T; kwargs...) => T

Read and parses a delimited file or files, materializing directly using the `sink` function. Allows avoiding excessive copies
of columns for certain sinks like `DataFrame`.

# Example
```julia-repl
julia> using CSV, DataFrames

julia> path = tempname();

julia> write(path, "a,b,c\\n1,2,3");

julia> CSV.read(path, DataFrame)
1×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> CSV.read(path, DataFrame; header=false)
2×3 DataFrame
 Row │ Column1  Column2  Column3
     │ String1  String1  String1
─────┼───────────────────────────
   1 │ a        b        c
   2 │ 1        2        3
```

$KEYWORD_DOCS
"""
function read(source, sink=nothing; copycols::Bool=false, kwargs...)
    if sink === nothing
        throw(ArgumentError("provide a valid sink argument, like `using DataFrames; CSV.read(source, DataFrame)`"))
    end
    Tables.CopiedColumns(CSV.File(source; kwargs...)) |> sink
end

include("precompile.jl")

function __init__()
end

end # module

nms(::Type{NamedTuple{names, types}}) where {names, types} = names
typs(::Type{NamedTuple{names, types}}) where {names, types} = Tuple(fieldtype(types, i) for i = 1:fieldcount(types))

function testfile(file, kwargs, expected_sz, expected_sch, testfunc; dir=dir)
    println("testing $file")
    if file isa IO
        seekstart(file)
    end
    f = CSV.File(file isa IO ? file : joinpath(dir, file); kwargs...)
    if file isa IO
        seekstart(file)
    end
    kwargs = Base.structdiff(kwargs, (ntasks=0,)) # Rows does not support the "ntasks" kwarg
    rows = CSV.Rows(file isa IO ? file : joinpath(dir, file); kwargs...) |> Tables.dictrowtable |> columntable
    t = f |> columntable
    actual_sch = Tables.schema(t)
    @test Tuple(typs(expected_sch)) == actual_sch.types
    @test Tuple(nms(expected_sch)) == actual_sch.names
    @test (length(t) == 0 ? 0 : length(t[1]), length(t)) == expected_sz
    if testfunc === nothing
    elseif testfunc isa Function
        testfunc(t)
    else
        @test isequal(t, testfunc)
    end
    if file isa IO
        seekstart(file)
    end
    kwargs = Base.structdiff(kwargs, (types=[],))
    types = haskey(kwargs, :select) ? Dict(nm=>T for (nm, T) in zip(f.names, getfield(f, :types))) : getfield(f, :types)
    try
        rows = CSV.Rows(file isa IO ? file : joinpath(dir, file); types=types, kwargs...) |> Tables.dictrowtable |> columntable
        actual_sch = Tables.schema(rows)
    catch e
        # check if just a column-widening issue to ignore
        !(e isa ArgumentError) && rethrow(e)
    end
    return t
end

testfiles = [
    # file, kwargs, expected_sz, expected_sch, testfunc =
    ("test_utf8_with_BOM.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Float64,Float64}},
        (col1 = [1.0, 4.0, 7.0], col2 = [2.0, 5.0, 8.0], col3 = [3.0, 6.0, 9.0])
    ),
    ("test_utf8.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Float64,Float64}},
        (col1 = [1.0, 4.0, 7.0], col2 = [2.0, 5.0, 8.0], col3 = [3.0, 6.0, 9.0])
    ),
    ("test_windows.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Float64,Float64}},
        (col1 = [1.0, 4.0, 7.0], col2 = [2.0, 5.0, 8.0], col3 = [3.0, 6.0, 9.0])
    ),
    ("test_single_column.csv", NamedTuple(),
        (3, 1),
        NamedTuple{(:col1,), Tuple{Int}},
        (col1=[1,2,3],)
    ),
    ("test_empty_file.csv", NamedTuple(),
        (0, 0),
        NamedTuple{(), Tuple{}},
        NamedTuple()
    ),
    ("test_empty_file_newlines.csv", (normalizenames=true, ignoreemptyrows=false),
        (9, 1),
        NamedTuple{(:Column1,), Tuple{Missing}},
        (Column1 = Missing[missing, missing, missing, missing, missing, missing, missing, missing, missing],)
    ),
    ("test_simple_quoted.csv", (escapechar='\\', pool=false),
        (1, 2),
        NamedTuple{(:col1, :col2), Tuple{InlineString15, InlineString15}},
        (col1 = ["quoted field 1"], col2 = ["quoted field 2"])
    ),
    ("test_quoted_delim_and_newline.csv", (escapechar='\\', pool=false),
        (1, 2),
        NamedTuple{(:col1, :col2), Tuple{InlineString15, InlineString15}},
        (col1 = ["quoted ,field 1"], col2 = ["quoted\n field 2"])
    ),
    ("test_quoted_numbers.csv", (escapechar='\\',),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{InlineString7,Int,Int}},
        (col1 = ["123", "abc", "123abc"], col2 = [1, 42, 12], col3 = [1, 42, 12])
    ),
    ("test_crlf_line_endings.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1,:col2,:col3), Tuple{Int, Int, Int}},
        (col1 = [1, 4, 7], col2 = [2, 5, 8], col3 = [3, 6, 9])
    ),
    ("test_newline_line_endings.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1,:col2,:col3), Tuple{Int, Int, Int}},
        (col1 = [1, 4, 7], col2 = [2, 5, 8], col3 = [3, 6, 9])
    ),
    ("test_mac_line_endings.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1,:col2,:col3), Tuple{Int, Int, Int}},
        (col1 = [1, 4, 7], col2 = [2, 5, 8], col3 = [3, 6, 9])
    ),
    ("test_no_header.csv", (header=0,),
        (3, 3),
        NamedTuple{(:Column1, :Column2, :Column3), Tuple{Float64, Float64, Float64}},
        (Column1 = [1.0, 4.0, 7.0], Column2 = [2.0, 5.0, 8.0], Column3 = [3.0, 6.0, 9.0])
    ),
    ("test_2_footer_rows.csv", (header=4, footerskip=2),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3), Tuple{Int, Int, Int}},
        (col1 = [1, 4, 7], col2 = [2, 5, 8], col3 = [3, 6, 9])
    ),
    # 418
    ("test_footer_missing.csv", NamedTuple(),
        (5, 3),
        NamedTuple{(:col1, :col2, :col3), Tuple{Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}}},
        (col1 = Union{Missing, Int}[1, 4, 7, 10, missing], col2 = Union{Missing, Int}[2, 5, 8, 11, missing], col3 = Union{Missing, Int}[3, 6, 9, 12, missing])
    ),
    ("test_footer_missing.csv", (footerskip=1,),
        (4, 3),
        NamedTuple{(:col1, :col2, :col3), Tuple{Int, Int, Int}},
        (col1 = [1, 4, 7, 10], col2 = [2, 5, 8, 11], col3 = [3, 6, 9, 12])
    ),
    ("test_dates.csv", NamedTuple(),
        (3, 1),
        NamedTuple{(:col1,), Tuple{Date}},
        (col1 = Date[Date("2015-01-01"), Date("2015-01-02"), Date("2015-01-03")],)
    ),
    ("test_excel_date_formats.csv", (dateformat="mm/dd/yy",),
        (3, 1),
        NamedTuple{(:col1,), Tuple{Date}},
        (col1 = Date[Date("2015-01-01"), Date("2015-01-02"), Date("2015-01-03")],)
    ),
    ("test_datetimes.csv", (dateformat="yyyy-mm-dd HH:MM:SS.s",),
        (3, 1),
        NamedTuple{(:col1,), Tuple{DateTime}},
        (col1 = DateTime[DateTime("2015-01-01"), DateTime("2015-01-02T00:00:01"), DateTime("2015-01-03T00:12:00.001")],)
    ),
    ("test_missing_value_NULL.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,InlineString7,Float64}},
        (col1 = [1.0, 4.0, 7.0], col2 = ["2.0", "NULL", "8.0"], col3 = [3.0, 6.0, 9.0])
    ),
    ("test_missing_value_NULL.csv", (missingstring="NULL",),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Union{Missing, Float64},Float64}},
        (col1 = [1.0, 4.0, 7.0], col2 = Union{Missing, Float64}[2.0, missing, 8.0], col3 = [3.0, 6.0, 9.0])
    ),
    ("test_missing_value.csv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Union{Missing, Float64},Float64}},
        (col1 = [1.0, 4.0, 7.0], col2 = Union{Missing, Float64}[2.0, missing, 8.0], col3 = [3.0, 6.0, 9.0])
    ),
    ("test_header_range.csv", (header=1:3,),
        (3, 3),
        NamedTuple{(:col1_sub1_part1, :col2_sub2_part2, :col3_sub3_part3),Tuple{Int,Int,Int}},
        (col1_sub1_part1 = [1, 4, 7], col2_sub2_part2 = [2, 5, 8], col3_sub3_part3 = [3, 6, 9])
    ),
    # 343
    ("test_header_int_list.csv", (header=[1, 3, 5], ignoreemptyrows=false),
        (3, 3),
        NamedTuple{(:col1_sub1_part1, :col2_sub2_part2, :col3_sub3_part3),Tuple{Int,Int,Int}},
        (col1_sub1_part1 = [1, 4, 7], col2_sub2_part2 = [2, 5, 8], col3_sub3_part3 = [3, 6, 9])
    ),
    ("test_basic.csv", (types=Dict(2=>Float64),),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Int,Float64,Int}},
        (col1 = [1, 4, 7], col2 = [2.0, 5.0, 8.0], col3 = [3, 6, 9])
    ),
    ("test_basic_pipe.csv", (delim='|',),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3), Tuple{Int, Int, Int}},
        (col1 = [1, 4, 7], col2 = [2, 5, 8], col3 = [3, 6, 9])
    ),
    ("test_tab_null_empty.txt", (delim='\t',),
        (2, 4),
        NamedTuple{(:A, :B, :C, :D),Tuple{Int,Union{Missing, Int},InlineString1,Int}},
        (A = [1, 2], B = Union{Missing, Int}[2000, missing], C = ["x", "y"], D = [100, 200])
    ),
    ("test_tab_null_string.txt", (delim='\t', missingstring="NULL"),
        (2, 4),
        NamedTuple{(:A, :B, :C, :D),Tuple{Int,Union{Missing, Int},InlineString1,Int}},
        (A = [1, 2], B = Union{Missing, Int}[2000, missing], C = ["x", "y"], D = [100, 200])
    ),
    # CSV with header and no data is treated the same as an empty buffer with header supplied
    (IOBuffer("a,b,c"), NamedTuple(),
        (0, 3),
        NamedTuple{(:a, :b, :c), Tuple{Missing, Missing, Missing}},
        (a = Missing[], b = Missing[], c = Missing[])
    ),
    (IOBuffer(""), (header=["a", "b", "c"],),
        (0, 3),
        NamedTuple{(:a, :b, :c), Tuple{Missing, Missing, Missing}},
        (a = Missing[], b = Missing[], c = Missing[])
    ),
    # dash as missingstring; #92
    ("dash_as_null.csv", (missingstring="-",),
        (2, 2),
        NamedTuple{(:x, :y),Tuple{Union{Missing, Int}, Int}},
        (x = Union{Missing, Int}[1, missing], y = [2, 4])
    ),
    ("plus_as_null.csv", (missingstring="+",),
        (2, 2),
        NamedTuple{(:x, :y),Tuple{Union{Missing, Int}, Int}},
        (x = Union{Missing, Int}[1, missing], y = [2, 4])
    ),
    # #83
    ("comma_decimal.csv", (delim=';', decimal=','),
        (2, 2),
        NamedTuple{(:x, :y),Tuple{Float64,Int}},
        (x = [3.14, 1.0], y = [1, 1])
    ),
    # #86
    # ("double_quote_quotechar_and_escapechar.csv", (escapechar='"',),
    #     (24, 5),
    #     NamedTuple{(:APINo, :FileNo, :CurrentWellName, :LeaseName, :OriginalWellName),Tuple{Float64,Int,String,String,String}},
    #     x->x.OriginalWellName[24] == "NORTH DAKOTA STATE \"\"A\"\" #1"
    # ),
    # #84
    ("census.txt", (normalizenames=true,),
        (3, 9),
        NamedTuple{(:GEOID, :POP10, :HU10, :ALAND, :AWATER, :ALAND_SQMI, :AWATER_SQMI, :INTPTLAT, :INTPTLONG),Tuple{Int,Int,Int,Int,Int,Float64,Float64,Float64,Float64}},
        (GEOID = [601, 602, 603], POP10 = [18570, 41520, 54689], HU10 = [7744, 18073, 25653], ALAND = [166659789, 79288158, 81880442], AWATER = [799296, 4446273, 183425], ALAND_SQMI = [64.348, 30.613, 31.614], AWATER_SQMI = [0.309, 1.717, 0.071], INTPTLAT = [18.180555, 18.362268, 18.455183], INTPTLONG = [-66.749961, -67.17613, -67.119887])
    ),
    # #79
    ("bools.csv", NamedTuple(),
        (4, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Bool,Bool,Int}},
        (col1 = Bool[true, false, true, false], col2 = Bool[false, true, true, false], col3 = [1, 2, 3, 4])
    ),
    ("boolext.csv", NamedTuple(),
        (4, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Bool,Bool,Int}},
        (col1 = Bool[true, false, true, false], col2 = Bool[false, true, true, false], col3 = [1, 2, 3, 4])
    ),
    # #64
    # #115 (Int -> Union{Int, Missing} -> Union{String, Missing} promotion)
    ("attenu.csv", (missingstring="NA",),
        (182, 5),
        NamedTuple{(:Event, :Mag, :Station, :Dist, :Accel),Tuple{Int,Float64,Union{Missing, InlineString7},Float64,Float64}},
        x->map(y->y[1:10], x|>columntable) == (Event = [1, 2, 2, 2, 2, 2, 2, 2, 2, 2], Mag = [7.0, 7.4, 7.4, 7.4, 7.4, 7.4, 7.4, 7.4, 7.4, 7.4], Station = Union{Missing, String}["117", "1083", "1095", "283", "135", "475", "113", "1008", "1028", "2001"], Dist = [12.0, 148.0, 42.0, 85.0, 107.0, 109.0, 156.0, 224.0, 293.0, 359.0], Accel = [0.359, 0.014, 0.196, 0.135, 0.062, 0.054, 0.014, 0.018, 0.01, 0.004])
    ),
    ("test_null_only_column.csv", (missingstring="NA",),
        (3, 2),
        NamedTuple{(:col1, :col2),Tuple{InlineString7,Missing}},
        (col1 = ["123", "abc", "123abc"], col2 = Missing[missing, missing, missing])
    ),
    # #107
    (IOBuffer("1,a,i\n2,b,ii\n3,c,iii"), (skipto=1,),
        (3, 3),
        NamedTuple{(:Column1, :Column2, :Column3),Tuple{Int,InlineString1,InlineString3}},
        (Column1 = [1, 2, 3], Column2 = ["a", "b", "c"], Column3 = ["i", "ii", "iii"])
    ),
    ("categorical.csv", (pool=true,),
        (15, 1),
        NamedTuple{(:cat,), Tuple{InlineString1}},
        (cat = ["a", "a", "a", "b", "b", "b", "b", "b", "b", "b", "c", "c", "c", "c", "a"],)
    ),
    ("categorical.csv", (pool=0.3,),
        (15, 1),
        NamedTuple{(:cat,), Tuple{InlineString1}},
        (cat = ["a", "a", "a", "b", "b", "b", "b", "b", "b", "b", "c", "c", "c", "c", "a"],)
    ),
    ("categorical.csv", (pool=false,),
        (15, 1),
        NamedTuple{(:cat,), Tuple{InlineString1}},
        (cat = ["a", "a", "a", "b", "b", "b", "b", "b", "b", "b", "c", "c", "c", "c", "a"],)
    ),
    ("categorical.csv", (pool=0.0,),
        (15, 1),
        NamedTuple{(:cat,), Tuple{InlineString1}},
        (cat = ["a", "a", "a", "b", "b", "b", "b", "b", "b", "b", "c", "c", "c", "c", "a"],)
    ),
    # other various files from around the interwebs
    ("baseball.csv", (pool=true, normalizenames=true),
        (35, 15),
        NamedTuple{(:Rk, :Year, :Age, :Tm, :Lg, :Column6, :W, :L, :W_L_, :G, :Finish, :Wpost, :Lpost, :W_L_post, :Column15), Tuple{Union{Int, Missing},Union{Int, Missing},Union{Int, Missing},Union{InlineString31, Missing},Union{InlineString3, Missing},Union{InlineString15, Missing},Union{Int, Missing},Union{Int, Missing},Union{Float64, Missing},Union{Int, Missing},Union{Float64, Missing},Union{Int, Missing},Union{Int, Missing},Union{Float64, Missing},Union{String, Missing}}},
        nothing
    ),
    ("FL_insurance_sample.csv", (pool=true,),
        (36634, 18),
        NamedTuple{(:policyID, :statecode, :county, :eq_site_limit, :hu_site_limit, :fl_site_limit, :fr_site_limit, :tiv_2011, :tiv_2012, :eq_site_deductible, :hu_site_deductible, :fl_site_deductible, :fr_site_deductible, :point_latitude, :point_longitude, :line, :construction, :point_granularity),Tuple{Int,InlineString3,InlineString31,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Int,Float64,Float64,InlineString15,InlineString31,Int}},
        nothing
    ),
    ("SacramentocrimeJanuary2006.csv", (pool=true, stringtype=String),
        (7584, 9),
        NamedTuple{(:cdatetime, :address, :district, :beat, :grid, :crimedescr, :ucr_ncic_code, :latitude, :longitude),Tuple{String, String, Int, String, Int, String, Int, Float64, Float64}},
        nothing
    ),
    ("Sacramentorealestatetransactions.csv", (pool=true, normalizenames=false, stringtype=String),
        (985, 12),
        NamedTuple{(:street, :city, :zip, :state, :beds, :baths, :sq__ft, :type, :sale_date, :price, :latitude, :longitude),Tuple{String, String, Int, String, Int, Int, Int, String, String, Int, Float64, Float64}},
        nothing
    ),
    ("SalesJan2009.csv", (pool=true,),
        (998, 12),
        NamedTuple{(:Transaction_date, :Product, :Price, :Payment_Type, :Name, :City, :State, :Country, :Account_Created, :Last_Login, :Latitude, :Longitude),Tuple{InlineString15,InlineString15,InlineString7,InlineString15,InlineString31,String,Union{Missing, InlineString31},InlineString31,InlineString15,InlineString15,Float64,Float64}},
        nothing
    ),
    ("stocks.csv", (normalizenames=true,),
        (30, 2),
        NamedTuple{(:Stock_Name, :Company_Name), Tuple{InlineString7, String}},
        nothing
    ),
    ("TechCrunchcontinentalUSA.csv", (pool=true, stringtype=String),
        (1460, 10),
        NamedTuple{(:permalink, :company, :numEmps, :category, :city, :state, :fundedDate, :raisedAmt, :raisedCurrency, :round),Tuple{String, String, Union{Missing, Int}, Union{Missing, String}, Union{Missing, String}, String, String, Int, String, String}},
        nothing
    ),
    ("Fielding.csv", (pool=false,),
        (167938, 18),
        NamedTuple{(:playerID, :yearID, :stint, :teamID, :lgID, :POS, :G, :GS, :InnOuts, :PO, :A, :E, :DP, :PB, :WP, :SB, :CS, :ZR),Tuple{InlineString15, Int, Int, InlineString3, InlineString3, InlineString3, Int, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}}},
        nothing
    ),
    ("latest (1).csv", (header=0, missingstring="\\N", pool=true),
        (1000, 25),
        NamedTuple{(:Column1, :Column2, :Column3, :Column4, :Column5, :Column6, :Column7, :Column8, :Column9, :Column10, :Column11, :Column12, :Column13, :Column14, :Column15, :Column16, :Column17, :Column18, :Column19, :Column20, :Column21, :Column22, :Column23, :Column24, :Column25),Tuple{InlineString7, String, Int, Int, InlineString31, Int, InlineString31, Int, Date, Date, Int, InlineString3, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Int}, Union{Missing, Float64}, Float64, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Int}, Float64, Union{Missing, Float64}, Union{Missing, Float64}}},
        t -> @test(t.Column17[end-2] === missing)
    ),
    # #217
    (IOBuffer("aa,bb\n1,\"1,b,c\"\n"), (pool=false,),
        (1, 2),
        NamedTuple{(:aa, :bb), Tuple{Int, InlineString7}},
        (aa = [1], bb = ["1,b,c"])
    ),
    # #198
    ("issue_198.csv", (decimal=',', delim=';', missingstring="-", skipto = 2, header = ["Date", "EONIA", "1m", "12m", "3m", "6m", "9m"], normalizenames=false),
        (6, 7),
        NamedTuple{(:Date, :EONIA, Symbol("1m"), Symbol("12m"), Symbol("3m"), Symbol("6m"), Symbol("9m")),Tuple{InlineString15, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}}},
        NamedTuple{(:Date, :EONIA, Symbol("1m"), Symbol("12m"), Symbol("3m"), Symbol("6m"), Symbol("9m"))}((String["18/04/2018", "17/04/2018", "16/04/2018", "15/04/2018", "14/04/2018", "13/04/2018"], Union{Missing, Float64}[-0.368, -0.368, -0.367, missing, missing, -0.364], Union{Missing, Float64}[-0.371, -0.371, -0.371, missing, missing, -0.371], Union{Missing, Float64}[-0.189, -0.189, -0.189, missing, missing, -0.19], Union{Missing, Float64}[-0.328, -0.328, -0.329, missing, missing, -0.329], Union{Missing, Float64}[-0.271, -0.27, -0.27, missing, missing, -0.271], Union{Missing, Float64}[-0.219, -0.219, -0.219, missing, missing, -0.219]))
    ),
    # #198 part 2
    ("issue_198_part2.csv", (missingstring="++", delim=';', decimal=','),
        (4, 4),
        NamedTuple{(:A, :B, :C, :Column4),Tuple{InlineString1, Union{Missing, Float64}, Union{Missing, Float64}, Missing}},
        (A = ["a", "b", "c", "d"], B = Union{Missing, Float64}[-0.367, missing, missing, -0.364], C = Union{Missing, Float64}[-0.371, missing, missing, -0.371], Column4 = [missing, missing, missing, missing])
    ),
    # #207
    ("issue_207.csv", NamedTuple(),
        (2, 6),
        NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int, Int, Int, Float64, InlineString15, Union{Missing, Float64}}},
        (a = [1863001, 1863209], b = [134, 137], c = [10000, 0], d = [1.0009, 1.0], e = ["1.0000", "2,773.9000"], f = Union{Missing, Float64}[-0.002033899, missing])
    ),
    # #120
    ("issue_120.csv", (header=0,),
        (5, 20),
        NamedTuple{(:Column1, :Column2, :Column3, :Column4, :Column5, :Column6, :Column7, :Column8, :Column9, :Column10, :Column11, :Column12, :Column13, :Column14, :Column15, :Column16, :Column17, :Column18, :Column19, :Column20),Tuple{Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Int,Int,Int,Int,Missing,Float64,Float64,Float64,Float64,Float64,Float64}},
        (Column1 = [3.52848962348857e9, 3.52848962448866e9, 3.52848962548857e9, 3.52848962648866e9, 3.52848962748875e9], Column2 = [312.73, 312.49, 312.74, 312.49, 312.62], Column3 = [0.0, 0.0, 0.0, 0.0, 0.0], Column4 = [41.87425, 41.87623, 41.87155, 41.86422, 41.87615], Column5 = [297.6302, 297.6342, 297.6327, 297.632, 297.6324], Column6 = [0.0, 0.0, 0.0, 0.0, 0.0], Column7 = [286.3423, 286.3563, 286.3723, 286.3837, 286.397], Column8 = [-99.99, -99.99, -99.99, -99.99, -99.99], Column9 = [-99.99, -99.99, -99.99, -99.99, -99.99], Column10 = [12716, 12716, 12716, 12716, 12716], Column11 = [0, 0, 0, 0, 0], Column12 = [0, 0, 0, 0, 0], Column13 = [0, 0, 0, 0, 0], Column14 = Missing[missing, missing, missing, missing, missing], Column15 = [-24.81942, -24.8206, -24.82111, -24.82091, -24.82035], Column16 = [853.8073, 852.1921, 853.4257, 854.1342, 851.171], Column17 = [0.0, 0.0, 0.0, 0.0, 0.0], Column18 = [0.0, 0.0, 0.0, 0.0, 0.0], Column19 = [60.07, 38.27, 61.38, 49.23, 42.49], Column20 = [132.356, 132.356, 132.356, 132.356, 132.356])
    ),
    ("pandas_zeros.csv", (normalizenames=true,),
        (100000, 50),
        NamedTuple{Tuple(Symbol("_$i") for i = 0:49), NTuple{50, Int}},
        nothing
    ),
    ("table_test.txt", NamedTuple(),
        (49, 770),
        NamedTuple{(:ind_50km, :nse_gsurf_cfg1, :r_gsurf_cfg1, :bias_gsurf_cfg1, :ngrids, :nse_hatmo_cfg1, :r_hatmo_cfg1, :bias_hatmo_cfg1, :nse_latmo_cfg1, :r_latmo_cfg1, :bias_latmo_cfg1, :nse_melt_cfg1, :r_melt_cfg1, :bias_melt_cfg1, :nse_rnet_cfg1, :r_rnet_cfg1, :bias_rnet_cfg1, :nse_rof_cfg1, :r_rof_cfg1, :bias_rof_cfg1, :nse_snowdepth_cfg1, :r_snowdepth_cfg1, :bias_snowdepth_cfg1, :nse_swe_cfg1, :r_swe_cfg1, :bias_swe_cfg1, :nse_gsurf_cfg2, :r_gsurf_cfg2, :bias_gsurf_cfg2, :nse_hatmo_cfg2, :r_hatmo_cfg2, :bias_hatmo_cfg2, :nse_latmo_cfg2, :r_latmo_cfg2, :bias_latmo_cfg2, :nse_melt_cfg2, :r_melt_cfg2, :bias_melt_cfg2, :nse_rnet_cfg2, :r_rnet_cfg2, :bias_rnet_cfg2, :nse_rof_cfg2, :r_rof_cfg2, :bias_rof_cfg2, :nse_snowdepth_cfg2, :r_snowdepth_cfg2, :bias_snowdepth_cfg2, :nse_swe_cfg2, :r_swe_cfg2, :bias_swe_cfg2, :nse_gsurf_cfg3, :r_gsurf_cfg3, :bias_gsurf_cfg3, :nse_hatmo_cfg3, :r_hatmo_cfg3, :bias_hatmo_cfg3, :nse_latmo_cfg3, :r_latmo_cfg3, :bias_latmo_cfg3, :nse_melt_cfg3, :r_melt_cfg3, :bias_melt_cfg3, :nse_rnet_cfg3, :r_rnet_cfg3, :bias_rnet_cfg3, :nse_rof_cfg3, :r_rof_cfg3, :bias_rof_cfg3, :nse_snowdepth_cfg3, :r_snowdepth_cfg3, :bias_snowdepth_cfg3, :nse_swe_cfg3, :r_swe_cfg3, :bias_swe_cfg3, :nse_gsurf_cfg4, :r_gsurf_cfg4, :bias_gsurf_cfg4, :nse_hatmo_cfg4, :r_hatmo_cfg4, :bias_hatmo_cfg4, :nse_latmo_cfg4, :r_latmo_cfg4, :bias_latmo_cfg4, :nse_melt_cfg4, :r_melt_cfg4, :bias_melt_cfg4, :nse_rnet_cfg4, :r_rnet_cfg4, :bias_rnet_cfg4, :nse_rof_cfg4, :r_rof_cfg4, :bias_rof_cfg4, :nse_snowdepth_cfg4, :r_snowdepth_cfg4, :bias_snowdepth_cfg4, :nse_swe_cfg4, :r_swe_cfg4, :bias_swe_cfg4, :nse_gsurf_cfg5, :r_gsurf_cfg5, :bias_gsurf_cfg5, :nse_hatmo_cfg5, :r_hatmo_cfg5, :bias_hatmo_cfg5, :nse_latmo_cfg5, :r_latmo_cfg5, :bias_latmo_cfg5, :nse_melt_cfg5, :r_melt_cfg5, :bias_melt_cfg5, :nse_rnet_cfg5, :r_rnet_cfg5, :bias_rnet_cfg5, :nse_rof_cfg5, :r_rof_cfg5, :bias_rof_cfg5, :nse_snowdepth_cfg5, :r_snowdepth_cfg5, :bias_snowdepth_cfg5, :nse_swe_cfg5, :r_swe_cfg5, :bias_swe_cfg5, :nse_gsurf_cfg6, :r_gsurf_cfg6, :bias_gsurf_cfg6, :nse_hatmo_cfg6, :r_hatmo_cfg6, :bias_hatmo_cfg6, :nse_latmo_cfg6, :r_latmo_cfg6, :bias_latmo_cfg6, :nse_melt_cfg6, :r_melt_cfg6, :bias_melt_cfg6, :nse_rnet_cfg6, :r_rnet_cfg6, :bias_rnet_cfg6, :nse_rof_cfg6, :r_rof_cfg6, :bias_rof_cfg6, :nse_snowdepth_cfg6, :r_snowdepth_cfg6, :bias_snowdepth_cfg6, :nse_swe_cfg6, :r_swe_cfg6, :bias_swe_cfg6, :nse_gsurf_cfg7, :r_gsurf_cfg7, :bias_gsurf_cfg7, :nse_hatmo_cfg7, :r_hatmo_cfg7, :bias_hatmo_cfg7, :nse_latmo_cfg7, :r_latmo_cfg7, :bias_latmo_cfg7, :nse_melt_cfg7, :r_melt_cfg7, :bias_melt_cfg7, :nse_rnet_cfg7, :r_rnet_cfg7, :bias_rnet_cfg7, :nse_rof_cfg7, :r_rof_cfg7, :bias_rof_cfg7, :nse_snowdepth_cfg7, :r_snowdepth_cfg7, :bias_snowdepth_cfg7, :nse_swe_cfg7, :r_swe_cfg7, :bias_swe_cfg7, :nse_gsurf_cfg8, :r_gsurf_cfg8, :bias_gsurf_cfg8, :nse_hatmo_cfg8, :r_hatmo_cfg8, :bias_hatmo_cfg8, :nse_latmo_cfg8, :r_latmo_cfg8, :bias_latmo_cfg8, :nse_melt_cfg8, :r_melt_cfg8, :bias_melt_cfg8, :nse_rnet_cfg8, :r_rnet_cfg8, :bias_rnet_cfg8, :nse_rof_cfg8, :r_rof_cfg8, :bias_rof_cfg8, :nse_snowdepth_cfg8, :r_snowdepth_cfg8, :bias_snowdepth_cfg8, :nse_swe_cfg8, :r_swe_cfg8, :bias_swe_cfg8, :nse_gsurf_cfg9, :r_gsurf_cfg9, :bias_gsurf_cfg9, :nse_hatmo_cfg9, :r_hatmo_cfg9, :bias_hatmo_cfg9, :nse_latmo_cfg9, :r_latmo_cfg9, :bias_latmo_cfg9, :nse_melt_cfg9, :r_melt_cfg9, :bias_melt_cfg9, :nse_rnet_cfg9, :r_rnet_cfg9, :bias_rnet_cfg9, :nse_rof_cfg9, :r_rof_cfg9, :bias_rof_cfg9, :nse_snowdepth_cfg9, :r_snowdepth_cfg9, :bias_snowdepth_cfg9, :nse_swe_cfg9, :r_swe_cfg9, :bias_swe_cfg9, :nse_gsurf_cfg10, :r_gsurf_cfg10, :bias_gsurf_cfg10, :nse_hatmo_cfg10, :r_hatmo_cfg10, :bias_hatmo_cfg10, :nse_latmo_cfg10, :r_latmo_cfg10, :bias_latmo_cfg10, :nse_melt_cfg10, :r_melt_cfg10, :bias_melt_cfg10, :nse_rnet_cfg10, :r_rnet_cfg10, :bias_rnet_cfg10, :nse_rof_cfg10, :r_rof_cfg10, :bias_rof_cfg10, :nse_snowdepth_cfg10, :r_snowdepth_cfg10, :bias_snowdepth_cfg10, :nse_swe_cfg10, :r_swe_cfg10, :bias_swe_cfg10, :nse_gsurf_cfg11, :r_gsurf_cfg11, :bias_gsurf_cfg11, :nse_hatmo_cfg11, :r_hatmo_cfg11, :bias_hatmo_cfg11, :nse_latmo_cfg11, :r_latmo_cfg11, :bias_latmo_cfg11, :nse_melt_cfg11, :r_melt_cfg11, :bias_melt_cfg11, :nse_rnet_cfg11, :r_rnet_cfg11, :bias_rnet_cfg11, :nse_rof_cfg11, :r_rof_cfg11, :bias_rof_cfg11, :nse_snowdepth_cfg11, :r_snowdepth_cfg11, :bias_snowdepth_cfg11, :nse_swe_cfg11, :r_swe_cfg11, :bias_swe_cfg11, :nse_gsurf_cfg12, :r_gsurf_cfg12, :bias_gsurf_cfg12, :nse_hatmo_cfg12, :r_hatmo_cfg12, :bias_hatmo_cfg12, :nse_latmo_cfg12, :r_latmo_cfg12, :bias_latmo_cfg12, :nse_melt_cfg12, :r_melt_cfg12, :bias_melt_cfg12, :nse_rnet_cfg12, :r_rnet_cfg12, :bias_rnet_cfg12, :nse_rof_cfg12, :r_rof_cfg12, :bias_rof_cfg12, :nse_snowdepth_cfg12, :r_snowdepth_cfg12, :bias_snowdepth_cfg12, :nse_swe_cfg12, :r_swe_cfg12, :bias_swe_cfg12, :nse_gsurf_cfg13, :r_gsurf_cfg13, :bias_gsurf_cfg13, :nse_hatmo_cfg13, :r_hatmo_cfg13, :bias_hatmo_cfg13, :nse_latmo_cfg13, :r_latmo_cfg13, :bias_latmo_cfg13, :nse_melt_cfg13, :r_melt_cfg13, :bias_melt_cfg13, :nse_rnet_cfg13, :r_rnet_cfg13, :bias_rnet_cfg13, :nse_rof_cfg13, :r_rof_cfg13, :bias_rof_cfg13, :nse_snowdepth_cfg13, :r_snowdepth_cfg13, :bias_snowdepth_cfg13, :nse_swe_cfg13, :r_swe_cfg13, :bias_swe_cfg13, :nse_gsurf_cfg14, :r_gsurf_cfg14, :bias_gsurf_cfg14, :nse_hatmo_cfg14, :r_hatmo_cfg14, :bias_hatmo_cfg14, :nse_latmo_cfg14, :r_latmo_cfg14, :bias_latmo_cfg14, :nse_melt_cfg14, :r_melt_cfg14, :bias_melt_cfg14, :nse_rnet_cfg14, :r_rnet_cfg14, :bias_rnet_cfg14, :nse_rof_cfg14, :r_rof_cfg14, :bias_rof_cfg14, :nse_snowdepth_cfg14, :r_snowdepth_cfg14, :bias_snowdepth_cfg14, :nse_swe_cfg14, :r_swe_cfg14, :bias_swe_cfg14, :nse_gsurf_cfg15, :r_gsurf_cfg15, :bias_gsurf_cfg15, :nse_hatmo_cfg15, :r_hatmo_cfg15, :bias_hatmo_cfg15, :nse_latmo_cfg15, :r_latmo_cfg15, :bias_latmo_cfg15, :nse_melt_cfg15, :r_melt_cfg15, :bias_melt_cfg15, :nse_rnet_cfg15, :r_rnet_cfg15, :bias_rnet_cfg15, :nse_rof_cfg15, :r_rof_cfg15, :bias_rof_cfg15, :nse_snowdepth_cfg15, :r_snowdepth_cfg15, :bias_snowdepth_cfg15, :nse_swe_cfg15, :r_swe_cfg15, :bias_swe_cfg15, :nse_gsurf_cfg16, :r_gsurf_cfg16, :bias_gsurf_cfg16, :nse_hatmo_cfg16, :r_hatmo_cfg16, :bias_hatmo_cfg16, :nse_latmo_cfg16, :r_latmo_cfg16, :bias_latmo_cfg16, :nse_melt_cfg16, :r_melt_cfg16, :bias_melt_cfg16, :nse_rnet_cfg16, :r_rnet_cfg16, :bias_rnet_cfg16, :nse_rof_cfg16, :r_rof_cfg16, :bias_rof_cfg16, :nse_snowdepth_cfg16, :r_snowdepth_cfg16, :bias_snowdepth_cfg16, :nse_swe_cfg16, :r_swe_cfg16, :bias_swe_cfg16, :nse_gsurf_cfg17, :r_gsurf_cfg17, :bias_gsurf_cfg17, :nse_hatmo_cfg17, :r_hatmo_cfg17, :bias_hatmo_cfg17, :nse_latmo_cfg17, :r_latmo_cfg17, :bias_latmo_cfg17, :nse_melt_cfg17, :r_melt_cfg17, :bias_melt_cfg17, :nse_rnet_cfg17, :r_rnet_cfg17, :bias_rnet_cfg17, :nse_rof_cfg17, :r_rof_cfg17, :bias_rof_cfg17, :nse_snowdepth_cfg17, :r_snowdepth_cfg17, :bias_snowdepth_cfg17, :nse_swe_cfg17, :r_swe_cfg17, :bias_swe_cfg17, :nse_gsurf_cfg18, :r_gsurf_cfg18, :bias_gsurf_cfg18, :nse_hatmo_cfg18, :r_hatmo_cfg18, :bias_hatmo_cfg18, :nse_latmo_cfg18, :r_latmo_cfg18, :bias_latmo_cfg18, :nse_melt_cfg18, :r_melt_cfg18, :bias_melt_cfg18, :nse_rnet_cfg18, :r_rnet_cfg18, :bias_rnet_cfg18, :nse_rof_cfg18, :r_rof_cfg18, :bias_rof_cfg18, :nse_snowdepth_cfg18, :r_snowdepth_cfg18, :bias_snowdepth_cfg18, :nse_swe_cfg18, :r_swe_cfg18, :bias_swe_cfg18, :nse_gsurf_cfg19, :r_gsurf_cfg19, :bias_gsurf_cfg19, :nse_hatmo_cfg19, :r_hatmo_cfg19, :bias_hatmo_cfg19, :nse_latmo_cfg19, :r_latmo_cfg19, :bias_latmo_cfg19, :nse_melt_cfg19, :r_melt_cfg19, :bias_melt_cfg19, :nse_rnet_cfg19, :r_rnet_cfg19, :bias_rnet_cfg19, :nse_rof_cfg19, :r_rof_cfg19, :bias_rof_cfg19, :nse_snowdepth_cfg19, :r_snowdepth_cfg19, :bias_snowdepth_cfg19, :nse_swe_cfg19, :r_swe_cfg19, :bias_swe_cfg19, :nse_gsurf_cfg20, :r_gsurf_cfg20, :bias_gsurf_cfg20, :nse_hatmo_cfg20, :r_hatmo_cfg20, :bias_hatmo_cfg20, :nse_latmo_cfg20, :r_latmo_cfg20, :bias_latmo_cfg20, :nse_melt_cfg20, :r_melt_cfg20, :bias_melt_cfg20, :nse_rnet_cfg20, :r_rnet_cfg20, :bias_rnet_cfg20, :nse_rof_cfg20, :r_rof_cfg20, :bias_rof_cfg20, :nse_snowdepth_cfg20, :r_snowdepth_cfg20, :bias_snowdepth_cfg20, :nse_swe_cfg20, :r_swe_cfg20, :bias_swe_cfg20, :nse_gsurf_cfg21, :r_gsurf_cfg21, :bias_gsurf_cfg21, :nse_hatmo_cfg21, :r_hatmo_cfg21, :bias_hatmo_cfg21, :nse_latmo_cfg21, :r_latmo_cfg21, :bias_latmo_cfg21, :nse_melt_cfg21, :r_melt_cfg21, :bias_melt_cfg21, :nse_rnet_cfg21, :r_rnet_cfg21, :bias_rnet_cfg21, :nse_rof_cfg21, :r_rof_cfg21, :bias_rof_cfg21, :nse_snowdepth_cfg21, :r_snowdepth_cfg21, :bias_snowdepth_cfg21, :nse_swe_cfg21, :r_swe_cfg21, :bias_swe_cfg21, :nse_gsurf_cfg22, :r_gsurf_cfg22, :bias_gsurf_cfg22, :nse_hatmo_cfg22, :r_hatmo_cfg22, :bias_hatmo_cfg22, :nse_latmo_cfg22, :r_latmo_cfg22, :bias_latmo_cfg22, :nse_melt_cfg22, :r_melt_cfg22, :bias_melt_cfg22, :nse_rnet_cfg22, :r_rnet_cfg22, :bias_rnet_cfg22, :nse_rof_cfg22, :r_rof_cfg22, :bias_rof_cfg22, :nse_snowdepth_cfg22, :r_snowdepth_cfg22, :bias_snowdepth_cfg22, :nse_swe_cfg22, :r_swe_cfg22, :bias_swe_cfg22, :nse_gsurf_cfg23, :r_gsurf_cfg23, :bias_gsurf_cfg23, :nse_hatmo_cfg23, :r_hatmo_cfg23, :bias_hatmo_cfg23, :nse_latmo_cfg23, :r_latmo_cfg23, :bias_latmo_cfg23, :nse_melt_cfg23, :r_melt_cfg23, :bias_melt_cfg23, :nse_rnet_cfg23, :r_rnet_cfg23, :bias_rnet_cfg23, :nse_rof_cfg23, :r_rof_cfg23, :bias_rof_cfg23, :nse_snowdepth_cfg23, :r_snowdepth_cfg23, :bias_snowdepth_cfg23, :nse_swe_cfg23, :r_swe_cfg23, :bias_swe_cfg23, :nse_gsurf_cfg24, :r_gsurf_cfg24, :bias_gsurf_cfg24, :nse_hatmo_cfg24, :r_hatmo_cfg24, :bias_hatmo_cfg24, :nse_latmo_cfg24, :r_latmo_cfg24, :bias_latmo_cfg24, :nse_melt_cfg24, :r_melt_cfg24, :bias_melt_cfg24, :nse_rnet_cfg24, :r_rnet_cfg24, :bias_rnet_cfg24, :nse_rof_cfg24, :r_rof_cfg24, :bias_rof_cfg24, :nse_snowdepth_cfg24, :r_snowdepth_cfg24, :bias_snowdepth_cfg24, :nse_swe_cfg24, :r_swe_cfg24, :bias_swe_cfg24, :nse_gsurf_cfg25, :r_gsurf_cfg25, :bias_gsurf_cfg25, :nse_hatmo_cfg25, :r_hatmo_cfg25, :bias_hatmo_cfg25, :nse_latmo_cfg25, :r_latmo_cfg25, :bias_latmo_cfg25, :nse_melt_cfg25, :r_melt_cfg25, :bias_melt_cfg25, :nse_rnet_cfg25, :r_rnet_cfg25, :bias_rnet_cfg25, :nse_rof_cfg25, :r_rof_cfg25, :bias_rof_cfg25, :nse_snowdepth_cfg25, :r_snowdepth_cfg25, :bias_snowdepth_cfg25, :nse_swe_cfg25, :r_swe_cfg25, :bias_swe_cfg25, :nse_gsurf_cfg26, :r_gsurf_cfg26, :bias_gsurf_cfg26, :nse_hatmo_cfg26, :r_hatmo_cfg26, :bias_hatmo_cfg26, :nse_latmo_cfg26, :r_latmo_cfg26, :bias_latmo_cfg26, :nse_melt_cfg26, :r_melt_cfg26, :bias_melt_cfg26, :nse_rnet_cfg26, :r_rnet_cfg26, :bias_rnet_cfg26, :nse_rof_cfg26, :r_rof_cfg26, :bias_rof_cfg26, :nse_snowdepth_cfg26, :r_snowdepth_cfg26, :bias_snowdepth_cfg26, :nse_swe_cfg26, :r_swe_cfg26, :bias_swe_cfg26, :nse_gsurf_cfg27, :r_gsurf_cfg27, :bias_gsurf_cfg27, :nse_hatmo_cfg27, :r_hatmo_cfg27, :bias_hatmo_cfg27, :nse_latmo_cfg27, :r_latmo_cfg27, :bias_latmo_cfg27, :nse_melt_cfg27, :r_melt_cfg27, :bias_melt_cfg27, :nse_rnet_cfg27, :r_rnet_cfg27, :bias_rnet_cfg27, :nse_rof_cfg27, :r_rof_cfg27, :bias_rof_cfg27, :nse_snowdepth_cfg27, :r_snowdepth_cfg27, :bias_snowdepth_cfg27, :nse_swe_cfg27, :r_swe_cfg27, :bias_swe_cfg27, :nse_gsurf_cfg28, :r_gsurf_cfg28, :bias_gsurf_cfg28, :nse_hatmo_cfg28, :r_hatmo_cfg28, :bias_hatmo_cfg28, :nse_latmo_cfg28, :r_latmo_cfg28, :bias_latmo_cfg28, :nse_melt_cfg28, :r_melt_cfg28, :bias_melt_cfg28, :nse_rnet_cfg28, :r_rnet_cfg28, :bias_rnet_cfg28, :nse_rof_cfg28, :r_rof_cfg28, :bias_rof_cfg28, :nse_snowdepth_cfg28, :r_snowdepth_cfg28, :bias_snowdepth_cfg28, :nse_swe_cfg28, :r_swe_cfg28, :bias_swe_cfg28, :nse_gsurf_cfg29, :r_gsurf_cfg29, :bias_gsurf_cfg29, :nse_hatmo_cfg29, :r_hatmo_cfg29, :bias_hatmo_cfg29, :nse_latmo_cfg29, :r_latmo_cfg29, :bias_latmo_cfg29, :nse_melt_cfg29, :r_melt_cfg29, :bias_melt_cfg29, :nse_rnet_cfg29, :r_rnet_cfg29, :bias_rnet_cfg29, :nse_rof_cfg29, :r_rof_cfg29, :bias_rof_cfg29, :nse_snowdepth_cfg29, :r_snowdepth_cfg29, :bias_snowdepth_cfg29, :nse_swe_cfg29, :r_swe_cfg29, :bias_swe_cfg29, :nse_gsurf_cfg30, :r_gsurf_cfg30, :bias_gsurf_cfg30, :nse_hatmo_cfg30, :r_hatmo_cfg30, :bias_hatmo_cfg30, :nse_latmo_cfg30, :r_latmo_cfg30, :bias_latmo_cfg30, :nse_melt_cfg30, :r_melt_cfg30, :bias_melt_cfg30, :nse_rnet_cfg30, :r_rnet_cfg30, :bias_rnet_cfg30, :nse_rof_cfg30, :r_rof_cfg30, :bias_rof_cfg30, :nse_snowdepth_cfg30, :r_snowdepth_cfg30, :bias_snowdepth_cfg30, :nse_swe_cfg30, :r_swe_cfg30, :bias_swe_cfg30, :nse_gsurf_cfg31, :r_gsurf_cfg31, :bias_gsurf_cfg31, :nse_hatmo_cfg31, :r_hatmo_cfg31, :bias_hatmo_cfg31, :nse_latmo_cfg31, :r_latmo_cfg31, :bias_latmo_cfg31, :nse_melt_cfg31, :r_melt_cfg31, :bias_melt_cfg31, :nse_rnet_cfg31, :r_rnet_cfg31, :bias_rnet_cfg31, :nse_rof_cfg31, :r_rof_cfg31, :bias_rof_cfg31, :nse_snowdepth_cfg31, :r_snowdepth_cfg31, :bias_snowdepth_cfg31, :nse_swe_cfg31, :r_swe_cfg31, :bias_swe_cfg31, :nse_gsurf_cfg32, :r_gsurf_cfg32, :bias_gsurf_cfg32, :nse_hatmo_cfg32, :r_hatmo_cfg32, :bias_hatmo_cfg32, :nse_latmo_cfg32, :r_latmo_cfg32, :bias_latmo_cfg32, :nse_melt_cfg32, :r_melt_cfg32, :bias_melt_cfg32, :nse_rnet_cfg32, :r_rnet_cfg32, :bias_rnet_cfg32, :nse_rof_cfg32, :r_rof_cfg32, :bias_rof_cfg32, :nse_snowdepth_cfg32, :r_snowdepth_cfg32, :bias_snowdepth_cfg32, :nse_swe_cfg32, :r_swe_cfg32, :bias_swe_cfg32),Tuple{Int,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64,Float64}},
        nothing
    ),
    ("transposed.csv", (transpose=true,),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Int,Int,Int}},
        (col1 = [1, 2, 3], col2 = [4, 5, 6], col3 = [7, 8, 9])
    ),
    ("transposed_1row.csv", (transpose=true,),
        (1, 1),
        NamedTuple{(:col1,),Tuple{Int}},
        (col1 = [1],)
    ),
    ("transposed_empty.csv", (transpose=true,),
        (0, 1),
        NamedTuple{(:col1,),Tuple{Missing}},
        (col1 = Missing[],)
    ),
    ("transposed_extra_newline.csv", (transpose=true,),
        (2, 2),
        NamedTuple{(:col1, :col2),Tuple{Int,Int}},
        (col1 = [1, 2], col2 = [3, 4])
    ),
    ("transposed_noheader.csv", (transpose=true, header=0),
        (2, 3),
        NamedTuple{(:Column1, :Column2, :Column3),Tuple{Int,Int,Int}},
        (Column1 = [1, 2], Column2 = [3, 4], Column3 = [5, 6])
    ),
    ("transposed_noheader.csv", (transpose=true, header=["c1", "c2", "c3"]),
        (2, 3),
        NamedTuple{(:c1, :c2, :c3),Tuple{Int,Int,Int}},
        (c1 = [1, 2], c2 = [3, 4], c3 = [5, 6])
    ),
    ("test_utf8.csv", (limit=2,),
        (2, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Float64,Float64}},
        (col1 = Union{Missing, Float64}[1.0, 4.0], col2 = Union{Missing, Float64}[2.0, 5.0], col3 = Union{Missing, Float64}[3.0, 6.0])
    ),
    ("test_utf8.csv", (limit=4,),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Float64,Float64}},
        (col1 = Union{Missing, Float64}[1.0, 4.0, 7.0], col2 = Union{Missing, Float64}[2.0, 5.0, 8.0], col3 = Union{Missing, Float64}[3.0, 6.0, 9.0])
    ),
    ("test_multiple_missing.csv", (missingstring=["NA", "NULL", "\\N"],),
        (4, 3),
        NamedTuple{(:col1, :col2, :col3), Tuple{Float64, Union{Missing, Float64}, Float64}},
        (col1 = [1.0, 4.0, 7.0, 7.0], col2 = Union{Missing, Float64}[2.0, missing, missing, missing], col3 = [3.0, 6.0, 9.0, 9.0])
    ),
    ("test_openclosequotes.csv", (missingstring=["NA", "NULL"], openquotechar='{', closequotechar='}'),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3), Tuple{Float64, Union{Missing, Float64}, Float64}},
        (col1 = [1.0, 4.0, 7.0], col2 = Union{Missing, Float64}[2.0, missing, missing], col3 = [3.0, 6.0, 9.0])
    ),
    ("test_truestrings.csv", (truestrings=["T", "TRUE", "true"], falsestrings=["F", "FALSE", "false"]),
        (6, 2),
        NamedTuple{(:int, :bools), Tuple{Int, Bool}},
        (int = [1, 2, 3, 4, 5, 6], bools = Bool[true, true, true, false, false, false])
    ),
    ("test_truestrings.csv", (truestrings=["T", "TRUE", "true"], falsestrings=["F", "FALSE", "false"], typemap=IdDict(Bool=>String)),
        (6, 2),
        NamedTuple{(:int, :bools), Tuple{Int, String}},
        (int = [1, 2, 3, 4, 5, 6], bools = ["T", "TRUE", "true", "F", "FALSE", "false"])
    ),
    ("test_string_delimiters.csv", (delim="::",),
        (2, 4),
        NamedTuple{(:num1, :num2, :num3, :num4), Tuple{Int, Int, Int, Int}},
        (num1 = [1, 1], num2 = [1193, 661], num3 = [5, 3], num4 = [978300760, 978302109])
    ),
    (IOBuffer("1,a,i\n2,b,ii\n3,c,iii"), (skipto=1,),
        (3, 3),
        NamedTuple{(:Column1, :Column2, :Column3),Tuple{Int, InlineString1, InlineString3}},
        (Column1 = [1, 2, 3], Column2 = ["a", "b", "c"], Column3 = ["i", "ii", "iii"])
    ),
    # #249
    ("test_basic.csv", (types=Dict(:col2=>Float64),),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Int,Float64,Int}},
        (col1 = [1, 4, 7], col2 = [2.0, 5.0, 8.0], col3 = [3, 6, 9])
    ),
    # #251
    ("test_basic.csv", (types=Dict(:col2=>Union{Float64, Missing}),),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Int,Union{Missing,Float64},Int}},
        (col1 = [1, 4, 7], col2 = Union{Missing,Float64}[2.0, 5.0, 8.0], col3 = [3, 6, 9])
    ),
    ("test_truestrings.csv", (truestrings=["T", "TRUE", "true"], falsestrings=["F", "FALSE", "false"]),
        (6, 2),
        NamedTuple{(:int, :bools), Tuple{Int, Bool}},
        (int = [1, 2, 3, 4, 5, 6], bools = [true, true, true, false, false, false])
    ),
    ("test_repeated_delimiters.csv", (delim=" ", ignorerepeated=true),
        (3, 5),
        NamedTuple{(:a, :b, :c, :d, :e), Tuple{Int, Int, Int, Int, Int}},
        (a = [1, 1, 1], b = [2, 2, 2], c = [3, 3, 3], d = [4, 4, 4], e = [5, 5, 5])
    ),
    ("test_comments1.csv", (comment="#",),
        (2, 3),
        NamedTuple{(:a, :b, :c), Tuple{Int, Int, Int}},
        (a=[1,7], b=[2,8], c=[3,9])
    ),
    ("test_comments_multiple.csv", (comment="#",),
        (4, 3),
        NamedTuple{(:a, :b, :c), Tuple{Int, Int, Int}},
        (a = [1, 7, 10, 13], b = [2, 8, 11, 14], c = [3, 9, 12, 15])
    ),
    ("test_comments_multichar.csv", (comment="//",),
        (2, 3),
        NamedTuple{(:a, :b, :c), Tuple{Int, Int, Int}},
        (a=[1,7], b=[2,8], c=[3,9])
    ),
    # #230
    ("test_not_enough_columns.csv", NamedTuple(),
        (2, 5),
        NamedTuple{(:A, :B, :C, :D, :E),Tuple{Int,Int,Int,Missing,Missing}},
        (A = [1, 4], B = [2, 5], C = [3, 6], D = Missing[missing, missing], E = Missing[missing, missing])
    ),
    ("test_not_enough_columns2.csv", NamedTuple(),
        (2, 5),
        NamedTuple{(:A, :B, :C, :D, :E),Tuple{Int,Int,Int,Union{Int, Missing},Union{Int, Missing}}},
        (A = [1, 6], B = [2, 7], C = [3, 8], D = [4, missing], E = [5, missing])
    ),
    ("test_correct_trailing_missings.csv", NamedTuple(),
        (2, 5),
        NamedTuple{(:A, :B, :C, :D, :E),Tuple{Int,Int,Int,Missing,Missing}},
        (A = [1, 4], B = [2, 5], C = [3, 6], D = Missing[missing, missing], E = Missing[missing, missing])
    ),
    ("norwegian_data.csv", (delim=';', decimal=',', missingstring="NULL", dateformat="yyyy-mm-dd HH:MM:SS.s", pool=false),
        (1230, 83),
        NamedTuple{(:regine_area, :main_no, :point_no, :param_key, :version_no_end, :station_name, :station_status_name, :dt_start_date, :dt_end_date, :percent_missing_days, :first_year_regulation, :start_year, :end_year, :aktuell_avrenningskart, :excluded_years, :tilgang, :latitude, :longitude, :utm_east_z33, :utm_north_z33, :regulation_part_area, :regulation_part_reservoirs, :transfer_area_in, :transfer_area_out, :drainage_basin_key, :area_norway, :area_total, :comment, :drainage_dens, :dt_registration_date, :dt_regul_date, :gradient_1085, :gradient_basin, :gradient_river, :height_minimum, :height_hypso_10, :height_hypso_20, :height_hypso_30, :height_hypso_40, :height_hypso_50, :height_hypso_60, :height_hypso_70, :height_hypso_80, :height_hypso_90, :height_maximum, :length_km_basin, :length_km_river, :ocean_polar_angle, :ocean_polar_distance, :perc_agricul, :perc_bog, :perc_eff_bog, :perc_eff_lake, :perc_forest, :perc_glacier, :perc_lake, :perc_mountain, :perc_urban, :prec_intens_max, :utm_zone_gravi, :utm_east_gravi, :utm_north_gravi, :utm_zone_inlet, :utm_east_inlet, :utm_north_inlet, :br1_middelavrenning_1930_1960, :br2_Tilsigsberegning, :br3_Regional_flomfrekvensanalyse, :br5_Regional_lavvannsanalyse, :br6_Klimastudier, :br7_Klimascenarier, :br9_Flomvarsling, :br11_FRIEND, :br12_GRDC, :br23_HBV, :br24_middelavrenning_1961_1990, :br26_TotalAvlop, :br31_FlomserierPrim, :br32_FlomserierSekundar, :br33_Flomkart_aktive_ureg, :br34_Hydrologisk_referanseserier_klimastudier, :br38_Flomkart_aktive_ureg_periode, :br39_Flomkart_nedlagt_stasjon),Tuple{Int, Int, Int, Int, Int, String, InlineString15, DateTime, Union{Missing, DateTime}, Union{Missing, Float64}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, InlineString15}, Union{Missing, String}, InlineString7, Float64, Float64, Int, Int, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Int}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, String}, Missing, Union{Missing, DateTime}, Union{Missing, DateTime}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Missing, Union{Missing, Float64}, Union{Missing, Float64}, Missing, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Union{Missing, Float64}, Missing, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Missing, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}, Union{Missing, InlineString1}}},
        nothing
    ),
    # #276
    ("test_duplicate_columnnames.csv", NamedTuple(),
        (2, 8),
        NamedTuple{(:a, :b, :c, :a_1, :a_2, :a_3, :a_4, :b_1), Tuple{Int, Int, Int, Int, Int, Int, Int, Int}},
        (a = [1, 9], b = [2, 10], c = [3, 11], a_1 = [4, 12], a_2 = [5, 13], a_3 = [6, 14], a_4 = [7, 15], b_1 = [8, 16])
    ),
    # #310
    ("test_bad_datetime.csv", NamedTuple(),
        (2, 3),
        NamedTuple{(:event,:time,:typ), Tuple{InlineString15, InlineString31, InlineString7}},
        (event = ["StartMovie", "Type"], time = ["2018-09-20T18:00:30.12345+00:00", "2018-09-20T18:02:13.67188+00:00"], typ = ["Event", "Event"])
    ),
    ("test_types.csv", (pool=false,),
        (1, 8),
        NamedTuple{(:int,:float,:date,:datetime,:bool,:string,:weakrefstring,:missing), Tuple{Int,Float64,Date,DateTime,Bool,InlineString3,InlineString7,Missing}},
        (int = [1], float = [1.0], date = [Date("2018-01-01")], datetime = [DateTime("2018-01-01T00:00:00")], bool = [true], string = ["hey"], weakrefstring = ["there"], missing = [missing])
    ),
    # #326
    ("test_issue_326.wsv", (delim=" ", ignorerepeated=true),
        (2, 2),
        NamedTuple{(:A, :B),Tuple{Int,Int}},
        (A = [1, 11], B = [2, 22])
    ),
    ("test_missing_last_field.csv", NamedTuple(),
        (2, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Float64,Float64,Union{Float64, Missing}}},
        (col1 = [1.0, 4.0], col2 = [2.0, 5.0], col3 = [3.0, missing])
    ),
    # #340
    ("test_delim.tsv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Int,Int,Int}},
        (col1 = [1, 4, 7], col2 = [2, 5, 8], col3 = [3, 6, 9])
    ),
    ("test_delim.wsv", NamedTuple(),
        (3, 3),
        NamedTuple{(:col1, :col2, :col3),Tuple{Int,Int,Int}},
        (col1 = [1, 4, 7], col2 = [2, 5, 8], col3 = [3, 6, 9])
    ),
    # #351
    ("test_comment_first_row.csv", (comment="#",),
        (2, 3),
        NamedTuple{(:a, :b, :c), Tuple{Int, Int, Int}},
        (a=[1,7], b=[2,8], c=[3,9])
    ),
    ("test_comment_first_row.csv", (comment="#", header=2),
        (2, 3),
        NamedTuple{(:a, :b, :c), Tuple{Int, Int, Int}},
        (a=[1,7], b=[2,8], c=[3,9])
    ),
    # #371
    ("test_repeated_delim_371.csv", (ignorerepeated=true, delim=' ',),
        (15, 4),
        NamedTuple{(:FAMILY, :PERSON, :MARKER, :RATIO), Tuple{InlineString31, InlineString15, InlineString15, Float64}},
        (FAMILY = ["A", "A", "A", "A", "A", "A", "EPGP013951", "EPGP014065", "EPGP014065", "EPGP014065", "EP07", "83346_EPGP014244", "83346_EPGP014244", "83506", "87001"], PERSON = ["EP01223", "EP01227", "EP01228", "EP01228", "EP01227", "EP01228", "EPGP013952", "EPGP014066", "EPGP014065", "EPGP014068", "706", "T3011", "T3231", "T17255", "301"], MARKER = ["rs710865", "rs11249215", "rs11249215", "rs10903129", "rs621559", "rs1514175", "rs773564", "rs2794520", "rs296547", "rs296547", "rs10927875", "rs2251760", "rs2251760", "rs2475335", "rs2413583"], RATIO = [0.0214, 0.0107, 0.00253, 0.0116, 0.00842, 0.0202, 0.00955, 0.0193, 0.0135, 0.0239, 0.0157, 0.0154, 0.0154, 0.00784, 0.0112])
    ),
    # #154
    ("test_file_issue_154.csv", (normalizenames=true,),
        (2, 4),
        NamedTuple{(:a, :b, :_, :Column4), Tuple{Int, Int, InlineString1, Union{Missing, InlineString15}}},
        (a = [0, 12], b = [1, 5], _ = [" ", " "], Column4 = Union{Missing, String}[" comment ", missing])
    ),
    (IOBuffer("""A,B,C\n1,1,10\n6,1"""), NamedTuple(),
        (2, 3),
        NamedTuple{(:A, :B, :C), Tuple{Int, Int, Union{Int, Missing}}},
        (A = [1, 6], B = [1, 1], C = [10, missing])
    ),
    (IOBuffer("""A;B;C\n1,1,10\n2,0,16"""), (normalizenames=true,),
        (2, 3),
        NamedTuple{(:A, :B, :C), Tuple{InlineString7, Missing, Missing}},
        (A = ["1,1,10", "2,0,16"], B = [missing, missing], C = [missing, missing])
    ),
    (IOBuffer("""A;B;C\n1,1,10\n2,0,16"""), (delim=';',),
        (2, 3),
        NamedTuple{(:A, :B, :C), Tuple{InlineString7, Missing, Missing}},
        (A = ["1,1,10", "2,0,16"], B = [missing, missing], C = [missing, missing])
    ),
    (IOBuffer("""a b c d e\n1 2  3 4 5\n1 2 3  4 5\n1  2 3  4 5"""), (delim=' ',),
        (3, 7),
        NamedTuple{(:a, :b, :c, :d, :e, :Column6, :Column7), Tuple{Int, Union{Int, Missing}, Union{Int, Missing}, Union{Int, Missing}, Union{Int, Missing}, Int, Union{Int, Missing}}},
        (a = [1, 1, 1], b = [2, 2, missing], c = [missing, 3, 2], d = [3, missing, 3], e = [4, 4, missing], Column6 = [5, 5, 4], Column7 = [missing, missing, 5])
    ),
    # 323
    (IOBuffer("a0001000\na0001000"), (skipto=1, pool=true),
        (2, 1),
        NamedTuple{(:Column1,), Tuple{InlineString15}},
        (Column1 = ["a0001000", "a0001000"],)
    ),
    # 396
    ("heat_flux.dat", (delim=' ', ignorerepeated=true, skipto=2, header=[:t, :heat_flux]),
        (16001, 2),
        NamedTuple{(:t, :heat_flux), Tuple{Float64, Float64}},
        nothing
    ),
    # #422
    ("log001_vehicle_status_flags_0.txt", NamedTuple(),
        (281, 31),
        NamedTuple{(:timestamp, :condition_calibration_enabled, :condition_system_sensors_initialized, :condition_system_hotplug_timeout, :condition_system_returned_to_home, :condition_auto_mission_available, :condition_global_position_valid, :condition_home_position_valid, :condition_local_position_valid, :condition_local_velocity_valid, :condition_local_altitude_valid, :condition_power_input_valid, :condition_battery_healthy, :circuit_breaker_engaged_power_check, :circuit_breaker_engaged_airspd_check, :circuit_breaker_engaged_enginefailure_check, :circuit_breaker_engaged_gpsfailure_check, :circuit_breaker_flight_termination_disabled, :circuit_breaker_engaged_usb_check, :circuit_breaker_engaged_posfailure_check, :offboard_control_signal_found_once, :offboard_control_signal_lost, :offboard_control_set_by_command, :offboard_control_loss_timeout, :rc_signal_found_once, :rc_input_blocked, :rc_calibration_valid, :vtol_transition_failure, :usb_connected, :avoidance_system_required, :avoidance_system_valid), Tuple{Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int, Int}},
        nothing
    ),
    # tape re-allocation
    ("fecal_samples.csv", (debug=true, normalizenames=true),
        (1079, 39),
        NamedTuple{(:SampleID, :Mother_Child, :SubjectID, :MaternalID, :TimePoint, :Fecal_EtOH, :CollectionRep, :DOC, :RAInitials_DOC, :DOF, :RAInitials_DOF, :Date_Brought_In, :RAInitials_Brought, :Date_Shipped, :RAInitials_Shipped, :Date_Aliquoted, :Number_Replicates, :RAInitials_Aliquot, :StorageBox, :DOE, :Extract_number, :AliquotRep, :DNABox, :KitUsed, :RAInitials_Extract, :DNAConc, :DOM, :Mgx_processed, :Mgx_batch, :DO16S, :_16S_processed, :_16S_batch, :_16S_plate, :Notes, :Discrepancies, :Batch_1_Mapping, :Mgx_batch_Mapping, :_16S_batch_Mapping, :Mother_Child_Dyads), Tuple{InlineString15, InlineString1, Int, InlineString7, Int, InlineString1, Int, Date, Union{Missing, InlineString7}, Union{Missing, Date}, Union{Missing, InlineString3}, Union{Missing, Date}, Union{Missing, InlineString7}, Union{Missing, Date}, Union{Missing, InlineString3}, Union{Missing, Date}, Union{Missing, InlineString7}, Union{Missing, InlineString3}, Union{Missing, InlineString7}, Union{Missing, Date}, Union{Missing, InlineString7}, Union{Missing, InlineString1}, Union{Missing, InlineString7}, Union{Missing, InlineString31}, Union{Missing, InlineString3}, Union{Missing, Float64}, Union{Missing, Date}, Union{Missing, InlineString15}, Union{Missing, InlineString7}, Union{Missing, Date}, Union{Missing, InlineString15}, Union{Missing, InlineString7}, Union{Missing, InlineString7}, Union{Missing, String}, Union{Missing, String}, Union{Missing, InlineString31}, Union{Missing, InlineString15}, Union{Missing, InlineString15}, Union{Missing, Int}}},
        nothing
    ),
    # 459, support parsing Time
    ("time.csv", (dateformat="H:M:S",),
        (2, 2),
        NamedTuple{(:time, :value), Tuple{Time, Int}},
        (time = [Time(0), Time(0, 10)], value = [1, 2])
    ),
    # https://github.com/JuliaData/DataFrames.jl/issues/1880
    ("escaped_pooled.csv", (header=[:a, :b, :c], pool=Dict(1=>true)),
        (2, 3),
        NamedTuple{(:a, :b, :c), Tuple{String, String, Float64}},
        (a = ["\\孕晚期下午和晚上血压高\"", "\\孕晚期下午和晚上血压高\""], b = ["为什么中老年人血压不高也要定期测量血压", "晚上睡眠不好会导致血压升高吗"], c = [0.744359, 0.714016])
    ),
    # https://github.com/JuliaData/CSV.jl/issues/478
    ("error_comment.txt", (comment="#",),
        (8, 4),
        NamedTuple{(:fluid, :col2, :col3, :acentric_factor), Tuple{InlineString7, Float64, Float64, Float64}},
        (fluid = ["Ar", "C2H4", "CO2", "CO", "CH4", "H2", "Kr", "Xe"], col2 = [150.86, 282.34, 304.12, 132.85, 190.56, 32.98, 209.4, 289.74], col3 = [48.98, 50.41, 73.74, 34.94, 45.99, 12.93, 55.0, 58.4], acentric_factor = [-0.002, 0.087, 0.225, 0.045, 0.011, -0.217, 0.005, 0.008])
    ),
    # https://github.com/JuliaData/CSV.jl/issues/508
    ("test_508.csv", (comment="#", header=[:eats_steak, :how_cooked]),
        (6, 2),
        NamedTuple{(:eats_steak, :how_cooked), Tuple{InlineString3, Union{InlineString15, Missing}}},
        (eats_steak=["Yes", "Yes", "Yes", "Yes", "No", "Yes"], how_cooked=["Medium rare", "Medium", "Medium", "Medium rare", missing, "Rare"])
    ),
    # https://github.com/JuliaData/CSV.jl/issues/555
    ("bug555.txt", (header=true,ignorerepeated=true,delim=' '),
        (3, 9),
        NamedTuple{(:RESULTAT, :NOM_CHAM, :INST, :NUME_ORDRE, :NOEUD, :COOR_X, :COOR_Y, :COOR_Z, :TEMP), Tuple{InlineString3, InlineString3, Float64, Int, InlineString3, Float64, Float64, Float64, Float64}},
        (RESULTAT = ["A0", "B0", "C0"], NOM_CHAM = ["A1", "B1", "C1"], INST = [0.0, 0.0, 0.0], NUME_ORDRE = [0, 0, 0], NOEUD = ["N1", "N2", "N3"], COOR_X = [0.0, 2.3, 2.5], COOR_Y = [2.27374e-15, 0.0, 0.0], COOR_Z = [0.0, 0.0, 0.0], TEMP = [0.0931399, 0.311013, 0.424537])
    ),
    # https://github.com/JuliaData/CSV.jl/issues/577
    ("csv_segfault.txt", (delim="\t", ignoreemptyrows=true),
        (468, 9),
        NamedTuple{(Symbol("Time (CEST)"), :Latitude, :Longitude, :Course, :kts, :mph, :feet, :Rate, Symbol("Reporting Facility")),Tuple{String, Union{Missing, InlineString15}, Union{Missing, InlineString15}, Union{Missing, InlineString31}, Union{Missing, InlineString3}, Union{Missing, InlineString3}, Union{Missing, InlineString7}, Union{Missing, InlineString31}, Union{Missing, InlineString31}}},
        nothing
    ),
    # https://github.com/JuliaData/CSV.jl/issues/575
    ("types_override.csv", (types=[String, Int, Int, Int, Int],),
        (3, 5),
        NamedTuple{(:col1,:col2,:col3,:col4,:col5), Tuple{String, Int, Int, Int, Int}},
        (col1 = ["A", "B", "C"], col2 = [1, 5, 9], col3 = [2, 6, 10], col4 = [3, 7, 11], col5 = [4, 8, 12])
    ),
    # https://github.com/JuliaData/CSV.jl/issues/592
    ("select.csv", (select = [:state, :dateChecked, :positive, :negative, :pending, :hospitalized, :death],),
        (1485, 7),
        NamedTuple{(:state, :positive, :negative, :pending, :hospitalized, :death, :dateChecked), Tuple{InlineString3, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, Union{Missing, Int}, InlineString31}},
        nothing
    ),
    # https://github.com/JuliaData/CSV.jl/issues/1010
    ("test_multithreaded_row_start_detection_singlecol.csv", (ntasks=120,),
        (3210, 1),
        NamedTuple{(:foobar,), Tuple{Float64}},
        nothing
    ),
    # https://github.com/JuliaData/CSV.jl/issues/1047
    ("test_multithreaded_row_start_detection_int.csv", (ntasks=8,),
        (151, 30),
        NamedTuple{ntuple(i -> Symbol("col", i), 30), NTuple{30,Int}},
        nothing
    ),
    # https://github.com/JuliaData/CSV.jl/pull/1073
    ("test_multithreaded_row_start_detection_float.csv", (ntasks=16,),
        (81, 55),
        NamedTuple{ntuple(Symbol, 55), NTuple{55,Float64}},
        nothing
    ),
    ("test_multithreaded_row_start_detection_float.csv", (ntasks=12,),
        (81, 55),
        NamedTuple{ntuple(Symbol, 55), NTuple{55,Float64}},
        nothing
    ),
    ("test_multithreaded_row_start_detection_float.csv", (ntasks=16, limit=82),
        (81, 55),
        NamedTuple{ntuple(Symbol, 55), NTuple{55,Float64}},
        nothing
    ),
    ("test_quoted_delim_multiple_newlines.csv", (escapechar='\\', pool=false, ntasks=2),
        (9, 3),
        NamedTuple{(:col1, :col2, :col3), Tuple{String, InlineString31, Union{Missing,InlineString15}}},
        (
            col1 = ["quoted ,field 1", "fieldA", "\n\nlarge multiline quoted field\n\n", "A", "U", "lastfieldmissing", "\nx", ",", "\n"],
            col2 = ["quoted\n field 2", "fieldB", "nextfieldmissing", "B", "\"\n\n\nV", "\n\n", "y\n", "", "quoted,field"],
            col3 = ["quoted field 3", "quoted\"field C", missing, "C", "w\n\n\n\"", missing, " z", "\\\n,", "unquotedfield"]
        )
    ),
    # https://github.com/JuliaData/CSV.jl/pull/1093
    ("groupmark_quote.csv", (groupmark=',',),
        (2, 2),
        NamedTuple{(:x, :y), Tuple{Int, Int}},
        (x = [15887, 23603], y = [24651, 14076])
    ),
    ("groupmark_space.csv", (groupmark=',',),
        (2, 2),
        NamedTuple{(:x, :y), Tuple{Int, Int}},
        (x = [15887, 23603], y = [24651, 14076])
    ),
    ("test_trailing_empty_column.csv", (ntasks=3,),
        (14,3),
        NamedTuple{(:X,:Y,:Z), Tuple{Int, Union{Missing,String7}, Union{Missing,Float64}}},
        nothing
    )
];

@static if VERSION >= v"1.3-DEV"
    # https://github.com/JuliaData/CSV.jl/issues/597
    push!(testfiles, ("ampm.csv", (dateformat="m/d/yyyy I:M:S p",),
        (2, 16),
        NamedTuple{(:ID, :INTERLOCK_NUMBER, :INTERLOCK_DESCRIPTION, :TYPE, :CREATE_DATE, :MODIFY_DATE, :USERNAME, :UNIT, :AREA, :PURPOSE, :PID, :LOCATION, :FUNC_DATE, :FUNC_BY, :TECHNICAL_DESCRIPTION, :types), Tuple{Int, Union{Missing, InlineString15}, String, Missing, DateTime, DateTime, InlineString15, InlineString15, InlineString15, InlineString31, Missing, Missing, DateTime, Missing, String, InlineString3}},
        x -> @test x.CREATE_DATE == [DateTime("2012-02-09T00:00:00"), DateTime("1998-07-22T16:37:01")]
    ))
    nothing
end

for test in testfiles
    testfile(test...)
end
# Test file with FilePaths
testfile("test_basic.csv", (types=Dict(2=>Float64),),
    (3, 3),
    NamedTuple{(:col1, :col2, :col3),Tuple{Int,Float64,Int}},
    (col1 = [1, 4, 7], col2 = [2.0, 5.0, 8.0], col3 = [3, 6, 9]);
    dir=Path(dir)
)

# https://github.com/JuliaData/CSV.jl/pull/1099
@info "The following test is expected to @error with \"Multithreaded parsing failed...\""
testfile("test_multiline_field_errorwarning.csv", (ntasks=3,),
    (20, 3),
    NamedTuple{(:col1, :col2, :col3), Tuple{String3, String, Int}},
    let col1 = [String3("A$i") for i in 1:19], col2 = [".$i" for i in 1:19], col3 = collect(1:19)
        insert!(col1, 14, String3("foo"))
        insert!(col2, 14, "a field to thwart all heuristics\n  ,,,\n, ,\n   , ,,\n, ,,\n  , ,,\n,,\n    ,,\n  ,    ,\n ,   ,\n ,,  ,  ,\n  ,  ,,,\n,   ,,\n\n, , ,    ,\n    ,     ,\n\n  ,,,\n,,,\n,,,\n ,,,\n\n,\n,\n")
        insert!(col3, 14, 0)
        (; col1, col2, col3)
    end
)

# CSV.jl Documentation

GitHub Repo: [https://github.com/JuliaData/CSV.jl](https://github.com/JuliaData/CSV.jl)

Welcome to CSV.jl! A pure-Julia package for handling delimited text data, be it comma-delimited (csv), tab-delimited (tsv), or otherwise.

## Installation

You can install CSV by typing the following in the Julia REPL:
```julia
] add CSV 
```

followed by 
```julia
using CSV
```
to load the package.

## Overview 

To start out, let's discuss the high-level functionality provided by the package, which hopefully will help direct you to more specific documentation for your use-case:

  * [`CSV.File`](@ref): the most commonly used function for ingesting delimited data; will read an entire data input or vector of data inputs, detecting number of columns and rows, along with the type of data for each column. Returns a `CSV.File` object, which is like a lightweight table/DataFrame. Assuming `file` is a variable of a `CSV.File` object, individual columns can be accessed like `file.col1`, `file[:col1]`, or `file["col"]`. You can see parsed column names via `file.names`. A `CSV.File` can also be iterated, where a `CSV.Row` is produced on each iteration, which allows access to each value in the row via `row.col1`, `row[:col1]`, or `row[1]`. You can also index a `CSV.File` directly, like `file[1]` to return the entire `CSV.Row` at the provided index/row number. Multiple threads will be used while parsing the input data if the input is large enough, and full return column buffers to hold the parsed data will be allocated. `CSV.File` satisfies the [Tables.jl](https://github.com/JuliaData/Tables.jl) "source" interface, and so can be passed to valid sink functions like `DataFrame`, `SQLite.load!`, `Arrow.write`, etc. Supports a number of keyword arguments to control parsing, column type, and other file metadata options.
  * [`CSV.read`](@ref): a convenience function identical to `CSV.File`, but used when a `CSV.File` will be passed directly to a sink function, like a `DataFrame`. In some cases, sinks may make copies of incoming data for their own safety; by calling `CSV.read(file, DataFrame)`, no copies of the parsed `CSV.File` will be made, and the `DataFrame` will take direct ownership of the `CSV.File`'s columns, which is more efficient than doing `CSV.File(file) |> DataFrame` which will result in an extra copy of each column being made. Keyword arguments are identical to `CSV.File`. Any valid Tables.jl sink function/table type can be passed as the 2nd argument. Like `CSV.File`, a vector of data inputs can be passed as the 1st argument, which will result in a single "long" table of all the inputs vertically concatenated. Each input must have identical schemas (column names and types).
  * [`CSV.Rows`](@ref): an alternative approach for consuming delimited data, where the input is only consumed one row at a time, which allows "streaming" the data with a lower memory footprint than `CSV.File`. Supports many of the same options as `CSV.File`, except column type handling is a little different. By default, every column type will be essentially `Union{Missing, String}`, i.e. no automatic type detection is done, but column types can be provided manually. Multithreading is not used while parsing. After constructing a `CSV.Rows` object, rows can be "streamed" by iterating, where each iteration produces a `CSV.Row2` object, which operates similar to `CSV.File`'s `CSV.Row` type where individual row values can be accessed via `row.col1`, `row[:col1]`, or `row[1]`. If each row is processed individually, additional memory can be saved by passing `reusebuffer=true`, which means a single buffer will be allocated to hold the values of only the currently iterated row. `CSV.Rows` also supports the Tables.jl interface and can also be passed to valid sink functions.
  * [`CSV.Chunks`](@ref): similar to `CSV.File`, but allows passing a `ntasks::Integer` keyword argument which will cause the input file to be "chunked" up into `ntasks` number of chunks. After constructing a `CSV.Chunks` object, each iteration of the object will return a `CSV.File` of the next parsed chunk. Useful for processing extremely large files in "chunks". Because each iterated element is a valid Tables.jl "source", `CSV.Chunks` satisfies the `Tables.partitions` interface, so sinks that can process input partitions can operate by passing `CSV.Chunks` as the "source".
  * [`CSV.write`](@ref): A valid Tables.jl "sink" function for writing any valid input table out in a delimited text format. Supports many options for controlling the output like delimiter, quote characters, etc. Writes data to an internal buffer, which is flushed out when full, buffer size is configurable. Also supports writing out partitioned inputs as separate output files, one file per input partition. To write out a `DataFrame`, for example, it's simply `CSV.write("data.csv", df)`, or to write out a matrix, it's `using Tables; CSV.write("data.csv", Tables.table(mat))`
  * [`CSV.RowWriter`](@ref): An alternative way to produce csv output; takes any valid Tables.jl input, and on each iteration, produces a single csv-formatted string from the input table's row.

That's quite a bit! Let's boil down a TL;DR:
  * Just want to read a delimited file or collection of files and do basic stuff with data? Use [`CSV.File(file)`](@ref CSV.File) or [`CSV.read(file, DataFrame)`](@ref CSV.read)
  * Don't need the data as a whole or want to stream through a large file row-by-row? Use [`CSV.Rows`](@ref).
  * Want to process a large file in "batches"/chunks? Use [`CSV.Chunks`](@ref).
  * Need to produce a csv? Use [`CSV.write`](@ref).
  * Want to iterate an input table and produce a single csv string per row? [`CSV.RowWriter`](@ref).

For the rest of the manual, we're going to have two big sections, *[Reading](@ref)* and *[Writing](@ref)* where we'll walk through the various options to `CSV.File`/`CSV.read`/`CSV.Rows`/`CSV.Chunks` and `CSV.write`/`CSV.RowWriter`.

```@contents
Pages = ["reading.md", "writing.md", "examples.md"]
```

# Reading

The format for this section will go through the various inputs/options supported by [`CSV.File`](@ref)/[`CSV.read`](@ref), with notes about compatibility with the other reading functionality ([`CSV.Rows`](@ref), [`CSV.Chunks`](@ref), etc.).

## [`input`](@id input)

A required argument for reading. Input data should be ASCII or UTF-8 encoded text; for other text encodings, use the [StringEncodings.jl](https://github.com/JuliaStrings/StringEncodings.jl) package to convert to UTF-8.

Any delimited input is ultimately converted to a byte buffer (`Vector{UInt8}`) for parsing/processing, so with that in mind, let's look at the various supported input types:

  * File name as a `String` or [`FilePath`](https://juliahub.com/docs/FilePaths/PrU4O/0.8.0/); parsing will call `Mmap.mmap(string(file))` to get a byte buffer to the file data. For gzip compressed inputs, like `file.gz`, the [CodecZlib.jl](https://juliahub.com/docs/CodecZlib/1TI30/0.7.0/) package will be used to decompress the data to a temporary file first, then mmapped to a byte buffer. Decompression can also be done in memory by passing `buffer_in_memory=true`. Note that only gzip-compressed data is automatically decompressed; for other forms of compressed data, seek out the appropriate package to decompress and pass an IO or `Vector{UInt8}` of decompressed data as input.
  * `Vector{UInt8}` or `SubArray{UInt8, 1, Vector{UInt8}}`: if you already have a byte buffer from wherever, you can just pass it in directly. If you have a csv-formatted string, you can pass it like `CSV.File(IOBuffer(str))`
  * `IO` or `Cmd`: you can pass an `IO` or `Cmd` directly, which will be consumed into a temporary file, then mmapped as a byte vector; to avoid a temp file and instead buffer data in memory, pass `buffer_in_memory=true`.
  * For files from the web, you can call `HTTP.get(url).body` to request the file, then access the data as a `Vector{UInt8}` from the `body` field, which can be passed directly for parsing. For Julia 1.6+, you can also use the `Downloads` stdlib, like `Downloads.download(url)` which can be passed to parsing

### Examples
  * [StringEncodings.jl example](@ref stringencodings)
  * [Vector of inputs example](@ref vectorinputs)
  * [Gzip input](@ref gzipped_input)
  * [Delimited data in a string](@ref csv_string)
  * [Data from the web](@ref http)
  * [Data in zip archive](@ref zip_example)

## [`header`](@id header)

The `header` keyword argument controls how column names are treated when processing files. By default, it is assumed that the column names are the first row/line of the input, i.e. `header=1`. Alternative valid augments for `header` include:
  * `Integer`, e.g. `header=2`: provide the row number as an `Integer` where the column names can be found
  * `Bool`, e.g. `header=false`: no column names exist in the data; column names will be auto-generated depending on the # of columns, like `Column1`, `Column2`, etc.
  * `Vector{String}` or `Vector{Symbol}`: manually provide column names as strings or symbols; should match the # of columns in the data. A copy of the `Vector` will be made and converted to `Vector{Symbol}`
  * `AbstractVector{<:Integer}`: in rare cases, there may be multi-row headers; by passing a collection of row numbers, each row will be parsed and the values for each row will be concatenated to form the final column names

### Examples
  * [Column names on second row](@ref second_row_header)
  * [No column names in the data](@ref no_header)
  * [Manually provide column names](@ref manual_header)
  * [Multi-row column names](@ref multi_row_header)

## [`normalizenames`](@id normalizenames)

Controls whether column names will be "normalized" to valid Julia identifiers. By default, this is `false`. If `normalizenames=true`, then column names with spaces, or that start with numbers, will be adjusted with underscores to become valid Julia identifiers. This is useful when you want to access columns via dot-access or `getproperty`, like `file.col1`. The identifier that comes after the `.` must be valid, so spaces or identifiers starting with numbers aren't allowed.

### Examples
  * [Normalizing column names](@ref normalize_header)

## [`skipto`](@id skipto)

An `Integer` can be provided that specifies the row number where the data is located. By default, the row immediately following the header row is assumed to be the start of data. If `header=false`, or column names are provided manually as `Vector{String}` or `Vector{Symbol}`, the data is assumed to start on row 1, i.e. `skipto=1`.

### Examples
  * [Skip to specific row where data starts](@ref skipto_example)

## [`footerskip`](@id footerskip)

An `Integer` argument specifying the number of rows to ignore at the end of a file. This works by the parser starting at the end of the file and parsing in reverse until `footerskip` # of rows have been parsed, then parsing the entire file, stopping at the newly adjusted "end of file".

### Examples
  * [Skipping trailing useless rows](@ref footerskip_example)

## [`transpose`](@id transpose)

If `transpose=true` is passed, data will be read "transposed", so each row will be parsed as a column, and each column in the data will be returned as a row. Useful when data is extremely wide (many columns), but you want to process it in a "long" format (many rows). Note that multithreaded parsing is not supported when parsing is transposed.

### Examples
  * [Reading transposed data](@ref transpose_example)

## [`comment`](@id comment)

A `String` argument that, when encountered at the start of a row while parsing, will cause the row to be skipped. When providing `header`, `skipto`, or `footerskip` arguments, it should be noted that commented rows, while ignored, still count as "rows" when skipping to a specific row. In this way, you can visually identify, for example, that column names are on row 6, and pass `header=6`, even if row 5 is a commented row and will be ignored.

### Examples
  * [Ignoring commented rows](@ref comment_example)

## [`ignoreemptyrows`](@id ignoreemptyrows)

This argument specifies whether "empty rows", where consecutive [newlines](@ref newlines) are parsed, should be ignored or not. By default, they are. If `ignoreemptyrows=false`, then for an empty row, all existing columns will have `missing` assigned to their value for that row. Similar to commented rows, empty rows also still count as "rows" when any of the `header`, `skipto`, or `footerskip` arguments are provided.

### Examples
  * [Ignoring empty rows](@ref ignoreemptyrows_example)

## [`select` / `drop`](@id select)

Arguments that control which columns from the input data will actually be parsed and available after processing. `select` controls which columns _will_ be accessible after parsing while `drop` controls which columns to _ignore_. Either argument can be provided as a vector of `Integer`, `String`, or `Symbol`, specifying the column numbers or names to include/exclude. A vector of `Bool` matching the number of columns in the input data can also be provided, where each element specifies whether the corresponding column should be included/excluded. Finally, these arguments can also be given as boolean functions, of the form `(i, name) -> Bool`, where each column number and name will be given as arguments and the result of the function will determine if the column will be included/excluded.

### Examples
  * [Including/excluding columns](@ref select_example)

## [`limit`](@id limit)

An `Integer` argument to specify the number of rows that should be read from the data. Can be used in conjunction with [`skipto`](@ref skipto) to read contiguous chunks of a file. Note that with multithreaded parsing (when the data is deemed large enough), it can be difficult for parsing to determine the exact # of rows to limit to, so it may or may not return exactly `limit` number of rows. To ensure an exact limit on larger files, also pass `ntasks=1` to force single-threaded parsing.

### Examples
  * [Limiting number of rows from data](@ref limit_example)

## [`ntasks`](@id ntasks)

NOTE: not applicable to `CSV.Rows`

For large enough data inputs, `ntasks` controls the number of multithreaded tasks used to concurrently parse the data. By default, it uses `Threads.nthreads()`, which is the number of threads the julia process was started with, either via `julia -t N` or the `JULIA_NUM_THREADS` environment variable. To avoid multithreaded parsing, even on large files, pass `ntasks=1`. This argument is only applicable to `CSV.File`, not `CSV.Rows`. For `CSV.Chunks`, it controls the total number of chunk iterations a large file will be split up into for parsing.

## [`rows_to_check`](@id rows_to_check)

NOTE: not applicable to `CSV.Rows`

When input data is large enough, parsing will attempt to "chunk" up the data for multithreaded tasks to parse concurrently. To chunk up the data, it is split up into even chunks, then initial parsers attempt to identify the correct start of the first row of that chunk. Once the start of the chunk's first row is found, each parser will check `rows_to_check` number of rows to ensure the expected number of columns are present.

## [`source`](@id source)

NOTE: only applicable to vector of inputs passed to `CSV.File`

A `Symbol`, `String`, or `Pair` of `Symbol` or `String` to `Vector`. As a single `Symbol` or `String`, provides the column name that will be added to the parsed columns, the values of the column will be the input "name" (usually file name) of the input from whence the value was parsed. As a `Pair`, the 2nd part of the pair should be a `Vector` of values matching the length of the # of inputs, where each value will be used instead of the input name for that inputs values in the auto-added column.

## [`missingstring`](@id missingstring)

Argument to control how `missing` values are handled while parsing input data. The default is `missingstring=""`, which means two consecutive delimiters, like `,,`, will result in a cell being set as a `missing` value. Otherwise, you can pass a single string to use as a "sentinel", like `missingstring="NA"`, or a vector of strings, where _each_ will be checked for when parsing, like `missingstring=["NA", "NAN", "NULL"]`, and if _any_ match, the cell will be set to `missing`. By passing `missingstring=nothing`, no `missing` values will be checked for while parsing.

### Examples
  * [Specifying custom missing strings](@ref missing_string_example)

## [`delim`](@id delim)

A `Char` or `String` argument that parsing looks for in the data input that separates distinct columns on each row. If no argument is provided (the default), parsing will try to detect the most consistent delimiter on the first 10 rows of the input, falling back to a single comma (`,`) if no other delimiter can be detected consistently.

### Examples
  * [String delimiter](@ref string_delim)

## [`ignorerepeated`](@id ignorerepeated)

A `Bool` argument, default `false`, that, if set to `true`, will cause parsing to ignore any number of consecutive delimiters between columns. This option can often be used to accurately parse fixed-width data inputs, where columns are delimited with a fixed number of delimiters, or a row is fixed-width and columns may have a variable number of delimiters between them based on the length of cell values.

### Examples
  * [Fixed width files](@ref ignorerepeated_example)

## [`quoted`](@id quoted)

A `Bool` argument that controls whether parsing will check for opening/closing quote characters at the start/end of cells. Default `true`. If you happen to know a file has no quoted cells, it can simplify parsing to pass `quoted=false`, so parsing avoids treating the `quotechar` or `openquotechar`/`closequotechar` arguments specially.

### Examples
  * [Turning off quoted cell parsing](@ref quoted_example)

## [`quotechar` / `openquotechar` / `closequotechar`](@id quotechar)

An ASCII `Char` argument (or arguments if both `openquotechar` and `closequotechar` are provided) that parsing uses to handle "quoted" cells. If a cell string value contains the [delim](@ref delim) argument, or a newline, it should start and end with `quotechar`, or start with `openquotechar` and end with `closequotechar` so parsing knows to treat the `delim` or newline as part of the cell _value_ instead of as significant parsing characters. If the `quotechar` or `closequotechar` characters also need to appear in the cell value, they should be properly escaped via the [escapechar](@ref escapechar) argument.

### Examples
  * [Quoted & escaped fields](@ref quotechar_example)

## [`escapechar`](@id escapechar)

An ASCII `Char` argument that parsing uses when parsing quoted cells and the `quotechar` or `closequotechar` characters appear in a cell string value. If the `escapechar` character is encountered inside a quoted cell, it will be "skipped", and the following character will not be checked for parsing significance, but just treated as another character in the value of the cell. Note the `escapechar` is _not_ included in the value of the cell, but is ignored completely.

## [`dateformat`](@id dateformat)

A `String` or `AbstractDict` argument that controls how parsing detects datetime values in the data input. As a single `String` (or `DateFormat`) argument, the same format will be applied to _all_ columns in the file. For columns without type information provided otherwise, parsing will use the provided format string to check if the cell is parseable and if so, will attempt to parse the entire column as the datetime type (`Time`, `Date`, or `DateTime`). By default, if no `dateformat` argument is explicitly provided, parsing will try to detect any of `Time`, `Date`, or `DateTime` types following the standard `Dates.ISOTimeFormat`, `Dates.ISODateFormat`, or `Dates.ISODateTimeFormat` formats, respectively. If a datetime type is provided for a column, (see the [types](@ref types) argument), then the `dateformat` format string needs to match the format of values in that column, otherwise, a warning will be emitted and the value will be replaced with a `missing` value (this behavior is also configurable via the [strict](@ref) and [silencewarnings](@ref strict) arguments). If an `AbstractDict` is provided, different `dateformat` strings can be provided for specific columns; the provided dict can map either an `Integer` for column number or a `String`, `Symbol` or `Regex` for column name to the dateformat string that should be used for that column. Columns not mapped in the dict argument will use the default format strings mentioned above.

### Examples
  * [DateFormat](@ref dateformat_example)

## [`decimal`](@id decimal)

An ASCII `Char` argument that is used when parsing float values that indicates where the fractional portion of the float value begins. i.e. for the truncated values of pie `3.14`, the `'.'` character separates the `3` and `14` values, whereas for `3,14` (common European notation), the `','` character separates the fractional portion. By default, `decimal='.'`.

### Examples
  * [Custom decimal separator](@ref decimal_example)

## [`groupmark` / thousands separator](@id groupmark)

A "groupmark" is a symbol that separates groups of digits so that it easier for humans to read a number. Thousands separators are a common example of groupmarks. The argument `groupmark`, if provided, must be an ASCII `Char` which will be ignored during parsing when it occurs between two digits on the left hand side of the decimal. e.g the groupmark in the integer `1,729` is `','` and the groupmark for the US social security number `875-39-3196` is `-`. By default, `groupmark=nothing` which indicates that there are no stray characters separating digits.

### Examples
  * [Thousands separator](@ref thousands_example)
  * [Custom groupmarks](@ref groupmark_example)

## [`truestrings` / `falsestrings`](@id truestrings)

These arguments can be provided as `Vector{String}` to specify custom values that should be treated as the `Bool` `true`/`false` values for all the columns of a data input. By default, `["true", "True", "TRUE", "T", "1"]` string values are used to detect `true` values, and `["false", "False", "FALSE", "F", "0"]` string values are used to detect `false` values. Note that even though `"1"` and `"0"` _can_ be used to parse `true`/`false` values, in terms of _auto_ detecting column types, those values will be parsed as `Int64` first, instead of `Bool`. To instead parse those values as `Bool`s for a column, you can manually provide that column's type as `Bool` (see the [type](@ref types) argument).

### Examples
  * [Custom bool strings](@ref truestrings_example)

## [`types`](@id types)

Argument to control the types of columns that get parsed in the data input. Can be provided as a single `Type`, an `AbstractVector` of types, an `AbstractDict`, or a function.
- If a single type is provided, like `types=Float64`, then _all_ columns in the data input will be parsed as `Float64`. If a column's value isn't a valid `Float64` value, then a warning will be emitted, unless `silencewarnings=false` is passed, then no warning will be printed. However, if `strict=true` is passed, then an error will be thrown instead, regarldess of the `silencewarnings` argument.
- If a `AbstractVector{Type}` is provided, then the length of the vector should match the number of columns in the data input, and each element gives the type of the corresponding column in order.
- If an `AbstractDict`, then specific columns can have their column type specified with the key of the dict being an `Integer` for column number, or `String` or `Symbol` for column name or `Regex` matching column names, and the dict value being the column type. Unspecified columns will have their column type auto-detected while parsing.
- If a function, then it should be of the form `(i, name) -> Union{T, Nothing}`, and will be applied to each detected column during initial parsing. Returning `nothing` from the function will result in the column's type being automatically detected during parsing.

By default `types=nothing`, which means all column types in the data input will be detected while parsing. Note that it isn't necessary to pass `types=Union{Float64, Missing}` if the data input contains `missing` values. Parsing will detect `missing` values if present, and promote any manually provided column types from the singular (`Float64`) to the missing equivalent (`Union{Float64, Missing}`) automatically. Standard types will be auto-detected in the following order when not otherwise specified:  `Int64`, `Float64`, `Date`, `DateTime`, `Time`, `Bool`, `String`.

Non-standard types can be provided, like `Dec64` from the DecFP.jl package, but must support the `Base.tryparse(T, str)` function for parsing a value from a string. This allows, for example, easily defining a custom type, like `struct Float64Array; values::Vector{Float64}; end`, as long as a corresponding `Base.tryparse` definition is defined, like `Base.tryparse(::Type{Float64Array}, str) = Float64Array(map(x -> parse(Float64, x), split(str, ';')))`, where a single cell in the data input is like `1.23;4.56;7.89`.

Note that the default [stringtype](@ref stringtype) can be overridden by providing a column's type manually, like `CSV.File(source; types=Dict(1 => String), stringtype=PosLenString)`, where the first column will be parsed as a `String`, while any other string columns will have the `PosLenString` type.

### Examples
  * [Matrix-like Data](@ref matrix_example)
  * [Providing types](@ref types_example)

## [`typemap`](@id typemap)

An `AbstractDict{Type, Type}` argument that allows replacing a non-`String` standard type with another type when a column's type is auto-detected. Most commonly, this would be used to force all numeric columns to be `Float64`, like `typemap=IdDict(Int64 => Float64)`, which would cause any columns detected as `Int64` to be parsed as `Float64` instead. Another common case would be wanting all columns of a specific type to be parsed as strings instead, like `typemap=IdDict(Date => String)`, which will cause any columns detected as `Date` to be parsed as `String` instead.

### Examples
  * [Typemap](@ref typemap_example)

## [`pool`](@id pool)

Argument that controls whether columns will be returned as `PooledArray`s. Can be provided as a `Bool`, `Float64`, `Tuple{Float64, Int}`, vector, dict, or a function of the form `(i, name) -> Union{Bool, Real,  Tuple{Float64, Int}, Nothing}`. As a `Bool`, controls absolutely whether a column will be pooled or not; if passed as a single `Bool` argument like `pool=true`, then all string columns will be pooled, regardless of cardinality. When passed as a `Float64`, the value should be between `0.0` and `1.0` to indicate the threshold under which the % of unique values found in the column will result in the column being pooled. For example, if `pool=0.1`, then all string columns with a unique value % less than 10% will be returned as `PooledArray`, while other string columns will be normal string vectors. If `pool` is provided as a tuple, like `(0.2, 500)`, the first tuple element is the same as a single `Float64` value, which represents the % cardinality allowed. The second tuple element is an upper limit on the # of unique values allowed to pool the column. So the example, `pool=(0.2, 500)` means if a String column has less than or equal to 500 unique values _and_ the # of unique values is less than 20% of total # of values, it will be pooled, otherwise, it won't. As mentioned, when the `pool` argument is a single `Bool`, `Real`, or `Tuple{Float64, Int}`, only string columns will be considered for pooling. When a vector or dict is provided, the pooling for any column can be provided as a `Bool`, `Float64`, or `Tuple{Float64, Int}`. Similar to the [types](@ref types) argument, providing a vector to `pool` should have an element for each column in the data input, while a dict argument can map column number/name to `Bool`, `Float64`, or `Tuple{Float64, Int}` for specific columns. Unspecified columns will not be pooled when the argument is a dict.

### Examples
  * [Pooled values](@ref pool_example)
  * [Non-string column pooling](@ref nonstring_pool_example)
  * [Pool with absolute threshold](@ref pool_absolute_threshold)

## [`downcast`](@id downcast)

A `Bool` argument that controls whether `Integer` detected column types will be "shrunk" to the smallest possible integer type. Argument is `false` by default. Only applies to auto-detected column types; i.e. if a column type is provided manually as `Int64`, it will not be shrunk. Useful for shrinking the overall memory footprint of parsed data, though care should be taken when processing the results as Julia by default as [integer overflow](https://en.wikipedia.org/wiki/Integer_overflow) behavior, which is increasingly likely the smaller the integer type.

## [`stringtype`](@id stringtype)

An argument that controls the precise type of string columns. Supported values are `InlineString` (the default), `PosLenString`, or `String`. The various string types are aimed at being mostly transparent to most users. In certain workflows, however, it can be advantageous to be more specific. Here's a quick rundown of the possible options:

  * `InlineString`: a set of fixed-width, stack-allocated primitive types. Can take memory pressure off the GC because they aren't reference types/on the heap. For very large files with string columns that have a fairly low variance in string length, this can provide much better GC interaction than `String`. When string length has a high variance, it can lead to lots of "wasted space", since an entire column will be promoted to the smallest InlineString type that fits the longest string value. For small strings, that can mean a lot of wasted space when they're promoted to a high fixed-width.
  * `PosLenString`: results in columns returned as `PosLenStringVector` (or `ChainedVector{PosLenStringVector}` for the multithreaded case), which holds a reference to the original input data, and acts as one large "view" vector into the original data where each cell begins/ends. Can result in the smallest memory footprint for string columns. `PosLenStringVector`, however, does not support traditional mutable operations like regular `Vector`s, like `push!`, `append!`, or `deleteat!`.
  * `String`: each string must be heap-allocated, which can result in higher GC pressure in very large files. But columns are returned as normal `Vector{String}` (or `ChainedVector{Vector{String}}`), which can be processed normally, including any mutating operations.

## [`strict` / `silencewarnings` / `maxwarnings`](@id strict)

Arguments that control error behavior when invalid values are encountered while parsing. Only applicable when types are provided manually by the user via the [types](@ref types) argument. If a column type is manually provided, but an invalid value is encountered, the default behavior is to set the value for that cell to `missing`, emit a warning (i.e. `silencewarnings=false` and `strict=false`), but only up to 100 total warnings and then they'll be silenced (i.e. `maxwarnings=100`). If `strict=true`, then invalid values will result in an error being thrown instead of any warnings emitted.

## [`debug`](@id debug)

A `Bool` argument that controls the printing of extra "debug" information while parsing. Can be useful if parsing doesn't produce the expected result or a bug is suspected in parsing somehow.

## API Reference

```@docs
CSV.read
CSV.File
CSV.Chunks
CSV.Rows
```

### Utilities
```@docs
CSV.detect
```

## Common terms

### Standard types

The types that are detected by default when column types are not provided by the user otherwise. They include: `Int64`, `Float64`, `Date`, `DateTime`, `Time`, `Bool`, and `String`.

### [Newlines](@id newlines)

For all parsing functionality, newlines are detected/parsed automatically, regardless if they're present in the data as a single newline character (`'\n'`), single return character ('`\r'`), or full CRLF sequence (`"\r\n"`).

### Cardinality

Refers to the ratio of unique values to total number of values in a column. Columns with "low cardinality" have a low % of unique values, or put another way, there are only a few unique values for the entire column of data where unique values are repeated many times. Columns with "high cardinality" have a high % of unique values relative to total number of values. Think of these as "id-like" columns where each or almost each value is a unique identifier with no (or few) repeated values.

# Examples

```@contents
Pages = ["examples.md"]
```

## [Non-UTF-8 character encodings](@id stringencodings)

```julia
# assume I have csv text data encoded in ISO-8859-1 encoding
# I load the StringEncodings package, which provides encoding conversion functionality
using CSV, StringEncodings

# I open my `iso8859_encoded_file.csv` with the `enc"ISO-8859-1"` encoding
# and pass the opened IO object to `CSV.File`, which will read the entire
# input into a temporary file, then parse the data from the temp file
file = CSV.File(open("iso8859_encoded_file.csv", enc"ISO-8859-1"))

# to instead have the encoding conversion happen in memory, pass
# `buffer_in_memory=true`; this can be faster, but obviously results
# in more memory being used rather than disk via a temp file
file = CSV.File(open("iso8859_encoded_file.csv", enc"ISO-8859-1"); buffer_in_memory=true)
```

## [Concatenate multiple inputs at once](@id vectorinputs)

```julia
using CSV

# in this case, I have a vector of delimited data inputs that each have
# matching schema (the same column names and types). I'd like to process all
# of the inputs together and vertically concatenate them into one "long" table.
data = [
    "a,b,c\n1,2,3\n4,5,6\n",
    "a,b,c\n7,8,9\n10,11,12\n",
    "a,b,c\n13,14,15\n16,17,18",
]

# I can just pass a `Vector` of inputs, in this case `IOBuffer(::String)`, but it
# could also be a `Vector` of any valid input source, like `AbstractVector{UInt8}`,
# filenames, `IO`, etc. Each input will be processed on a separate thread, with the results
# being vertically concatenated afterwards as a single `CSV.File`. Each thread's columns
# will be lazily concatenated using the `ChainedVector` type. As always, if we want to
# send the parsed columns directly to a sink function, we can use `CSV.read`, like
# `df = CSV.read(map(IOBuffer, data), DataFrame)`.
f = CSV.File(map(IOBuffer, data))
```

## [Gzipped input](@id gzipped_input)

```julia
# assume I have csv text data compressed via gzip
# no additional packages are needed; CSV.jl can decompress automatically
using CSV

# pass name of gzipped input file directly; data will be decompressed to a
# temporary file, then mmapped as a byte buffer for actual parsing
file = CSV.File("data.gz")

# to instead have the decompression happen in memory, pass
# `buffer_in_memory=true`; this can be faster, but obviously results
# in more memory being used rather than disk via a temp file
file = CSV.File("data.gz"; buffer_in_memory=true)
```

## [Delimited data in a string](@id csv_string)

```julia
using CSV

# I have csv data in a string I want to parse
data = """
a,b,c
1,2,3
4,5,6
"""

# Calling `IOBuffer` on a string returns an in-memory IO object
# of the string data, which can be passed to `CSV.File` for parsing
file = CSV.File(IOBuffer(data))
```

## [Data from the web/a url](@id http)

```julia
# assume there's delimited data I want to read from the web
# one option is to use the HTTP.jl package
using CSV, HTTP

# I first make the web request to get the data via `HTTP.get` on the `url`
http_response = HTTP.get(url)

# I can then access the data of the response as a `Vector{UInt8}` and pass
# it directly to `CSV.File` for parsing
file = CSV.File(http_response.body)

# another option, with Julia 1.6+, is using the Downloads stdlib
using Downloads
http_response = Downloads.download(url)

# by default, `Downloads.download` writes the response data to a temporary file
# which can then be passed to `CSV.File` for parsing
file = CSV.File(http_response)
```

## [Reading from a zip file](@id zip_example)

```julia
using ZipArchives, Mmap, CSV, DataFrames

a = DataFrame(a = 1:3)
CSV.write("a.csv", a)

# zip the file; Windows users who do not have zip available on the PATH can manually zip the CSV
# or write directly into the zip archive as shown below
;zip a.zip a.csv

# alternatively, write directly into the zip archive (without creating an unzipped csv file first)
ZipWriter("a2.zip") do z
    zip_newfile(z, "a.csv"; compress=true)
    a |> CSV.write(z)
end

# read file from zip archive
z = ZipReader(mmap(open("a.zip"))) # or "a2.zip"

# identify the right file in zip
a_copy = CSV.File(zip_openentry(z, "a.csv")) |> DataFrame

a == a_copy
```

## [Column names on 2nd row](@id second_row_header)

```julia
using CSV

data = """
descriptive row with information about the file that we'd like to ignore
a,b,c
1,2,3
4,5,6
"""

# by passing header=2, parsing will ignore the 1st row entirely
# then parse the column names on row 2, then by default, it assumes
# the data starts on the row after the column names (row 3 in this case)
# which is correct for this case
file = CSV.File(IOBuffer(data); header=2)
```

## [No column names in data](@id no_header)

```julia
using CSV

# in this case, our data doesn't have any column names
data = """
1,2,3
4,5,6
"""

# by passing `header=false`, parsing won't worry about looking for column names
# anywhere, but instead just start parsing the data and generate column names
# as needed, like `Column1`, `Column2`, and `Column3` in this case
file = CSV.File(IOBuffer(data); header=false)
```

## [Manually provide column names](@id manual_header)

```julia
using CSV

# in this case, our data doesn't have any column names
data = """
1,2,3
4,5,6
"""

# instead of passing `header=false` and getting auto-generated column names,
# we can instead pass the column names ourselves
file = CSV.File(IOBuffer(data); header=["a", "b", "c"])

# we can also pass the column names as Symbols; a copy of the manually provided
# column names will always be made and then converted to `Vector{Symbol}`
file = CSV.File(IOBuffer(data); header=[:a, :b, :c])
```

## [Multi-row column names](@id multi_row_header)

```julia
using CSV

# in this case, our column names are `col_a`, `col_b`, and `col_c`,
# but split over the first and second rows
data = """
col,col,col
a,b,c
1,2,3
4,5,6
"""

# by passing a collection of integers, parsing will parse each row in the collection
# and concatenate the values for each column, separating rows with `_` character
file = CSV.File(IOBuffer(data); header=[1, 2])
```

## [Normalizing column names](@id normalize_header)

```julia
using CSV

# in this case, our data are single letters, with column names of "1", "2", and "3"
# A single digit isn't a valid identifier in Julia, meaning we couldn't do something
# like `1 = 2 + 2`, where `1` would be a variable name
data = """
1,2,3
a,b,c
d,e,f
h,i,j
"""

# in order to have valid identifiers for column names, we can pass
# `normalizenames=true`, which result in our column names becoming "_1", "_2", and "_3"
# note this isn't required, but can be convenient in certain cases
file = CSV.File(IOBuffer(data); normalizenames=true)

# we can access the first column like
file._1

# another example where we may want to normalize is column names with spaces in them
data = """
column one,column two, column three
1,2,3
4,5,6
"""

# normalizing will result in column names like "column_one", "column_two" and "column_three"
file = CSV.File(IOBuffer(data); normalizenames=true)
```

## [Skip to specific row where data starts](@id skipto_example)

```julia
using CSV

# our data has a first row that we'd like to ignore; our data also doesn't have
# column names, so we'd like them to be auto-generated
data = """
descriptive row that gives information about the data that we'd like to ignore
1,2,3
4,5,6
"""

# with no column names in the data, we first pass `header=false`; by itself,
# this would result in parsing starting on row 1 to parse the actual data;
# but we'd like to ignore the first row, so we pass `skipto=2` to skip over
# the first row; our colum names will be generated like `Column1`, `Column2`, `Column3`
file = CSV.File(IOBuffer(data); header=false, skipto=2)
```

## [Skipping trailing useless rows](@id footerskip_example)

```julia
using CSV

# our data has column names of "a", "b", and "c"
# but at the end of the data, we have 2 rows we'd like to ignore while parsing
# since they're not properly delimited
data = """
a,b,c
1,2,3
4,5,6
7,8,9
totals: 12, 15, 18
grand total: 45
"""

# by passing `footerskip=2`, we tell parsing to start the end of the data and
# read 2 rows, ignoring their contents, then mark the ending position where
# the normal parsing process should finish
file = CSV.File(IOBuffer(data); footerskip=2)
```

## [Reading transposed data](@id transpose_example)

```julia
using CSV

# our data is transposed, meaning our column names are in the first column,
# with the data for column "a" all on the first row, data for column "b"
# all on the second row, and so on.
data = """
a,1,4,7
b,2,5,8
c,3,6,9
"""

# by passing `transpose=true`, parsing will look for column names in the first
# column of data, then parse each row as a separate column
file = CSV.File(IOBuffer(data); transpose=true)
```

## [Ignoring commented rows](@id comment_example)

```julia
using CSV

# here, we have several non-data rows that all begin with the "#" string
data = """
# row describing column names
a,b,c
# row describing first row of data
1,2,3
# row describing second row of data
4,5,6
"""

# we want to ignore these "commented" rows
file = CSV.File(IOBuffer(data); comment="#")
```

## [Ignoring empty rows](@id ignoreemptyrows_example)

```julia
using CSV

# here, we have a "gap" row in between the first and second row of data
# by default, these "empty" rows are ignored, but in our case, this is
# how a row of data is input when all columns have missing/null values
# so we don't want those rows to be ignored so we can know how many
# missing cases there are in our data
data = """
a,b,c
1,2,3

4,5,6
"""

# by passing `ignoreemptyrows=false`, we ensure parsing treats an empty row
# as each column having a `missing` value set for that row
file = CSV.File(IOBuffer(data); ignoreemptyrows=true)
```

## [Including/excluding columns](@id select_example)

```julia
using CSV

# simple dataset, but we know column "b" isn't needed
# so we'd like to save time by having parsing ignore it completely
data = """
a,b,c
1,2,3
4,5,6
7,8,9
"""

# there are quite a few ways to provide the select/drop arguments
# so we provide an example of each, first for selecting the columns
# "a" and "c" that we want to include or keep from parsing
file = CSV.File(IOBuffer(data); select=[1, 3])
file = CSV.File(IOBuffer(data); select=[:a, :c])
file = CSV.File(IOBuffer(data); select=["a", "c"])
file = CSV.File(IOBuffer(data); select=[true, false, true])
file = CSV.File(IOBuffer(data); select=(i, nm) -> i in (1, 3))
# now examples of dropping, when we'd rather specify the column(s)
# we'd like to drop/exclude from parsing
file = CSV.File(IOBuffer(data); drop=[2])
file = CSV.File(IOBuffer(data); drop=[:b])
file = CSV.File(IOBuffer(data); drop=["b"])
file = CSV.File(IOBuffer(data); drop=[false, true, false])
file = CSV.File(IOBuffer(data); drop=(i, nm) -> i == 2)
```

## [Limiting number of rows from data](@id limit_example)

```julia
using CSV

# here, we have quite a few rows of data (relative to other examples, lol)
# but we know we only need the first 3 for the analysis we need to do
# so instead of spending the time parsing the entire file, we'd like
# to just read the first 3 rows and ignore the rest
data = """
a,b,c
1,2,3
4,5,6
7,8,9
10,11,12
13,14,15
"""

# parsing will start reading rows, and once 3 have been read, it will
# terminate early, avoiding the parsing of the rest of the data entirely
file = CSV.File(IOBuffer(data); limit=3)
```

## [Specifying custom missing strings](@id missing_string_example)

```julia
using CSV

# in this data, our first column has "missing" values coded with -999
# but our score column has "NA" instead
# we'd like either of those values to show up as `missing` after we parse the data
data = """
code,age,score
0,21,3.42
1,42,6.55
-999,81,NA
-999,83,NA
"""

# by passing missingstring=["-999", "NA"], parsing will check each cell if it matches
# either string in order to set the value of the cell to `missing`
file = CSV.File(IOBuffer(data); missingstring=["-999", "NA"])
```

## [String delimiter](@id string_delim)

```julia
using CSV

# our data has two columns, separated by double colon
# characters ("::")
data = """
col1::col2
1::2
3::4
"""

# we can pass a single character or string for delim
file = CSV.File(IOBuffer(data); delim="::")
```

## [Fixed width files](@id ignorerepeated_example)

```julia
using CSV

# This is an example of "fixed width" data, where each
# column is the same number of characters away from each
# other on each row. Fields are "padded" with extra
# delimiters (in this case `' '`) so that each column is
# the same number of characters each time
data = """
col1    col2 col3
123431  2    3421
2355    346  7543
"""
# In addition to our `delim`, we can pass
# `ignorerepeated=true`, which tells parsing that
#consecutive delimiters should be treated as a single
# delimiter.
file = CSV.File(IOBuffer(data); delim=' ', ignorerepeated=true)
```

## [Turning off quoted cell parsing](@id quoted_example)

```julia
using CSV

# by default, cells like the 1st column, 2nd row
# will be treated as "quoted" cells, where they start
# and end with the quote character '"'. The quotes will
# be removed from the final parsed value
# we may, however, want the "raw" value and _not_ ignore
# the quote characters in the final value
data = """
a,b,c
"hey",2,3
there,4,5
sailor,6,7
"""

# we can "turn off" the detection of quoted cells
# by passing `quoted=false`
file = CSV.File(IOBuffer(data); quoted=false)
```

## [Quoted & escaped fields](@id quotechar_example)

```julia
using CSV

# In this data, we have a few "quoted" fields, which means the field's value starts and ends with `quotechar` (or
# `openquotechar` and `closequotechar`, respectively). Quoted fields allow the field to contain characters that would otherwise
# be significant to parsing, such as delimiters or newline characters. When quoted, parsing will ignore these otherwise
# significant characters until the closing quote character is found. For quoted fields that need to also include the quote
# character itself, an escape character is provided to tell parsing to ignore the next character when looking for a close quote
# character. In the syntax examples, the keyword arguments are passed explicitly, but these also happen to be the default
# values, so just doing `CSV.File(IOBuffer(data))` would result in successful parsing.
data = """
col1,col2
"quoted field with a delimiter , inside","quoted field that contains a \\n newline and ""inner quotes\"\"\"
unquoted field,unquoted field with "inner quotes"
"""

file = CSV.File(IOBuffer(data); quotechar='"', escapechar='"')

file = CSV.File(IOBuffer(data); openquotechar='"' closequotechar='"', escapechar='"')
```

## [DateFormat](@id dateformat_example)

```julia
using CSV

# In this file, our `date` column has dates that are formatted like `yyyy/mm/dd`. We can pass just such a string to the
# `dateformat` keyword argument to tell parsing to use it when looking for `Date` or `DateTime` columns. Note that currently,
# only a single `dateformat` string can be passed to parsing, meaning multiple columns with different date formats cannot all
# be parsed as `Date`/`DateTime`.
data = """
code,date
0,2019/01/01
1,2019/01/02
"""

file = CSV.File(IOBuffer(data); dateformat="yyyy/mm/dd")
```

## [Custom decimal separator](@id decimal_example)

```julia
using CSV

# In many places in the world, floating point number decimals are separated with a comma instead of a period (`3,14` vs. `3.14`).
# We can correctly parse these numbers by passing in the `decimal=','` keyword argument. If the file has no header or
# delimiter detection is otherwise ambiguous, pass `delim=';'` explicitly so commas are treated only as decimal markers.
data = """
col1;col2;col3
1,01;2,02;3,03
4,04;5,05;6,06
"""

file = CSV.File(IOBuffer(data); delim=';', decimal=',')
```

## [Thousands separator](@id thousands_example)

```julia
using CSV

# In many places in the world, digits to the left of the decimal place are broken into
# groups by a thousands separator. We can ignore those separators by passing the `groupmark`
# keyword argument.
data = """
x y
1 2
2 1,729
3 87,539,319
"""

file = CSV.File(IOBuffer(data); groupmark=',')
```

## [Custom groupmarks](@id groupmark_example)

```julia
using CSV

# In some contexts, separators other than thousands separators group digits in a number.
# `groupmark` supports ignoring them as long as the separator character is ASCII
data = """
name;ssn;credit card number
Ayodele Beren;597-21-8366;5538-6111-0574-2633
Trinidad Shiori;387-35-5126;3017-9300-0776-5301
Ori Cherokee;731-12-4606;4682-5416-0636-3877
"""

file = CSV.File(IOBuffer(data); groupmark='-')
```

## [Custom bool strings](@id truestrings_example)

```julia
using CSV

# By default, parsing only considers the string values `true` and `false` as valid `Bool` values. To consider alternative
# values, we can pass a `Vector{String}` to the `truestrings` and `falsestrings` keyword arguments.
data = """
id,paid,attended
0,T,TRUE
1,F,TRUE
2,T,FALSE
3,F,FALSE
"""

file = CSV.File(IOBuffer(data); truestrings=["T", "TRUE"], falsestrings=["F", "FALSE"])
```

## [Matrix-like Data](@id matrix_example)

```julia
using CSV

# This file contains a 3x3 identity matrix of `Float64`. By default, parsing will detect the delimiter and type, but we can
# also explicitly pass `delim= ' '` and `types=Float64`, which tells parsing to explicitly treat each column as `Float64`,
# without having to guess the type on its own.
data = """
1.0 0.0 0.0
0.0 1.0 0.0
0.0 0.0 1.0
"""

file = CSV.File(IOBuffer(data); header=false)
file = CSV.File(IOBuffer(data); header=false, delim=' ', types=Float64)

# as a last step if you want to convert this to a Matrix, this can be done by reading in first as a DataFrame and then
# function chaining to a Matrix
using DataFrames
A = file|>DataFrame|>Matrix

# another alternative is to simply use CSV.Tables.matrix and say
B = file|>CSV.Tables.matrix # does not require DataFrames
```

## [Providing types](@id types_example)

```julia
using CSV

# In this file, our 3rd column has an invalid value on the 2nd row `invalid`. Let's imagine we'd still like to treat it as an
# `Int` column, and ignore the `invalid` value. The syntax examples provide several ways we can tell parsing to treat the 3rd
# column as `Int`, by referring to column index `3`, or column name with `Symbol` or `String`. We can also provide an entire
# `Vector` of types for each column (and which needs to match the length of columns in the file). There are two additional
# keyword arguments that control parsing behavior; in the first 4 syntax examples, we would see a warning printed like
# `"warning: invalid Int64 value on row 2, column 3"`. In the fifth example, passing `silencewarnings=true` will suppress this
# warning printing. In the last syntax example, passing `strict=true` will result in an error being thrown during parsing.
data = """
col1,col2,col3
1,2,3
4,5,invalid
6,7,8
"""

file = CSV.File(IOBuffer(data); types=Dict(3 => Int))
file = CSV.File(IOBuffer(data); types=Dict(:col3 => Int))
file = CSV.File(IOBuffer(data); types=Dict("col3" => Int))
file = CSV.File(IOBuffer(data); types=[Int, Int, Int])
file = CSV.File(IOBuffer(data); types=[Int, Int, Int], silencewarnings=true)
file = CSV.File(IOBuffer(data); types=[Int, Int, Int], strict=true)


# In this file we have lots of columns, and would like to specify the same type for all
# columns except one which should have a different type. We can do this by providing a
# function that takes the column index and column name and uses these to decide the type.
data = """
col1,col2,col3,col4,col5,col6,col7
1,2,3,4,5,6,7
0,2,3,4,5,6,7
1,2,3,4,5,6,7
"""
file = CSV.File(IOBuffer(data); types=(i, name) -> i == 1 ? Bool : Int8)
file = CSV.File(IOBuffer(data); types=(i, name) -> name == :col1 ? Bool : Int8)
# Alternatively by providing the exact name for the first column and a Regex to match the rest.
# Note that an exact column name always takes precedence over a regular expression.
file = CSV.File(IOBuffer(data); types=Dict(:col1 => Bool, r"^col\d" => Int8))
```

## [Typemap](@id typemap_example)

```julia
using CSV

# In this file, we have U.S. zipcodes in the first column that we'd rather not treat as `Int`, but parsing will detect it as
# such. In the first syntax example, we pass `typemap=IdDict(Int => String)`, which tells parsing to treat any detected `Int`
# columns as `String` instead. In the second syntax example, we alternatively set the `zipcode` column type manually.
data = """
zipcode,score
03494,9.9
12345,6.7
84044,3.4
"""

file = CSV.File(IOBuffer(data); typemap=IdDict(Int => String))
file = CSV.File(IOBuffer(data); types=Dict(:zipcode => String))
```

## [Pooled values](@id pool_example)

```julia
using CSV

# In this file, we have an `id` column and a `code` column. There can be advantages with various DataFrame/table operations
# like joining and grouping when `String` values are "pooled", meaning each unique value is mapped to a `UInt32`. By default,
# `pool=(0.2, 500)`, so string columns with low cardinality are pooled by default. Via the `pool` keyword argument, we can provide
# greater control: `pool=0.4` means that if 40% or less of a column's values are unique, then it will be pooled.
data = """
id,code
A18E9,AT
BF392,GC
93EBC,AT
54EE1,AT
8CD2E,GC
"""

file = CSV.File(IOBuffer(data))
file = CSV.File(IOBuffer(data); pool=0.4)
file = CSV.File(IOBuffer(data); pool=0.6)
```

## [Non-string pooled values](@id nonstring_pool_example)

```julia
using CSV

# in this data, our `category` column is an integer type, but represents a limited set of values that could benefit from
# pooling. Indeed, we may want to do various DataFrame grouping/joining operations on the column, which can be more
# efficient if the column type is a PooledVector. By default, passing `pool=true` will only pool string column types,
# if we pass a vector or dict however, we can specify how specific, non-string type, columns should be pooled.
data = """
category,amount
1,100.01
1,101.10
2,201.10
2,202.40
"""

file = CSV.File(IOBuffer(data); pool=Dict(1 => true))
file = CSV.File(IOBuffer(data); pool=[true, false])
```

## [Pool with absolute threshold](@id pool_absolute_threshold)

```julia
using CSV

# In this file, we have an `id` column and a `code` column. There can be advantages with various DataFrame/table operations
# like joining and grouping when `String` values are "pooled", meaning each unique value is mapped to a `UInt32`. By default,
# `pool=(0.2, 500)`, so string columns with low cardinality are pooled by default. Via the `pool` keyword argument, we can provide
# greater control: `pool=(0.5, 2)` means that if a column has 2 or fewer unique values _and_ the total number of unique values is less than 50% of all values, then it will be pooled.
data = """
id,code
A18E9,AT
BF392,GC
93EBC,AT
54EE1,AT
8CD2E,GC
"""

file = CSV.File(IOBuffer(data); pool=(0.5, 2))
```
